      SUBROUTINE SETUP ( JOBX    , XLABX   , NYMDBX  , NHMSBX  ,
     .                   NYMDEX  , NHMSEX  , NDBUDX  , NDOUTX  , NDSEGX,
     .                   NDTX    , NDRSWX  , NDRSHX  , LEAPX   , NDPNTX,
     .                   MATSX   , ALPHAX  , QQINITX , PLEVSX  ,
     .                   NULEVX  )
C***********************************************************************
C
C  PURPOSE
C     SET CONTROL FOR MODEL EXECUTION AND OUTPUT
C  I/O DDNAME  DESCRIPTION
C     11       REWINDABLE COPY OF CARD-IMAGE DATA FROM INPUT
C
C***********************************************************************
C******               DATA ASSIMILATION OFFICE                    ******
C***********************************************************************

      DIMENSION    PLEVSX(50), PLEVS(50)
      CHARACTER*40 XLAB(2), XLABX(2)
      CHARACTER*8  JOB, JOBX
      LOGICAL      LEAP, MATS, QQINIT, LEAPX, MATSX, QQINITX
      PARAMETER  ( ZERO = 0.0 )

C  SETUP INPUT NAMELIST
C  ====================
      NAMELIST /INPUT/  JOB     , XLAB    , NYMDB   , NHMSB   ,
     .                  NYMDE   , NHMSE   , NDBUD   , NDOUT   ,
     .                  NDT     , NDRSW   , NDRSH   , LEAP    ,
     .                  MATS    , ALPHA   , QQINIT  , PLEVS   ,

     .                  NDSEG   , NDPNT

      NAMELIST /INPTZ/  JOB     , XLAB    , NYMDB   , NHMSB   ,
     .                  NYMDE   , NHMSE   , NDBUD   , NDOUT   ,
     .                  NDT     , NDRSW   , NDRSH   , LEAP    ,
     .                  MATS    , ALPHA   , QQINIT  , NDSEG   ,
     .                  NDPNT
       
C  VARIABLE     TYPE                    DESCRIPTION
C  ========  ===========   ==========================================
C  JOB        CHARACTER      EXPERIMENT IDENTIFIER
C  XLAB       CHARACTER      EXPERIMENT DESCRIPTION LABEL
C  NYMDB        INTEGER      BEGINNING YYMMDD
C  NHMSB        INTEGER      BEGINNING HHMMSS
C  NYMDE        INTEGER      ENDING    YYMMDD
C  NHMSE        INTEGER      ENDING    YYMMDD
C  NDSEG        INTEGER      HHMMSS FREQUENCY OF PRODUCTION  SEGMENT
C  NDBUD        INTEGER      HHMMSS FREQUENCY OF BUDGET      OUTPUT
C  NDOUT        INTEGER      HHMMSS FREQUENCY OF GENERIC GLA OUTPUT
C  NDRSW        INTEGER      HHMMSS FREQUENCY OF RESTART     OUTPUT
C  NDRSH        INTEGER      HHMMSS FREQUENCY OF RESTART     HISTORY
C  NDPNT        INTEGER      HHMMSS FREQUENCY OF POINT BY POINT DIAG
C  NDT          INTEGER      TIME-STEP (SECONDS)
C  MATS         LOGICAL      LOGICAL FLAG FOR MATSUNO  TIME-SCHEME
C  LEAP         LOGICAL      LOGICAL FLAG FOR LEAPFROG TIME-SCHEME
C  ALPHA           REAL      TIME-FILTER COEFFICIENT FOR LEAPFROG
C  QQINIT       LOGICAL      LOGICAL FLAG TO INITIALIZE QQ FIELD
C  PLEVS           REAL      PRESSURE LEVELS USED FOR OUTPUT (50 MAX)
C     
C **********************************************************************
C ****              INITIALIZE SETUP NAMELIST VARIABLES             ****
C **********************************************************************
       
      DATA PLEVS /50*0.0/
       
      LEAP   = .FALSE.
      MATS   = .FALSE.
      QQINIT = .FALSE.
      ALPHA  = ZERO
      NDT    = 0
      NDBUD  = 0
      NDOUT  = 0
      NDSEG  = 0
      NDRSW  = 0
      NDRSH  = 0
      NDPNT  = 0
      NYMDB  = 0
      NHMSB  = 0
      NYMDE  = 0
      NHMSE  = 0
       
C **********************************************************************
C ****                     READ SETUP NAMELIST                      ****
C **********************************************************************
       
      REWIND 11
      WRITE (6 ,1000)
      READ  (11,INPUT)
      WRITE (6 ,INPTZ)
       
      NULEV  = 0
      DO 10 I=1,50
          PLEVSX(I) = PLEVS(I)
      IF( PLEVSX(I).NE.0.0 ) NULEV = NULEV + 1
   10 CONTINUE
      IF( NULEV.NE.0 ) THEN
      PRINT *, 'PRESSURE LEVELS FOR OUTPUT:'
      WRITE(6,100) (PLEVSX(I),I=1,NULEV)
  100 FORMAT(1X,10(F6.1,2X))
      ENDIF
       
C **********************************************************************
C ****                        ASSIGN VALUES                         ****
C **********************************************************************
       
      JOBX     = JOB
      XLABX(1) = XLAB(1)
      XLABX(2) = XLAB(2)
      LEAPX    = LEAP
      MATSX    = MATS
      QQINITX  = QQINIT
      ALPHAX   = ALPHA
      NDTX     = NDT
      NDSEGX   = NDSEG
      NDBUDX   = NDBUD
      NDOUTX   = NDOUT
      NDRSWX   = NDRSW
      NDRSHX   = NDRSH
      NDPNTX   = NDPNT
      NYMDBX   = NYMDB
      NHMSBX   = NHMSB
      NYMDEX   = NYMDE
      NHMSEX   = NHMSE
      NULEVX   = NULEV
       
 1000 FORMAT(1X,'READING SETUP NAMELIST:')
      RETURN
      END
