C **********************************************************************
C *****                     STATE VARIABLES                        *****
C **********************************************************************

      PARAMETER ( NPROGS1 = 1 )
      PARAMETER ( NPROGU1 = 6 )
      PARAMETER ( NPROGS2 = 1 )
      PARAMETER ( NPROGU2 = 4 )

      COMMON /STATE/   NLWCLD, NSWCLD
      COMMON /STATE/   PROGS2(IMR,JMR+1,      NPROGS2,2)
      COMMON /STATE/   PROGU2(IMR,JMR+1,NLAYR,NPROGU2,2)
      COMMON /STATE/   PROGS1(IMR,JMR+1,      NPROGS1)
      COMMON /STATE/   PROGU1(IMR,JMR+1,NLAYR,NPROGU1)
      COMMON /STATE/   IRAS
      DIMENSION       PZ(IMR,(JMR+1)*NPROGS2,1)

      DIMENSION       UZ(IMR,JMR+1,NLAYR*NPROGU2,1)
      DIMENSION       VZ(IMR,JMR+1,NLAYR*NPROGU2,1)
      DIMENSION       TZ(IMR,JMR+1,NLAYR*NPROGU2,1)
      DIMENSION       QZ(IMR,JMR+1,NLAYR*NPROGU2,1)

      EQUIVALENCE (   PZ(1,1,1)   , PROGS2(1,1,1,1)   )
      EQUIVALENCE (   UZ(1,1,1,1) , PROGU2(1,1,1,1,1) )
      EQUIVALENCE (   VZ(1,1,1,1) , PROGU2(1,1,1,2,1) )
      EQUIVALENCE (   TZ(1,1,1,1) , PROGU2(1,1,1,3,1) )
      EQUIVALENCE (   QZ(1,1,1,1) , PROGU2(1,1,1,4,1) )

      DIMENSION      TGZ(IMR,JMR+1)
      DIMENSION     PKHT(IMR,JMR+1,NLAYR)
      DIMENSION    CLWRO(IMR,JMR+1,NLAYR)
      DIMENSION    CLWMO(IMR,JMR+1,NLAYR)
      DIMENSION    CSWRO(IMR,JMR+1,NLAYR)
      DIMENSION    CSWMO(IMR,JMR+1,NLAYR)
      DIMENSION      QQZ(IMR,JMR+1,NLAYR)

      EQUIVALENCE (   TGZ(1,1)   , PROGS1(1,1,1)   )
      EQUIVALENCE (  PKHT(1,1,1) , PROGU1(1,1,1,1) )
      EQUIVALENCE ( CLWRO(1,1,1) , PROGU1(1,1,1,2) )
      EQUIVALENCE ( CLWMO(1,1,1) , PROGU1(1,1,1,3) )
      EQUIVALENCE ( CSWRO(1,1,1) , PROGU1(1,1,1,4) )
      EQUIVALENCE ( CSWMO(1,1,1) , PROGU1(1,1,1,5) )
      EQUIVALENCE (   QQZ(1,1,1) , PROGU1(1,1,1,6) )

C **********************************************************************
C *****                  BOUNDARY CONDITIONS                       *****
C **********************************************************************

      COMMON  /BCS/  PHISZ(IMR,JMR+1)
      COMMON  /BCS/   TVAZ(IMR,JMR+1)
      COMMON  /BCS/    GWZ(IMR,JMR+1)
      COMMON  /BCS/   SSTZ(IMR,JMR+1)
      COMMON  /BCS/   ALBZ(IMR,JMR+1)
      COMMON  /BCS/    SRZ(IMR,JMR+1)
      COMMON  /BCS/   THKZ(IMR,JMR+1)
      COMMON  /BCS/   ZLWI(IMR,JMR+1)
      COMMON  /BCS/ RADSWT(IMR,JMR+1)

C **********************************************************************
C *****                       DIAGNOSTICS                          *****
C **********************************************************************

      PARAMETER    ( NDIAGT = 500)

      COMMON /DIAGP/ CDIAG   (NDIAGT)
      COMMON /DIAGP/ IDIAG   (NDIAGT)
      COMMON /DIAGP/ KDIAG   (NDIAGT)
      COMMON /DIAGP/ NDIAG   (NDIAGT)
      COMMON /DIAGP/ TDIAG   (NDIAGT)
      COMMON /DIAG/  NDIAGMX, QDIAG (IMR,JMR+1,1)

      CHARACTER*40  TDIAG
      CHARACTER*8   CDIAG
      CHARACTER*8   CUFLUX
      CHARACTER*8   CVFLUX
      CHARACTER*8   CHFLUX
      CHARACTER*8   CEFLUX
      CHARACTER*8   CQICE
      CHARACTER*8   CRADLWG
      CHARACTER*8   CRADSWG
      CHARACTER*8   CRI
      CHARACTER*8   CCT
      CHARACTER*8   CCU
      CHARACTER*8   CET
      CHARACTER*8   CEU
      CHARACTER*8   CTURBU
      CHARACTER*8   CTURBV
      CHARACTER*8   CTURBT
      CHARACTER*8   CTURBQ
      CHARACTER*8   CMOISTT
      CHARACTER*8   CMOISTQ
      CHARACTER*8   CRADLW
      CHARACTER*8   CRADSW
      CHARACTER*8   CPREACC
      CHARACTER*8   CPRECON
      CHARACTER*8   CTUFLUX
      CHARACTER*8   CTVFLUX
      CHARACTER*8   CTTFLUX
      CHARACTER*8   CTQFLUX
      CHARACTER*8   CCN
      CHARACTER*8   CWINDS
      CHARACTER*8   CDTSRF
      CHARACTER*8   CTG
      CHARACTER*8   CTS
      CHARACTER*8   CDTG
      CHARACTER*8   CQG
      CHARACTER*8   CQS
      CHARACTER*8   CTGRLW
      CHARACTER*8   CST4
      CHARACTER*8   COLR
      CHARACTER*8   COLRCLR
      CHARACTER*8   CLWGCLR
      CHARACTER*8   CLWCLR
      CHARACTER*8   CTLW
      CHARACTER*8   CSHLW
      CHARACTER*8   COZLW
      CHARACTER*8   CCLMOLW
      CHARACTER*8   CCLROLW
      CHARACTER*8   CCLMOSW
      CHARACTER*8   CCLROSW
      CHARACTER*8   CRADSWT
      CHARACTER*8   CFREQMD
      CHARACTER*8   CFREQPN
      CHARACTER*8   CFREQLW
      CHARACTER*8   CEVAP
      CHARACTER*8   CDPDT
      CHARACTER*8   CANALU
      CHARACTER*8   CANALV
      CHARACTER*8   CANALT
      CHARACTER*8   CANALQ
      CHARACTER*8   COMEGA
      CHARACTER*8   CDUDT
      CHARACTER*8   CDVDT
      CHARACTER*8   CDTDT
      CHARACTER*8   CDQDT
      CHARACTER*8   CVORT
      CHARACTER*8   CPGV
      CHARACTER*8   CCORU
      CHARACTER*8   CCORV
      CHARACTER*8   CUSTAR
      CHARACTER*8   CZ0
      CHARACTER*8   CFRQTRB
      CHARACTER*8   CPBL
      CHARACTER*8   CSWCLR
      CHARACTER*8   COSR
      CHARACTER*8   COSRCLR
      CHARACTER*8   CCLDMAS
      CHARACTER*8   CUAVE
      CHARACTER*8   CVAVE
      CHARACTER*8   CTAVE
      CHARACTER*8   CQAVE
      CHARACTER*8   CMDIV
      CHARACTER*8   CPAVE
      CHARACTER*8   CQQAVE
      CHARACTER*8   CSWGCLR
      CHARACTER*8   CANALP
      CHARACTER*8   CSDIAG1
      CHARACTER*8   CSDIAG2
      CHARACTER*8   CUDIAG1
      CHARACTER*8   CUDIAG2
      CHARACTER*8   CDIABU
      CHARACTER*8   CDIABV
      CHARACTER*8   CDIABT
      CHARACTER*8   CDIABQ
      CHARACTER*8   CPSIGDOT
      CHARACTER*8   CPGU
      CHARACTER*8   CPUFLX
      CHARACTER*8   CPVFLX
      CHARACTER*8   CPTFLX
      CHARACTER*8   CPQFLX
      CHARACTER*8   CDPUDT
      CHARACTER*8   CDPVDT
      CHARACTER*8   CDPTDT
      CHARACTER*8   CDPQDT
      CHARACTER*8   CVINTUQ
      CHARACTER*8   CVINTVQ
      CHARACTER*8   CVINTUT
      CHARACTER*8   CVINTVT
      CHARACTER*8   CCLDFRC
      CHARACTER*8   CQINT
      CHARACTER*8   CU2M
      CHARACTER*8   CV2M
      CHARACTER*8   CT2M
      CHARACTER*8   CQ2M
      CHARACTER*8   CU10M
      CHARACTER*8   CV10M
      CHARACTER*8   CT10M
      CHARACTER*8   CQ10M
      CHARACTER*8   CDTRAIN
      CHARACTER*8   CQFILL
      CHARACTER*8   CVINTQANA
      CHARACTER*8   CVINTQFIL
C
      EQUIVALENCE ( CDIAG( 1) ,  CUFLUX  )
      EQUIVALENCE ( CDIAG( 2) ,  CVFLUX  )
      EQUIVALENCE ( CDIAG( 3) ,  CHFLUX  )
      EQUIVALENCE ( CDIAG( 4) ,  CEFLUX  )
      EQUIVALENCE ( CDIAG( 5) ,  CQICE   )
      EQUIVALENCE ( CDIAG( 6) ,  CRADLWG )
      EQUIVALENCE ( CDIAG( 7) ,  CRADSWG )
      EQUIVALENCE ( CDIAG( 8) ,  CRI     )
      EQUIVALENCE ( CDIAG( 9) ,  CCT     )
      EQUIVALENCE ( CDIAG(10) ,  CCU     )
      EQUIVALENCE ( CDIAG(11) ,  CET     )
      EQUIVALENCE ( CDIAG(12) ,  CEU     )
      EQUIVALENCE ( CDIAG(13) ,  CTURBU  )
      EQUIVALENCE ( CDIAG(14) ,  CTURBV  )
      EQUIVALENCE ( CDIAG(15) ,  CTURBT  )
      EQUIVALENCE ( CDIAG(16) ,  CTURBQ  )
      EQUIVALENCE ( CDIAG(17) ,  CMOISTT )
      EQUIVALENCE ( CDIAG(18) ,  CMOISTQ )
      EQUIVALENCE ( CDIAG(19) ,  CRADLW  )
      EQUIVALENCE ( CDIAG(20) ,  CRADSW  )
      EQUIVALENCE ( CDIAG(21) ,  CPREACC )
      EQUIVALENCE ( CDIAG(22) ,  CPRECON )
      EQUIVALENCE ( CDIAG(23) ,  CTUFLUX )
      EQUIVALENCE ( CDIAG(24) ,  CTVFLUX )
      EQUIVALENCE ( CDIAG(25) ,  CTTFLUX )
      EQUIVALENCE ( CDIAG(26) ,  CTQFLUX )
      EQUIVALENCE ( CDIAG(27) ,  CCN     )
      EQUIVALENCE ( CDIAG(28) ,  CWINDS  )
      EQUIVALENCE ( CDIAG(29) ,  CDTSRF  )
      EQUIVALENCE ( CDIAG(30) ,  CTG     )
      EQUIVALENCE ( CDIAG(31) ,  CTS     )
      EQUIVALENCE ( CDIAG(32) ,  CDTG    )
      EQUIVALENCE ( CDIAG(33) ,  CQG     )
      EQUIVALENCE ( CDIAG(34) ,  CQS     )
      EQUIVALENCE ( CDIAG(35) ,  CTGRLW  )
      EQUIVALENCE ( CDIAG(36) ,  CST4    )
      EQUIVALENCE ( CDIAG(37) ,  COLR    )
      EQUIVALENCE ( CDIAG(38) ,  COLRCLR )
      EQUIVALENCE ( CDIAG(39) ,  CLWGCLR )
      EQUIVALENCE ( CDIAG(40) ,  CLWCLR  )
      EQUIVALENCE ( CDIAG(41) ,  CTLW    )
      EQUIVALENCE ( CDIAG(42) ,  CSHLW   )
      EQUIVALENCE ( CDIAG(43) ,  COZLW   )
      EQUIVALENCE ( CDIAG(44) ,  CCLMOLW )
      EQUIVALENCE ( CDIAG(45) ,  CCLROLW )
      EQUIVALENCE ( CDIAG(46) ,  CCLMOSW )
      EQUIVALENCE ( CDIAG(47) ,  CCLROSW )
      EQUIVALENCE ( CDIAG(48) ,  CRADSWT )
      EQUIVALENCE ( CDIAG(49) ,  CFREQMD )
      EQUIVALENCE ( CDIAG(50) ,  CFREQPN )
      EQUIVALENCE ( CDIAG(51) ,  CFREQLW )
      EQUIVALENCE ( CDIAG(52) ,  CEVAP   )
      EQUIVALENCE ( CDIAG(53) ,  CDPDT   )
      EQUIVALENCE ( CDIAG(54) ,  CANALU  )
      EQUIVALENCE ( CDIAG(55) ,  CANALV  )
      EQUIVALENCE ( CDIAG(56) ,  CANALT  )
      EQUIVALENCE ( CDIAG(57) ,  CANALQ  )
      EQUIVALENCE ( CDIAG(58) ,  COMEGA  )
      EQUIVALENCE ( CDIAG(59) ,  CDUDT   )
      EQUIVALENCE ( CDIAG(60) ,  CDVDT   )
      EQUIVALENCE ( CDIAG(61) ,  CDTDT   )
      EQUIVALENCE ( CDIAG(62) ,  CDQDT   )
      EQUIVALENCE ( CDIAG(63) ,  CVORT   )
      EQUIVALENCE ( CDIAG(64) ,  CPGV    )
      EQUIVALENCE ( CDIAG(65) ,  CCORU   )
      EQUIVALENCE ( CDIAG(66) ,  CCORV   )
      EQUIVALENCE ( CDIAG(67) ,  CUSTAR  )
      EQUIVALENCE ( CDIAG(68) ,  CZ0     )
      EQUIVALENCE ( CDIAG(69) ,  CFRQTRB )
      EQUIVALENCE ( CDIAG(70) ,  CPBL    )
      EQUIVALENCE ( CDIAG(71) ,  CSWCLR  )
      EQUIVALENCE ( CDIAG(72) ,  COSR    )
      EQUIVALENCE ( CDIAG(73) ,  COSRCLR )
      EQUIVALENCE ( CDIAG(74) ,  CCLDMAS )
      EQUIVALENCE ( CDIAG(75) ,  CUAVE   )
      EQUIVALENCE ( CDIAG(76) ,  CVAVE   )
      EQUIVALENCE ( CDIAG(77) ,  CTAVE   )
      EQUIVALENCE ( CDIAG(78) ,  CQAVE   )
      EQUIVALENCE ( CDIAG(79) ,  CMDIV   )
      EQUIVALENCE ( CDIAG(80) ,  CPAVE   )
      EQUIVALENCE ( CDIAG(81) ,  CQQAVE  )
      EQUIVALENCE ( CDIAG(82) ,  CSWGCLR )
      EQUIVALENCE ( CDIAG(83) ,  CANALP  )
      EQUIVALENCE ( CDIAG(84) ,  CSDIAG1 )
      EQUIVALENCE ( CDIAG(85) ,  CSDIAG2 )
      EQUIVALENCE ( CDIAG(86) ,  CUDIAG1 )
      EQUIVALENCE ( CDIAG(87) ,  CUDIAG2 )
      EQUIVALENCE ( CDIAG(88) ,  CDIABU  )
      EQUIVALENCE ( CDIAG(89) ,  CDIABV  )
      EQUIVALENCE ( CDIAG(90) ,  CDIABT  )
      EQUIVALENCE ( CDIAG(91) ,  CDIABQ  )
      EQUIVALENCE ( CDIAG(92) ,  CPSIGDOT)
      EQUIVALENCE ( CDIAG(93) ,  CPGU    )
      EQUIVALENCE ( CDIAG(94) ,  CPUFLX  )
      EQUIVALENCE ( CDIAG(95) ,  CPVFLX  )
      EQUIVALENCE ( CDIAG(96) ,  CPTFLX  )
      EQUIVALENCE ( CDIAG(97) ,  CPQFLX  )
      EQUIVALENCE ( CDIAG(98) ,  CDPUDT  )
      EQUIVALENCE ( CDIAG(99) ,  CDPVDT  )
      EQUIVALENCE ( CDIAG(100),  CDPTDT  )
      EQUIVALENCE ( CDIAG(101),  CDPQDT  )
      EQUIVALENCE ( CDIAG(102),  CVINTUQ )
      EQUIVALENCE ( CDIAG(103),  CVINTVQ )
      EQUIVALENCE ( CDIAG(104),  CVINTUT )
      EQUIVALENCE ( CDIAG(105),  CVINTVT )
      EQUIVALENCE ( CDIAG(106),  CCLDFRC )
      EQUIVALENCE ( CDIAG(107),  CQINT   )
      EQUIVALENCE ( CDIAG(108),  CU2M    )
      EQUIVALENCE ( CDIAG(109),  CV2M    )
      EQUIVALENCE ( CDIAG(110),  CT2M    )
      EQUIVALENCE ( CDIAG(111),  CQ2M    )
      EQUIVALENCE ( CDIAG(112),  CU10M   )
      EQUIVALENCE ( CDIAG(113),  CV10M   )
      EQUIVALENCE ( CDIAG(114),  CT10M   )
      EQUIVALENCE ( CDIAG(115),  CQ10M   )
      EQUIVALENCE ( CDIAG(116),  CDTRAIN )
      EQUIVALENCE ( CDIAG(117),  CQFILL  )
      EQUIVALENCE ( CDIAG(118),  CVINTQANA )
      EQUIVALENCE ( CDIAG(119),  CVINTQFIL )
C
      EQUIVALENCE ( IDIAG( 1) ,  IUFLUX  )
      EQUIVALENCE ( IDIAG( 2) ,  IVFLUX  )
      EQUIVALENCE ( IDIAG( 3) ,  IHFLUX  )
      EQUIVALENCE ( IDIAG( 4) ,  IEFLUX  )
      EQUIVALENCE ( IDIAG( 5) ,  IQICE   )
      EQUIVALENCE ( IDIAG( 6) ,  IRADLWG )
      EQUIVALENCE ( IDIAG( 7) ,  IRADSWG )
      EQUIVALENCE ( IDIAG( 8) ,  IRI     )
      EQUIVALENCE ( IDIAG( 9) ,  ICT     )
      EQUIVALENCE ( IDIAG(10) ,  ICU     )
      EQUIVALENCE ( IDIAG(11) ,  IET     )
      EQUIVALENCE ( IDIAG(12) ,  IEU     )
      EQUIVALENCE ( IDIAG(13) ,  ITURBU  )
      EQUIVALENCE ( IDIAG(14) ,  ITURBV  )
      EQUIVALENCE ( IDIAG(15) ,  ITURBT  )
      EQUIVALENCE ( IDIAG(16) ,  ITURBQ  )
      EQUIVALENCE ( IDIAG(17) ,  IMOISTT )
      EQUIVALENCE ( IDIAG(18) ,  IMOISTQ )
      EQUIVALENCE ( IDIAG(19) ,  IRADLW  )
      EQUIVALENCE ( IDIAG(20) ,  IRADSW  )
      EQUIVALENCE ( IDIAG(21) ,  IPREACC )
      EQUIVALENCE ( IDIAG(22) ,  IPRECON )
      EQUIVALENCE ( IDIAG(23) ,  ITUFLUX )
      EQUIVALENCE ( IDIAG(24) ,  ITVFLUX )
      EQUIVALENCE ( IDIAG(25) ,  ITTFLUX )
      EQUIVALENCE ( IDIAG(26) ,  ITQFLUX )
      EQUIVALENCE ( IDIAG(27) ,  ICN     )
      EQUIVALENCE ( IDIAG(28) ,  IWINDS  )
      EQUIVALENCE ( IDIAG(29) ,  IDTSRF  )
      EQUIVALENCE ( IDIAG(30) ,  ITG     )
      EQUIVALENCE ( IDIAG(31) ,  ITS     )
      EQUIVALENCE ( IDIAG(32) ,  IDTG    )
      EQUIVALENCE ( IDIAG(33) ,  IQG     )
      EQUIVALENCE ( IDIAG(34) ,  IQS     )
      EQUIVALENCE ( IDIAG(35) ,  ITGRLW  )
      EQUIVALENCE ( IDIAG(36) ,  IST4    )
      EQUIVALENCE ( IDIAG(37) ,  IOLR    )
      EQUIVALENCE ( IDIAG(38) ,  IOLRCLR )
      EQUIVALENCE ( IDIAG(39) ,  ILWGCLR )
      EQUIVALENCE ( IDIAG(40) ,  ILWCLR  )
      EQUIVALENCE ( IDIAG(41) ,  ITLW    )
      EQUIVALENCE ( IDIAG(42) ,  ISHLW   )
      EQUIVALENCE ( IDIAG(43) ,  IOZLW   )
      EQUIVALENCE ( IDIAG(44) ,  ICLMOLW )
      EQUIVALENCE ( IDIAG(45) ,  ICLROLW )
      EQUIVALENCE ( IDIAG(46) ,  ICLMOSW )
      EQUIVALENCE ( IDIAG(47) ,  ICLROSW )
      EQUIVALENCE ( IDIAG(48) ,  IRADSWT )
      EQUIVALENCE ( IDIAG(49) ,  IFREQMD )
      EQUIVALENCE ( IDIAG(50) ,  IFREQPN )
      EQUIVALENCE ( IDIAG(51) ,  IFREQLW )
      EQUIVALENCE ( IDIAG(52) ,  IEVAP   )
      EQUIVALENCE ( IDIAG(53) ,  IDPDT   )
      EQUIVALENCE ( IDIAG(54) ,  IANALU  )
      EQUIVALENCE ( IDIAG(55) ,  IANALV  )
      EQUIVALENCE ( IDIAG(56) ,  IANALT  )
      EQUIVALENCE ( IDIAG(57) ,  IANALQ  )
      EQUIVALENCE ( IDIAG(58) ,  IOMEGA  )
      EQUIVALENCE ( IDIAG(59) ,  IDUDT   )
      EQUIVALENCE ( IDIAG(60) ,  IDVDT   )
      EQUIVALENCE ( IDIAG(61) ,  IDTDT   )
      EQUIVALENCE ( IDIAG(62) ,  IDQDT   )
      EQUIVALENCE ( IDIAG(63) ,  IVORT   )
      EQUIVALENCE ( IDIAG(64) ,  IPGV    )
      EQUIVALENCE ( IDIAG(65) ,  ICORU   )
      EQUIVALENCE ( IDIAG(66) ,  ICORV   )
      EQUIVALENCE ( IDIAG(67) ,  IUSTAR  )
      EQUIVALENCE ( IDIAG(68) ,  IZ0     )
      EQUIVALENCE ( IDIAG(69) ,  IFRQTRB )
      EQUIVALENCE ( IDIAG(70) ,  IPBL    )
      EQUIVALENCE ( IDIAG(71) ,  ISWCLR  )
      EQUIVALENCE ( IDIAG(72) ,  IOSR    )
      EQUIVALENCE ( IDIAG(73) ,  IOSRCLR )
      EQUIVALENCE ( IDIAG(74) ,  ICLDMAS )
      EQUIVALENCE ( IDIAG(75) ,  IUAVE   )
      EQUIVALENCE ( IDIAG(76) ,  IVAVE   )
      EQUIVALENCE ( IDIAG(77) ,  ITAVE   )
      EQUIVALENCE ( IDIAG(78) ,  IQAVE   )
      EQUIVALENCE ( IDIAG(79) ,  IMDIV   )
      EQUIVALENCE ( IDIAG(80) ,  IPAVE   )
      EQUIVALENCE ( IDIAG(81) ,  IQQAVE  )
      EQUIVALENCE ( IDIAG(82) ,  ISWGCLR )
      EQUIVALENCE ( IDIAG(83) ,  IANALP  )
      EQUIVALENCE ( IDIAG(84) ,  ISDIAG1 )
      EQUIVALENCE ( IDIAG(85) ,  ISDIAG2 )
      EQUIVALENCE ( IDIAG(86) ,  IUDIAG1 )
      EQUIVALENCE ( IDIAG(87) ,  IUDIAG2 )
      EQUIVALENCE ( IDIAG(88) ,  IDIABU  )
      EQUIVALENCE ( IDIAG(89) ,  IDIABV  )
      EQUIVALENCE ( IDIAG(90) ,  IDIABT  )
      EQUIVALENCE ( IDIAG(91) ,  IDIABQ  )
      EQUIVALENCE ( IDIAG(92) ,  IPSIGDOT)
      EQUIVALENCE ( IDIAG(93) ,  IPGU    )
      EQUIVALENCE ( IDIAG(94) ,  IPUFLX  )
      EQUIVALENCE ( IDIAG(95) ,  IPVFLX  )
      EQUIVALENCE ( IDIAG(96) ,  IPTFLX  )
      EQUIVALENCE ( IDIAG(97) ,  IPQFLX  )
      EQUIVALENCE ( IDIAG(98) ,  IDPUDT  )
      EQUIVALENCE ( IDIAG(99) ,  IDPVDT  )
      EQUIVALENCE ( IDIAG(100),  IDPTDT  )
      EQUIVALENCE ( IDIAG(101),  IDPQDT  )
      EQUIVALENCE ( IDIAG(102),  IVINTUQ )
      EQUIVALENCE ( IDIAG(103),  IVINTVQ )
      EQUIVALENCE ( IDIAG(104),  IVINTUT )
      EQUIVALENCE ( IDIAG(105),  IVINTVT )
      EQUIVALENCE ( IDIAG(106),  ICLDFRC )
      EQUIVALENCE ( IDIAG(107),  IQINT   )
      EQUIVALENCE ( IDIAG(108),  IU2M    )
      EQUIVALENCE ( IDIAG(109),  IV2M    )
      EQUIVALENCE ( IDIAG(110),  IT2M    )
      EQUIVALENCE ( IDIAG(111),  IQ2M    )
      EQUIVALENCE ( IDIAG(112),  IU10M   )
      EQUIVALENCE ( IDIAG(113),  IV10M   )
      EQUIVALENCE ( IDIAG(114),  IT10M   )
      EQUIVALENCE ( IDIAG(115),  IQ10M   )
      EQUIVALENCE ( IDIAG(116),  IDTRAIN )
      EQUIVALENCE ( IDIAG(117),  IQFILL  )
      EQUIVALENCE ( IDIAG(118),  IVINTQANA )
      EQUIVALENCE ( IDIAG(119),  IVINTQFIL )
C
      EQUIVALENCE ( KDIAG( 1) ,  KUFLUX  )
      EQUIVALENCE ( KDIAG( 2) ,  KVFLUX  )
      EQUIVALENCE ( KDIAG( 3) ,  KHFLUX  )
      EQUIVALENCE ( KDIAG( 4) ,  KEFLUX  )
      EQUIVALENCE ( KDIAG( 5) ,  KQICE   )
      EQUIVALENCE ( KDIAG( 6) ,  KRADLWG )
      EQUIVALENCE ( KDIAG( 7) ,  KRADSWG )
      EQUIVALENCE ( KDIAG( 8) ,  KRI     )
      EQUIVALENCE ( KDIAG( 9) ,  KCT     )
      EQUIVALENCE ( KDIAG(10) ,  KCU     )
      EQUIVALENCE ( KDIAG(11) ,  KET     )
      EQUIVALENCE ( KDIAG(12) ,  KEU     )
      EQUIVALENCE ( KDIAG(13) ,  KTURBU  )
      EQUIVALENCE ( KDIAG(14) ,  KTURBV  )
      EQUIVALENCE ( KDIAG(15) ,  KTURBT  )
      EQUIVALENCE ( KDIAG(16) ,  KTURBQ  )
      EQUIVALENCE ( KDIAG(17) ,  KMOISTT )
      EQUIVALENCE ( KDIAG(18) ,  KMOISTQ )
      EQUIVALENCE ( KDIAG(19) ,  KRADLW  )
      EQUIVALENCE ( KDIAG(20) ,  KRADSW  )
      EQUIVALENCE ( KDIAG(21) ,  KPREACC )
      EQUIVALENCE ( KDIAG(22) ,  KPRECON )
      EQUIVALENCE ( KDIAG(23) ,  KTUFLUX )
      EQUIVALENCE ( KDIAG(24) ,  KTVFLUX )
      EQUIVALENCE ( KDIAG(25) ,  KTTFLUX )
      EQUIVALENCE ( KDIAG(26) ,  KTQFLUX )
      EQUIVALENCE ( KDIAG(27) ,  KCN     )
      EQUIVALENCE ( KDIAG(28) ,  KWINDS  )
      EQUIVALENCE ( KDIAG(29) ,  KDTSRF  )
      EQUIVALENCE ( KDIAG(30) ,  KTG     )
      EQUIVALENCE ( KDIAG(31) ,  KTS     )
      EQUIVALENCE ( KDIAG(32) ,  KDTG    )
      EQUIVALENCE ( KDIAG(33) ,  KQG     )
      EQUIVALENCE ( KDIAG(34) ,  KQS     )
      EQUIVALENCE ( KDIAG(35) ,  KTGRLW  )
      EQUIVALENCE ( KDIAG(36) ,  KST4    )
      EQUIVALENCE ( KDIAG(37) ,  KOLR    )
      EQUIVALENCE ( KDIAG(38) ,  KOLRCLR )
      EQUIVALENCE ( KDIAG(39) ,  KLWGCLR )
      EQUIVALENCE ( KDIAG(40) ,  KLWCLR  )
      EQUIVALENCE ( KDIAG(41) ,  KTLW    )
      EQUIVALENCE ( KDIAG(42) ,  KSHLW   )
      EQUIVALENCE ( KDIAG(43) ,  KOZLW   )
      EQUIVALENCE ( KDIAG(44) ,  KCLMOLW )
      EQUIVALENCE ( KDIAG(45) ,  KCLROLW )
      EQUIVALENCE ( KDIAG(46) ,  KCLMOSW )
      EQUIVALENCE ( KDIAG(47) ,  KCLROSW )
      EQUIVALENCE ( KDIAG(48) ,  KRADSWT )
      EQUIVALENCE ( KDIAG(49) ,  KFREQMD )
      EQUIVALENCE ( KDIAG(50) ,  KFREQPN )
      EQUIVALENCE ( KDIAG(51) ,  KFREQLW )
      EQUIVALENCE ( KDIAG(52) ,  KEVAP   )
      EQUIVALENCE ( KDIAG(53) ,  KDPDT   )
      EQUIVALENCE ( KDIAG(54) ,  KANALU  )
      EQUIVALENCE ( KDIAG(55) ,  KANALV  )
      EQUIVALENCE ( KDIAG(56) ,  KANALT  )
      EQUIVALENCE ( KDIAG(57) ,  KANALQ  )
      EQUIVALENCE ( KDIAG(58) ,  KOMEGA  )
      EQUIVALENCE ( KDIAG(59) ,  KDUDT   )
      EQUIVALENCE ( KDIAG(60) ,  KDVDT   )
      EQUIVALENCE ( KDIAG(61) ,  KDTDT   )
      EQUIVALENCE ( KDIAG(62) ,  KDQDT   )
      EQUIVALENCE ( KDIAG(63) ,  KVORT   )
      EQUIVALENCE ( KDIAG(64) ,  KPGV    )
      EQUIVALENCE ( KDIAG(65) ,  KCORU   )
      EQUIVALENCE ( KDIAG(66) ,  KCORV   )
      EQUIVALENCE ( KDIAG(67) ,  KUSTAR  )
      EQUIVALENCE ( KDIAG(68) ,  KZ0     )
      EQUIVALENCE ( KDIAG(69) ,  KFRQTRB )
      EQUIVALENCE ( KDIAG(70) ,  KPBL    )
      EQUIVALENCE ( KDIAG(71) ,  KSWCLR  )
      EQUIVALENCE ( KDIAG(72) ,  KOSR    )
      EQUIVALENCE ( KDIAG(73) ,  KOSRCLR )
      EQUIVALENCE ( KDIAG(74) ,  KCLDMAS )
      EQUIVALENCE ( KDIAG(75) ,  KUAVE   )
      EQUIVALENCE ( KDIAG(76) ,  KVAVE   )
      EQUIVALENCE ( KDIAG(77) ,  KTAVE   )
      EQUIVALENCE ( KDIAG(78) ,  KQAVE   )
      EQUIVALENCE ( KDIAG(79) ,  KMDIV   )
      EQUIVALENCE ( KDIAG(80) ,  KPAVE   )
      EQUIVALENCE ( KDIAG(81) ,  KQQAVE  )
      EQUIVALENCE ( KDIAG(82) ,  KSWGCLR )
      EQUIVALENCE ( KDIAG(83) ,  KANALP  )
      EQUIVALENCE ( KDIAG(84) ,  KSDIAG1 )
      EQUIVALENCE ( KDIAG(85) ,  KSDIAG2 )
      EQUIVALENCE ( KDIAG(86) ,  KUDIAG1 )
      EQUIVALENCE ( KDIAG(87) ,  KUDIAG2 )
      EQUIVALENCE ( KDIAG(88) ,  KDIABU  )
      EQUIVALENCE ( KDIAG(89) ,  KDIABV  )
      EQUIVALENCE ( KDIAG(90) ,  KDIABT  )
      EQUIVALENCE ( KDIAG(91) ,  KDIABQ  )
      EQUIVALENCE ( KDIAG(92) ,  KPSIGDOT)
      EQUIVALENCE ( KDIAG(93) ,  KPGU    )
      EQUIVALENCE ( KDIAG(94) ,  KPUFLX  )
      EQUIVALENCE ( KDIAG(95) ,  KPVFLX  )
      EQUIVALENCE ( KDIAG(96) ,  KPTFLX  )
      EQUIVALENCE ( KDIAG(97) ,  KPQFLX  )
      EQUIVALENCE ( KDIAG(98) ,  KDPUDT  )
      EQUIVALENCE ( KDIAG(99) ,  KDPVDT  )
      EQUIVALENCE ( KDIAG(100),  KDPTDT  )
      EQUIVALENCE ( KDIAG(101),  KDPQDT  )
      EQUIVALENCE ( KDIAG(102),  KVINTUQ )
      EQUIVALENCE ( KDIAG(103),  KVINTVQ )
      EQUIVALENCE ( KDIAG(104),  KVINTUT )
      EQUIVALENCE ( KDIAG(105),  KVINTVT )
      EQUIVALENCE ( KDIAG(106),  KCLDFRC )
      EQUIVALENCE ( KDIAG(107),  KQINT   )
      EQUIVALENCE ( KDIAG(108),  KU2M    )
      EQUIVALENCE ( KDIAG(109),  KV2M    )
      EQUIVALENCE ( KDIAG(110),  KT2M    )
      EQUIVALENCE ( KDIAG(111),  KQ2M    )
      EQUIVALENCE ( KDIAG(112),  KU10M   )
      EQUIVALENCE ( KDIAG(113),  KV10M   )
      EQUIVALENCE ( KDIAG(114),  KT10M   )
      EQUIVALENCE ( KDIAG(115),  KQ10M   )
      EQUIVALENCE ( KDIAG(116),  KDTRAIN )
      EQUIVALENCE ( KDIAG(117),  KQFILL  )
      EQUIVALENCE ( KDIAG(118),  KVINTQANA )
      EQUIVALENCE ( KDIAG(119),  KVINTQFIL )
C
      EQUIVALENCE ( NDIAG( 1) ,  NUFLUX  )
      EQUIVALENCE ( NDIAG( 2) ,  NVFLUX  )
      EQUIVALENCE ( NDIAG( 3) ,  NHFLUX  )
      EQUIVALENCE ( NDIAG( 4) ,  NEFLUX  )
      EQUIVALENCE ( NDIAG( 5) ,  NQICE   )
      EQUIVALENCE ( NDIAG( 6) ,  NRADLWG )
      EQUIVALENCE ( NDIAG( 7) ,  NRADSWG )
      EQUIVALENCE ( NDIAG( 8) ,  NRI     )
      EQUIVALENCE ( NDIAG( 9) ,  NCT     )
      EQUIVALENCE ( NDIAG(10) ,  NCU     )
      EQUIVALENCE ( NDIAG(11) ,  NET     )
      EQUIVALENCE ( NDIAG(12) ,  NEU     )
      EQUIVALENCE ( NDIAG(13) ,  NTURBU  )
      EQUIVALENCE ( NDIAG(14) ,  NTURBV  )
      EQUIVALENCE ( NDIAG(15) ,  NTURBT  )
      EQUIVALENCE ( NDIAG(16) ,  NTURBQ  )
      EQUIVALENCE ( NDIAG(17) ,  NMOISTT )
      EQUIVALENCE ( NDIAG(18) ,  NMOISTQ )
      EQUIVALENCE ( NDIAG(19) ,  NRADLW  )
      EQUIVALENCE ( NDIAG(20) ,  NRADSW  )
      EQUIVALENCE ( NDIAG(21) ,  NPREACC )
      EQUIVALENCE ( NDIAG(22) ,  NPRECON )
      EQUIVALENCE ( NDIAG(23) ,  NTUFLUX )
      EQUIVALENCE ( NDIAG(24) ,  NTVFLUX )
      EQUIVALENCE ( NDIAG(25) ,  NTTFLUX )
      EQUIVALENCE ( NDIAG(26) ,  NTQFLUX )
      EQUIVALENCE ( NDIAG(27) ,  NCN     )
      EQUIVALENCE ( NDIAG(28) ,  NWINDS  )
      EQUIVALENCE ( NDIAG(29) ,  NDTSRF  )
      EQUIVALENCE ( NDIAG(30) ,  NTG     )
      EQUIVALENCE ( NDIAG(31) ,  NTS     )
      EQUIVALENCE ( NDIAG(32) ,  NDTG    )
      EQUIVALENCE ( NDIAG(33) ,  NQG     )
      EQUIVALENCE ( NDIAG(34) ,  NQS     )
      EQUIVALENCE ( NDIAG(35) ,  NTGRLW  )
      EQUIVALENCE ( NDIAG(36) ,  NST4    )
      EQUIVALENCE ( NDIAG(37) ,  NOLR    )
      EQUIVALENCE ( NDIAG(38) ,  NOLRCLR )
      EQUIVALENCE ( NDIAG(39) ,  NLWGCLR )
      EQUIVALENCE ( NDIAG(40) ,  NLWCLR  )
      EQUIVALENCE ( NDIAG(41) ,  NTLW    )
      EQUIVALENCE ( NDIAG(42) ,  NSHLW   )
      EQUIVALENCE ( NDIAG(43) ,  NOZLW   )
      EQUIVALENCE ( NDIAG(44) ,  NCLMOLW )
      EQUIVALENCE ( NDIAG(45) ,  NCLROLW )
      EQUIVALENCE ( NDIAG(46) ,  NCLMOSW )
      EQUIVALENCE ( NDIAG(47) ,  NCLROSW )
      EQUIVALENCE ( NDIAG(48) ,  NRADSWT )
      EQUIVALENCE ( NDIAG(49) ,  NFREQMD )
      EQUIVALENCE ( NDIAG(50) ,  NFREQPN )
      EQUIVALENCE ( NDIAG(51) ,  NFREQLW )
      EQUIVALENCE ( NDIAG(52) ,  NEVAP   )
      EQUIVALENCE ( NDIAG(53) ,  NDPDT   )
      EQUIVALENCE ( NDIAG(54) ,  NANALU  )
      EQUIVALENCE ( NDIAG(55) ,  NANALV  )
      EQUIVALENCE ( NDIAG(56) ,  NANALT  )
      EQUIVALENCE ( NDIAG(57) ,  NANALQ  )
      EQUIVALENCE ( NDIAG(58) ,  NOMEGA  )
      EQUIVALENCE ( NDIAG(59) ,  NDUDT   )
      EQUIVALENCE ( NDIAG(60) ,  NDVDT   )
      EQUIVALENCE ( NDIAG(61) ,  NDTDT   )
      EQUIVALENCE ( NDIAG(62) ,  NDQDT   )
      EQUIVALENCE ( NDIAG(63) ,  NVORT   )
      EQUIVALENCE ( NDIAG(64) ,  NPGV    )
      EQUIVALENCE ( NDIAG(65) ,  NCORU   )
      EQUIVALENCE ( NDIAG(66) ,  NCORV   )
      EQUIVALENCE ( NDIAG(67) ,  NUSTAR  )
      EQUIVALENCE ( NDIAG(68) ,  NZ0     )
      EQUIVALENCE ( NDIAG(69) ,  NFRQTRB )
      EQUIVALENCE ( NDIAG(70) ,  NPBL    )
      EQUIVALENCE ( NDIAG(71) ,  NSWCLR  )
      EQUIVALENCE ( NDIAG(72) ,  NOSR    )
      EQUIVALENCE ( NDIAG(73) ,  NOSRCLR )
      EQUIVALENCE ( NDIAG(74) ,  NCLDMAS )
      EQUIVALENCE ( NDIAG(75) ,  NUAVE   )
      EQUIVALENCE ( NDIAG(76) ,  NVAVE   )
      EQUIVALENCE ( NDIAG(77) ,  NTAVE   )
      EQUIVALENCE ( NDIAG(78) ,  NQAVE   )
      EQUIVALENCE ( NDIAG(79) ,  NMDIV   )
      EQUIVALENCE ( NDIAG(80) ,  NPAVE   )
      EQUIVALENCE ( NDIAG(81) ,  NQQAVE  )
      EQUIVALENCE ( NDIAG(82) ,  NSWGCLR )
      EQUIVALENCE ( NDIAG(83) ,  NANALP  )
      EQUIVALENCE ( NDIAG(84) ,  NSDIAG1 )
      EQUIVALENCE ( NDIAG(85) ,  NSDIAG2 )
      EQUIVALENCE ( NDIAG(86) ,  NUDIAG1 )
      EQUIVALENCE ( NDIAG(87) ,  NUDIAG2 )
      EQUIVALENCE ( NDIAG(88) ,  NDIABU  )
      EQUIVALENCE ( NDIAG(89) ,  NDIABV  )
      EQUIVALENCE ( NDIAG(90) ,  NDIABT  )
      EQUIVALENCE ( NDIAG(91) ,  NDIABQ  )
      EQUIVALENCE ( NDIAG(92) ,  NPSIGDOT)
      EQUIVALENCE ( NDIAG(93) ,  NPGU    )
      EQUIVALENCE ( NDIAG(94) ,  NPUFLX  )
      EQUIVALENCE ( NDIAG(95) ,  NPVFLX  )
      EQUIVALENCE ( NDIAG(96) ,  NPTFLX  )
      EQUIVALENCE ( NDIAG(97) ,  NPQFLX  )
      EQUIVALENCE ( NDIAG(98) ,  NDPUDT  )
      EQUIVALENCE ( NDIAG(99) ,  NDPVDT  )
      EQUIVALENCE ( NDIAG(100),  NDPTDT  )
      EQUIVALENCE ( NDIAG(101),  NDPQDT  )
      EQUIVALENCE ( NDIAG(102),  NVINTUQ )
      EQUIVALENCE ( NDIAG(103),  NVINTVQ )
      EQUIVALENCE ( NDIAG(104),  NVINTUT )
      EQUIVALENCE ( NDIAG(105),  NVINTVT )
      EQUIVALENCE ( NDIAG(106),  NCLDFRC )
      EQUIVALENCE ( NDIAG(107),  NQINT   )
      EQUIVALENCE ( NDIAG(108),  NU2M    )
      EQUIVALENCE ( NDIAG(109),  NV2M    )
      EQUIVALENCE ( NDIAG(110),  NT2M    )
      EQUIVALENCE ( NDIAG(111),  NQ2M    )
      EQUIVALENCE ( NDIAG(112),  NU10M   )
      EQUIVALENCE ( NDIAG(113),  NV10M   )
      EQUIVALENCE ( NDIAG(114),  NT10M   )
      EQUIVALENCE ( NDIAG(115),  NQ10M   )
      EQUIVALENCE ( NDIAG(116),  NDTRAIN )
      EQUIVALENCE ( NDIAG(117),  NQFILL  )
      EQUIVALENCE ( NDIAG(118),  NVINTQANA )
      EQUIVALENCE ( NDIAG(119),  NVINTQFIL )
C
