      SUBROUTINE ATOC ( qa,qc,im,jm,km,itype )                          
C                                                                       
C ******************************************************************    
C ****                                                          ****    
C ****  This program converts 'A' gridded data                  ****    
C ****                     to 'C' gridded data.                 ****    
C ****                                                          ****    
C ****  A direct transfer           is made      for itype = 0  ****    
C ****  An FFT shift transformation is made in x for itype = 1  ****    
C ****  An FFT shift transformation is made in y for itype = 2  ****    
C ****                                                          ****    
C ******************************************************************    
                                                                        
#include<vrslv.com>                                                    
                                                                        
      DIMENSION qa   (im,jm,km)                                         
      DIMENSION qc   (im,jm,km)                                         
      DIMENSION qz   (im,jm,km)                                         
                                                                        
      DIMENSION qax  (   im+2 ,km)                                          
      DIMENSION  cx  (2*(im+2),km)                                          
      DIMENSION qay  (   2*jm ,km)                                          
      DIMENSION  cy  (2*(2*jm),km)                                          
                                                                        
      DIMENSION cosx (imr/2), sinx(imr/2)                               
      DIMENSION cosy (jmr)  , siny(jmr)                                 
      DIMENSION IFX  (100) , IFY (100)                                    
      REAL      TRIGX(3*(IMR+1))                                        
      REAL      TRIGY(3*(2*JMR+1))                                          
      
      save IFX  , IFY
      save TRIGX
      save TRIGY
      save cosx , sinx
      save cosy , siny

      logical first                                                     
      data    first /.true./                                            
                                                                        
      parameter ( zero  = 0.0 )                                         
      parameter ( ahalf = 0.5 )                                         
                                                                        
      JMM1  = JM-1                                                      
      JMM2  = JM-2                                                      
      JMM3  = JM-3                                                      
      JP    = 2*jmm1                                                    
                                                                        
      IMD2  = IM/2                                                      
      PI    = 4.*ATAN(1.)                                               
      DX    = 2*PI/IM                                                   
      DY    = PI/JMM1                                                   
                                                                        
C *********************************************************             
C ****     define sinx, cosx and trigs coefficients    ****             
C *********************************************************             
                                                                        
      if (first) then                                                   
                                                                        
      call fftfax (im,ifx,trigx)                                        
      do k=1,im/2                                                       
      thx = k*dx*ahalf                                                  
      cosx(k) = cos(thx)                                                
      sinx(k) = sin(thx)                                                
      enddo                                                             
                                                                        
      call fftfax (jp,ify,trigy)                                        
      do l=1,jmm1                                                       
      thy = l*dy*ahalf                                                  
      cosy(l) = cos(thy)                                                
      siny(l) = sin(thy)                                                
      enddo                                                             
                                                                        
      first = .false.                                                   
      endif                                                             
                                                                        
C *********************************************************             
C ****       load input array into temporary array     ****             
C *********************************************************             
                                                                        
      do i = 1,im*jm*km                                                 
      qz(i,1,1) = qa(i,1,1)                                             
      enddo                                                             
                                                                        
C *********************************************************             
C ****                mass points                      ****             
C *********************************************************             
                                                                        
      if (itype.eq.0) then                                              
      do i=1,im*jm*km                                                   
      qc(i,1,1) = qz(i,1,1)                                             
      enddo                                                             
      endif                                                             
                                                                        
C *********************************************************             
C ****           stagger in x-direction                ****             
C *********************************************************             
                                                                        
      if (itype.eq.1) then                                              
      do j=1,jm                                                         
                                                                        
      do l=1,km                                                         
      do i=1,im                                                         
      qax(i,l) = qz(i,j,l)                                              
      enddo                                                             
      enddo                                                             
      call rfftmlt (qax,cx,trigx,ifx,1 ,im+2,im,km,-1)                   
                                                                        
      do l=1,km                                                         
      do k=1,IMD2                                                       
      kr = 2*k+1                                                        
      ki = 2*k+2                                                        
      crprime = qax(kr,l)*cosx(k) - qax(ki,l)*sinx(k)                   
      ciprime = qax(ki,l)*cosx(k) + qax(kr,l)*sinx(k)                   
      qax(kr,l) = crprime                                               
      qax(ki,l) = ciprime                                               
      enddo                                                             
      enddo                                                             
                                                                        
      call rfftmlt (qax,cx,trigx,ifx,1 ,im+2,im,km, 1)                   
      do l=1,km                                                         
      do i=1,im                                                         
      qc(i,j,l) = qax(i,l)                                              
      enddo                                                             
      enddo                                                             
      enddo                                                             
                                                                        
      endif                                                             
                                                                        
C *********************************************************             
C ****           stagger in y-direction                ****             
C *********************************************************             
                                                                        
      if (itype.eq.2) then                                              
                                                                        
      do i=1,im/2                                                       
                                                                        
      do l=1,km                                                         
      do j=1,jmm1                                                       
      qay(j,l)      =  qz(i,j,l)                                        
      qay(j+jmm1,l) = -qz(i+imd2,jm-j+1,l)                              
      enddo                                                             
      enddo                                                             
                                                                        
      call rfftmlt (qay,cy,trigy,ify,1 ,jp+2,jp,km,-1)                   
                                                                        
      do l=1,km                                                         
      do k=1,jmm1                                                       
      kr = 2*k+1                                                        
      ki = 2*k+2                                                        
      crprime = qay(kr,l)*cosy(k) - qay(ki,l)*siny(k)                   
      ciprime = qay(ki,l)*cosy(k) + qay(kr,l)*siny(k)                   
      qay(kr,l) = crprime                                               
      qay(ki,l) = ciprime                                               
      enddo                                                             
      enddo                                                             
                                                                        
      call rfftmlt (qay,cy,trigy,ify,1 ,jp+2,jp,km, 1)                   
                                                                        
      do l=1,km                                                         
      do j=1,jmm1                                                       
      qc(i,j,l)             =  qay(j,l)                                 
      qc(i+imd2,jmm1-j+1,l) = -qay(j+jmm1,l)                            
      enddo                                                             
      enddo                                                             
                                                                        
      enddo                                                             
      endif                                                             
                                                                        
      RETURN                                                            
      END                                                               
