      SUBROUTINE GETDIAG (LEV, IPOINT, QTMP, UNDEF)                             
C***********************************************************************        
C                                                                               
C  PURPOSE                                                                      
C     RETRIEVE MODEL DIAGNOSTICS FROM COMMON                                    
C  INPUT:                                                                       
C     LEV ..... SIGMA LEVEL                                                     
C  IPOINT ..... DIAGNOSTIC NUMBER FROM MENU                                     
C   UNDEF ..... UNDEFINED VALUE                                                 
C                                                                               
C  OUTPUT:                                                                      
C    QTMP ..... DIAGNOSTIC QUANTITY                                             
C                                                                               
C***********************************************************************        
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *        
C***********************************************************************        
C                                                                               
#include <vrslv.com>                                                            
#include <vstate.com>                                                           
C                                                                               
      PARAMETER ( ZERO  = 0.0 )                                                 
      PARAMETER ( ONE   = 1.0 )                                                 
      PARAMETER ( IMJMR = IMR*(JMR+1) )                                         
      DIMENSION   QTMP(IMJMR)                                                   
                                                                                
      DO 10 I=1,IMJMR                                                           
      QTMP(I) = UNDEF                                                           
   10 CONTINUE                                                                  
      IF (IPOINT.LT.1) GO TO 999                                                
                                                                                
      KLEV = KDIAG(IPOINT)                                                      
      IF(KLEV.GE.LEV) THEN                                                      
      IPNT = IDIAG(IPOINT) + LEV - 1                                            
                                FACTOR = ONE                                    
      IF( NDIAG(IPOINT).NE.0 )  FACTOR = ONE   / NDIAG(IPOINT)                  
      DO 20 I=1,IMJMR                                                           
      QTMP(I) = QDIAG(I,1,IPNT) * FACTOR                                        
   20 CONTINUE                                                                  
      ENDIF                                                                     
                                                                                
 999  RETURN                                                                    
      END                                                                       
