      SUBROUTINE INTERP (U,UOT,PKE,PKO,PSTR,UNDEF)                              
C***********************************************************************        
C                                                                               
C INPUT                                                                         
C   UOT .... QUANTITY TO BE INTERPOLATED AT FULL LEVELS                         
C   PKE .... P TO THE KAPPA AT THE BASE OF EACH FULL LEVELS                     
C   PKO .... P TO THE KAPPA AT FULL LEVELS                                      
C   PSTR ... OUTPUT PRESSURE LEVEL (SCALAR) IN MB                               
C   UNDEF .. UNDEFINED VALUE                                                    
C                                                                               
C OUTPUT                                                                        
C   U ...... INTERPOLATED QUANTITY AT PSTR                                      
C                                                                               
C***********************************************************************        
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *        
C***********************************************************************        
C                                                                               
#include <vrslv.com>                                                            
                                                                                
      PARAMETER ( IMJMR = IMR*(JMR+1) )                                         
                                                                                
      DIMENSION UOT(IMJMR,NLAYR), PKO(IMJMR,NLAYR)                              
      DIMENSION   U(IMJMR)      , PKE(IMJMR,NLAYR)                              
                                                                                
      PARAMETER (ONE=1.0)                                                       
                                                                                
      AKP   = GETCON('KAPPA')                                                   
      PKSTR = PSTR**AKP                                                         
                                                                                
      DO 10 I=1,IMJMR                                                           
      U(I) = UNDEF                                                              
   10 CONTINUE                                                                  
                                                                                
      DO 20 L=1,NLAYR-1                                                         
      PKMIN = PKO(1,L)                                                          
      PKMAX = PKO(1,L+1)                                                        
      DO 30 I=2,IMJMR                                                           
      IF( PKO(I,L)  .LT.PKMIN ) PKMIN = PKO(I,L)                                
      IF( PKO(I,L+1).GT.PKMAX ) PKMAX = PKO(I,L+1)                              
   30 CONTINUE                                                                  
                                                                                
      IF (PKSTR .LE. PKMAX .AND. PKSTR .GE. PKMIN) THEN                         
      DO 40 I=1,IMJMR                                                           
      IF( PKSTR.LE.PKO(I,L+1) .AND. PKSTR.GE.PKO(I,L) ) THEN                    
      U(I) = (PKO(I,L)-PKSTR) / (PKO(I,L)-PKO(I,L+1))                           
      U(I) =  UOT(I,L+1)*U(I) +  UOT(I,L)*(ONE-U(I))                            
      ENDIF                                                                     
   40 CONTINUE                                                                  
      ENDIF                                                                     
   20 CONTINUE                                                                  
                                                                                
      DO 50 I=1,IMJMR                                                           
      IF( PKSTR.LT.PKO(I,1) ) THEN                                              
      U(I) = (PKO(I,1)-PKSTR) / (PKO(I,1)-PKO(I,2))                             
      U(I) =  UOT(I,2)*U(I)   +  UOT(I,1)*(ONE-U(I))                            
      ENDIF                                                                     
      IF( PKSTR.GT.PKO(I,NLAYR) .AND. PKSTR.LE.PKE(I,NLAYR) ) THEN              
      U(I) =  UOT(I,NLAYR)                                                      
      ENDIF                                                                     
   50 CONTINUE                                                                  
                                                                                
      RETURN                                                                    
      END                                                                       
