      SUBROUTINE INTERQ (T,Q,RH,TMP,QZ,PKE,PKO,PSTR,                            
     .                   UNDEF,TEM,TEM1,TEM2,TEM3,ITEM1,ITEM2)                  
C***********************************************************************        
C                                                                               
C INPUT                                                                         
C   QZ .... SPECIFIC HUMIDITY AT FULL LEVELS                                    
C   RH .... RELATIVE HUMIDITY AT FULL LEVELS                                    
C   TMP ... TEMPERATURE AT FULL LEVELS                                          
C   PKE ... P TO THE KAPPA AT THE BASE OF EACH FULL LEVELS                      
C   PKO ... P TO THE KAPPA AT FULL LEVELS                                       
C   PSTR .. OUTPUT PRESSURE LEVEL (SCALAR) IN MB                                
C   UNDEF . UNDEFINED VALUE                                                     
C   TEM ... SCRATCH ARRAY                                                       
C                                                                               
C OUTPUT                                                                        
C   T ..... TEMPERATURE AT PSTR                                                 
C   Q ..... SPECIFIC HUMIDITY (G/G) AT PSTR                                     
C                                                                               
C***********************************************************************        
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *        
C***********************************************************************        
C                                                                               
#include <vrslv.com>                                                            
                                                                                
      PARAMETER ( IMJMR = IMR*(JMR+1) )                                         
                                                                                
      DIMENSION    RH(IMJMR,NLAYR),  TMP(IMJMR,NLAYR),  PKO(IMJMR,NLAYR)        
      DIMENSION    QZ(IMJMR,NLAYR),  PKE(IMJMR,NLAYR)                           
      DIMENSION     Q(IMJMR)      ,    T(IMJMR)      ,  TEM(IMJMR,2)            
      DIMENSION  TEM1(IMJMR)      , TEM2(IMJMR)      , TEM3(IMJMR)              
      DIMENSION ITEM1(IMJMR)      ,ITEM2(IMJMR)                                 
                                                                                
      CALL INTERP (Q,RH, PKE,PKO,PSTR,UNDEF)                                    
      CALL INTERP (T,TMP,PKE,PKO,PSTR,UNDEF)                                    
                                                                                
      AKP   = GETCON('KAPPA')                                                   
      PKSTR = PSTR**AKP                                                         
                                                                                
      DO 10 I=1,IMJMR                                                           
      TEM(I,1) = PSTR                                                           
   10 CONTINUE                                                                  
                                                                                
      CALL QSTARS (T,TEM(1,1),                                                  
     .             TEM1,TEM2,TEM3,ITEM1,ITEM2,IMJMR,                            
     .             TEM(1,2) )                                                   
                                                                                
      DO 20 I=1,IMJMR                                                           
      IF( Q(I).NE.UNDEF ) Q(I) = Q(I) * TEM(I,2)                                
      IF( PKSTR.GT.PKO(I,NLAYR).AND.PKSTR.LE.PKE(I,NLAYR)) THEN                 
      Q(I) = QZ(I,NLAYR)                                                        
      ENDIF                                                                     
   20 CONTINUE                                                                  
                                                                                
      RETURN                                                                    
      END                                                                       
