      FUNCTION NALARM (MHMS,NYMD,NHMS,NYMD0,NHMS0)                              
C***********************************************************************        
C  PURPOSE                                                                      
C     COMPUTES MODULO-FRACTION BETWEEN MHHS AND TOTAL TIME                      
C  USAGE                                                                        
C  ARGUMENTS   DESCRIPTION                                                      
C     MHMS     INTERVAL FREQUENCY (HHMMSS)                                      
C     NYMD     CURRENT   YYMMDD                                                 
C     NHMS     CURRENT   HHMMSS                                                 
C     NYMD0    BEGINNING YYMMDD                                                 
C     NHMS0    BEGINNING HHMMSS                                                 
C                                                                               
C***********************************************************************        
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *        
C***********************************************************************        
C                                                                               
      PARAMETER ( NSDAY  = 86400 )                                              
      PARAMETER ( NCYCLE = 1461*24*3600 )                                       
C                                                                               
      INTEGER YEAR, DAY, SEC, YEAR0, DAY0, SEC0                                 
                                                                                
      DIMENSION  MNDY(12,4)                                                     
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,                
     .           397,34*0 /                                                     
                                                                                
      NSECF(N) = N/10000*3600 + MOD(N,10000)/100* 60 + MOD(N,100)               
C                                                                               
C***********************************************************************        
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *        
C***********************************************************************        
                                                                                
      DO 100 I=15,48                                                            
      MNDY(I,1) = MNDY(I-12,1) + 365                                            
100   CONTINUE                                                                  
                                                                                
C***********************************************************************        
C*                   SET CURRENT AND BEGINNING TIMES                   *        
C***********************************************************************        
C                                                                               
      YEAR   = NYMD / 10000                                                     
      MONTH  = MOD(NYMD,10000) / 100                                            
      DAY    = MOD(NYMD,100)                                                    
      SEC    = NSECF(NHMS)                                                      
C                                                                               
      YEAR0  = NYMD0 / 10000                                                    
      MONTH0 = MOD(NYMD0,10000) / 100                                           
      DAY0   = MOD(NYMD0,100)                                                   
      SEC0   = NSECF(NHMS0)                                                     
C                                                                               
C***********************************************************************        
C*      COMPUTE POSITIONS IN CYCLE FOR CURRENT AND BEGINNING TIMES     *        
C***********************************************************************        
C                                                                               
      IDAY   = (DAY -1) + MNDY( MONTH ,MOD(YEAR ,4)+1 )                         
      IDAY0  = (DAY0-1) + MNDY( MONTH0,MOD(YEAR0,4)+1 )                         
                                                                                
      NSEC   = IDAY *NSDAY + SEC                                                
      NSEC0  = IDAY0*NSDAY + SEC0                                               
                                                                                
                       NTIME  = NSEC-NSEC0                                      
      IF (NTIME.LT.0 ) NTIME  = NTIME + NCYCLE                                  
                       NALARM = NTIME                                           
      IF ( MHMS.NE.0 ) NALARM = MOD( NALARM,NSECF(MHMS) )                       
C                                                                               
      RETURN                                                                    
      END                                                                       
