      SUBROUTINE P2KAP ( PKE,PE,IRN,LM,PK,T1 )                                  
C***********************************************************************        
C  PURPOSE                                                                      
C     CALCULATE PHILLIPS P**KAPPA                                               
C  ARGUEMENTS                                                                   
C     PKE .... SIGMA EDGE-LEVEL PRESSURE**KAPPA                                 
C     PE ..... SIGMA EDGE-LEVEL PRESSURE                                        
C     IRN .... HORIZONTAL DIMENSION                                             
C     LM ..... VERTICAL   DIMENSION                                             
C     PK ..... SIGMA      LEVEL PRESSURE**KAPPA                                 
C     T1 ..... TEMPORARY  WORK ARRAY                                            
C                                                                               
C***********************************************************************        
C*                GODDARD LABORATORY FOR ATMOSPHERES                            
C***********************************************************************        
C                                                                               
      PARAMETER ( ONE = 1.0 )                                                   
                                                                                
      DIMENSION PKE(IRN,LM+1)                                                   
      DIMENSION  PE(IRN,LM+1)                                                   
      DIMENSION  PK(IRN,LM)                                                     
      DIMENSION  T1(IRN,LM+1)                                                   
                                                                                
      AKAP  = GETCON('KAPPA')                                                   
      MAXV  = GETCON('MAX VECT LENGTH')                                         
                                                                                
      IRNLM   = IRN*LM                                                          
      IRNLMP1 = IRN*(LM+1)                                                      
                                                                                
      IF( IRNLMP1.LT.MAXV ) THEN                                                
      DO 10 I=1,IRNLMP1                                                         
      T1(I,1) = PE(I,1)*PKE(I,1)                                                
   10 CONTINUE                                                                  
      DO 20 I=1,IRNLM                                                           
      PK(I,1) = ( T1(I,2)-T1(I,1) ) / ((ONE+AKAP)*( PE(I,2)-PE(I,1) ))          
   20 CONTINUE                                                                  
                                                                                
      ELSE                                                                      
                                                                                
      DO 30 L=1,LM+1                                                            
      DO 30 I=1,IRN                                                             
      T1(I,L) = PE(I,L)*PKE(I,L)                                                
   30 CONTINUE                                                                  
      DO 40 L=1,LM                                                              
      DO 40 I=1,IRN                                                             
      PK(I,L) = ( T1(I,L+1)-T1(I,L) )                                           
     *        / ((ONE+AKAP)*( PE(I,L+1)-PE(I,L) ))                              
   40 CONTINUE                                                                  
      ENDIF                                                                     
                                                                                
      RETURN                                                                    
      END                                                                       
