      SUBROUTINE PNTPRF(NN,IRUN,NLEV,NYMD,NHMS,FIELD,NAME)                      
C**********************************************************************         
C  PURPOSE                                                                      
C     STORES DIAGNOSTIC POINT BY POINT PROFILES                                 
C  INPUT PARAMETERS:                                                            
C      NN     - WHICH 'STRIP' IS BEING SENT                                     
C      IRUN   - FIRST DIMENSION OF INPUT VARIABLES                              
C      NLEV   - HOW MANY LEVELS                                                 
C      NYMD   - DATE IN YYMMDD FORMAT                                           
C      NHMS   - TIME IN HHMMSS FORMAT                                           
C      FIELD  - FIELD TO BE STORED - DIMENSION IRUN X NLEV                      
C**********************************************************************         
#include <vrslv.com>                                                            
#include <stripmine.com>
      PARAMETER( IMJMR = IMR * (JMR+1) )                                        
C                                                                               
C COMMON TO STORE DIAGNOSTIC ARRAYS - 100     POSSIBLE QUANTITIES,              
C                                     NLAYR+1 POSSIBLE LEVELS                   
C                                     20      POSSIBLE POINTS                   
C                                     50      POSSIBLE TIME PERIODS             
      COMMON /SAVPNT/ NDAYS(50),NHOURS(50)                                      
      COMMON /SAVPNT/ QNAMES(100),NUMLEVS(100)                                  
      CHARACTER * 16 QNAMES                                                     
      COMMON /SAVPNT/ INDXS(20),JNDXS(20)                                       
      COMMON /SAVPNT/ NPALL,NQUANTS,NTIMES                                      
      COMMON /SAVPNT/ PNTDIAG(1,1,1,1)                                          
C                                                                               
      DIMENSION FIELD(IRUN,NLEV)                                                
      CHARACTER * 16 NAME                                                       
      DIMENSION IJOUT(IMR,JMR+1),INDALL(IMJMR)                                  
      DIMENSION IJSTR(IRUN),INDEX(IRUN)                                         
C                                                                               
      LOGICAL FIRST                                                             
      DATA FIRST/.TRUE./                                                        
      SAVE                                                                      
      IF(FIRST)THEN                                                             
       NNM1    = 0                                                              
       NYMD1   = 0                                                              
       NHMS1   = 0                                                              
       NTIMES  = 0                                                              
       NPOINTS = 0                                                              
       NQUANTS = 0                                                              
C fill the array of which points are selected the first time here               
C  and then get the I (lon) and J (lat) indeces of the points                   
       CALL SETPRF(IMR,JMR+1,IJOUT)                                             
       CALL WHENEQ(IMJMR,IJOUT,1,1,INDALL,NPALL)                                
       DO IJ = 1,NPALL                                                          
        JNDXS(IJ) = INDALL(IJ)/IMR + 1                                          
        INDXS(IJ) = MOD(INDALL(IJ),IMR)                                         
       ENDDO                                                                    
       FIRST = .FALSE.                                                          
      ENDIF                                                                     
C                                                                               
C get the points for this strip only                                            
      CALL STRINT(IJOUT,IJSTR,IMJMR,IRUN,1,NN)                                  
C count up how many of ijstr are '1', (NPSTR) and put the indeces               
C                     into array index                                          
      CALL WHENEQ(IRUN,IJSTR,1,1,INDEX,NPSTR)                                   
C for a new time, bump the time count and zero out points and quantities        
      IF((NYMD.NE.NYMD1).OR.(NHMS.NE.NHMS1)) THEN                               
       NOTTIME = 1                                                              
       NTIMES = NTIMES + 1                                                      
       NQUANTS = 0                                                              
       NPOINTS = 0                                                              
      ELSE                                                                      
       NOTTIME = 0                                                              
      ENDIF                                                                     
C if we have any points in this strip we want, do some work                     
      IF(NPSTR.GT.0)THEN                                                        
C for a new strip, zero out the quantities counter                              
       IF((NN.NE.NNM1).OR.((NPCS.EQ.1).AND.(NOTTIME.EQ.1)))THEN                 
CCCC   IF(NN.NE.NNM1)THEN                                                       
        NQUANTS = 0                                                             
       ENDIF                                                                    
       NQUANTS = NQUANTS + 1                                                    
C if we are on the first quantity of a time period or of a strip,               
C      increment the counter for the number of points                           
       IF(NQUANTS.EQ.1)NPOINTS = NPOINTS + NPSTR                                
C FILL THE ARRAY KEEPING THE NAMES AND THE ONE KEEPING THE LEVELS               
       QNAMES(NQUANTS) = NAME                                                   
       NUMLEVS(NQUANTS) = NLEV                                                  
C fill the array keeping the date and time                                      
       NDAYS(NTIMES) = NYMD                                                     
       NHOURS(NTIMES) = NHMS                                                    
C now fill the saver array with the sent quantity for each chosen point         
       DO NS = NPOINTS-NPSTR+1,NPOINTS                                          
        II = INDEX(NS-NPOINTS+NPSTR)                                            
        DO LEV = 1,NLEV                                                         
         PNTDIAG(NQUANTS,LEV,NS,NTIMES) = FIELD(II,LEV)                         
        ENDDO                                                                   
       ENDDO                                                                    
      ENDIF                                                                     
C save the strip number and the date and time for the next call                 
      NNM1 = NN                                                                 
      NYMD1 = NYMD                                                              
      NHMS1 = NHMS                                                              
C                                                                               
      RETURN                                                                    
      END                                                                       
