      SUBROUTINE QCHECK (QZ,DSIG,IMAX,JMAX,KMAX,BUDFLG,QOLD)            
C***********************************************************************
C  PURPOSE                                                              
C     CHECK SPECIFIC HUMIDITY FIELD FOR NEGATIVE VALUES.                
C  USAGE                                                                
C     CALLED BY HYDRO                                                   
C  RECORD OF MODIFICATIONS                                              
C  REMARKS:                                                             
C                                                                       
C***********************************************************************
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *
C***********************************************************************
                                                                        
#include <vrslv.com>                                                    
#include <vbudget.com>                                                  
                                                                        
      DIMENSION   QZ(IMAX,JMAX,KMAX), DSIG(KMAX)                        
      DIMENSION QOLD(IMAX,JMAX,KMAX)                                    
      PARAMETER ( ZERO    = 0.0 )                                       
      PARAMETER ( AHALF   = 0.5 )                                       
      PARAMETER ( IMJMR   = IMR*(JMR+1) )                               
      PARAMETER ( IMJMM1R = IMR* JMR    )                               
      PARAMETER ( IMJMM2R = IMR*(JMR-1) )                               
      LOGICAL     BUDFLG                                                
                                                                        
C **********************************************************************
C ****               CORRECT SPECIFIC HUMIDITY                      ****
C **********************************************************************
                                                                        
      IF(BUDFLG) THEN                                                   
      DO 10 L=1,KMAX                                                    
      DO 10 I=1,IMJMM2R                                                 
      QOLD(I,2,L) = QZ(I,2,L)                                           
   10 CONTINUE                                                          
      ENDIF                                                             
                                                                        
      DO 20 L = 2,KMAX                                                  
          LM1 = L-1                                                     
          NCHECK = 0                                                    
          DO 30 I=1,IMJMM2R                                             
          IF( QZ(I,2,LM1).LT.ZERO ) NCHECK = NCHECK + 1                 
   30     CONTINUE                                                      
      IF (NCHECK.EQ.0) GOTO 20                                          
          DDSIG = DSIG(LM1)/DSIG(L)                                     
          DO 40 I=1,IMJMM2R                                             
          IF( QZ(I,2,LM1).LT.ZERO ) THEN                                
          QZ(I,2,L  ) = QZ(I,2,L) + QZ(I,2,LM1)*DDSIG                   
          QZ(I,2,LM1) = ZERO                                            
          ENDIF                                                         
   40     CONTINUE                                                      
   20 CONTINUE                                                          
          DO 50 I=1,IMJMM2R                                             
          IF( QZ(I,2,KMAX).LT.ZERO ) QZ(I,2,KMAX) = ZERO                
   50     CONTINUE                                                      
C                                                                       
      IF(BUDFLG) THEN                                                   
      DO 60 L=1,KMAX                                                    
      DO 70 I=1,IMJMM2R                                                 
      ZTEMP(I,2) = QZ(I,2,L)-QOLD(I,2,L)                                
   70 CONTINUE                                                          
      CALL ZMEAN ( ZTEMP,ZDPQDT(1,L),IMAX,JMAX,AHALF )                  
      CALL ZMEAN ( ZTEMP,ZQFILL(1,L),IMAX,JMAX,AHALF )                  
   60 CONTINUE                                                          
      ENDIF                                                             
                                                                        
      RETURN                                                            
      END                                                               
