      SUBROUTINE SETDIAG (NUM)                                                  
C***********************************************************************        
C                                                                               
C  PURPOSE                                                                      
C     SET POINTER LOCATIONS, NAMES, LEVELS and TITLES FOR DIAGNOSTIC NUM
C  ENTRY POINTS:                                                                
C  ============                                                                 
C   ZAPDIAG (NUM):  ZAP POINTER LOCATION FOR DIAGNOSTIC NUM                     
C                                                                               
C***********************************************************************        
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *        
C***********************************************************************        
C                                                                               
#include <vrslv.com>                                                            
#include <vstate.com>                                                           
                                                                                
      PARAMETER ( IMJMR   = IMR*(JMR+1) )                                       
      PARAMETER ( NLAYM1R = NLAYR-1     )                                       
                                                                                
      DATA IPOINTER / 1 /                                                       
      DATA IDIAG    / NDIAGT*0 /                                                
                                                                                
C **********************************************************************        
C ****               SET DIAGNOSTIC LEVELS AND NAMES                ****        
C **********************************************************************        
                                                                                
      DATA KDIAG( 1) /  1    /, CDIAG( 1) /'UFLUX   '/                          
      DATA KDIAG( 2) /  1    /, CDIAG( 2) /'VFLUX   '/                          
      DATA KDIAG( 3) /  1    /, CDIAG( 3) /'HFLUX   '/                          
      DATA KDIAG( 4) /  1    /, CDIAG( 4) /'EFLUX   '/                          
      DATA KDIAG( 5) /  1    /, CDIAG( 5) /'QICE    '/                          
      DATA KDIAG( 6) /  1    /, CDIAG( 6) /'RADLWG  '/                          
      DATA KDIAG( 7) /  1    /, CDIAG( 7) /'RADSWG  '/                          
      DATA KDIAG( 8) /NLAYR  /, CDIAG( 8) /'RI      '/                          
      DATA KDIAG( 9) /  1    /, CDIAG( 9) /'CT      '/                          
      DATA KDIAG(10) /  1    /, CDIAG(10) /'CU      '/                          
      DATA KDIAG(11) /NLAYR  /, CDIAG(11) /'ET      '/                          
      DATA KDIAG(12) /NLAYR  /, CDIAG(12) /'EU      '/                          
      DATA KDIAG(13) /NLAYR  /, CDIAG(13) /'TURBU   '/                          
      DATA KDIAG(14) /NLAYR  /, CDIAG(14) /'TURBV   '/                          
      DATA KDIAG(15) /NLAYR  /, CDIAG(15) /'TURBT   '/                          
      DATA KDIAG(16) /NLAYR  /, CDIAG(16) /'TURBQ   '/                          
      DATA KDIAG(17) /NLAYR  /, CDIAG(17) /'MOISTT  '/                          
      DATA KDIAG(18) /NLAYR  /, CDIAG(18) /'MOISTQ  '/                          
      DATA KDIAG(19) /NLAYR  /, CDIAG(19) /'RADLW   '/                          
      DATA KDIAG(20) /NLAYR  /, CDIAG(20) /'RADSW   '/                          
      DATA KDIAG(21) / 1     /, CDIAG(21) /'PREACC  '/                          
      DATA KDIAG(22) / 1     /, CDIAG(22) /'PRECON  '/                          
      DATA KDIAG(23) /NLAYR  /, CDIAG(23) /'TUFLUX  '/                          
      DATA KDIAG(24) /NLAYR  /, CDIAG(24) /'TVFLUX  '/                          
      DATA KDIAG(25) /NLAYR  /, CDIAG(25) /'TTFLUX  '/                          
      DATA KDIAG(26) /NLAYR  /, CDIAG(26) /'TQFLUX  '/                          
      DATA KDIAG(27) / 1     /, CDIAG(27) /'CN      '/                          
      DATA KDIAG(28) / 1     /, CDIAG(28) /'WINDS   '/                          
      DATA KDIAG(29) / 1     /, CDIAG(29) /'DTSRF   '/                          
      DATA KDIAG(30) / 1     /, CDIAG(30) /'TG      '/                          
      DATA KDIAG(31) / 1     /, CDIAG(31) /'TS      '/                          
      DATA KDIAG(32) / 1     /, CDIAG(32) /'DTG     '/                          
      DATA KDIAG(33) / 1     /, CDIAG(33) /'QG      '/                          
      DATA KDIAG(34) / 1     /, CDIAG(34) /'QS      '/                          
      DATA KDIAG(35) / 1     /, CDIAG(35) /'TGRLW   '/                          
      DATA KDIAG(36) / 1     /, CDIAG(36) /'ST4     '/                          
      DATA KDIAG(37) / 1     /, CDIAG(37) /'OLR     '/                          
      DATA KDIAG(38) / 1     /, CDIAG(38) /'OLRCLR  '/                          
      DATA KDIAG(39) / 1     /, CDIAG(39) /'LWGCLR  '/                          
      DATA KDIAG(40) / NLAYR /, CDIAG(40) /'LWCLR   '/                          
      DATA KDIAG(41) / NLAYR /, CDIAG(41) /'TLW     '/                          
      DATA KDIAG(42) / NLAYR /, CDIAG(42) /'SHLW    '/                          
      DATA KDIAG(43) / NLAYR /, CDIAG(43) /'OZLW    '/                          
      DATA KDIAG(44) / NLAYR /, CDIAG(44) /'CLMOLW  '/                          
      DATA KDIAG(45) / NLAYR /, CDIAG(45) /'CLROLW  '/                          
      DATA KDIAG(46) / NLAYR /, CDIAG(46) /'CLMOSW  '/                          
      DATA KDIAG(47) / NLAYR /, CDIAG(47) /'CLROSW  '/                          
      DATA KDIAG(48) / 1     /, CDIAG(48) /'RADSWT  '/                          
      DATA KDIAG(49) / 1     /, CDIAG(49) /'FREQMD  '/                          
      DATA KDIAG(50) / NLAYR /, CDIAG(50) /'FREQPN  '/                          
      DATA KDIAG(51) / 1     /, CDIAG(51) /'FREQLW  '/                          
      DATA KDIAG(52) / 1     /, CDIAG(52) /'EVAP    '/                          
      DATA KDIAG(53) / 1     /, CDIAG(53) /'DPDT    '/                          
      DATA KDIAG(54) / NLAYR /, CDIAG(54) /'ANALU   '/                          
      DATA KDIAG(55) / NLAYR /, CDIAG(55) /'ANALV   '/                          
      DATA KDIAG(56) / NLAYR /, CDIAG(56) /'ANALT   '/                          
      DATA KDIAG(57) / NLAYR /, CDIAG(57) /'ANALQ   '/                          
      DATA KDIAG(58) / NLAYR /, CDIAG(58) /'OMEGA   '/                          
      DATA KDIAG(59) / NLAYR /, CDIAG(59) /'DUDT    '/                          
      DATA KDIAG(60) / NLAYR /, CDIAG(60) /'DVDT    '/                          
      DATA KDIAG(61) / NLAYR /, CDIAG(61) /'DTDT    '/                          
      DATA KDIAG(62) / NLAYR /, CDIAG(62) /'DQDT    '/                          
      DATA KDIAG(63) / NLAYR /, CDIAG(63) /'VORT    '/                          
      DATA KDIAG(64) / NLAYR /, CDIAG(64) /'PGV     '/                          
      DATA KDIAG(65) / NLAYR /, CDIAG(65) /'CORU    '/                          
      DATA KDIAG(66) / NLAYR /, CDIAG(66) /'CORV    '/                          
      DATA KDIAG(67) / 1     /, CDIAG(67) /'USTAR   '/                          
      DATA KDIAG(68) / 1     /, CDIAG(68) /'Z0      '/                          
      DATA KDIAG(69) /NLAYM1R/, CDIAG(69) /'FRQTRB  '/                          
      DATA KDIAG(70) / 1     /, CDIAG(70) /'PBL     '/                          
      DATA KDIAG(71) / NLAYR /, CDIAG(71) /'SWCLR   '/                          
      DATA KDIAG(72) / 1     /, CDIAG(72) /'OSR     '/                          
      DATA KDIAG(73) / 1     /, CDIAG(73) /'OSRCLR  '/                          
      DATA KDIAG(74) / NLAYR /, CDIAG(74) /'CLDMAS  '/                          
      DATA KDIAG(75) / NLAYR /, CDIAG(75) /'UAVE    '/                          
      DATA KDIAG(76) / NLAYR /, CDIAG(76) /'VAVE    '/                          
      DATA KDIAG(77) / NLAYR /, CDIAG(77) /'TAVE    '/                          
      DATA KDIAG(78) / NLAYR /, CDIAG(78) /'QAVE    '/                          
      DATA KDIAG(79) / NLAYR /, CDIAG(79) /'MDIV    '/                          
      DATA KDIAG(80) / 1     /, CDIAG(80) /'PAVE    '/                          
      DATA KDIAG(81) / NLAYR /, CDIAG(81) /'QQAVE   '/                          
      DATA KDIAG(82) / 1     /, CDIAG(82) /'SWGCLR  '/                          
      DATA KDIAG(83) / 1     /, CDIAG(83) /'ANALP   '/                          
      DATA KDIAG(84) / 1     /, CDIAG(84) /'SDIAG1  '/                          
      DATA KDIAG(85) / 1     /, CDIAG(85) /'SDIAG2  '/                          
      DATA KDIAG(86) / NLAYR /, CDIAG(86) /'UDIAG1  '/                          
      DATA KDIAG(87) / NLAYR /, CDIAG(87) /'UDIAG2  '/                          
      DATA KDIAG(88) / NLAYR /, CDIAG(88) /'DIABU   '/                          
      DATA KDIAG(89) / NLAYR /, CDIAG(89) /'DIABV   '/                          
      DATA KDIAG(90) / NLAYR /, CDIAG(90) /'DIABT   '/                          
      DATA KDIAG(91) / NLAYR /, CDIAG(91) /'DIABQ   '/                          
      DATA KDIAG(92) / NLAYR /, CDIAG(92) /'PSIGDOT '/                          
      DATA KDIAG(93) / NLAYR /, CDIAG(93) /'PGU     '/                          
      DATA KDIAG(94) / NLAYR /, CDIAG(94) /'PUFLX   '/                          
      DATA KDIAG(95) / NLAYR /, CDIAG(95) /'PVFLX   '/                          
      DATA KDIAG(96) / NLAYR /, CDIAG(96) /'PTFLX   '/                          
      DATA KDIAG(97) / NLAYR /, CDIAG(97) /'PQFLX   '/                          
      DATA KDIAG(98) / NLAYR /, CDIAG(98) /'DPUDT   '/                          
      DATA KDIAG(99) / NLAYR /, CDIAG(99) /'DPVDT   '/                          
      DATA KDIAG(100)/ NLAYR /, CDIAG(100)/'DPTDT   '/                          
      DATA KDIAG(101)/ NLAYR /, CDIAG(101)/'DPQDT   '/                          
      DATA KDIAG(102)/ 1     /, CDIAG(102)/'VINTUQ  '/                          
      DATA KDIAG(103)/ 1     /, CDIAG(103)/'VINTVQ  '/                          
      DATA KDIAG(104)/ 1     /, CDIAG(104)/'VINTUT  '/                          
      DATA KDIAG(105)/ 1     /, CDIAG(105)/'VINTVT  '/                          
      DATA KDIAG(106)/ 1     /, CDIAG(106)/'CLDFRC  '/                          
      DATA KDIAG(107)/ 1     /, CDIAG(107)/'QINT    '/                          
      DATA KDIAG(108)/ 1     /, CDIAG(108)/'U2M     '/
      DATA KDIAG(109)/ 1     /, CDIAG(109)/'V2M     '/
      DATA KDIAG(110)/ 1     /, CDIAG(110)/'T2M     '/
      DATA KDIAG(111)/ 1     /, CDIAG(111)/'Q2M     '/
      DATA KDIAG(112)/ 1     /, CDIAG(112)/'U10M    '/
      DATA KDIAG(113)/ 1     /, CDIAG(113)/'V10M    '/
      DATA KDIAG(114)/ 1     /, CDIAG(114)/'T10M    '/
      DATA KDIAG(115)/ 1     /, CDIAG(115)/'Q10M    '/
      DATA KDIAG(116)/ NLAYR /, CDIAG(116)/'DTRAIN  '/
      DATA KDIAG(117)/ NLAYR /, CDIAG(117)/'QFILL   '/
                                                                                
      DATA TDIAG( 1)  /'U-MOMENTUM SURFACE STRESS     (N/M**2)  '/
      DATA TDIAG( 2)  /'V-MOMENTUM SURFACE STRESS     (N/M**2)  '/
      DATA TDIAG( 3)  /'SRFCE FLX OF SENSIBLE    HEAT (W/M**2)  '/
      DATA TDIAG( 4)  /'SRFCE FLX OF EVAPORATIVE HEAT (W/M**2)  '/
      DATA TDIAG( 5)  /'HEAT CONDUCTION THRU SEA-ICE  (W/M**2)  '/
      DATA TDIAG( 6)  /'NET UPWARD   LW RAD. AT GRND  (W/M**2)  '/
      DATA TDIAG( 7)  /'NET DOWNWARD SW RAD. AT GRND  (W/M**2)  '/
      DATA TDIAG( 8)  /'RICHARDSON NUMBER                       '/
      DATA TDIAG( 9)  /'SURFACE DRAG COEF. FOR T AND Q (M/S)    '/
      DATA TDIAG(10)  /'SURFACE DRAG COEF. FOR U AND V (M/S)    '/
      DATA TDIAG(11)  /'DIFFUSIVITY  COEF. FOR T AND Q (M**2/S) '/
      DATA TDIAG(12)  /'DIFFUSIVITY  COEF. FOR U AND V (M**2/S) '/
      DATA TDIAG(13)  /'U-MOMENTUM  CHNGS DUE TO TURB (M/S/DAY) '/
      DATA TDIAG(14)  /'V-MOMENTUM  CHNGS DUE TO TURB (M/S/DAY) '/
      DATA TDIAG(15)  /'TEMPERATURE CHNGS DUE TO TURB (DEG/DAY) '/
      DATA TDIAG(16)  /'MOISTURE    CHNGS DUE TO TURB (G/KG/DAY)'/
      DATA TDIAG(17)  /'TEMPERATURE CHNGS DUE TO MOIST (DEG/DAY)'/
      DATA TDIAG(18)  /'MOISTURE CHANGES DUE TO MOIST (G/KG/DAY)'/
      DATA TDIAG(19)  /'TEMPERATURE CHNGS DUE TO LW RAD  DEG/DAY'/
      DATA TDIAG(20)  /'TEMPERATURE CHNGS DUE TO SW RAD  DEG/DAY'/
      DATA TDIAG(21)  /'TOTAL PRECIPITATION       (MM/DAY)      '/
      DATA TDIAG(22)  /'CONVECTIVE PRECIPITATION  (MM/DAY)      '/
      DATA TDIAG(23)  /'TURBULENT FLUX OF U-MOMENTUM (N/M**2)   '/
      DATA TDIAG(24)  /'TURBULENT FLUX OF V-MOMENTUM (N/M**2)   '/
      DATA TDIAG(25)  /'TURBULENT FLUX OF SENS.  HEAT (W/M**2)  '/
      DATA TDIAG(26)  /'TURBULENT FLUX OF LATENT HEAT (W/M**2)  '/
      DATA TDIAG(27)  /'NEUTRAL DRAG COEFFICIENT   (M/S)        '/
      DATA TDIAG(28)  /'SURFACE WIND SPEED         (M/S)        '/
      DATA TDIAG(29)  /'AIR/SURFACE VIRTUAL TEMP. DIFF.  (DEG)  '/
      DATA TDIAG(30)  /'GROUND TEMPERATURE            (DEG)     '/
      DATA TDIAG(31)  /'SURFACE AIR TEMPERATURE       (DEG)     '/
      DATA TDIAG(32)  /'GROUND TEMPERATURE ADJUSTMENT (DEG)     '/
      DATA TDIAG(33)  /'GROUND SPECIFIC HUMIDITY      (G/KG)    '/
      DATA TDIAG(34)  /'SATURATION SURFACE SPEC. HUM. (G/KG)    '/
      DATA TDIAG(35)  /'GROUND TEMP SEEN BY LONGWAVE RAD  (DEG) '/
      DATA TDIAG(36)  /'SIGMA T**4                    (W/M**2)  '/
      DATA TDIAG(37)  /'OUTGOING LONGWAVE RADIATION   (W/M**2)  '/
      DATA TDIAG(38)  /'OUTGOING LONGWAVE RAD CLEAR SKY (W/M**2)'/
      DATA TDIAG(39)  /'SURFACE LONGWAVE FLUX CLEAR SKY (W/M**2)'/
      DATA TDIAG(40)  /'CLEAR SKY LW HEATING RATES   (DEG/DAY)  '/
      DATA TDIAG(41)  /'TEMPERATURE SEEN BY LONGWAVE RAD   (DEG)'/
      DATA TDIAG(42)  /'SPEC. HUM.  SEEN BY LONGWAVE RAD (G/G)  '/
      DATA TDIAG(43)  /'OZONE SEEN BY LONGWAVE RAD              '/
      DATA TDIAG(44)  /'MAXIMUM OVERLAP CLOUD FRACTION FOR LW   '/
      DATA TDIAG(45)  /'RANDOM  OVERLAP CLOUD FRACTION FOR LW   '/
      DATA TDIAG(46)  /'MAXIMUM OVERLAP CLOUD FRACTION FOR SW   '/
      DATA TDIAG(47)  /'RANDOM  OVERLAP CLOUD FRACTION FOR SW   '/
      DATA TDIAG(48)  /'INCIDENT SW RAD. AT TOP OF ATM. (W/M**2)'/
      DATA TDIAG(49)  /'FREQUENCY OF MID-LEVEL CONVECTION       '/
      DATA TDIAG(50)  /'FREQUENCY OF PEN-LEVEL CONVECTION       '/
      DATA TDIAG(51)  /'FREQUENCY OF LOW-LEVEL CONVECTION       '/
      DATA TDIAG(52)  /'SURFACE EVAPORATION  (MM/DAY)           '/
      DATA TDIAG(53)  /'SURFACE PRESSURE TENDENCY  (MB/DAY)     '/
      DATA TDIAG(54)  /'ANALYSIS INCREMENT OF U-WIND  (M/S/SEC) '/
      DATA TDIAG(55)  /'ANALYSIS INCREMENT OF V-WIND  (M/S/SEC) '/
      DATA TDIAG(56)  /'ANALYSIS INCREMENT OF THETA (PI*TH/SEC) '/
      DATA TDIAG(57)  /'ANALYSIS INCREMENT OF SPHU  (PI*SH/SEC) '/
      DATA TDIAG(58)  /'VERTICAL VELOCITY OMEGA   (MB/DAY)      '/
      DATA TDIAG(59)  /'TOTAL PU TENDENCY   (M/S/DAY)           '/
      DATA TDIAG(60)  /'TOTAL PV TENDENCY   (M/S/DAY)           '/
      DATA TDIAG(61)  /'TOTAL PT TENDENCY   (DEG/DAY)           '/
      DATA TDIAG(62)  /'TOTAL PQ TENDENCY  (G/KG/DAY)           '/
      DATA TDIAG(63)  /'RELATIVE VORTICITY * 10**-4   (SEC**-1) '/
      DATA TDIAG(64)  /'V PRESSURE GRADIENT TENDENCY  (M/S/DAY) '/
      DATA TDIAG(65)  /'U CORIOLIS TENDENCY           (M/S/DAY) '/
      DATA TDIAG(66)  /'V CORIOLIS TENDENCY           (M/S/DAY) '/
      DATA TDIAG(67)  /'USTAR    (M/SEC)                        '/
      DATA TDIAG(68)  /'SURFACE ROUGHNESS Z0   (M)              '/
      DATA TDIAG(69)  /'FREQUENCY OF TURBULENCE   (0-1)         '/
      DATA TDIAG(70)  /'PBL DEPTH (MB)                          '/
      DATA TDIAG(71)  /'CLEAR SKY SW HEATING RATES   (DEG/DAY)  '/
      DATA TDIAG(72)  /'OUTGOING SHORTWAVE RADIATION  (W/M**2)  '/
      DATA TDIAG(73)  /'OUTGOING SHORTWAVE RAD CLEAR  (W/M**2)  '/
      DATA TDIAG(74)  /'CLOUD MASS FLUX  (KG M/SEC)             '/
      DATA TDIAG(75)  /'TIME-AVERAGED UWND    (M/SEC)           '/
      DATA TDIAG(76)  /'TIME-AVERAGED VWND    (M/SEC)           '/
      DATA TDIAG(77)  /'TIME-AVERAGED TMPU    (DEG)             '/
      DATA TDIAG(78)  /'TIME-AVERAGED SPHU    (G/G)             '/
      DATA TDIAG(79)  /'MASS FLUX DIVERGENCE  (MB/DAY)          '/
      DATA TDIAG(80)  /'TIME-AVERAGED PS-PTOP (MB)              '/
      DATA TDIAG(81)  /'TIME-AVERAGED QQ      (M/SEC)**2        '/
!      DATA TDIAG(82)  /'NET DWNWRD SWRAD AT GRND CLRSKY (W/M**2)'/
      DATA TDIAG(82)  /'SURF. SHORTWAVE FLUX CLEAR SKY (W/M**2) '/
      DATA TDIAG(83)  /'ANALYSIS INCREMENT OF PSURF    (MB/SEC) '/
      DATA TDIAG(84)  /'USER-DEFINED SURFACE DIAGNOSTIC-1       '/
      DATA TDIAG(85)  /'USER-DEFINED SURFACE DIAGNOSTIC-2       '/
      DATA TDIAG(86)  /'USER-DEFINED UPPER-AIR DIAGNOSTIC-1     '/
      DATA TDIAG(87)  /'USER-DEFINED UPPER-AIR DIAGNOSTIC-2     '/
      DATA TDIAG(88)  /'TOT DIABATIC FORCING ON U-WIND (M/S/DAY)'/
      DATA TDIAG(89)  /'TOT DIABATIC FORCING ON V-WIND (M/S/DAY)'/
      DATA TDIAG(90)  /'TOT DIABATIC FORCING ON TMPU   (DEG/DAY)'/
      DATA TDIAG(91)  /'TOT DIABATIC FORCING ON SPHU  (G/KG/DAY)'/
      DATA TDIAG(92)  /'VRT SIGMA VELCTY PI*D(SIGMA)/DT (MB/DAY)'/
      DATA TDIAG(93)  /'M/S/DAY  U PRESSURE GRAD TEND   (A-GRID)'/
      DATA TDIAG(94)  /'M/S/DAY  3-D FLUX CONVERG OF PU (A-GRID)'/
      DATA TDIAG(95)  /'M/S/DAY  3-D FLUX CONVERG OF PV (A-GRID)'/
      DATA TDIAG(96)  /'DEG/DAY  3-D FLUX CONVERG OF PT (A-GRID)'/
      DATA TDIAG(97)  /'G/KG/DAY 3-D FLUX CONVERG OF PQ (A-GRID)'/
      DATA TDIAG(98)  /'M/S/DAY  TOTAL PU TENDENCY      (A-GRID)'/
      DATA TDIAG(99)  /'M/S/DAY  TOTAL PV TENDENCY      (A-GRID)'/
      DATA TDIAG(100) /'DEG/DAY  TOTAL PT TENDENCY      (A-GRID)'/
      DATA TDIAG(101) /'G/KG/DAY  TOTAL PQ TENDENCY     (A-GRID)'/
      DATA TDIAG(102) /'VERTICALLY INTEGRATED U*Q   (M/SEC G/KG)'/
      DATA TDIAG(103) /'VERTICALLY INTEGRATED V*Q   (M/SEC G/KG)'/
      DATA TDIAG(104) /'VERTICALLY INTEGRATED U*T   (M/SEC  DEG)'/
      DATA TDIAG(105) /'VERTICALLY INTEGRATED V*T   (M/SEC  DEG)'/
      DATA TDIAG(106) /'2-DIMENSIONAL TOTAL CLOUD FRACTION (0-1)'/
      DATA TDIAG(107) /'PRECIPITABLE WATER   (GM/CM**2)         '/
      DATA TDIAG(108) /'U AT  2 METERS (M/SEC)                  '/
      DATA TDIAG(109) /'V AT  2 METERS (M/SEC)                  '/
      DATA TDIAG(110) /'T AT  2 METERS (DEG)                    '/
      DATA TDIAG(111) /'Q AT  2 METERS (KG/KG)                  '/
      DATA TDIAG(112) /'U AT 10 METERS (M/SEC)                  '/
      DATA TDIAG(113) /'V AT 10 METERS (M/SEC)                  '/
      DATA TDIAG(114) /'T AT 10 METERS (DEG)                    '/
      DATA TDIAG(115) /'Q AT 10 METERS (KG/KG)                  '/
      DATA TDIAG(116) /'CONVECTIVE CLOUD DETRAINMENT  (KG M/S)  '/
      DATA TDIAG(117) /'FILLING OF NEGATIVE SPHU      (G/KG/DAY)'/

C **********************************************************************        
C ****                SET POINTERS FOR DIAGNOSTIC NUM               ****        
C **********************************************************************        
                                                                                
      IF( IDIAG(NUM).EQ.0 ) THEN                                                
      ISPAN = IPOINTER + KDIAG(NUM) - 1                                         
        IF (ISPAN.GT.NDIAGMX) THEN                                              
            WRITE(6,1000) KDIAG(NUM), NUM, CDIAG(NUM)                           
        ELSE                                                                    
            IDIAG(NUM) = IPOINTER                                               
            IPOINTER   = IPOINTER + KDIAG(NUM)                                  
            ISPACE     = NDIAGMX  - IPOINTER + 1                                
            WRITE(6,2000) KDIAG(NUM), NUM, CDIAG(NUM), ISPACE                   
        ENDIF                                                                   
      ELSE                                                                      
            WRITE(6,3000) NUM, CDIAG(NUM)                                       
      ENDIF                                                                     
      RETURN                                                                    
                                                                                
C **********************************************************************        
C ****                ZAP POINTERS FOR DIAGNOSTIC NUM               ****        
C **********************************************************************        
                                                                                
      ENTRY ZAPDIAG (NUM)                                                       
                                                                                
      IF( IDIAG(NUM).NE.0 ) THEN                                                
          DO 10 L=IDIAG(NUM)+KDIAG(NUM),IPOINTER-1                              
          DO 10 I=1,IMJMR                                                       
          QDIAG(I,1,L-KDIAG(NUM)) = QDIAG(I,1,L)                                
   10     CONTINUE                                                              
                                                                                
          DO 20 N=1,NDIAGT                                                      
          IF ( IDIAG(N).GT.IDIAG(NUM) ) IDIAG(N) = IDIAG(N) - KDIAG(NUM)        
   20     CONTINUE                                                              
                                                                                
          IDIAG(NUM) = 0                                                        
          NDIAG(NUM) = 0                                                        
          IPOINTER   = IPOINTER - KDIAG(NUM)                                    
      ENDIF                                                                     
      WRITE(6,4000) NUM, CDIAG(NUM)                                             
      RETURN                                                                    
                                                                                
C **********************************************************************        
                                                                                
 1000 FORMAT(1X,'NO SPACE LEFT FOR ',I2,' LEVEL(S) OF DIAGNOSTIC # ',           
     .       I3,' (',A8,')')                                                    
 2000 FORMAT(1X,'ALLOCATING ',I2,' LEVEL(S) FOR DIAGNOSTIC # ',I3,              
     .          ' (',A8,'),  ',I3,' SLOTS REMAIN')                              
 3000 FORMAT(1X,'DIAGNOSTIC # ',I3,' (',A8,') HAS ALREADY BEEN SET')            
 4000 FORMAT(1X,'DIAGNOSTIC # ',I3,' (',A8,') HAS BEEN ZAPPED')                 
      END                                                                       
