      SUBROUTINE ctoaset (n)                                            
C***********************************************************************
C  PURPOSE                                                              
C     Converts C-Grid data to A-Grid data                               
C  ARGUMENTS   DESCRIPTION                                              
C     N ........ Current Time Index                                     
C                                                                       
C***********************************************************************
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *
C***********************************************************************
                                                                        
#include <vrslv.com>                                                    
#include <vstate.com>                                                   
                                                                        
      dimension utmp(imr,jmr+1,nlayr)                                   
      dimension vtmp(imr,jmr+1,nlayr)                                   
                                                                        
C **********************************************************************
C ****                      CONVERT TO A-GRID                       ****
C **********************************************************************
                                                                        
      do l=1,nlayr                                                      
      call polewnd ( uz(1,1,L,n),vz(1,1,L,n),                           
     .               utmp(1,1,L),vtmp(1,1,L),imr,jmr+1)                 
      enddo                                                             
                                                                        
      call ctoa ( phisz      , phisz      , imr,jmr+1,1    ,0 )         
      call ctoa ( pz(1,1,  n), pz(1,1,  n), imr,jmr+1,1    ,0 )         
      call ctoa ( utmp(1,1,1), uz(1,1,1,n), imr,jmr+1,nlayr,1 )         
      call ctoa ( vtmp(1,1,1), vz(1,1,1,n), imr,jmr+1,nlayr,2 )         
      call ctoa ( tz(1,1,1,n), tz(1,1,1,n), imr,jmr+1,nlayr,0 )         
      call ctoa ( qz(1,1,1,n), qz(1,1,1,n), imr,jmr+1,nlayr,0 )         
      call ctoa ( pkht(1,1,1), pkht(1,1,1), imr,jmr+1,nlayr,0 )         
                                                                        
      return                                                            
      end                                                               
