      subroutine dd_write(dd_unit, grads_dsn, title, rmiss, im, jnp, 
     .                    nplevs_kept, plevs_kept, 
     .                    first_date, first_time, inchms, ntimes,
     .                    nvars_kept, kept_var, level_var, descr_var,
     .                    template)

      real plevs_kept(nplevs_kept)
      integer level_var(nvars_kept)
      integer nvars_kept
      integer nplevs_kept
      integer ntimes
      integer dd_unit
      integer first_date
      integer first_time
      integer timinc
      character*8 kept_var(nvars_kept)
      character*40 title
      character*80 grads_dsn
      character*3 cmonth(12)
      character*2 cdd, chh, cmm, cuu
      character*2 timkey
      character*40 descr_var(nvars_kept)
      logical template

      data cmonth /'JAN','FEB','MAR','APR','MAY','JUN',
     .             'JUL','AUG','SEP','OCT','NOV','DEC'/

      ihh=first_time/10000
      iuu=mod(first_time/100,100)
      iyy=first_date/10000
      imm=mod(first_date/100,100)
      idd=mod(first_date,100)
      write(chh,'(i2.2)') ihh
      write(cuu,'(i2.2)') iuu
      write(cmm,'(i2.2)') imm
      write(cdd,'(i2.2)') idd

      write(dd_unit,3001) grads_dsn
 3001 format('DSET ',a80)

      if ( template ) then
         write(dd_unit,3011)
 3011    format('OPTIONS template')
      end if

      write(dd_unit,3002) title
 3002 format('TITLE ',a40)

      write(dd_unit,3003) rmiss
 3003 format('UNDEF ',g13.5)

      dlon=360./real(im)
      dlat=180./real(jnp-1)

      write(dd_unit,3004) im, dlon
 3004 format('XDEF ', i4,  ' LINEAR -180.0',  f7.4)

      write(dd_unit,3005) jnp, dlat
 3005 format('YDEF ', i4,  ' LINEAR -90.0',  f7.4)

      write(dd_unit,3006) 
     .                     nplevs_kept,(plevs_kept(l),l=1,nplevs_kept)
 3006 format('ZDEF ',i4,' LEVELS ',6f9.3,/,(17x,6f9.3))

      inchh=inchms/10000
      incuu=mod(inchms/100,100)
!!!   incss=mod(inchms,100)
      if (incuu.ne.0) then
         timinc=incuu+60*inchh
         timkey='MN'
      else
         timinc=inchh
         timkey='HR'
      end if
      write(dd_unit,3007) ntimes, 
     .                  ihh,cuu,cdd,cmonth(imm),iyy,timinc,timkey
 3007 format('TDEF ', i4, ' LINEAR ', i2,':',a2,'Z',a2,a3,'19',i2,
     .       ' ',i2,a2)

      write(dd_unit,3008) nvars_kept
 3008 format('VARS ',i4)

      do n=1,nvars_kept
         write(dd_unit,3009) kept_var(n), level_var(n), descr_var(n)
 3009    format(a8,i3,' 99 ',a40)
      end do

      write(dd_unit,3010)
 3010 format('ENDVARS')

      end
