\section{Makefile}

@d resolution @{
#RESOLUTION=RES2x2x46
#ANALYSIS_LEVEL=18

RESOLUTION=RES4x5x20
ANALYSIS_LEVEL=14

#RESOLUTION=RES2x2x20
#RESOLUTION=RES4x5x46

GCM_LIBRARY=gcm/libgcm_${RESOLUTION}.a OI_LIBRARY=oi/libloadlib.a

@}


\subsection{Cray}

@O makefile.dir/Makefile.cray -t @{

@}

\subsection{Alpha}

@O makefile.dir/Makefile.alpha -t @{

@}

\subsection{RS6000}

@O makefile.dir/Makefile.RS6000 @{ 
VERSION=rs6000 
MACHINE=RS6000 
CPP= 
F77 = xlf 
F90 = xlf90 
AR = ar crv 
LINK = $(F77)
CPPFLAGS=-WF,-D$(MACHINE),-D$(RESOLUTION),-Icom 
FFLAGS=-q fixed=132 -q source $(CPPFLAGS) 
OPTIMIZE=-03 -qtune=pwr2
@}

@O Makefile.RS6000 -t @{

@< resolution @>

include makefile/Makefile.$(MACHINE)
LAPACK_LIBRARY=/usr/npac/lib/math/liblapack.a -lblas

NOTUSED = testmvp.o satwnd.o 
LIBLAPACK =  /usr/npac/lib/math/liblapack.a -lblas

LIBRARIES= $(GCM_LIBRARY) $(OI_LIBRARY) $(LAPACK_LIBRARY) missing/libmissing.a

#MAINPRG=write_oneoi.f
#MAINPRG=oneoi.f

MAINPRG=read_oneoi.f

OI_DIR=oi_$(VERSION) 
GCM_DIR=gcm

unpack:
	nuweb makefile/makefile.w

run:
	-ln -s $(OI_DIR) oi 
	qsub scripts/gregor.job

	
compile:
	cd $(OI_DIR) ; make -f Makefile
	cd $(GCM_DIR); make RESOLUTION=$(RESOLUTION) -f Makefile
#	cd LAPACK; make -f Makefile
	cd missing; make -f Makefile

main:
	-rm user_routines.F
	-rm com/oirslv.com 
	cat applications/io_unformatted.f  >> user_routines.F
	cat applications/${MAINPRG}        >> user_routines.F
	cat applications/iauout.f          >> user_routines.F
	cat oi/glassim.F         >> user_routines.F
	cd com; ln -s oirslv${ANALYSIS_LEVEL}.com oirslv.com 
	$(F77) $(FFLAGS) -Icom $(LIBRARIES) -o oneoi.x user_routines.F 
@< info @>
@< clean @>
@}


@d info @{
info:
	@@clear
	@@echo ============================================================
	@@echo
	@@-qstat -a | fgrep syg0v 
	@@echo
	@@echo ============================================================
	@@echo
	@@-qstat -a bug60 
	@@echo
	@@echo ============================================================
	@@echo
	@@-qstat -a bug120 
	@@echo
	@@echo ============================================================

view:
	more 0OUTPUT/xoneoi.out
@}

@d clean @{
clean:
	-\rm */*.o 
	-\rm */*.l
	-\rm */*.a

@}