

      SUBROUTINE GETCONOI

!      implicit none

      CHARACTER*8       CONNAME
!     REAL              HCON
      INTEGER           ICON
      LOGICAL           LCON

      include "physic.h"

      COMMON /CONST/    SIGE(20),DLAT,  DLON,   PI,     PI180,  PTOP,
     $                  PINT,   GI,     OMG2RE, RADEI,  RADEI2, GRADEI,
     $                  GRADEI2,G2,     POLEFAC,RTD,    POLELAT

      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FSOAR,   FLOW,
     $                  SIGDAT,  MAXREP
      LOGICAL           STRAT,   SLP,     FDCOS,   FSOAR,   FLOW,
     $                  SIGDAT

      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1

      COMMON /SATWIND/  CWIND
      LOGICAL           CWIND

      COMMON /SCAN/     MAXOBS, RSCAN, ONESTAGE
      REAL              RSCAN
      LOGICAL           ONESTAGE

      
      common /sparam/ volcenter_x(13104),
     &                volcenter_y(13104), 
     &                glatup(13104),
     &                glonup(13104),
     &                nh(13104),
     &                kq(3), 
     &                lsolve, ns, nr, nv,  nq, ngv


      COMMON /TYPFUNC/  IFDCOS, IFSOAR



!  ENTRY GETCONH FOR REAL CONSTANTS
      ENTRY GETCONH( CONNAME, HCON )
           IF( CONNAME.EQ.'BETA    ' ) THEN
         HCON = BETA
      ELSE IF( CONNAME.EQ.'CP      ' ) THEN
         HCON = CP
      ELSE IF( CONNAME.EQ.'GRAV    ' ) THEN
         HCON = GRAV
      ELSE IF( CONNAME.EQ.'OMEGA2  ' ) THEN
         HCON = OMEGA2
      ELSE IF( CONNAME.EQ.'RADE    ' ) THEN
         HCON = RADE
      ELSE IF( CONNAME.EQ.'RGAS    ' ) THEN
         HCON = RGAS
      ELSE IF( CONNAME.EQ.'ROCP    ' ) THEN
         HCON = ROCP
      ELSE IF( CONNAME.EQ.'CPOG    ' ) THEN
         HCON = CPOG
      ELSE IF( CONNAME.EQ.'GAMMA   ' ) THEN
         HCON = GAMMA
      ELSE IF( CONNAME.EQ.'ROCP1   ' ) THEN
         HCON = ROCP1
      ELSE IF( CONNAME.EQ.'GOCP    ' ) THEN
         HCON = GOCP
      ELSE IF( CONNAME.EQ.'DLAT    ' ) THEN
         HCON = DLAT
      ELSE IF( CONNAME.EQ.'DLON    ' ) THEN
         HCON = DLON
      ELSE IF( CONNAME.EQ.'PI      ' ) THEN
         HCON = PI
      ELSE IF( CONNAME.EQ.'PI180   ' ) THEN
         HCON = PI180
      ELSE IF( CONNAME.EQ.'PTOP    ' ) THEN
         HCON = PTOP
      ELSE IF( CONNAME.EQ.'PINT    ' ) THEN
         HCON = PINT
      ELSE IF( CONNAME.EQ.'RADEI   ' ) THEN
         HCON = RADEI
      ELSE IF( CONNAME.EQ.'RADEI2  ' ) THEN
         HCON = RADEI2
      ELSE IF( CONNAME.EQ.'GRADEI  ' ) THEN
         HCON = GRADEI
      ELSE IF( CONNAME.EQ.'GRADEI2 ' ) THEN
         HCON = GRADEI2
      ELSE IF( CONNAME.EQ.'G2      ' ) THEN
         HCON = G2
      ELSE IF( CONNAME.EQ.'RTD     ' ) THEN
         HCON = RTD
      ELSE IF( CONNAME.EQ.'RHOBAR  ' ) THEN
         HCON = 1.24
      ELSE IF( CONNAME.EQ.'RSCAN   ' ) THEN
         HCON = RSCAN
      ELSE
         WRITE(6,901) CONNAME
         call flash ( 5,"GETCON: Failure to find desired constant. ",1 )
      ENDIF
      RETURN

!  ENTRY GETCONL FOR LOGICAL CONSTANTS
      ENTRY GETCONL( CONNAME, LCON )
           IF( CONNAME.EQ.'STRAT   ' ) THEN
         LCON = STRAT
      ELSE IF( CONNAME.EQ.'SLP     ' ) THEN
         LCON = SLP
      ELSE IF( CONNAME.EQ.'FDCOS   ' ) THEN
         LCON = FDCOS
      ELSE IF( CONNAME.EQ.'FSOAR   ' ) THEN
         LCON = FSOAR
      ELSE IF( CONNAME.EQ.'FLOW    ' ) THEN
         LCON = FLOW
      ELSE IF( CONNAME.EQ.'SIGDAT  ' ) THEN
         LCON = SIGDAT
      ELSE IF( CONNAME.EQ.'ONESTAGE' ) THEN
         LCON = ONESTAGE
      ELSE IF( CONNAME.EQ.'CWIND   ' ) THEN
         LCON = CWIND
      ELSE
         WRITE(6,902) CONNAME
         call flash ( 5,"GETCON: Failure to find desired constant. ",1 )
      ENDIF
      RETURN

!  ENTRY GETCONI FOR INTEGER CONSTANTS
      ENTRY GETCONI( CONNAME, ICON )
           IF( CONNAME.EQ.'IM      ' ) THEN
         ICON = IM
      ELSE IF( CONNAME.EQ.'JNP     ' ) THEN
         ICON = JNP
      ELSE IF( CONNAME.EQ.'NYMD    ' ) THEN
         ICON = NYMD
      ELSE IF( CONNAME.EQ.'NHMS    ' ) THEN
         ICON = NHMS
      ELSE IF( CONNAME.EQ.'IDIMEN  ' ) THEN
         ICON = IDIMEN
      ELSE IF( CONNAME.EQ.'MAXREP  ' ) THEN
         ICON = MAXREP
      ELSE IF( CONNAME.EQ.'MAXOBS  ' ) THEN
         ICON = MAXOBS
      ELSE IF( CONNAME.EQ.'MLEV    ' ) THEN
         ICON = MLEV
      ELSE IF( CONNAME.EQ.'IFDCOS  ' ) THEN
         ICON = IFDCOS
      ELSE IF( CONNAME.EQ.'IFSOAR  ' ) THEN
         ICON = IFSOAR
      ELSE IF( CONNAME.EQ.'LSOLVE  ' ) THEN
         ICON = LSOLVE
      ELSE IF( CONNAME.EQ.'NS      ' ) THEN
         ICON = NS
      ELSE IF( CONNAME.EQ.'NR      ' ) THEN
         ICON = NR
      ELSE IF( CONNAME.EQ.'NV      ' ) THEN
         ICON = NV
      ELSE IF( CONNAME.EQ.'NQ      ' ) THEN
         ICON = NQ
      ELSE IF( CONNAME.EQ.'KQ(1)   ' ) THEN
         ICON = KQ(1)
      ELSE IF( CONNAME.EQ.'KQ(2)   ' ) THEN
         ICON = KQ(2)
      ELSE IF( CONNAME.EQ.'KQ(3)   ' ) THEN
         ICON = KQ(3)
      ELSE IF( CONNAME.EQ.'MAXNHGP ' ) THEN
         ICON = 288
      ELSE
         WRITE(6,903) CONNAME
         call flash( 5,"GETCON: Failure to find desired constant. ",1 )
      ENDIF
      RETURN

  901 FORMAT(' GETCONH: CANNOT FIND REAL CONSTANT -  ',A8)
  902 FORMAT(' GETCONL: CANNOT FIND LOGICAL CONSTANT - ',A8)
  903 FORMAT(' GETCONI: CANNOT FIND INTEGER CONSTANT - ',A8)
      END

