C   --------------------------------------------------------------------
                                                                        
            SUBROUTINE CHKTWIND (INTIME,IWINDOW,CENTR,LBOUND,RBOUND)    
C                                                                       
C    ------------------------------                                     
C    |  CHECK   TIME WINDOW       |                                     
C    ------------------------------                                     
C                                                                       
C  INPUT:     INTIME   - CENTRAL TIME OF WINDOW (HHMMSS)                
C             IWINDOW  - SIZE OF WINDOW  ( HHMMSS)                      
C   OUTPUT:   CENTR   -  CENTRAL TIME  |                                
C             LBOUND  -  LEFT BOUND    | OF TIME WINDOW (IN MINUTES)    
C             RBOUND  -  RIGHT BOUND   |                                
C                                                                       
C         IF TIME WINDOW IS NOT BETWEEN (0,6)  OR                       
C            TIME WINDOW IS NOT INSIDE (21,21) -->                      
C             ISSUE ERROR MESSAGE AND STOP                              
C                                                                       
         REAL LBOUND,RBOUND                                             
                                                                        
         IF (IWINDOW .LE.0 .OR. IWINDOW .GT.60000) THEN                 
            PRINT *, 'RDUCONV:  WRONG LENGTH OF TIME WINDOW'            
            PRINT *, ' TIME WINDOW EXPECTED TO BE BETWEEN 0 AND 6 HOURS'
            PRINT *, '        ASKING ABOUT TIME WINDOW =', IWINDOW      
                                                                        
            STOP                                                        
         ENDIF                                                          
C                                                                       
         IF (INTIME .GT.210000) THEN                                    
                CENTR=TMINUT(INTIME) -1440.0                            
              ELSE                                                      
                CENTR=TMINUT (INTIME)                                   
         ENDIF                                                          
            WINDOW = TMINUT (IWINDOW)                                   
                                                                        
            LBOUND = CENTR - WINDOW /2.0                                
            RBOUND = CENTR + WINDOW /2.0                                
                                                                        
                                                                        
            IF  (LBOUND .LT. -180.0 .OR. RBOUND .GT. 1260) THEN         
              PRINT *,'RDDATA UCONV: TIME WINDOW IS WRONG   '           
              PRINT *,'TIME WINDOW EXPECTED TO BE INSIDE (21,21)'       
              PRINT *,'CENTRAL TIME  = ', INTIME                        
              PRINT *,'TIME WINDOW   = ', IWINDOW                       
C             MESSAGE = 'RDDATA UCONV: TIME WINDOW IS WRONG   '         
C             CALL FLASH( 5,MESSAGE,1 )                                 
            STOP                                                        
            ENDIF                                                       
      RETURN                                                            
      END                                                               
