                                                                        
         SUBROUTINE DAPROF (PA)                                         
C  EXTRACTS (P, T)-PROFILE FROM LAYER MEAN TEMPERATURE DATA             
C  PROFILE RETURNED IN /INPRO/                                          
C  PA = BOTTOM-MOST PRESSURE (RETURNED)                                 
C     INTEGER PE(16)                                                    
          REAL PE(16)                                                   
         DATA    PE    /1000., 850., 700., 500., 400., 300., 200.,      
     *    100., 70., 50., 30., 10., 5., 2., 1.,0.4/                     
C     DATA    PE    /10000, 8500, 7000, 5000, 4000, 3000, 2000,         
C    *    1000, 700, 500, 300, 100, 50, 20, 10, 4/                      
C  --EDGE PRESSURES USED FOR LAYERS                                     
       COMMON /INPRO/ NX, PBAR(15), TBAR(15)                            
        COMMON /PIECE/  NXX,PP1(15),                                    
     *    PP2(15),TDATA(15)                                             
C        REAL PP1(15),PP2(15),TDATA(15)                                 
         INTEGER  NXX                                                   
C          DATA NXX /14/                                                
C          DATA    PP1   /1000., 850., 700., 500., 400., 300., 200.,    
C           DATA    PP1   / 850., 700., 500., 400., 300., 200.,         
C    *    100., 70., 50., 30., 10., 5., 2., 1.,0./                      
C          DATA    PP2   / 850., 700., 500., 400., 300., 200.,          
C         DATA    PP2   /  700., 500., 400., 300., 200.,                
C    *    100., 70., 50., 30., 10., 5., 2., 1.,0.4,0./                  
C         DATA   TDATA  / 264., 258., 248., 235., 222., 207.,           
C         DATA   TDATA  / 264., 258., 248., 235., 222., 207.,           
C    *    198.,194., 195.,196.,209.,232., 262.,281., 273/               
         REAL PMID(15), KAPPA                                           
         DATA           KAPPA/.28563/                                   
          DATA JUMP/0/                                                  
C  --KAPPA = R/CP                                                       
C  * * *                                                                
C  COLLIN'S MID-PRESSURE FORMULA                                        
          PP(P1, P2) =                                                  
     *    ((P1**KAPPA - P2**KAPPA)/ALOG(P1/P2)/KAPPA)**(1/KAPPA)        
C INTEGER CONVERSION (FOR MATCHING PRESSURES)                           
         IC(P) = 10*P + 0.5                                             
C  * * *                                                                
C         SUBROUTINE SETUP0                                             
C  PRELIMINARY CALCULATIONS FOR LASER THICKNESSES                       
         IF (JUMP .EQ. 1) GO TO 12                                      
C  PRELIMARY COMPUTATIONS IN SUBR. DAPROF--                             
C        CALL SETUP1                                                    
C       ENTRY SETUP1                                                    
C  PRELIMINARY COMPUTATION OF MID-PRESSURES OF THE STANDARD LAYERS      
C  TO BE CALLED ONCE ONLY                                               
         IF (JUMP .EQ. 1) GO TO 12                                      
         DO 9 L = 1, 15                                                 
C        PMID(L) = PP (0.1*PE(L), 0.1*PE(L+1))                          
         PMID(L) = PP (PE(L), PE(L+1))                                  
 9       CONTINUE                                                       
            JUMP = 1                                                    
                                                                        
C  COMPUTE MIDPRESSURE OF FIRST LAYER                                   
 12      CONTINUE                                                       
         PBAR(1) = PP(PP1(1), PP2(1))                                   
        TBAR(1) = TDATA(1)                                              
C  HOLD LOWERMOST PRESSURE--                                            
         PA = PP1(1)                                                    
        IF (NXX .EQ. 1) RETURN                                          
C  TREATMENT OF LAYERS ABOVE THE FIRST                                  
         L2 = 1                                                         
         DO 8 L = 2, NXX                                                
 1       CONTINUE                                                       
         IF (L2 .EQ. 15) GO TO 4                                        
         L2 = L2 + 1                                                    
C  MATCH L-TH DATA LAYER WITH L2-TH STANDARD LAYER--                    
C  LOWER EDGE FIRST--                                                   
           IF (PP1(L) .NE. PE(L2)) GO TO 1                              
C  LOWER EDGE MATCHES. CHECK UPPER EDGE--                               
          IF (PP2(L) .EQ. PE(L2+1)) GO TO 7                             
C  UPPER EDGE DOES NOT MATCH (LAYER NOT STANDARD)                       
         PRINT 2, L, PP1(L), PP2(L), L2, PE(L2), PE(L2+1)               
 2      FORMAT (' MISMATCH--', I5, 2F10.2, I5, 2I10)                    
         PRINT 3, L, PP1(L), PP2(L)                                     
 3       FORMAT ('         --', I5, 2Z10)                               
C    ZDES ZAMENA L2 NA L   (V PBAR( ) I TBAR( ) )                       
        PBAR(L) = PP (PP1(L), PP2(L))                                   
        TBAR(L) = TDATA(L)                                              
         GO TO 8                                                        
 4        CONTINUE                                                      
C  LOWER EDGE NOT STANDARD                                              
C  LAYER NOT STANDARD. MID-PRESSURES MUST BE CALCULATED                 
          PRINT 5, L, PP1(L), PP2(L)                                    
 5       FORMAT (' NON-STANDARD LAYER NO.', I4, '--', 2F10.2)           
         PRINT 6, PP1(L), PP2(L)                                        
 6         FORMAT (20X, '--', 2F10.2)                                   
C    ZDES ZAMENA L2 NA L   (V PBAR( ) I TBAR( ) )                       
         PBAR(L) = PP (PP1(L), PP2(L))                                  
        TBAR(L)= TDATA(L)                                               
C  R ESET STANDARD LAYER INDEX--                                        
        L2 = 1                                                          
        GO TO 8                                                         
 7        CONTINUE                                                      
C  STANDARD MID-PRESSURE (USE PRELIMINARY CALCULATION)--                
C  ZDES  PROVERIT L2   OR  L                                            
         PBAR(L) = PMID(L2)                                             
         TBAR(L) = TDATA(L)                                             
         NX = NXX                                                       
 8       CONTINUE                                                       
C        PRINT *,'PBAR=    ', PBAR                                      
                                                                        
C        PRINT *,'TBAR=    ', TBAR                                      
C        PRINT *, 'NX=  ',NX                                            
                                                                        
         RETURN                                                         
         END                                                            
