      subroutine deldate ( date, tau )
 
***********************************************************************
*                                                                     *
*    Program Name:  DELDATE                                           *
*    Date:          March 19, 1990                                    *
*    Computer:      IBM 3081                                          *
*    Language:      Fortran 77 (with Fortran 90 enhancements)         *
*    Programmer:    Mike Seablom, NASA/GSFC Code 911                  *
*                   Greenbelt, Md. 20771                              *
*                   (301) 286-7360   (FTS) 888-7360                   *
*                                                                     *
* DELDATE computes the "Gregorian factor" of any date (since 1583AD). *
*                                                                     *
* Input: "date" >> Integer variable containing date to factor ( use   *
*                  format (YYMMDD). If YY < 50 DELDATE assumes the    *
*                  21st century.                                      *
*                                                                     *
* Output: "tau" >> Real variable containing the Gregorian factor.     *
*                                                                     *
*                                                                     *
***********************************************************************
 
      real tau, month, day, year
      integer date
 
      year  = float( date / 10000 )
      month = ( float( date / 100   )* 100. - year*1.e4 ) / 100.
      day   = float( date ) - ( float( date/100 ) * 100. )
 
 
      if ( year .ge. 50. ) then
         year = year + 1900.
      else
         year = year + 2000.
      end if
 
      if ( month .le. 2. ) then
 
         tau = 365. * year + day + 31. * ( month - 1. ) +
     &         int( ( year - 1. ) / 4. ) -
     &         int( .75 * ( int(((year-1.)/100. ) + 1.)) )
 
      else
 
         tau = 365. * year + day + 31. *( month - 1. ) -
     &         int( .4*month + 2.3 ) + int( year/4. ) -
     &         int( .75*( int(year/100. ) + 1.) )
 
      end if
 
      return
 
      end
