                                                                                
      SUBROUTINE DGSORT ( XLAT,       YLON,       TYPE,        PDATA,           
     $                   XKDATA,     LENDATA,    NREP,        MAXNREP,          
     $                   INDEXD,     PRES,       ALAT,        ALON,             
     $                   IXKXS,      ITYP,       RSCAN,       RADE,             
     $                   GLAT,       GLON,                                      
     $                   NTRIGS,     TRIGCON,    TRIGTAB,     DIST    )         
                                                                                
C  GATHERS ALL DATA WITHIN A RADIUS OF RSCAN KM ABOUT A VOLUME CENTERED         
C  AT LATITUDE GLAT AND LONGITUDE GLON.                                         
                                                                                
                                                                                
      REAL              AACOS                                                   
      REAL              ALAT(MAXNREP)                                           
      REAL              ALON(MAXNREP)                                           
C     FUNCTION          AMAX1                                                   
      REAL              AMAX1                                                   
      REAL              ANGDEG                                                  
      REAL              CCOS                                                    
      REAL              COSANG                                                  
      REAL              COSTAB                                                  
      REAL              CSCAN                                                   
      REAL              DATALAT                                                 
      REAL              DELLAT                                                  
      REAL              DELLON                                                  
      REAL              DIST(MAXNREP)                                           
      REAL              GLAT                                                    
      REAL              GLATCOS                                                 
      REAL              GLON                                                    
      INTEGER           I                                                       
C     FUNCTION          IFIX                                                    
      INTEGER           IFIX                                                    
      INTEGER           INDEXD(MAXNREP)                                         
      INTEGER           ITYP(MAXNREP)                                           
      INTEGER           IXKXS(MAXNREP)                                          
      INTEGER           LENDATA                                                 
      INTEGER           MAXNREP                                                 
      INTEGER           NREP                                                    
      INTEGER           NSUBSC                                                  
      INTEGER           NTRIGS                                                  
      DIMENSION         PDATA(LENDATA)                                          
      REAL              PRES(MAXNREP)                                           
C     REAL              RADE                                                    
C     REAL              RSCAN                                                   
      REAL              SEPCOS                                                  
      REAL              SINDEL                                                  
      REAL              SINTAB                                                  
C     FUNCTION          SQRT                                                    
      REAL              SUBSCR                                                  
      REAL              TRIGCON                                                 
      REAL              TRIGTAB(450*NTRIGS+1)                                   
      DIMENSION         TYPE(LENDATA)                                           
      DIMENSION         XKDATA(LENDATA)                                         
      DIMENSION         XLAT(LENDATA)                                           
      DIMENSION         YLON(LENDATA)                                           
                                                                                
C  TO USE THE IN-LINE SINE AND COSINE APPROXIMATIONS, PASS NTRIGS,              
C  TRIGCON, AND TRIGTAB ( DIMENSIONED TRIGTAB(450*NTRIGS+1) ) TO                
C  YOUR ROUTINE AND INCLUDE THE FOLLOWING BLOCK OF STATEMENT FUNCTIONS.         
C  ANGDEG MUST BE BETWEEN -180.0 AND +180.0                                     
                                                                                
      SUBSCR(ANGDEG) = NTRIGS * ( ANGDEG + 180.0 ) + 1.5                        
      NSUBSC(ANGDEG) = IFIX ( SUBSCR( ANGDEG ) )                                
      SINDEL(ANGDEG) = ( SUBSCR(ANGDEG)-NSUBSC(ANGDEG)-0.5 ) * TRIGCON          
      SINTAB(ANGDEG) = TRIGTAB( NSUBSC(ANGDEG) )                                
      COSTAB(ANGDEG) = TRIGTAB( NSUBSC(ANGDEG) + 90*NTRIGS )                    
      CCOS(ANGDEG)   = COSTAB(ANGDEG) - SINTAB(ANGDEG) * SINDEL(ANGDEG)         
                                                                                
      AACOS(COSANG)  = SQRT( 2.0 * AMAX1( 0.0, 1.0 - COSANG ) )                 
                                                                                
      NREP = 0                                                                  
      IF( LENDATA.LE.0 ) RETURN                                                 
      GLATCOS = CCOS ( GLAT )                                                   
      CSCAN   = 1.0 - 0.5 * ( ( RSCAN + 15.0 ) / RADE )**2                      
                                                                                
      DO 500 I = 1, LENDATA                                                     
         DATALAT = XLAT(I)                                                      
         DELLAT  = GLAT - DATALAT                                               
         DELLON  = GLON - YLON(I)                                               
         IF( DELLON.LT.-180.0 ) DELLON = DELLON + 360.0                         
         IF( DELLON.GT.+180.0 ) DELLON = DELLON - 360.0                         
         SEPCOS  = GLATCOS * COSTAB(DATALAT) * ( COSTAB(DELLON) - 1.0 )         
     $                                                  + COSTAB(DELLAT)        
         IF ( (SEPCOS.GE.CSCAN).AND.(TYPE(I).GT.0.5) ) THEN                     
            NREP = NREP + 1                                                     
            INDEXD(NREP) = I                                                    
            DIST(NREP)   = AACOS( SEPCOS ) * RADE                               
            ALAT(NREP)   = XLAT(I)                                              
            ALON(NREP)   = YLON(I)                                              
            ITYP(NREP)   = TYPE(I)                                              
            PRES(NREP)   = PDATA(I)                                             
            IXKXS(NREP)  = XKDATA(I)                                            
         ENDIF                                                                  
  500 CONTINUE                                                                  
                                                                                
      RETURN                                                                    
      END                                                                       
