c----------------------------------------------c                                
!  Subroutine FLASH                            !                                
!                                              !                                
! FLASH sends a message to the program canary  !                                
! which alerts the user of a serious or po-    !                                
! tential problem during program execution.    !                                
!                                              !                                
c ---------------------------------------------c                                
                                                                                
      subroutine flash ( severity_level, message, action )                      
                                                                                
      integer severity_level, action, message_count                             
      logical end_of_file                                                       
      character *60 message                                                     
      character *12 errorlevel(-2:6)

      data errorlevel /'comment     ',
     &                 'ambiguous   ',
     &                 'nominal     ',
     &                 'trival      ',
     &                 'problem     ',
     &                 'caution     ',
     &                 'warning     ',
     &                 'fatal       ',
     &                 'catastrophic'/
                                                                                
      data message_count /0/                                                    
                                                                                
!  If ACTION = 1, store the message; otherwise, retrieve the canary             
!  file and list all messages.                                                  
                                                                                
      if ( action .eq. 1 ) then                                                 
                                                                                
          write (99,'(1x,i3,a60)') severity_level, message                      
          write (6,'(1x,"Canary alerted.")')                                    
          message_count = message_count + 1                                     
          if ( message_count .gt. 50 ) then                                     
            print*,' FLASH: Dead canary.'                                       
            stop 'Fatal.'                                                       
          end if                                                                
          if ( severity_level .gt. 4 ) then                                     
              write (6,'(///)')                                                 
              print*,' ABNORMAL TERMINATION  - see messages above.'                          
              write(6,'(a60)') message
              rewind 99                                                         
              write(99,'(" severity = ",i3)') severity_level                    
              stop 'Abort.'                                                     
          end if                                                                
          return                                                                
                                                                                
      else                                                                      
                                                                                
          write(6,'(///," EGRESS encountered in FLASH.")')
          write(6,'(///,80("-"),/,10x,"NASA GODDARD EARTH OBSERVING",
     &     " SYSTEM / DATA ASSIMILATION SYSTEM",/,80("-"))')
          rewind 99                                                             
          iworst = 0                                                            
          if ( message_count .ne. 0 ) then                                      
            write(6,'(///," Error flags were encountered. ",
     &           /," Please note:")')                                           
            write(6,'(/," Severity Level",20x,"Message",/,
     &                  " --------------",20x,"-------",/)')

            do i = 1,message_count                                              
              read (99,'(1x,i3,a60)') severity_level, message                   
              if ( severity_level .gt. iworst ) iworst = severity_level         
              write(6,'(4x,a12,6x,a60)') errorlevel(severity_level),
     &                                   message
            end do                                                              
                                                                                
                                                                                
          else  

            write(6,'(//," No runtime errors detected. ",//)')

          end if
                                                                                
          rewind 99                                                             
          write(99,'(" severity = ",i3)') iworst                                
                                                                                
      end if                                                                    
      return                                                                    
      end                                                                       
