      subroutine glassim( repack, leap, mats, nymdb, nymde, nhmsb,
     &                    nhmse, ndt, exp_id, nb, nd, nymd, nhms, 
     &                    qbudget_switch )
C
C***********************************************************************
C************       NASA/GODDARD SPACE FLIGHT CENTER        ************
C********              LABORATORY FOR ATMOSPHERES               ********
C******                                                           ******
C******          Data Assimilation Office  -  Code 910.3          ******
C********       Optimum Interpolation Assimilation System       ********
C************         Frozen Version 2.0 - October 1994     ************
C***********************************************************************
#include <vrslv.com>
#include <oirslv.com>
#include <vstate.com>
#include <vmetric.com>
#include <vbudget.com>
C
      	

      common /contrl/   im0,     jnp0,    nb0,     ndalt0,  nhms0,
     &                  nlay0,   nlaym10, nlayp10, nymd0,   strat,
     &                  idimen0,  slp,    fdcos,   fexp,   saveae,
     &                  sigdat,  maxrep
      logical           strat,   slp,     fdcos,   fexp,   saveae,
     &                  sigdat, first, qbudget_switch, offlev
 
      character*8   dataname
      character*24  obsname
      parameter         ( mxqobs=200 )
      common /obs/ maxdex, nfgge, lun, dataname(5), hh(13,13,20),
     &             vcoroe(18,18,4), obserr(mxqobs,4,19),
     &             ww(13,13,20), obsname(mxqobs), qobs(mxqobs,5),
     &             offlev(mxqobs)
      common /scan/ maxobs, rscan, onestage, max_data
      real  rscan, data( 1500000       ), sat_wind( 150000   ),
     &      ztime(150000), ustar( imr,jmr+1 )
      logical onestage, repack, suspect( 150000  , 2 ), skippuv,
     &        skipmix, skipzuv, qobs, seasat, usesas, dalflg, 
     &        ldown
      integer bq( 150000   )
      data first /.true./
      save first, istart

      common /dalctl/ seasat, usesas, dalflg
 
! Unit numbers for I/O.

      data krsw/37/, kbud/14/, kbc/16/, kout/35/, krsh/36/,
     &     koip/95/, iread/1/, iwrit/2/, ndgoi/060000/


      real              maxvalue, minvalue
      EXTERNAL          MIXCOV
      EXTERNAL          PUVCOV
      EXTERNAL          ZUVCOV
 
C***********************************************************************
C*       FIELDS ON ANLAYSIS LEVELS
C***********************************************************************
C
C     lwflag_oi (imr,jmr+1)              LAND/WATER FLAG
C     psfc_oi   (imr,jmr+1)              SURFACE PRESSURE
C     tsfc_oi   (imr,jmr+1)              SURFACE TEMPERATURE (EXTRAPOLATED)
C     tvsfc_oi  (imr,jmr+1)              SURFACE VIRTUAL TEMPERATURE
C     psl_oi    (imr,jmr+1)              SEA LEVEL PRESSURE
C     usl_oi    (imr,jmr+1)              SEA LEVEL U WIND
C     vsl_oi    (imr,jmr+1)              SEA LEVEL V WIND
C     u_oi      (imr,jmr+1,nlevoi)       U WIND
C     v_oi      (imr,jmr+1,nlevoi)       V WIND
C     tv_oi     (imr,jmr+1,nlevoi)       VIRTUAL TEMPERATURE
C     t_oi      (imr,jmr+1,nlevoi)       DRY BULB TEMPERATURE
C     tgrnd     (imr,jmr+1)              GROUND TEMPERATURE
C     rh_oi     (imr,jmr+1,nlevoi)       RELATIVE HUMIDITY
C     rmix_oi   (imr,jmr+1,nlevoi)       MIXING RATIO
C     z_oi      (imr,jmr+1,nlevoi)       GEOPOTENTIAL HEIGHT

      real lwflag_oi (imr,jmr+1)
      real psfc_oi   (imr,jmr+1)
      real tsfc_oi   (imr,jmr+1)
      real tvsfc_oi  (imr,jmr+1)
      real psl_oi    (imr,jmr+1)
      real phis      (imr,jmr)
      real usl_oi    (imr,jmr+1)
      real vsl_oi    (imr,jmr+1)
      real u_oi      (imr,jmr+1,nlevoi)
      real v_oi      (imr,jmr+1,nlevoi)
      real tv_oi     (imr,jmr+1,nlevoi)
      real tgnd      (imr,jmr+1)
      real t_oi      (imr,jmr+1,nlevoi)
      real rh_oi     (imr,jmr+1,nlevoi)
      real rmix_oi   (imr,jmr+1,nlevoi)
      real z_oi      (imr,jmr+1,nlevoi)
      real zlwflag   (imr,jmr+1)

C***********************************************************************
C*       ANALYSIS INCREMENTS
C***********************************************************************
 
      real usl_inc    (imr,jmr+1)          !    SEA LEVEL U WIND
      real vsl_inc    (imr,jmr+1)          !    SEA LEVEL V WIND
      real u_inc      (imr,jmr+1,nlevoi)   !    U WIND
      real v_inc      (imr,jmr+1,nlevoi)   !    V WIND
      real rmix_inc   (imr,jmr+1,nlevoi)   !    MIXING RATIO
      real tv_inc     (imr,jmr+1,nlevoi)   !    TEMPERATURE
C
C***********************************************************************
C*       FIRST GUESS/ANALYSIS ERROR STANDARD DEVIATIONS                *
C***********************************************************************
 
C     psl_err  (imr,jmr+1)              SEA LEVEL PRESSURE
C     tsl_err  (imr,jmr+1)              SEA LEVEL TEMPERATURE
C     rmix_err (imr,jmr+1,nlevoi)       MIXING RATIO
!     u_err    (imr,jmr+1,nlevoi)       U-WIND                    <1.3>  
!     v_err    (imr,jmr+1,nlevoi)       V_WIND                    <1.3>  
!     usl_err  (imr,jmr+1)              SEA-LEVEL U-WIND          <1.3>
!     vsl_err  (imr,jmr+1)              SEA-LEVEL V-WIND          <1.3>
 
      real psl_err    (imr,jmr+1)
      real tsl_err    (imr,jmr+1)
      real rmix_err   (imr,jmr+1,nlevoi+1)
      real u_err      (imr,jmr+1,nlevoi+1)
      real v_err      (imr,jmr+1,nlevoi+1)
      real mass_err   (imr,jmr+1,nlevoi+1)
 
      save psl_err, tsl_err, rmix_err, mass_err, u_err, 
     &     v_err, usl_err, vsl_err

C Use model common /SPACE/ to store those analysis fields that are only
C needed during the execution of the OI.  Note that the analysis errors
C are required by subsequent analyses; they are kept out of common /SPACE/
C since it is overwritten during the execution of the GCM.
 
#ifdef CRAY
!gvl      common /space/ lwflag_oi
!gvl      common /space/ psfc_oi
!gvl      common /space/ tsfc_oi
!gvl      common /space/ tvsfc_oi
!gvl      common /space/ psl_oi
!gvl      common /space/ usl_oi
!gvl      common /space/ vsl_oi
!gvl      common /space/ u_oi
!gvl      common /space/ v_oi
!gvl      common /space/ tv_oi
!gvl      common /space/ t_oi
!gvl      common /space/ rh_oi
!gvl      common /space/ rmix_oi
!gvl      common /space/ z_oi
!gvl 
!gvl      common /space/ usl_inc
!gvl      common /space/ vsl_inc
!gvl      common /space/ u_inc
!gvl      common /space/ v_inc
!gvl      common /space/ rmix_inc
!gvl      common /space/ tv_inc
#endif
C
C***********************************************************************
C*       WORKSPACE                                                     *
C***********************************************************************
C
      real WKSPACE (IMR*(JMR+1)*(NLEVOI+1)*4 + 60000 + IMR*(JMR+1))
#ifdef CRAY
!gvl      common /space/ wkspace
#endif

      real prep_space (IMR*(JMR+1)*NLAYR*4+IMR*(JMR+1)*8)
#ifdef CRAY
!gvl      common /diag/ prep_space
#endif
 
C***********************************************************************
C*       LOCAL VARIABLES                                               *
C***********************************************************************
C
      data fill /1.e10/
 
      PARAMETER ( ZERO = 0.0  )
      LOGICAL         QBUD,  QOUT, QRSH, QRSW, QPNT
      LOGICAL         QBEG, QEND, LEAP, MATS
      LOGICAL         QQINIT,QGOI
 
      character*8     atime, adate, xlabel(10), err_exp_id
      character*4     job(2), exp_id(2)
      character*60    message
 
 
C  GRID VOLUME SETUP FOR OI VERSIONS 1.2 AND LATER
C
C     Grid volume information is contained in dataset 'mvtable', unit 88.
C     This dataset contains the following:
C
C     NAME            TYPE                DESCRIPTION
C
C     ngv             simple int          Number of grid volumes
C     volcentre_x     array real          Longitude volume centres
C     volcentre_y     array real          Latitude volume centres
C     glatup          array real          Volume reference latitude
C     glonup          array real          Volume reference longitude
C     nh              array int           No. horiz gridpoints in volume
C
      common / sparam / lsolve, ns, nr, nv, nh(13104), nq, kq(3),
     &                  volcentre_x(13104), ngv,
     &                  volcentre_y(13104), glatup(13104), glonup(13104)
 
     
      skippuv = .false.
      skipmix = .false.
      skipzuv = .false.

      write (6,'(//," GLASSIM: Ingress.")')
      write(6,'(//)')
      write(6,'(1x," NASA GODDARD EARTH OBSERVING SYSTEM (GEOS)",/,
     &        1X," DATA ANALYSIS SYSTEM - VERSION 2.0 - OCT 1994",//)')
c
c**********************************************************************
c
c        Read dataset containing minivolume information.
c
c**********************************************************************
 
 
      read( 88 ) ngv
      write( 6,'(/," Number of horizontal grid volumes:",i6)') ngv
      read( 88 ) (volcentre_x(ii), ii = 1,ngv)
      read( 88 ) (volcentre_y(ii), ii = 1,ngv)
      read( 88 ) (glatup(ii), ii = 1,ngv)
      read( 88 ) (glonup(ii), ii = 1,ngv)
      read( 88 ) (nh(ii), ii = 1,ngv)
      close( 88 )
C
C***********************************************************************
C        WORKSPACE POINTERS AND ANALYSIS PARAMETERS
C***********************************************************************
C
      IAQUAN = 1
      IZE    = iaquan + imr*(jmr+1)*(NLEVOI+1)*3
      IZELON = IZE    + 20000
      IZELAT = IZELON + 20000
      IZ1000 = IZELAT + 20000
 
      CALL GETCONH( 'DLAT    ', DLAT )

C***********************************************************************
C*       UPDATE ANALYSIS ERROR STANDARD DEVIATIONS WITH MODEL          *
C*       ERROR GROWTH (ONLY IF NOT A BEGIN CASE)                       *
C***********************************************************************
C
      if ( first ) then
         CALL RDERROR(NYMD,NHMS,psl_err,tsl_err,rmix_err,
     .        mass_err,ISTART,exp_id)
         CALL ITPINIT(IMR,JMR+1,NLEVOI,NLAYR,SIGE)
         first = .false.
      end if
      IF (ISTART.NE.0) then
         CALL GROWTH(psl_err,tsl_err,rmix_err,mass_err)
      end if
      ISTART = 1
C
C

C***********************************************************************
C*       OBTAIN FIRST GUESS FOR OI ON PRESSURE LEVELS                  *
C***********************************************************************
C
      CALL OIPREP( nb, PZ(1,1,nb), ptop, ZLWI,
     .     lwflag_oi, tsfc_oi, tvsfc_oi,
     .     psfc_oi, psl_oi,
     .     usl_oi, vsl_oi, u_oi, v_oi,
     .     tv_oi, z_oi, rmix_oi, rh_oi,
     .     PMAND, PMIDM, IMR, JMR+1, NLEVOI, nlayr,
     .     prep_space,ustar)
      
 
C Save pressure level first guess
 
      usl_inc = usl_oi
      vsl_inc = vsl_oi
      u_inc = u_oi
      v_inc = v_oi
      rmix_inc = rmix_oi
      tv_inc = tv_oi
C
C
C***********************************************************************
C*       COMPUTATION OF PRESSURE LEVEL DRY BULB TEMPERATURES           *
C*       BEFORE ANALYSIS PRESSURE LEVEL HISTORY WRITE                  *
C***********************************************************************
C
      CALL TDRYBULB(tv_oi,rmix_oi,t_oi,PMAND,PMIDM)
 
!  Compute the first guess wind standard deviations.

      call werrinit ( mass_err, imr, jmr+1, nlevoi, u_err, v_err )

      call oihiswrt(koip,nymd,nhms,nymd0,nhms0,imr,jmr+1,nlevoi,-1,
     .     xlabel,exp_id,pmand,
     .     phisz, psl_oi, psfc_oi, tvsfc_oi, usl_oi, vsl_oi,
     .     u_oi, v_oi, t_oi, z_oi, rmix_oi, rh_oi,
     .     psl_err, u_err, v_err, mass_err, rmix_err  )

C
C        Position REPACK dataset for this synoptic time.
C        Bypass sea-level temperature data.
C
      if ( repack ) then
         call ptndat( nymd,nhms  )
         do logical_units = 1,nfgge
            call rdthru ( 1, lun-1+logical_units )
         end do
      end if
 
!**********************************************************************
!
!        Sea level pressure and wind analysis.
!
!*********************************************************************
 
      if ( .not. skippuv ) then

         call dragon( phisz, lwflag_oi, usl_oi, vsl_oi, tsfc_oi, tgz )
 
         nv = 1
         nq = 3

         call rdslp ( data, nobs, suspect )

         if ( nobs .gt. 0 ) then
            if ( seasat ) then
!gvl               call nscat(psl_err,lwflag_oi,psl_oi,usl_oi,vsl_oi,tsfc_oi,
!gvl     &              puvcov, wkspace(iaquan), mass_err, t_oi,
!gvl     &              wkspace(ize), wkspace(izelat), wkspace(izelon),
!gvl     &              nze, psfc_oi, data, nobs, suspect, type )
            end if

            call qcslp ( phisz, psl_oi, usl_oi, vsl_oi, data, nobs,
     &           t_oi, wkspace(ize), wkspace(izelat),
     &           wkspace(izelon), nze, psfc_oi, suspect,
     &           psl_err )

            mass_err(1:imr,1:jmr+1,nlevoi+1) = psl_err(1:imr,1:jmr+1)

            call puvanl( mass_err, u_err,v_err,phisz, psl_oi, usl_oi,
     &           vsl_oi,tsfc_oi,puvcov, wkspace(iaquan), t_oi,
     &           wkspace(ize), wkspace(izelat), wkspace(izelon),
     &           nze, psfc_oi, data, nobs, suspect, ztime)
            
            psl_err(1:imr,1:jmr+1) = mass_err(1:imr,1:jmr+1,nlevoi+1)
    
         else


            call flash ( 3,'GLASSIM: No slp observations.',1)
            nze=0

         end if
 
      else  ! skip the sea level pressure/wind analysis
 
         if ( repack ) then
            do logical_units = 1,nfgge
               call rdthru( 2, lun-1+logical_units )
            end do
         end if
 
      end if
 
!
!**********************************************************************
!
!      Upper air water vapour mixing ratio analysis
!
!**********************************************************************
 
      if ( .not. skipmix ) then
 
         nv = 2
         nq = 1
         mmix = 6
         call rdmix( nymd, nhms, data, bq, nobs, pmand, psfc_oi,
     &        imr, jmr+1, nlevoi, mmix )

         if ( nobs .gt. 0 ) then
            call delmix( nymd, nhms, rh_oi, rmix_oi, pmand,
     &           psfc_oi, data, nobs, imr, jmr+1, nlevoi, mmix,
     &           sigdat, bq, t_oi ) 
            call mixanl(rmix_err,u_err,v_err, rh_oi, rmix_oi, pmand, 
     &           psfc_oi, mixcov,  wkspace(iaquan), imr, jmr+1,
     &           nlevoi, mmix, nobs, data, bq, ztime)

         else
            call flash (3,'GLASSIM: No mix observations.',1)
         end if
 
      else ! skip the mixing ratio analysis
 
         if ( repack ) then
            do logical_units = 1,nfgge
               call rdthru( 3, lun-1+logical_units )
            end do
         end if
 
      end if
 
 
!
!**********************************************************************
!
!      Upper air height and wind analysis
!
!**********************************************************************
!
      if ( .not. skipzuv ) then
!
!  Recalculation of 1000mb heights using analyzed sea level analysis.
!

         call chgz1000(psfc_oi,tvsfc_oi,psl_oi,phisz,wkspace(iz1000),
     &        pmand, imr, jmr+1, nlevoi )
         nv = 2
         nq = 3
         call rdhuv ( z_oi, tv_oi, wkspace(iz1000), data, nobs,
     &        suspect, wkspace(ize), wkspace(izelat),
     &        wkspace(izelon), nze )
         if ( nobs.gt.0 ) then
            call delhuv( z_oi, u_oi, v_oi, tv_oi, psfc_oi, 
     &		 wkspace(iz1000),
     &           mass_err, u_err, v_err, data, nobs, wkspace(ize), 
     &           wkspace(izelat), wkspace(izelon), nze, nymd,
     &           nhms, suspect, ztime )
            call zuvanl ( mass_err, u_err, v_err, z_oi, u_oi, v_oi, 
     &		 t_oi,
     &		 psfc_oi, wkspace(iz1000), zuvcov, wkspace(iaquan),
     &           wkspace(ize), wkspace(izelat),
     &           wkspace(izelon), nze, data, nobs, ztime,
     &           nymd, nhms)
         else
            call flash(3,'GLASSIM: No zuv observations.',1)
         end if
 
 
      end if
 
      CALL PRPTLY

C
C***********************************************************************
C*       COMPUTE ANALYSIS INCREMENTS                                   *
C***********************************************************************
 
      do i=1,imr*(jmr+1)
         if (usl_inc(i,1).ne.fill) then
            usl_inc(i,1)=usl_oi(i,1)-usl_inc(i,1)
         end if
      end do

      do i=1,imr*(jmr+1)
         if (vsl_inc(i,1).ne.fill) then
            vsl_inc(i,1)=vsl_oi(i,1)-vsl_inc(i,1)
         end if
      end do


      do i=1,imr*(jmr+1)*nlevoi
         if (u_inc(i,1,1).ne.fill) then
            u_inc(i,1,1)=u_oi(i,1,1)-u_inc(i,1,1)
         end if
      end do
 
      do i=1,imr*(jmr+1)*nlevoi
         if (v_inc(i,1,1).ne.fill) then
            v_inc(i,1,1)=v_oi(i,1,1)-v_inc(i,1,1)
         end if
      end do
 
      do i=1,imr*(jmr+1)*nlevoi
         if (rmix_inc(i,1,1).ne.fill) then
            rmix_inc(i,1,1)=rmix_oi(i,1,1)-rmix_inc(i,1,1)
         end if
      end do
 
      call ztot(z_oi,tv_oi,PMAND,PMIDM,imr,jmr+1,nlevoi)
 
      do i=1,imr*(jmr+1)*nlevoi
         tv_inc(i,1,1)=tv_oi(i,1,1)-tv_inc(i,1,1)
      end do
C
C***********************************************************************
C*       COMPUTATION OF PRESSURE LEVEL DRY BULB TEMPERATURES           *
C*       AFTER ANALYSIS PRESSURE LEVEL HISTORY WRITE                   *
C***********************************************************************
C
      CALL TDRYBULB(tv_oi,rmix_oi,t_oi,PMAND,PMIDM)
 
      call werrinit ( mass_err, imr, jmr+1, nlevoi, u_err, v_err )

      call mixtorh ( rmix_oi, t_oi, pmand, imr, jmr+1, nlevoi,
     &     rh_oi, fill )

      do i = 1,imr
         do j = 1,jmr+1
            do k = 1,nlevoi

               if ( rh_oi(i,j,k) .ne. fill ) then
                  rh_oi(i,j,k) = rh_oi(i,j,k)*100.
               end if

            end do
         end do
      end do


      call oihiswrt(koip,nymd,nhms,nymd0,nhms0,imr,jmr+1,nlevoi,0,
     .     xlabel,exp_id,pmand,
     .     phisz, psl_oi, psfc_oi, tvsfc_oi, usl_oi, vsl_oi,
     .     u_oi, v_oi, t_oi, z_oi, rmix_oi, rh_oi,
     .     psl_err, u_err, v_err, mass_err, rmix_err  )
C
C***********************************************************************
C*       WRITE ANALYSIS ERROR STANDARD DEVIATIONS                      *
C***********************************************************************
C
      REWIND 89
      CALL OIERRWRT(89,exp_id,NYMD,NHMS,
     .     psl_err,tsl_err,rmix_err,mass_err,
     .     IMR,JMR+1,NLEVOI,WKSPACE,ISTAT)
      IF( ISTAT.NE.0 ) then
         print*,' FATAL: GLASSIM> Error in analysis error data conver',
     &        'sion.'
         stop 'Fatal.'
      end if
C
C***********************************************************************
C*       INTERPOLATE ANALYSIS INCREMENTS TO MODEL LEVELS AND UPDATE    *
C*       TIME STEP NB                                                  *
C***********************************************************************
C
C SET TIME STEP INDICIES
C
      IF(NB .EQ. 1) ND = 2
      IF(NB .EQ. 2) ND = 1
C
      CALL OIPOST(phisz, tvsfc_oi, psl_oi, usl_inc,  vsl_inc,
     .     u_inc, v_inc,    tv_inc, rmix_inc,
     .     PMAND, PMIDM,
     .     PZ(1,1,NB)  ,PZ(1,1,ND)  ,UZ(1,1,1,NB),UZ(1,1,1,ND),
     .     VZ(1,1,1,NB),VZ(1,1,1,ND),TZ(1,1,1,NB),TZ(1,1,1,ND),
     .     QZ(1,1,1,NB),QZ(1,1,1,ND),
     .     SIGE      ,  lwflag_oi  , PTOP      , PKHT        ,
     .     IMR        , JMR+1      , NLAYR     , NLEVOI      ,
     .     qbudget_switch, ZANALP     , ZANALU    , ZANALV      ,
     .     ZANALT     , ZANALQ    ,
     .     zdpdt      , zdpudt    , zdpvdt      ,
     .     zdptdt     , zdpqdt    , dsig )
 
          
      END
