CDECK     INT2TAU
C***********************************************************************
C  SUBROUTINE INT2TAU
C  PURPOSE
C     CONVERTS YYMMDD/HHMMSS TO TAU = HRS SINCE 29OCT72 00Z.
C  USAGE
C     CALL INT2TAU ( NYMD, NHMS, TAU )
C  DESCRIPTION OF PARAMETERS
C     NYMD    - YYMMDD   INTEGER DATE TO BE CONVERTED
C     NHMS    - HHMMSS   INTEGER TIME TO BE CONVERTED
C     TAU     - ELAPSED  HOURS FROM 29OCT72 00Z TO YYMMDD/HHMMSS
C  SUBPROGRAMS REQUIRED
C     HRDIFF  FUCTION    COMPUTES TIME DIFFERENCES FROM YYMMDD/HHMNMSS
C  RECORD OF MODIFICATIONS
C     17SEP84 JIM.PFAENDTNER  NEW PROGRAM
C     18SEP84 JIM.PFAENDTNER  COMMENT ADDED
C  REMARKS
C     . ONLY CORRECT IF YYMMDD/HHMMSS IS AFTER 01JAN72 00Z
C***********************************************************************
C
      SUBROUTINE INT2TAU ( NYMS, NHMS, TAU )
C
C***********************************************************************
C     COMMON /TAUBASE/ NYMDTAU, NHMSTAU
      DATA             NYMDTAU, NHMSTAU / 721029,      0 /
C
C***********************************************************************
C
      TAU      = HRDIFF ( NYMS, NHMS, NYMDTAU, NHMSTAU )
C
      RETURN
      END
