 
      subroutine mixanl ( mix_err, u_err, v_err,rh,rmix,pmand,psfc,
     &                    cov,aquan, im, jnp, mlev, mmix, nobs,
     &                    data, bq, ztime )
 
C  DRIVER FOR THE MIXING RATIO ANALYSIS
 
C  ANALYSIS IS DONE IN UNITS OF G/KG TO AVOID INDETERMINATE RESULTS IN
C  THE MATRIX EQUATION SOLVER.
 
 
      DIMENSION         AQUAN(IM*JNP,MLEV)
      integer           bq(150000)
      EXTERNAL          COV
      real              data( 1500000 ), ztime(150000)
      logical           onestage
      real              fill
      INTEGER           IMJM
      INTEGER           K
      INTEGER           LEV
      INTEGER           LEV1
      integer           max_data
      INTEGER           NHMS
      INTEGER           NYMD
      real              mix_err(im*jnp,mlev+1)
      real              u_err(im*jnp,mlev+1)
      real              v_err(im*jnp,mlev+1)
      real              psfc(im*jnp)
      real              pmand(mlev)
      logical           repack
      DIMENSION         RH(IM*JNP,MLEV)
      DIMENSION         RMIX(IM*JNP,MLEV)
      character*60      message
 
      common /dataptrs/ ikx, ilat, ilon, ipres, itype, imix, ifcer,
     &                    itime
      COMMON /scan/     maxobs, rscan, onestage, max_data
      common /sparam/ lsolve, ns, nr, nv, nh(13104), nq,
     &                kq(3), volcentre_x(13104),
     &                ngv, volcentre_y(13104), glatup(13104),
     &                glonup(13104)
 
      data fill /1.e10/
 
      CALL GETCONI ('NYMD    ', NYMD)
      CALL GETCONI ('NHMS    ', NHMS)
      WRITE( 6, 900 ) NYMD, NHMS
      IMJM  = IM * JNP
      LEV1  = MLEV - 5
      KQ(1) = 1
 
      if ( nobs .eq. 0 ) then
        message = 'MIXANL: No observations!'
        call flash( 2,message,1 )
      end if
 
C  INTERPOLATE FORECAST ERROR TO DATA POINTS
      IFCER  = IMIX + NOBS
      CALL VTERPV( DATA(ILAT), DATA(ILON), DATA(IPRES), DATA(IFCER),
     $             NOBS,       mix_err                              )
 
      aquan = 0.
 
C  FORM AND SOLVE COVARIANCE MATRICES
c     CALL ZEITBEG ('M SOLVE0')
      call solvedrv( LEV1, MLEV, COV, AQUAN, data, nobs,
     &               ztime, mix_err, u_err, v_err )
c     CALL ZEITEND
 
C  ADD INCREMENT TO FIRST GUESS FIELD AND FIX ANY NEGATIVE HUMIDITIES
      DO 400 LEV = LEV1, MLEV
         DO 300 K = 1, IMJM
            IF (RMIX(K,LEV).ne.fill)
     .                        RMIX(K,LEV) = RMIX(K,LEV) + AQUAN(K,LEV)
            IF( RMIX(K,LEV).LT.0.001 ) RMIX(K,LEV) = 0.001
  300    CONTINUE
  400 CONTINUE
 
      RETURN
  900 FORMAT('0MIXANL: START MOISTURE ANALYSIS FOR NYMD/NHMS',2I8/)
      END
