                                                                        
C   --------------------------------------------------------------------
          SUBROUTINE MIXRAT (PRES,TEMP,RHUM,HMIX)                       
C   --------------------------------------------------------------------
C                                                                       
C    RETURN MIX.RATIO AS A FUNCTION OF PRESSURE,TEMPERATURE             
C   AND RELATIVE HUMIDITY                                               
C   INPUT  -   PRESSURE                                                 
C          -   TEMPERATURE IN DEG.  K ( 150 K, 320 K )                  
C          -   RELATIVE HUMIDITY (IN PERCENT > 0.01)                    
C   OUTPUT  -   MIX. RATIO (IN G/KG )                                   
                                                                        
       REAL    TCR,HMIX                                                 
       REAL    A1, B1, A2, B2                                           
       REAL    C, C2                                                    
                                                                        
        DATA   TCR /273.16/                                             
        DATA   A1/21.874/, B1 /7.66/, A2 /17.269/, B2 /35.86/           
        DATA   C /6.11/, C2 /0.00622/                                   
                                                                        
C    - SATURATION VAPOR PRESSURE FUNCTION                               
             SATVP (T,A,B)= C* EXP(A*(T-TCR)/(T-B))                     
                                                                        
         IF (TEMP.LT.TCR) SVP= SATVP(TEMP,A1,B1)                        
         IF (TEMP.GE.TCR) SVP= SATVP(TEMP,A2,B2)                        
           HMIX = 1000 * C2 * RHUM * SVP/(PRES-RHUM*SVP/100)            
                                                                        
              RETURN                                                    
        END                                                             
