      subroutine mixtorh(rmix,t,pmand,im,jnp,mlev,rh,undef)            

      real pmand(mlev)
      real rmix(im,jnp,mlev), t(im,jnp,mlev)                            
      real rh(im,jnp,mlev), q_sat(im,jnp)
      real tem1(im,jnp), tem2(im,jnp), tem3(im,jnp)
      real tem4(im,jnp), tem5(im,jnp)       
      integer item1(im,jnp), item2(im,jnp)                 
c                                                                       
c            purpose: to compute relative humidity  at given            
c                      pressure level using mixing ratio and            
c                      temperature.                                     
c                                                                       
      imjm = im*jnp
c                                                                       
      do k = 1,mlev                                                  

         do  i = 1,imjm                                             

! If not filled, convert mixing ratio in g/kg to specific 
! humidity in g/g.

            if (rmix(i,1,k).ne.undef) then                                   
                 rh(i,1,k) = rmix(i,1,k) / 1000.
                 rh(i,1,k) = rh(i,1,k) / (1.+rh(i,1,k))         
            else                                                       
                 rh(i,1,k) = rmix(i,1,k)                               
            endif                                                      

! Load arrays of temperature and pressure. 

            tem1(i,1) = t(i,1,k)                                      
            tem2(i,1) = pmand(k)                                      

         end do                                                       

! Compute saturation specific humidity.

         call qstars(tem1,tem2,tem3,tem4,tem5,item1,item2,          
     .                   imjm,q_sat)                                     
                                                                        
! Where not filled, compute relative humidity as the ratio of 
! the specific humidity to the saturation specific humidity.

         do i = 1,imjm                                              
            if (rh(i,1,k).ne.undef) then                                    
               rh(i,1,k) = rh(i,1,k) / q_sat(i,1)                          
            endif                                                      
         end do                                                       

      end do
  
      return                                                          
      end                                                             


