       subroutine oihiswrt(iunit,nymd,nhms,nymd0,nhms0,im,jnp,nlev,
     .                     log8r,xlabel,job,pres,
     .                     phis,psla,psfc,tvsfc,usla,vsla,
     .                     upauwnd,upavwnd,upatemp,upahght,                     
     .                     uparmix,uparhmd,                                     
     .                     prsdiag,udiag,vdiag,hgtdiag,rmxdiag)                 
                                                                                
c                                                                               
       parameter  ( nsfld   = 6,nufld = 6,ndfld = 5)                            
c                                                                               
       dimension      pres(nlev), psfc(im,jnp)                                  
       dimension      phis(im,jnp),psla(im,jnp),tvsfc(im,jnp)                   
       dimension      usla(im,jnp),vsla(im,jnp)                                 
c                                                                               
       dimension      upauwnd(im,jnp,nlev),upavwnd(im,jnp,nlev)                 
       dimension      upatemp(im,jnp,nlev),upahght(im,jnp,nlev)                 
       dimension      uparmix(im,jnp,nlev),uparhmd(im,jnp,nlev)                 
c                                                                               
       dimension      hgtdiag(im,jnp,nlev), tem(im,jnp)                         
       dimension      prsdiag(im,jnp),udiag(im,jnp,nlev)                        
       dimension      vdiag(im,jnp,nlev),rmxdiag(im,jnp,nlev)                   
c                                                                               
       character*8    names(nsfld), xnames(nsfld),job                           
       character*8    nameu(nufld), xnameu(nufld)                               
       character*8    named(ndfld), xnamed(ndfld)                               
       character * 80 xlabel                                                    
c                                                                               
c                                                                               
c           surface field                                                       
c                                                                               
       DATA NAMES( 1) /'PHIS    '/                                              
       DATA NAMES( 2) /'TVSFC   '/                                              
       DATA NAMES( 3) /'PSFC    '/                                              
       DATA NAMES( 4) /'SLP     '/                                              
       DATA NAMES( 5) /'SLU     '/                                              
       DATA NAMES( 6) /'SLV     '/                                              
c                                                                               
c        upper air                                                              
                                                                                
       DATA NAMEU( 1) /'UWND    '/                                              
       DATA NAMEU( 2) /'VWND    '/                                              
       DATA NAMEU( 3) /'HGHT    '/                                              
       DATA NAMEU( 4) /'TMPU    '/                                              
       DATA NAMEU( 5) /'MIXR    '/                                              
       DATA NAMEU( 6) /'RH      '/                                              
c                                                                               
c           diagnostics                                                         
c                                                                               
       DATA NAMED( 1) /'PRSE    '/                                              
       DATA NAMED( 2) /'UWNDE   '/                                              
       DATA NAMED( 3) /'VWNDE   '/                                              
       DATA NAMED( 4) /'HGHTE   '/                                              
       DATA NAMED( 5) /'MIXRE   '/                                              
c                                                                               
c********************************************************************           
c            description  of input arguments                                    
c                                                                               
c       input :                                                                 
c                                                                               
c              iunit : unit number             job  : experiment numbeR         
c              nymd  : experiment date         nhms : experiment time           
c              im    : logitude index          jnp  : latitude index            
c              nlev  : number of levels        log8r: analysis flag             
c              xlabel: experiment description  pres : pressure levels           
c                                                                               
c        surface fields:                                                        
c                                                                               
c             phis  : gravity * heights      psla : sealevel pressure           
c             tvsfc : surface vertual temp.  usla : sealevel uwind              
c             vsla  : selevel vwind          psfc : surface pressure            
c                                                                               
c        upperair fields :                                                      
c                                                                               
c            upauwnd : upperair uwind         upavwnd: upperair vwind           
c            upahght : upperair heights       uparmix: upperair vwind           
c            upatemp : upperair temperatures  uparh  : relative humidity        
c                                                                               
c                                                                               
c        surface diagnostics                                                    
c                                                                               
c            prsdiag: pressure errors  tmpdiag: temperature errors
c                                                                               
c        surface diagnostics                                                    
c                                                                               
c            prsdiag  :  surface pressure errors                                
c            udiag    :  u-wind errors   vdiag   : v-wind errors                
c            hgtdiag  : height errors    rmxdiag : mixing ratio errors          
c                                                                               
c *********************************************************************         
c                                                                               
c                                                                               
c                     call a routine to write a header record                   
c                                                                               
            call oihished(iunit,xlabel,job,log8r,pres,names,nymd,nhms,          
     .                    nymd0,nhms0,nameu,named,                              
     .                    nsfld,nufld,ndfld,im,jnp,nlev)                        
c                                                                               
c                 writeout surface fields                                       
c                                                                               
             call oihisout(iunit,phis,im,jnp,0.0,names(1))                      
             call oihisout(iunit,tvsfc,im,jnp,0.0,names(2))                     
             call oihisout(iunit,psfc,im,jnp,0.0,names(3))                      
             call oihisout(iunit,psla,im,jnp,0.0,names(4))                      
             call oihisout(iunit,usla,im,jnp,0.0,names(5))                      
             call oihisout(iunit,vsla,im,jnp,0.0,names(6))                      
c                                                                               
c                  write out upper air fields                                   
c                                                                               
                                                                                
        do  50 k = nlev,1,-1                                                    
          call uptrans(iunit,upauwnd,im,jnp,nlev,k,tem,pres(k),nameu(1))        
          call uptrans(iunit,upavwnd,im,jnp,nlev,k,tem,pres(k),nameu(2))        
          call uptrans(iunit,upahght,im,jnp,nlev,k,tem,pres(k),nameu(3))        
          call uptrans(iunit,upatemp,im,jnp,nlev,k,tem,pres(k),nameu(4))        
          call uptrans(iunit,uparmix,im,jnp,nlev,k,tem,pres(k),nameu(5))        
          call uptrans(iunit,uparhmd,im,jnp,nlev,k,tem,pres(k),nameu(6))        
   50   continue                                                                
                                                                                
                                                                                
c                                                                               
c             write out surface pressure diagnostics                            
c                                                                               
             call oihisout(iunit,prsdiag,im,jnp,0.0,named(1))                   
c                                                                               
c               write out upper air u,v,z and mixing ratio                      
c                          diagnostics                                          
c                                                                               
             call dgtrans(iunit,udiag,im,jnp,nlev,tem,pres,named(2))            
             call dgtrans(iunit,vdiag,im,jnp,nlev,tem,pres,named(3))            
             call dgtrans(iunit,hgtdiag,im,jnp,nlev,tem,pres,named(4))          
             call dgtrans(iunit,rmxdiag,im,jnp,nlev,tem,pres,named(5))          
c                                                                               
             return                                                             
             end                                                                
c                                                                               
      subroutine oihisout(iunit,tem,im,jnp,prss,xname)                   
c                                                                               
      dimension tem(im,jnp)                                              
      character * 8 xname                                                
      real work(im,jnp)
      real tem2(im,jnp)                                              

      data fill_value /1.e10/

C Change missing value flag for output history
C --------------------------------------------

      UNDEF = getcon('UNDEF')

      do k=1,im*jnp
         if (tem(k,1).eq.fill_value) then
            tem2(k,1)=undef
         else
            tem2(k,1)=tem(k,1)
         end if
      end do

c                 writout the field                                             
 
      call glawrt(tem2, im*jnp, iunit, work, prss, xname)

      return                                                             
      end                                                                
c                                                                               
      subroutine oihished(iunit,xlabel,job,log8r,pres,names,nymd,nhms,          
     .                    nymd0,nhms0,nameu,named,                              
     .                    nsfld,nufld,ndfld,im,jnp,nlay)                        
c                                                                               
      parameter (nsfldr=6,nufldr=6,ndfldr=5,nulevr=50,nddiag=5)                 
      dimension pres(1)                                                         
       integer        int_header(100),num_lev_diag(100)                         
       real           real_header(100),sigma_edge(50)                           
       character * 40 header_descr(100)                                         
c                                                                               
      character*8    job                                                        
      character*8    names(nsfld)                                               
      character*8    nameu(nufld)                                               
      character*8    named(ndfld)                                               
      character*8    char_header(100),blanks                                    
      character*40   descs(nsfldr)                                              
      character*40   descu(nufldr)                                              
      character*40   descd(ndfldr)                                              
      character * 80 xlabel                                                     
c                                                                               
                                                                                
c                                                                               
c             description for surface fields                                    
c                                                                               
      data descs( 1) /'Surface geopotential (g*zs) (m**2/s**2) '/               
      data descs( 2) /'Surface virtual temperature (K)         '/               
      data descs( 3) /'Surface pressure (mb)                   '/               
      data descs( 4) /'Sea level pressure (mb)                 '/               
      data descs( 5) /'Sea level u-wind   (m/s)                '/               
      data descs( 6) /'Sea level v-wind   (m/s)                '/               
c                                                                               
c              description for upper air fields                                 
c                                                                               
      data descu( 1) /'U-wind (m/s)                            '/               
      data descu( 2) /'V-wind (m/s)                            '/               
      data descu( 3) /'Geopotential height (m)                 '/               
      data descu( 4) /'Temperature (K)                         '/               
      data descu( 5) /'Mixing ratio (g/kg)                     '/               
      data descu( 6) /'Relative humidity (%)                   '/               
                                                                                
c                                                                               
c              description for diagnostic errors                                
c                                                                               
      data descd( 1) /'Sea level pressure error std. dev. (mb) '/               
      data descd( 2) /'U-wind error std. dev. (m/s)            '/               
      data descd( 3) /'V-wind error std. dev. (m/s)            '/               
      data descd( 4) /'Height error std. dev. (m)              '/               
      data descd( 5) /'Mixing ratio error std. dev. (g/kg)     '/               
      data blanks /'        '/                                                  
c                                                                               
c        initialize the header constants                                        
c                                                                               
                                                                                
      nulev = nlay                                                              
      num_model_levels = 0                                                      
      model_top_pres  = 0                                                       
 
      do 10 i = 1,100                                                           
        char_header(i) = blanks                                                 
   10 continue                                                                  

      undef = getcon('UNDEF')

      num_hdr_vars = 2

      header_descr(1) = 'Record type flag (integer)'
      int_header(1) = log8r
      real_header(1) = undef
      char_header(1) = 'log8r'

      header_descr(2) = 'Undefined fill value (real)'
      int_header(2) = 0
      real_header(2) = undef
      char_header(2) = 'undef'

c         zero out the sigma edges                                              
 
      do 20 i = 1,100                                                           
        sigma_edge(i) = 0.0                                                     
   20 continue                                                                  
c                                                                               
c         set number of levels for each diagnostic field written                
c          surface pressure              1                                      
c          upper air u-wind             nlay                                    
c          upper air v-wind             nlay                                    
c          upper air heights            nlay                                    
c          upper air mixing ratio       nlay                                    
c                                                                               
        num_lev_diag(1) = 1                                                     
        num_lev_diag(2) = nlay                                                  
        num_lev_diag(3) = nlay                                                  
        num_lev_diag(4) = nlay                                                  
        num_lev_diag(5) = nlay                                                  
c                                                                               
      ndum   =  0                                                               
                                                                                
c *********************************************************************         
c *****                     header record                          ****         
c *********************************************************************         
c                                                                               
      write (iunit) job, nymd, nhms, nymd0, nhms0,                              
     .              xlabel, im, jnp,                                            
     .              nsfld, nufld, ndfld,model_top_pres,                         
     .              nulev, (pres(k),k=nulev,1,-1),num_model_levels,             
     .              (sigma_edge(i),i=1,num_model_levels+1),                     
     .              num_hdr_vars,                                               
     .              (header_descr(i),                                           
     .               int_header(i),                                             
     .               real_header(i),                                            
     .               char_header(i),i=1,num_hdr_vars)                           
                                                                                
      write (iunit) (names(n),descs(n),                    n=1,nsfld),          
     .              (nameu(n),descu(n),                    n=1,nufld),          
     .              (named(n),descd(n),num_lev_diag(n),    n=1,ndfld)           
       return                                                                   
       end                                                                      
c                                                                               
            subroutine dgtrans                                                  
     .              (iunit,buffer,im,jnp,nlev,tem,pres,nameu)                   
c                                                                               
            dimension  buffer(im,jnp,nlev),tem(im,jnp),pres(nlev)               
            character * 8 nameu                                                 
c                                                                               
c               purpose : transfer 3 dimensional upper air fields               
c                         into a 2 dismensional array and call                  
c                         a routine to store.                                   
                                                                                
            do 50 k = nlev,1,-1                                                 
              do 51 i = 1,im                                                    
                do 52 j = 1,jnp                                                 
                     tem(i,j) = buffer(i,j,k)                                   
   52           continue                                                        
   51         continue                                                          
               call oihisout(iunit,tem,im,jnp,pres(k),nameu)                    
   50       continue                                                            
            return                                                              
            end                                                                 
c                                                                               
        subroutine uptrans(iunit,buffer,im,jnp,nlev,k,tem,pres,nameu)           
        dimension buffer(im,jnp,nlev),tem(im,jnp)                               
        character * 8 nameu                                                     
c                                                                               
c             purpose : to write upperair fields for each level                 
c                                                                               
c                       extract upperair field from a buffer for the            
c                       given level                                             
c                                                                               
        do 20 j = 1,jnp                                                         
           do 10 i = 1,im                                                       
             tem(i,j) = buffer(i,j,k)                                           
   10      continue                                                             
   20   continue                                                                
c                                                                               
c             writeout the upperair field                                       
c                                                                               
        call oihisout(iunit,tem,im,jnp,pres,nameu)                              
        return                                                                  
        end                                                                     
