      SUBROUTINE OIINIT(NYMD,NHMS,NB,KBC,IM,JNP,NLAY,NLEVOI,
     .                  PMAND,PMIDM)
C***********************************************************************
C  PURPOSE                                                              
C     INITIALIZATION OF OI ANALYSIS PARAMETERS                          
C  USAGE                                                                
C     CALLED BY GLAOI ONLY ONCE AT START OF ASSIMILATION SEGMENT        
C                                                                       
C  ARGUMENTS   DESCRIPTION                                              
C     NYMD.... CURRENT DATE (YYMMDD)                                    
C     NHMS.... CURRENT TIME (HHMMSS)                                    
C     NB...... CURRENT TIME STEP INDEX                                  
C     KBC..... BOUNDARY CONDITION UNIT NUMBER                           
C     IM...... LONGITUDINAL GRID POINTS                                 
C     JNP..... LATITUDINAL GRID POINTS                                  
C     NLAY.... NUMBER OF MODEL LEVELS
C     NLEVOI.. NUMBER OF UPPER AIR ANALYSIS PRESSURE LEVELS             
C     PMAND... PRESSURES OF UPPER AIR LEVELS (MB)                       
C     PMIDM... MID LAYER PRESSURES OF UPPER AIR LAYERS (MB)             
C                                                                       
C  SUBROUTINES NEEDED                                                   
C     GCMDRV   MODEL DRIVER                                             
C     INITIAL  SET OI PARAMETERS AND READ NAMELIST                      
C     CORTABLE READ HORIZONTAL AND VERTICAL ERROR CORRELATIONS          
C     TRIGSET  SET TRIGONOMETRIC PARAMETERS                             
C                                                                       
C***********************************************************************
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *
C***********************************************************************
C                                                                       
C                                                                       
      DIMENSION         PMAND   (NLEVOI)                                
      DIMENSION         PMIDM   (NLEVOI-1)                              
      LOGICAL           QQINT                                           
      LOGICAL           QBUDGET                                         
C     REAL              ZERO                                            
C                                                                       
      DATA  QQINT   /.FALSE./                                           
      DATA  QBUDGET /.FALSE./                                           
      DATA  ZERO    /0./                                                
C                                                                       
C***********************************************************************
C*       SET MODEL BOUNDARY CONDITIONS                                 *
C***********************************************************************
C                                                                       
      NHMSP1 = NHMS+1                                                   
      NDT   = 0                                                         
      rewind (kbc)
      call setbcs (kbc, nymd, nhms, im*jnp)
      rewind (kbc)
C                                                                       
C***********************************************************************
C*       OI INITIALIZATION                                             *
C***********************************************************************
C                                                                       
      CALL INITIAL(IM,JNP,NLAY,NLEVOI,PMAND,PMIDM)                           
      CALL CORTABLE(pmand,nlevoi)                                         
      CALL TRIGSET                                                      
C                                                                       
      RETURN                                                            
      END                                                               
