      SUBROUTINE OIPREP( nb, PSM, ptop, ZLWI,
     .                   ZLWFLAG, TSFC, TVSFC, PSFC, PSL, USL, VSL,
     .                   UA, VA, TA, ZA, RMIXA, RHA,
     .                   PMAND, PMIDM, IM, JNP, NLEVOI, nlay,
     .                   workspace )
C                                                                       
C                                                                       
      DIMENSION         PMAND    (NLEVOI)                               
      DIMENSION         PMIDM    (NLEVOI-1)                             
      DIMENSION         PSFC     (IM,JNP)                               
      DIMENSION         PSL      (IM,JNP)                               
      DIMENSION         PSM      (IM,JNP)                               
      DIMENSION         RHA      (IM,JNP,NLEVOI)                        
      DIMENSION         RMIXA    (IM,JNP,NLEVOI)                        
      DIMENSION         TA       (IM,JNP,NLEVOI)                        
      DIMENSION         TSFC     (IM,JNP)                               
      DIMENSION         TVSFC    (IM,JNP)                               
      DIMENSION         UA       (IM,JNP,NLEVOI)                        
      DIMENSION         USL      (IM,JNP)                               
      DIMENSION         VA       (IM,JNP,NLEVOI)                        
      DIMENSION         VSL      (IM,JNP)                               
      DIMENSION         ZA       (IM,JNP,NLEVOI)                        
      DIMENSION         ZLWFLAG  (IM,JNP)                               
      DIMENSION         ZLWI     (IM,JNP)                               
      dimension         workspace(*)

      data fill_value /1.e10/

! Pointers into workspace for getfg

!     Dimension    PKZ (im*jnp,nlay)
!     Dimension    TD  (im*jnp,nlay)
!     Dimension    THV (im*jnp,nlay)
!     Dimension    RH  (im*jnp,nlay)
!     Dimension    WRK (im*jnp,8)

      ipkz     = 1
      itd      = 1 +   im*jnp*nlay
      ithv     = 1 + 2*im*jnp*nlay
      irh      = 1 + 3*im*jnp*nlay
      iscratch = 1 + 4*im*jnp*nlay
C                                                                       
C LAND/WATER FLAG                                                       
C ---------------                                                       
C                                                                       
      DO K=1,IM*JNP                                                 
         IF (ZLWI(K,1) .EQ. 1.0) THEN                                   
           ZLWFLAG(K,1) = 1.                                            
         ELSE                                                           
           ZLWFLAG(K,1) = 0.                                            
         END IF                                                         
      end do
C                                                                       
C Compute surface pressure
C ------------------------
C                                                                       
      DO K=1,IM*JNP                                                 
         PSFC(K,1) = PSM(K,1) + PTOP                                    
      end do
C                                                                       
C COMPUTE SEA LEVEL PRESSURE AND INTERPOLATE UPPER AIR FIELDS TO        
C PRESSURE LEVELS.  Model routine getfg returns prognostic fields
C interpolated to pressure, and computes surface temperatures.
C ---------------------------------------------------------------        
C                                                                       
      call getfg( UA, VA, ZA, RMIXA, RHA, PSL, USL, VSL, 
     .            TSFC, TVSFC, PMAND, IM*JNP, NLEVOI, nb,
     .            workspace(ipkz), workspace(itd), workspace(ithv),
     .            workspace(irh), workspace(iscratch) )      

C Compute mid mandatory mean layer virtual temperatures
C -----------------------------------------------------

      call ztot(za,ta,pmand,pmidm,im,jnp,nlevoi)

C Change missing value flag for OI subroutines
C --------------------------------------------

      UNDEF = getcon('UNDEF')

      do k=1,im*jnp
         if (usl(k,1).eq.undef) usl(k,1) = fill_value
         if (vsl(k,1).eq.undef) vsl(k,1) = fill_value
      end do

      do k=1,im*jnp*nlevoi
         if (   ua(k,1,1).eq.undef)    ua(k,1,1) = fill_value
         if (   va(k,1,1).eq.undef)    va(k,1,1) = fill_value
         if (rmixa(k,1,1).eq.undef) rmixa(k,1,1) = fill_value
         if (  rha(k,1,1).eq.undef)   rha(k,1,1) = fill_value
      end do

      RETURN                                                            
      END                                                               
