                                                                                
      subroutine ptndat ( nymd,nhms )                                           
                                                                                
c....................................................................           
c                                                                   .           
c  Program:    PTNDAT                    Date: September 21, 1990   .           
c                                                                   .           
c  Language:   Fortran 77                                           .           
c  Computer:   Cray YMP 4/832                                       .           
c  Programmer: Mike Seablom, NASA/GSFC Code 911                     .           
c              Greenbelt, Md. 20771   (301) 286-7360  (FTS) 888-7360.           
c                                                                   .           
c  Program positions a dataset in repacked, level2b format to prop- .           
c  er date/time.                                                    .           
c                                                                   .           
c....................................................................           
                                                                                
      parameter ( mxqobs=200 )                                                  
                                                                                
      real         form, buffer, xform, xbuff, dummy(3), xdummy(3),             
     &             date1, time1, increment                                      
                                                                                
      integer      iret, istat, lin, ndelt, nf, nhour, error_code               
      character* 6 dataset_name                                                 
      character*24 string                                                       
      character*60 message                                                      
                                                                                
      character*8       dataname
      character*24      obsname

      logical           qobs, offlev                                            
                                                                                
      common /obs/      maxdex, nfgge, lun, dataname(5), hh(13,13,20),          
     $                  vcoroe(18,18,4), obserr(mxqobs,4,19),                   
     $                  ww(13,13,20),                                           
     $                  obsname(mxqobs), qobs(mxqobs,5), offlev(mxqobs)         
                                                                                
      common /record/   indat, intim, inctim, nfor(5), nbuf(5)                  
                                                                                
! Analysis control parameters                                                   
                                                                                
      common /contrl/ im, jnp, nb, ndalt, nhms0, nlay, nlaym1, nlayp1,          
     .                 nymd0, strat, idimen, slp, fdcos, fexp, saveae,          
     .                 sigdat,maxrep                                            
      logical strat,slp,fdcos,fexp,saveae,sigdat                                
                                                                                
      nymd0 = nymd                                                              
      nhms0 = nhms                                                              
      message(1:60) = ' '                                                       
                                                                                
! Read NFGGE datasets.                                                          
                                                                                
      do 1 nf =  1,nfgge                                                        
                                                                                
       input_lu = lun - 1 + nf                                                  
       write ( dataset_name, '(i6)' ) nymd                                      
                                                                                
                                                                                
c  Position the dataset at the correct time.                                    
                                                                                
       read ( unit=input_lu, iostat=error_code )  date1, time1,                 
     &                                            increment, string             
       if ( error_code .ne. 0 ) then                                            
         message=' PTNDAT: Failure reading observation dataset. '               
         write(6,'(/," PTNDAT: Error reading logical unit ",i2,/,
     &    " Attempted to read date ",i9," and time ",i9)') input_lu,
     &    nymd,nhms
         call flash( 5,message,1 )                                              
       end if                                                                   
                                                                                
                                                                                
!  Check for correct date.                                                      
                                                                                
                                                                                
       do 2 while ( time1 .ne. float( nhms ) .or.                               
     &              date1 .ne. float( nymd )      )                             
                                                                                
           do k = 1,4                                                           
                                                                                
             read (input_lu) form, buffer                                       
                                                                                
             do kk = 1,int(buffer)                                              
               read (input_lu)                                                  
             end do                                                             
                                                                                
           end do                                                               
                                                                                
           read (input_lu) form, buffer                                         
           read ( input_lu , iostat=error_code )  date1, time1,                 
     &                                       increment, string                  
           if ( error_code .ne. 0 ) then                                        
              message = ' PTNDAT: Failure reading observation dataset.'         
         write(6,'(/," PTNDAT: Error reading logical unit ",i2,/,
     &    " Attempted to read date ",i9," and time ",i9)') input_lu,
     &    nymd,nhms
              call flash ( 5,message,1 )                                        
           end if                                                               
                                                                                
 2     end do                                                                   
                                                                                
       write (6,'(1x,"Input dataset contains date ",f8.0," and time ",          
     &        f8.0)') date1, time1                                              
                                                                                
       if ( time1 .ne. float(nhms) ) then                                       
         message = ' PTNDAT: Requested time not located.        '               
         call flash ( 5,message,1 )                                             
       end if                                                                   
                                                                                
c  Check for proper time interval.                                              
                                                                                
       nhour = int( increment ) / 60                                            
       ndelt = nhour * 10000 + ( int(increment) - nhour*60 ) * 100              
                                                                                
       if ( ndelt .ne. ndalt ) then                                             
         message=' PTNDAT: Bad data time interval grouping '                    
         write(6,'(1x,"Expected interval:",i8,2x,"From data:",i8)')             
     &        ndalt, ndelt                                                      
         call flash ( 5,message,1 )                                             
       end if                                                                   
                                                                                
       read (input_lu) form, buffer                                             
       nfor(nf) = int(form)                                                     
       nbuf(nf) = int(buffer)                                                   
                                                                                
 1    end do                                                                    
      indat = int( date1 )                                                      
      intim = int( time1 )                                                      
      return                                                                    
      end                                                                       
