       SUBROUTINE PTOSIGM(lat,delman,sigfgs,pmand,pmidsig,psfc,im,jnp,          
     .                    mlev,nlay)                                            
C                                                                               
C ORIGINAL: 910120 DJL - Created from PTOSIGW which will not use analysis       
C                        increments from mandatory levels below the             
c                        surface.  Any increments there are taken to be         
C                                                                               
C                                                                               
       real           PMIDSIG(IM,NLAY)                                          
       real           PMAND(MLEV)                                               
       real           DELMAN(IM,JNP,MLEV)                                       
       real           SIGFGS(IM,NLAY)                                           
       real           psfc(im)                                                  
 
       LOGICAL        DEBUG 
       real           fill
       integer        fillmsg_count 
                                                                                
       REAL           BETA,CP,GRAV,OMEGA2,RADE,RGAS,ROCP,CPOG,GAMMA,            
     .                RCOP1,GCOP                                                
       COMMON /PHYSIC/ BETA,  CP, GRAV,OMEGA2,RADE,RGAS,                        
     .                 ROCP,CPOG,GAMMA, ROCP1,GOCP                              
C                                                                               
       COMMON /PRNTPROF/NPROF,ILOC(10),JLOC(10)                                 
       data DEBUG /.false./                                                     
                                                                                
       data fill /1.e10/                                                        
                                                                                
       if (lat.eq.1) fillmsg_count = 0
C                                                                               
       DO N = 1,NLAY                                                            
       DO I = 1,IM                                                              
                                                                                
C                       FIND MANDATORY UPPER LEVEL AND LOWER LEVEL              
C                       AT MODEL LEVEL                                          
                                                                                
          NBLW = 0                                                              
          NABV = 0                                                              
          DO M = 2,MLEV                                                         
             IF (pmidsig(i,n).LE.PMAND(M)) THEN                                 
                NBLW = M                                                        
                GO TO 45                                                        
             ENDIF                                                              
          END DO                                                                
          NBLW = MLEV + 1                                                           
   45     CONTINUE                                                              
          NABV = NBLW - 1                                                       
C                                                                               
         if(nblw .le. mlev) then
          IF (PMAND(NBLW).GT.PSFC(I)) THEN                                      
C                                                                               
C                       COMPUTE INTERPOLATION FACTORS FOR A SIGMA LEVEL         
C                       WITH A BRACKETING LOWER MANDATORY LEVEL THAT IS         
C                       BELOW THE SURFACE.  SET INCREMENT THERE TO 0            
C                       BEFORE INTERPOLATING.                                   
C                                                                               
C                                                                               
             PTSIFB = (PMIDSIG(I,N)** ROCP-PMAND(NABV)**ROCP)/                  
     .                 (PMAND(NBLW)** ROCP-PMAND(NABV)**ROCP)                   
             PTSIFA = 1.0 - PTSIFB                                              
             DMABV = DELMAN(I,LAT,NABV)                                         
             DMBLW = 0.                                                         
C                                                                               
          ELSE                                                                  
C                                                                               
C                       COMPUTE INTERPOLATION FACTORS FOR                       
C                       NORMAL LEVELS                                           
C                                                                               
C                                                                               
             PTSIFB = (PMIDSIG(I,N)**ROCP-PMAND(NABV)**ROCP)/                   
     .                 (PMAND(NBLW)**ROCP-PMAND(NABV)**ROCP)                    
             PTSIFA = 1.0 - PTSIFB                                              
             DMABV = DELMAN(I,LAT,NABV)                                         
             DMBLW = DELMAN(I,LAT,NBLW)                                         
                                                                                
          ENDIF                                                                 
         else
c
c              set the parameters to compute if
c              sigma level is below  mandatory 
c              level - just assign increment at lowest 
c              mandatory level to sigma level.
c
            ptsifb = 0.0
            ptsifa = 1.0
            dmabv  = delman(i,lat,mlev)
            dmblw  = 0.0
         endif
C                                                                               
c                       Final trap for filled mandatory level increments        
c                                                                               
          if (dmabv.eq.fill.or.dmblw.eq.fill) then                              
                                                                                
             fillmsg_count = fillmsg_count + 1 
 
             if (debug.and.fillmsg_count.le.10) then
 
             print 9801, i,lat,n,dmabv,dmblw,PSFC(I)                            
 9801        format(' *** Note: attempted to use filled',                    
     .              ' analysis increment in PTOSIGM; increment',                
     .              ' set to 0.',/,'     Model grid point (i,j,l)=(',           
     .              i3,',',i3,',',i3,')',                                       
     .              ' dmabv=',1p,e12.3,2x,'dmblw=',e12.3,                       
     .              2x,'psfc=',0p,f8.1)                                         
             print 9802                                                         
 9802        format(' ',4x,'m',3x,'pmand',8x,'delman')                          
             do m=1,mlev                                                        
                print 9803, m,pmand(m),delman(i,lat,m)                          
 9803           format(' ',i5,f8.1,1p,e14.3)                                    
             end do                                                             
             print 9804                                                         
 9804        format(' ',4x,'m',1x,'pmidsig',8x,'sigfgs')                        
             do m=1,nlay                                                        
                print 9805, m,PMIDSIG(I,m),SIGFGS(I,m)                          
 9805           format(' ',i5,f8.1,1p,e14.3)                                    
             end do                                                             
 
             else if (debug.and.fillmsg_count.eq.11) then
 
                print 9806
 9806           format(' *** Note: more than 10 attempts to use filled',
     .                 ' analysis increments in PTOSIGM')
 
             end if 
                                                                                
             if (dmabv.eq.fill) then                                            
                dmabv=0.                                                        
                dmblw=0.                                                        
             else if (dmblw.eq.fill) then                                       
                dmblw=0.                                                        
             end if                                                             
                                                                                
          end if                                                                
c
C                                                                               
C              INTERPOLATE MANDATORY LEVEL MIXING RATIO DELTAS         
C              TO SIGMA LEVELS                                         
C                                                                               
             DELSIG = PTSIFA * DMABV + PTSIFB * DMBLW                              
c
c              sigma level is below lowest mid mandatory 
c              level - just assign increment at lowest 
c              mid mandatory level to sigma level.
c
                                                                                
C                       CONVERT FIRST GUESS SPECIFIC HUMIDITY ON SIGMA          
C                       LEVELS TO MIXING RATIO IN G/KG                          
                                                                                
          SIGFGS(I,N) = SIGFGS(I,N)/                                            
     .                       (1.0-SIGFGS(I,N))*1000.00                          
                                                                                
C SET ANY MIXING RATIO DELTAS ABOVE 300 MB TO 0                                 
C ---------------------------------------------                                 
                                                                                
          IF (PMIDSIG(I,N).LT.300.0) DELSIG=0.                                  
                                                                                
C ADD MIXING RATIO DELTAS ON SIGMA LEVELS TO FIRST GUESS - RESULT IS            
C ANALYSIS ON SIGMA LEVELS.  CHECK THAT ALL MIXING RATIOS ARE .GE. 0.           
C -------------------------------------------------------------------           
                                                                                
          SIGFGS(I,N) = SIGFGS(I,N) + DELSIG                                    
                                                                                
          IF (SIGFGS(I,N).LT.0.0) SIGFGS(I,N)= 0.0                              
                                                                                
       end do                                                                   
       end do                                                                   
                                                                                
C CONVERT ANALYZED MIXING RATIOS ON SIGMA LEVELS TO SPECIFIC HUMIDITIES         
C ---------------------------------------------------------------------         
                                                                                
       DO N = 1,NLAY                                                            
       DO I = 1,IM                                                              
          SIGFGS(I,N)=SIGFGS(I,N)/1000.0                                        
          SIGFGS(I,N)=SIGFGS(I,N)/(1.0+SIGFGS(I,N))                             
                                                                                
C RESET ANY SPECIFIC HUMIDITIES THAT EXCEED 1.0 OR FALL BELOW 0.                
C --------------------------------------------------------------                
                                                                                
          IF (SIGFGS(I,N).GT.1.0) SIGFGS(I,N)=1.0                               
          IF (SIGFGS(I,N).LT.0.0) SIGFGS(I,N)=0.0                               
                                                                                
       end do                                                                   
       end do                                                                   
                                                                                
       RETURN                                                                   
       END                                                                      
