      SUBROUTINE PTOSIGT ( LAT, TDELMDM, TSIGFGS,
     .                     PMIDSIG, PEDGESIG,TDELSIG,
     .                     TPROFILE ,pmand,pmidm,PTOP)
 
 
C ANALYSIS CONTROL VARIABLES
C --------------------------
 
      COMMON /CONTRL/ IM, JNP, NB, NDALT, NHMS, NLAY, NLAYM1, NLAYP1,
     .                NYMD, STRAT, IDIMEN, SLP, FDCOS, FEXP, SAVEAE,
     .                SIGDAT,MAXREP
 
      LOGICAL STRAT,SLP,FDCOS,FEXP,SAVEAE,SIGDAT
 
C VERTICAL INDEX COMMON
C ----------------------
 
      COMMON /MLAY/ MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1
      COMMON /MLAY2/ MLEVM2, MLEVP1
 
C PHYSICAL CONSTANTS
C -------------------
 
      COMMON /PHYSIC/ BETA,  CP, GRAV,OMEGA2,RADE,RGAS,
     .                ROCP,CPOG,GAMMA, ROCP1,GOCP
      REAL           BETA,CP,GRAV,OMEGA2,RADE,RGAS,ROCP,CPOG,GAMMA,
     .               ROCP1,GOCP
 
C INDEXES OF PROFILES TO PRINT
C ----------------------------
 
      COMMON /PRNTPROF/ NPROF,ILOC(10),JLOC(10)
 
C PRODUCTS OF GRID LIMITS
C -----------------------
 
      COMMON /PRODLIM/ IJMLEV, IJMLEVM1, ILBELOW, IMJNP, IMLSM1,
     .                 IMMLEV, IMMLEVM1, IMMLEVP1, IMNLAY, IMNLAYP1
 
C MODEL ARRAY DIMENSIONS
C ----------------------
 
 
      REAL           TDELMDM(IM,JNP,MLEV), TSIGFGS(IM,NLAY),
     .               PTSTIFA, PTSTIFB,
     .               PMIDSIG(IM,NLAY), PEDGESIG(IM,NLAYP1),
     .               TDELSIG(IM,NLAY),
     .               TPROFILE(7,NLAY,NPROF),
     .               TDMABOVE, TDMBELOW, PFACTOR, P1000K, VHPOWER
      real           pmand(mlev)
      real           VMPSL
      real           pmidm(MLEVM1)
      real           PTOP
 
 
      LOGICAL QPRTPROF
 
 
      P1000K=1000.00**ROCP
 
C DETERMINE IF ANY TEMPERATURE PROFILES ARE TO BE PRINTED AT THIS
C LATITUDE
C ---------------------------------------------------------------
 
      QPRTPROF=.FALSE.
 
      IF (NPROF.GT.0) THEN
 
         IFIRSTPF=0
         ILASTPF=0
         DO 10 IPROF=1,NPROF
            IF (LAT.EQ.JLOC(IPROF)) THEN
               IF (IFIRSTPF.EQ.0) IFIRSTPF=IPROF
               ILASTPF=IPROF
               QPRTPROF=.TRUE.
            ENDIF
   10    CONTINUE
      ENDIF
 
      IF (QPRTPROF) THEN
        CALL FILLPROF(PMIDSIG,ILOC,JLOC,IM,NLAY,1,7,NPROF,LAT,TPROFILE)
      ENDIF
 
C GATHER MID MANDATORY LEVEL TEMPERATURE DELTAS LYING ABOVE AND BELOW
C EACH SIGMA LEVEL
C -------------------------------------------------------------------
 
      IF (QPRTPROF) THEN
 
       CALL FILLPROF(TSIGFGS,ILOC,JLOC,IM,NLAY,2,7,NPROF,LAT,TPROFILE)
 
      ENDIF
      DO  50 I = 1,IM
      DO  40 LEV=1,NLAY
         VMPSL = PMIDSIG(I,LEV)
      DO  20 M=1,MLEVM1
         IF(VMPSL .LE. pmidm(M)) THEN
              NBLW = M
              GO TO 30
         ENDIF
   20 CONTINUE
      NBLW = MLEV
   30 CONTINUE
      NABV = NBLW - 1
 
C INTERPOLATE MID MANDATORY LEVEL TEMPERATURE DELTAS TO SIGMA LEVELS
C ------------------------------------------------------------------
                                                                        
      IF(NABV .LE. 0) THEN                                              
                                                                        
C SIGMA LEVEL IS ABOVE TOP MID MANDATORY LEVEL - INTERPOLATE BETWEEN THE
C TOP MID MANDATORY LEVEL AND A ZERO INCREMENT PLACED AT PTOP (10MB).   
                                                                        
          PTSTIFB = (PMIDSIG(I,LEV) ** ROCP - PTOP ** ROCP) /           
     .              (pmidm(NBLW) ** ROCP - PTOP ** ROCP)               
          PTSTIFA = 1.0 - PTSTIFB                                     
                                                                        
          TDMABOVE = 0                                                  
          TDMBELOW = TDELMDM(I,LAT,NBLW)                                
          TDELSIG(I,LEV) = PTSTIFA * TDMABOVE+PTSTIFB*TDMBELOW          
                                                                        
      ELSEIF (NBLW .LT. MLEV) THEN                                      
                                                                        
C SIGMA LEVEL IS ABOVE LOWEST MID MANDATORY LEVEL:                      
                                                                        
         IF (pmand(NBLW+1).GT.PEDGESIG(I,NLAYP1)) THEN                   
C                                                                       
C COMPUTE INTERPOLATION FACTORS FOR A SIGMA LEVEL WITH A BRACKETING     
C LOWER MID MANDATORY LEVEL THAT HAS BEEN OBTAINED USING A LOWER MANDATORY
C LEVEL THAT IS BELOW THE SURFACE.  SET INCREMENT   
C THERE TO 0 BEFORE INTERPOLATING.                                      
C                                                                       
            PTSTIFB = (PMIDSIG(I,LEV) ** ROCP - pmidm(NABV) ** ROCP) / 
     .                (pmidm(NBLW) ** ROCP - pmidm(NABV) ** ROCP)     
            PTSTIFA = 1.0 - PTSTIFB                                   
            TDMABOVE = TDELMDM(I,LAT,NABV)                              
            TDMBELOW = 0.                                               
            TDELSIG(I,LEV) = PTSTIFA * TDMABOVE+PTSTIFB*TDMBELOW        
                                                                        
         ELSE                                                           
                                                                        
C ELSE NORMAL CASE WHERE LOWER BRACKETING MID MANDATORY LEVEL IS ABOVE  
C THE SURFACE.                                                          
                                                                        
            PTSTIFB = (PMIDSIG(I,LEV) ** ROCP - pmidm(NABV) ** ROCP) / 
     .                (pmidm(NBLW) ** ROCP - pmidm(NABV) ** ROCP)     
            PTSTIFA = 1.0 - PTSTIFB                                   
            TDMABOVE = TDELMDM(I,LAT,NABV)                              
            TDMBELOW = TDELMDM(I,LAT,NBLW)                              
            TDELSIG(I,LEV) = PTSTIFA * TDMABOVE+PTSTIFB*TDMBELOW        
                                                                        
         END IF                                                         
                                                                        
      ELSE                                                              
                                                                        
C SIGMA LEVEL IS BELOW LOWEST MID MANDATORY LEVEL - JUST ASSIGN         
C INCREMENT AT LOWEST MID MANDATORY LEVEL TO SIGMA LEVEL.               
                                                                        
         TDELSIG(I,LEV) = TDELMDM(I,LAT,MLEVM1)                         
                                                                        
      ENDIF                                                             
 
 
C ADD TEMPERATURE DELTAS ON SIGMA LEVELS TO FIRST GUESS - RESULT IS
C ANALYSIS ON SIGMA LEVELS
C -----------------------------------------------------------------
 
      TSIGFGS(I,LEV)=
     .   TSIGFGS(I,LEV)+TDELSIG(I,LEV)
  40  CONTINUE
  50  CONTINUE
C
      IF (QPRTPROF) THEN
       CALL FILLPROF(TDELSIG,ILOC,JLOC,IM,NLAY,3,7,NPROF,LAT,TPROFILE)
      ENDIF
 
      IF(QPRTPROF) THEN
       CALL FILLPROF(TSIGFGS,ILOC,JLOC,IM,NLAY,4,7,NPROF,LAT,TPROFILE)
      ENDIF
C
C CHECK POTENTIAL TEMPERATURE PROFILES FOR STABILITY - TROPOSPHERIC
C TEMPERATURES MUST BE CONVERTED TO POTENTIAL TEMPERATURES FOR THE CHECK
C ----------------------------------------------------------------------
C
         DO 70 N = 1,NLAY
           DO 60 I = 1,IM
               PFACTOR = P1000K / (PMIDSIG(I,N) * * ROCP)
               TSIGFGS(I,N)=TSIGFGS(I,N)*PFACTOR
   60      CONTINUE
   70    CONTINUE
C
               IF(QPRTPROF) THEN
        CALL FILLPROF(TSIGFGS,ILOC,JLOC,IM,NLAY,5,7,NPROF,LAT,TPROFILE)
      ENDIF
C
      CALL STABLE ( LAT, TSIGFGS, PEDGESIG )
      IF(QPRTPROF) THEN
       CALL FILLPROF(TSIGFGS,ILOC,JLOC,IM,NLAY,6,7,NPROF,LAT,TPROFILE)
      ENDIF
C
          DO 90 N = 1,NLAY
             DO 80 I = 1,IM
                PFACTOR = P1000K / (PMIDSIG(I,N) * * ROCP)
                TSIGFGS(I,N)=TSIGFGS(I,N)/PFACTOR
   80        CONTINUE
   90     CONTINUE
 
      IF(QPRTPROF) THEN
        CALL FILLPROF(TSIGFGS,ILOC,JLOC,IM,NLAY,7,7,NPROF,LAT,TPROFILE)
      ENDIF
C
      IF (LAT.EQ.JNP.AND.NPROF.GT.0) THEN
 
         DO 520 IPROF=1,NPROF
            PRINT 5000, JLOC(IPROF),ILOC(IPROF)
 5000       FORMAT(//,' PROFILES OF SIGMA LEVEL TEMPERATURE',
     .             ' COMPUTATIONS AT LAT',I4,2X,'LON',I4,':',//,
     .             9X,'LEVEL',6X,'PMIDSIG',6X,'FG TEMP',
     .             3X,'INTP DEL T',4X,'ANAL TEMP',5X,'POT TEMP',
     .             3X,'STBL POT T',4X,'STBL TEMP',/)
            DO 510 LEV=1,NLAY
               PRINT 5010, LEV,(TPROFILE(K,LEV,IPROF),K=1,7)
 5010          FORMAT(' ',I13,1P7E13.3)
  510       CONTINUE
  520    CONTINUE
 
      END IF
 
      RETURN
      END
