


                                                                                
      SUBROUTINE RDERROR( nymd, nhms,PER,TER,RMXER,HER,ISTART,JOBNO )           
                                                                                
C  READS INITIAL ERROR VARIANCES FOR SEA LEVEL PRESSURE, SEA LEVEL              
C  TEMPERATURE, MIXING RATIO, AND HEIGHTS.                                      
                                                                                
C  NOTES:                                                                       
C  1) ABOVE 300 MB, MIXING RATIO ERRORS ARE SET TO ZERO. ONE IS                 
C     INTERESTED ONLY IN MIXING RATIO ERRORS AT AND BELOW 300 MB                
C  2) ALL ERROR ARRAYS ARE FROM TOP TO BOTTOM. I.E. 50 MB VALUE STORED          
C     FIRST, 1000 MB VALUE STORED LAST                                          
                                                                                
                                                                                
      CHARACTER*8       CUTOFF                                                  
      DIMENSION         HER(IM,JNP,MLEV)                                        
C                     - GEOPOTENTIAL HEIGHT FORECAST ERRORS                     
      INTEGER           I                                                       
      INTEGER           ICLOSE                                                  
      INTEGER           IDATE                                                   
      character*8       cjob                                                    
      INTEGER           ISTART                                                  
C                     - FLAG READ FROM ERROR FILE HEADER INDICATING             
C                       WHETHER EXPERIMENT IS BEGINING OR RESTARTING            
      INTEGER           ITIME                                                   
      CHARACTER*80      JCS                                                     
      character*8       jobno                                                   
C                     - NUMBER ASSIGNED TO THIS EXPERIMENT                      
      INTEGER           MFLTRY                                                  
      INTEGER           MFSTAT                                                  
      INTEGER           MXMSGS                                                  
      data              mxmsgs /20/                                             
      INTEGER           NOMSGS                                                  
      integer           dummy, dummy2                                           
      DIMENSION         PER(IM,JNP)                                             
C                     - SEA LEVEL PRESSURE FORECAST ERRORS                      
      REAL              TAUA                                                    
      REAL              TAUD                                                    
      REAL              TAUM                                                    
      DIMENSION         TER(IM,JNP)                                             
C                     - SEA LEVEL TEMPERATURE FORECAST ERRORS                   
      CHARACTER*80      RETMSG(20)                                              
      DIMENSION         RMXER(IM,JNP,MLEV)                                      
C                     - MIXING RATIO FORECAST ERRORS                            
                                                                                
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,             
     $                  SIGDAT                                                  
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS0,              
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD0,    STRAT,             
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,             
     $                  SIGDAT,  MAXREP                                         
                                                                                
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1                    
                                                                                
                                                                                
                                                                                
                                                                                
                                                                                
C  Read the error file header records.                                          
                                                                                
      read (89) dummy, istart                                                   
      read (89) cjob, dummy, idate, dummy2, itime                               
                                                                                
      write (6,950) istart, cjob, idate, itime                               
                                                                                
C  Check for proper date/time and job number.                                   
                                                                                
      if ( jobno .ne. cjob ) then                                         
        write(6,'(" From error file: ",a8,3x,"From namelist: ",a8)')            
     &       cjob, jobno                                                  
        call flash ( -2,                                                         
     &    'RDERROR: Error file contains wrong experiment number.       '        
     &    ,1 )                                                                  
      end if                                                                    
                                                                                
      CALL DATTAU( NYMD, NHMS, TAUM )                                           
      CALL DATTAU( IDATE, ITIME, TAUA )                                         
      WRITE(6,960) NYMD, NHMS, TAUM, IDATE, ITIME, TAUA                         
      IF( ISTART.NE.0 ) TAUA = TAUA + 6.0                                       
      TAUD = ABS( TAUM - TAUA )                                                 
      if ( taud .gt. 0.25 .and. istart .eq. 0 ) then                            
        write (6,*) ' PROBLEM: RDERROR>> Start flag on error file',             
     &    ' may be incorrect. Experiment will be allowed to continue.'          
                                                                                
        call flash ( 3,                                                         
     &    'RDERROR: The start flag on the error file is incorrect.     '        
     &    ,1 )                                                                  
                                                                                
      end if                                                                    
                                                                                
      if( taud .gt. 0.25 .and. istart .ne. 0 ) then                             
        write(6,'(" Model time:",2i7,/," Error time:",2i7)')                    
     &            nymd, nhms, idate, itime                                      
        call flash ( 2,                                                         
     &    'RDERROR: Model time does not match time on error file.      '        
     &    ,1 )                                                                  
      end if                                                                    
                                                                                
c Read the error file and load arrays.                                          
      read(89) ter                                                              
      read(89) per                                                              
      read(89) rmxer                                                            
      read(89) her                                                              
                                                                                
  910 FORMAT(4X,A4/2X,A6)                                                       
  920 FORMAT(' RDERROR: ***** Experiment ',A8,' *****',/                        
     $       ' RDERROR: ***** CUTOFF = ',A6,' *****' )                          
  950 FORMAT(' RDERROR:   START FLAG = ', I2, '   JOB = ', A8,                  
     $                             '   DATE = ', I8, '   TIME = ', I8 )         
  960 FORMAT(' RDERROR:  NYMD = ',I6,'   NHMS = ',I6,'  TAUM = ',F10.2/         
     $       ' RDERROR: IDATE = ',I6,'  ITIME = ',I6,'  TAUA = ',F10.2)         
      END                                                                       






