      subroutine rdmix ( nymd, nhms, data, bq, nobs, pmand, psfc,
     &                   im, jnp, mlev, mmix )
 
C  READ RELATIVE HUMIDITY AND MIXING RATIO DATA
 
 
 
      INTEGER           MXQOBS
      PARAMETER       ( MXQOBS = 200 )
 
      INTEGER           BQ(150000  )
C     REAL              BUFF
      real              data( 1500000 )
C     REAL              FORM
      INTEGER           I
      INTEGER           IERR
      INTEGER           IRET
      INTEGER           IRH
      INTEGER           KK
      INTEGER           LIN
      INTEGER           LMIX
      INTEGER           NBUFF
      INTEGER           NF
      INTEGER           NFORM
      INTEGER           NOBS
      real              psfc(im,jnp)
      real              pmand(mlev)
      integer           undergnd_count
C     REAL              XBUFF
C     REAL              XFORM
      character*60      message
      logical           onestage
 
C  ANALYSIS CONTROL PARAMETERS
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
 
C  DATA POINTERS
      common /dataptrs/ ikx, ilat, ilon, ipmix, itype, imix, ifcer,
     &                  itime
      common /scan/     maxobs, rscan, onestage, max_data
 
C  WORKING SPACE TO STORE A DATA BUFFER.
      real              IBMBUF, MIXTIM, MIXKX, MIXLAT, MIXLON, PMIX,
     $                  RH, MIX, QMIX, PAD3
      INTEGER           BPAD
      COMMON /LEVEL/    IBMBUF(128,8), MIXTIM(128), MIXKX(128),
     $                  MIXLAT(128), MIXLON(128), PMIX(128),
     $                  RH(128), MIX(128), QMIX(128),
     $                  PAD3(157952), BPAD(20000)
 
C  OBSERVATIONS INFORMATION
      CHARACTER*8       DATANAME
      character*24      obsname
      LOGICAL           QOBS, OFFLEV
      COMMON /OBS/      MAXDEX, NFGGE, LUN, DATANAME(5), HH(13,13,20),
     $                  VCOROE(18,18,4), OBSERR(MXQOBS,4,19),
     $                  WW(13,13,20),
     $                  OBSNAME(MXQOBS), QOBS(MXQOBS,5), OFFLEV(MXQOBS)
 
C  MANDATORY PRESSURE LEVELS
      COMMON /PRMAND18/ PMAND18(18), ALOGP18(18), PKAP18(18),
     $                  PKAP118(18), PM18(18)
 
C OBSERVATIONAL DATA INFO.
      COMMON /RECORD/   INDAT, INTIM, INCTIM, NFOR(5), NBUF(5)
 
      message(1:60) = ' '
      undergnd_count = 0
 
C  DEFINE HIGHEST PRESSURE LEVEL FOR MIXING RATIO ANALYSIS.
      LMIX = mlev - mmix + 1
 
C  SET STARTING ADDRESSES OF DATA .
      IKX   = 1
      ILAT  = 1 *150000    + 1
      ILON  = 2 *150000    + 1
      IPMIX = 3 *150000    + 1
      ITYPE = 4 *150000    + 1
      IMIX  = 5 *150000    + 1
      IRH   = 6 *150000    + 1
 
C  INITIALIZE DATA QUALITY FLAG ( GOOD DATA HAS BQ = 1 )
      DO 100 I = 1, 150000  
         BQ(I) = 1
  100 CONTINUE
 
C  CHECK ON DATASET POSITION TO RIGHT DATE/TIME.
      IF( INDAT.NE.NYMD .OR. INTIM.NE.NHMS ) THEN
         WRITE( 6, 900 ) NYMD, NHMS, INDAT, INTIM
         message = ' RDMIX: Dataset positioned to wrong date/time.'
         call flash( 5,message,1 )
      ENDIF
 
      NOBS = 0
C  READ FROM THE DIFFERENT FILES CONTAINING MIXING RATIO DATA
      DO 500 NF = 1, NFGGE
         LIN   = LUN + NF - 1
         NFORM = NFOR(NF)
         NBUFF = NBUF(NF)
         IF( NFORM.NE.3 ) THEN
            WRITE( 6, 901 ) NFORM
            message = ' RDMIX: Dataset positioned to wrong form.'
             call flash(5,message,1)
         ENDIF
 
         print*, ' RDMIX: Reading mixing ratio data. '
 
C  READ IN BLOCKS OF MIXING RATIO DATA
        IF( NBUFF.GT.0 ) THEN
        DO 400 J = 1, NBUFF
 
C  READ AND CONVERT NEXT BLOCK OF REPORTS
            READ( LIN, IOSTAT=IERR ) IBMBUF
            IF( IERR.NE.0 ) then
              message = ' RDMIX: I/O error, data lost.    '
              call flash( 2,message,1 )
            end if
 
            mixtim(1:128)  =  ibmbuf(1:128,1)
            mixkx (1:128)  =  ibmbuf(1:128,2)
            mixlat(1:128)  =  ibmbuf(1:128,3)
            mixlon(1:128)  =  ibmbuf(1:128,4)
            pmix  (1:128)  =  ibmbuf(1:128,5)
            rh    (1:128)  =  ibmbuf(1:128,6)
            mix   (1:128)  =  ibmbuf(1:128,7)
            qmix  (1:128)  =  ibmbuf(1:128,8)
 
C  STORE REPORTS THAT PASSED PROXIMITY CHECK ( Q.LT.2 ), HAVE DATA TYPES
C  MARKED FOR THE ANALYSIS, AND REPORTED AT PRESSURE LEVELS BELOW 300 MB
C  PART OF LAST BUFFER MAY BE FILLED.
            DO 300 I = 1, 128
            IF( MIXKX(I).LT.10.E+06 ) THEN
 
c Interpolate model surface pressure to observation location.
               call terpv ( mixlat(i), mixlon(i), psobs, 1, psfc )
 
c Trap for any mixing ratio observations below the interpolated surface
c pressure.  This check is quite crude and will sometimes remove and
c sometimes keep data near the surface in areas with rapidly varying
c topography.  Data well below the suface will be caught, however.
 
               if (pmix(i).lt.psobs) then
 
               KK = MIXKX(I) + 0.1
               IF( QOBS(KK,NF).AND.(PMIX(I).GE.PMAND(LMIX))
     $                                   .AND.(QMIX(I).LT.1.99) ) THEN
 
                  NOBS = NOBS + 1
                  IF( NOBS.GT.max_data ) then
                    message = ' RDMIX: NOBS exceeds MAX_DATA. '
                    call flash ( 5,message,1 )
                  end if
                  DATA( IKX  + NOBS-1) =  MIXKX(I)
                  DATA(ILAT  + NOBS-1) = MIXLAT(I)
                  DATA(ILON  + NOBS-1) = MIXLON(I)
                  DATA(IPMIX + NOBS-1) =   PMIX(I)
                  DATA(IMIX  + NOBS-1) =    MIX(I)
                  DATA(IRH   + NOBS-1) =     RH(I)
 
C  TURN QUALITY FLAG OFF FOR SUSPICIOUS REPORTS
                  IF( ABS(QMIX(I)-1.0).LT.0.5 ) BQ(NOBS) = 0
               ENDIF
 
               else
                  undergnd_count = undergnd_count + 1
               end if
 
            ENDIF
  300       CONTINUE
  400    CONTINUE
         ENDIF
 
C  READ NEXT SUBHEADER
         READ( LIN, IOSTAT=IERR ) FORM, BUFF
         IF( IERR.NE.0 ) then
          message = ' RDMIX: I/O error on form/buffer read, data lost.'
          call flash ( 2,message,1 )
         end if
         xform = form
         xbuff = buff
         NFOR(NF) = XFORM + 0.5
         NBUF(NF) = XBUFF + 0.5
 
  500 CONTINUE
 
      if (undergnd_count.gt.0) then
         write(6,1001) undergnd_count
 1001    format(' RDMIX:',i7,' observations below model surface')
      end if
 
      IF( NOBS.GT.0 ) THEN
 
         WRITE( 6, 902 ) NOBS
 
C  COMPRESS THE DATA AND DEFINE NEW STARTING ADDRESSES
         DO 600 I = 1, NOBS
            DATA(  NOBS + I) = DATA(ILAT  + I-1)
            DATA(2*NOBS + I) = DATA(ILON  + I-1)
            DATA(3*NOBS + I) = DATA(IPMIX + I-1)
            DATA(5*NOBS + I) = DATA(IMIX  + I-1)
            DATA(6*NOBS + I) = DATA(IRH   + I-1)
  600    CONTINUE
         ILAT  =  NOBS + 1
         ILON  = 2*NOBS + 1
         IPMIX = 3*NOBS + 1
         ITYPE = 4*NOBS + 1
         IMIX  = 5*NOBS + 1
      ENDIF
 
      RETURN
  900 FORMAT(' RDMIX: Obser. dataset positioned at the ',
     $                                             'wrong date/time'/
     $       ' RDMIX: Trying to perform analysis at date/time =',2I8 /
     $       ' RDMIX:         Dataset positioned at date/time =',2I8 )
  901 FORMAT(' RDMIX: Obser. dataset positioned to form =',I8 /
     $       ' RDMIX:                     expected form =       3 '  )
  902 FORMAT('0RDMIX: * * * NOBS read in by RDMIX = ',I8/)
      END
