                                                                        
c.....................................................................c         
!                                                                     !         
! Program Name :  REFHGT                     Date: May 31, 1991       !         
! Programmer   :  M. Seablom                                          !         
! Analysis Version 1.1                                                !         
!                                                                     !         
! Program REFHGT adds a space in the DATA array for reference level   !         
! height observations for satellite data.                             !         
!                                                                     !         
c.....................................................................c         
!                                                                     !         
! N A S A  /  G M S B   O p t i m u m   I n t e r p o l a t i o n     !         
!                                                                     !         
c.....................................................................c         
                                                                                
                                                                                
      subroutine refhgt ( data, nobs, ikx, ilat, ilon, ipzw, ityp,              
     &                    iz, iwu, iwv, itim, ref_pressure, max_data )          
                                                                                
      integer       ikx, ilat, ilon, ipzw, nobs, max_data,                      
     &              counter                                                     
      real          data(*), ref_pressure(*)                                    
      character*60 message
                                                                                
! Extract reference pressures. Check for profile existence by scan-             
! ning the 400 millibar level.                                                  
                                                                                
      counter = 0                                                               
                                                                                
      do i = 1,nobs                                                             
                                                                                
        if ( (  data( ipzw+i-1 ) .eq. 400. )   .and.                            
     &       (  data( ikx+i-1 ) .gt. 30.   )   .and.                            
     &       (  data( ikx+i-1 ) .le. 86.   ) ) then                             
                                                                                
           counter = counter + 1                                                
 
           if ( nobs+counter .gt. max_data ) then
              message = ' REFHGT: max_data exceeded while ' //         
     &               ' adding reference observations '
              call flash( 5,message,1 )
           end if
 
           data ( ikx+nobs+counter-1 ) = data( ikx+i-1 )                        
           data (ilat+nobs+counter-1 ) = data(ilat+i-1 )                        
           data (ilon+nobs+counter-1 ) = data(ilon+i-1 )                        
           data (ipzw+nobs+counter-1 ) = ref_pressure(i)                        
           data (  iz+nobs+counter-1 ) =    0.                                  
           data ( iwu+nobs+counter-1 ) = 1. e15                                 
           data ( iwv+nobs+counter-1 ) = 1. e15                                 
           data (itim+nobs+counter-1 ) = data(itim+i-1 )                        
 
           ref_pressure(nobs+counter ) = ref_pressure(i)
                                                                                
        end if                                                                  
                                                                                
      end do                                                                    
                                                                                
      nobs = nobs + counter                                                     
      write( 6,'(/," REFHGT: ",i7," reference height observations",             
     &      " constructed.",/)') counter                                        
                                                                                
      end                                                                       
