 
      SUBROUTINE SATHGT( KX, LAT, LON, Z, PREF, NOBS, ZMOD, Z1000 )
 
C  COMPUTE SATELLITE HEIGHTS FROM THICKNESSES USING FIRST GUESS HEIGHT
C  FIELD AND UPDATED HEIGHT AT 1000 MB.
 
 
      INTEGER           NOBS
 
      real              DZOBS(10000)
      real              DZ1000(144*91)
      INTEGER           I
      INTEGER           IBATCH
      INTEGER           II
      INTEGER           IREF
      real              KX(NOBS)
      real              LAT(NOBS)
      INTEGER           LBATCH
      INTEGER           LLAST
      real              LON(NOBS)
      INTEGER           N
      INTEGER           NBATCH
      DIMENSION         PREF(NOBS)
      DIMENSION         Z(NOBS)
      DIMENSION         ZMOD(im,jnp,mlev)
      real              ZREF
      DIMENSION         Z1000(im,jnp)
      character*60      message
 
C  ANALYSIS CONTROL PARAMETERS
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT,  MAXREP
 
      common /pmh/      pmand(18)
 
C VERTICAL INDICES
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1
 
      DATA              FILL / 1.e15 /
      message(1:60) = ' '
 
C COMPUTE DELZ AT THE GRIDPOINTS
      loop_count = 0
 
      do 100 i = 1,im
         do 101 j = 1,jnp
           loop_count = loop_count + 1
           dz1000(loop_count) = z1000(i,j) - zmod(i,j,mlev)
  101    continue
  100 CONTINUE
 
C  DO THE HEIGHT COMPUTATION IN BATCHES
      LBATCH = 10000
      NBATCH = NOBS / LBATCH
      IF( MOD( NOBS, LBATCH ).NE.0 ) THEN
         NBATCH = NBATCH + 1
         LLAST  = MOD( NOBS, LBATCH )
      ELSE
         LLAST  = LBATCH
      ENDIF
      IF( NBATCH.EQ.0 ) then
         message = ' SATHGT: Zero batch size detected. '
         call flash( 5,message,1 )
      end if
 
      DO 500 N = 1, NBATCH
         IBATCH = LBATCH*(N-1) + 1
         IF( N.EQ.NBATCH ) LBATCH = LLAST
 
C INTERPOLATE DZ TO OBS LOCATIONS IN THE BATCH.
         CALL TERPV( LAT(IBATCH), LON(IBATCH), DZOBS, LBATCH, DZ1000 )
 
C  COMPUTE HEIGHTS FOR SATELLITE OBSERVATIONS IN THE BATCH
         II = IBATCH - 1
         DO 200 I = 1, LBATCH
            II = II + 1
            IF( (KX(II).GT.30.0).AND.(KX(II).LE.86.0).AND.
     $                                       (Z(II).LT.1.0E+10) ) THEN
 
C  CHECK THAT REFERANCE PRESSURE IS ONE OF THE VALID MANDATORY LEVELS
               IREF = IPLEV( PREF(II) )
               IF( (IREF.LE.mlev).AND.
     $                     (ABS(PREF(II)-PMAND(IREF)).LT.0.001) ) THEN
                  CALL TERP( IM, JNP, LAT(II), LON(II),
     $                                   ZMOD(1,1,IREF), ZREF )
                  Z(II) = Z(II) + ZREF + DZOBS(I)
               ELSE
                  Z(II) = FILL
               ENDIF
            ENDIF
 200     CONTINUE
 
 500  CONTINUE
      RETURN
      END
