                                                                        
      SUBROUTINE SATWND( KX, LAT, LON, PR, U, V, TCL, NOBS, TMOD, ZMOD )
                                                                        
C  CLOUD MOTION WIND PRESSURE LEVEL REASSIGNMENT                        
                                                                        
                                                                        
      INTEGER           NOBS                                            
                                                                        
      INTEGER           I                                               
      INTEGER           IER                                             
      INTEGER           IJ                                              
      INTEGER           KCHNG                                           
      INTEGER           KOUT                                            
      real              KX(NOBS)                                        
      real              LAT(NOBS)                                       
      real              LON(NOBS)                                       
      INTEGER           NWND                                            
      DIMENSION         PR(NOBS)                                        
      COMMON            PTROP(144*91), PP(144*91)                       
      DIMENSION         TCL(NOBS)                                       
      DIMENSION         TMOD(IM,JNP,MLEV)                               
      DIMENSION         U(NOBS)                                         
      DIMENSION         V(NOBS)                                         
      DIMENSION         ZMOD(IM,JNP,MLEV)                               
                                                                        
C  ANALYSIS CONTROL PARAMETERS                                          
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,     
     $                  SIGDAT                                          
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,       
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,      
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,     
     $                  SIGDAT,  MAXREP                                 
                                                                        
C  VERTICAL INDICES                                                     
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1            
                                                                        
C  COMMON SFCDRAG HOLDS LAND/WATER FLAG                                 
      COMMON /SFCDRAG/  DRAG(144*91), iwater(144*91)                    
                                                                        
      DATA              FILL / 1.0E+15 /                                
                                                                        
C  COMPUTE TROPOPAUSE PRESSURE                                          
      CALL TROPSE( TMOD, ZMOD )                                         
      CALL FILLUP( PTROP, IM, JNP )                                     
                                                                        
C  CREATE A TEMPORARY ARRAY THAT IS 1 OVER LAND AND 0 OVER WATER        
      DO 100 IJ = 1, IM*JNP                                             
         PP(IJ) = IWATER(IJ)                                            
  100 CONTINUE                                                          
                                                                        
C  LOOP OVER ALL THE OBSERVATIONS PROCESSING ALL THE CLOUD TRACK WINDS  
C  EXCEPT FOR THE NESS WINDS THAT SEEM TO HAVE ACCURATE REF. PRESSURES. 
      NWND  = 0                                                         
      KOUT  = 0                                                         
      KCHNG = 0                                                         
      DO 500 I = 1, NOBS                                                
         IF( ((KX(I).GE.19.0).AND.(KX(I).LE.23.0)).OR.                  
     $                                          (KX(I).EQ.26.0) ) THEN  
            NWND = NWND + 1                                             
                                                                        
            IF( PR(I).GT.700.0 ) THEN                                   
C  LOW LEVEL WIND TO BE FIXED IF OVER WATER                             
               CALL TERP( IM, JNP, LAT(I), LON(I), PP, PLND )           
               IF( PLND.LE.0.00001 ) THEN                               
                  KCHNG  = KCHNG + 1                                    
                  TCL(I) = -1.0                                         
                  PR(I)  = 900.0                                        
               ENDIF                                                    
                                                                        
            ELSE                                                        
C  CHECK IF HIGH LEVEL WIND IS TO BE TOSSED OUT OR FIXED                
               CALL TERP( IM, JNP, LAT(I), LON(I), PTROP, PTRPS )       
                                                                        
               IF( PR(I).LT.PTRPS ) THEN                                
C  ORIGINALLY ASSIGNED PRESSURE IS ABOVE TROPOPAUSE (TOSS OR FIX IT)    
                                                                        
                  IF( (PR(I).LT.200.0).AND.(PTRPS.GT.200.0) ) THEN      
C  TROPOPAUSE BELOW 200 MB AND ORIGINAL WIND ABOVE 200 MB               
C  TOSS OUT THE OBSERVATION                                             
                     U(I)   = FILL                                      
                     V(I)   = FILL                                      
                     KOUT   = KOUT + 1                                  
                                                                        
                  ELSE                                                  
C  TROPOPAUSE ABOVE 200 MB OR ORIGINAL WIND BELOW 200MB                 
C  ASSIGN WIND OBSERVATION TO THE TROPOPAUSE LEVEL                      
                     PR(I)  = PTRPS                                     
                     KCHNG  = KCHNG + 1                                 
                     TCL(I) = -1.0                                      
                  ENDIF                                                 
                                                                        
               ELSE                                                     
C  IF REPORT IS BETWEEN TROPOPAUSE AND 400 MB, MATCH TCL TO THE FIRST   
C  GUESS TEMPERATURE PROFILE AND ASSIGN CORRESPONDING PRESSURE LEVEL.   
                  IF( PR(I).LE.400.0 ) THEN                             
                     CALL WNDCHG( LAT(I),LON(I),TCL(I),TMOD,PNEW,IER )  
                     IF( IER.NE.0 ) THEN                                
                        KOUT = KOUT + 1                                 
                        U(I) = FILL                                     
                        V(I) = FILL                                     
                     ELSE                                               
                        IF( (PNEW-PR(I)).LT.300.0 ) THEN                
                           KCHNG  = KCHNG + 1                           
                           TCL(I) = -1.00                               
                           PR(I)  = PNEW                                
                           IF( PR(I).LT.PTRPS ) PR(I) = PTRPS           
                        ENDIF                                           
                     ENDIF                                              
                  ENDIF                                                 
               ENDIF                                                    
            ENDIF                                                       
         ENDIF                                                          
  500 CONTINUE                                                          
                                                                        
      WRITE( 6, 900 ) KCHNG, KOUT                                       
                                                                        
      RETURN                                                            
                                                                        
  900 FORMAT('0SATWND:  NUMBER OF CLOUD TRACK WIND REPORTS ASSIGNED',   
     $                                       ' NEW PRESSURE --- ',I6 /  
     $       '0SATWND:  NUMBER OF CLOUD TRACK WIND REPORTS REJECTED',   
     $                                       ' ---------------- ',I6 )  
      END                                                               
