 
      SUBROUTINE SIGRMS( RKX, PX, DEL1, DEL2, N, NOBS )
 
C  ACCUMULATE AND PRINT RMS STATISTICS FOR SIGNIFICANT LEVEL DATA
 
 
      DIMENSION         DEL1(NOBS)
      DIMENSION         DEL2(NOBS)
      INTEGER           I
      INTEGER           KK
      DIMENSION         RKX(NOBS)
      LOGICAL           LGOOD
      INTEGER           N
      INTEGER           NOBS
      DIMENSION         PX(NOBS)
      CHARACTER*4       UNDRLINE(33) 
      data              undrline / 'SIGR','MS: ', 31*'----' / 
 
C  QUALITY CONTROL FLAGS
      INTEGER           BGRS, BGROS, BBUD, BCHK
      COMMON /BUDBITS/  BGRS(20000) ,BGROS(20000),  BBUD(20000),
     $                  BCHK(20000)
 
C  ANALYSIS CONTROL PARAMETERS
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT,  MAXREP
 
C  OBSERVATIONS INFORMATION
      LOGICAL           QOBS, OFFLEV
      CHARACTER*8       DATANAME
      character*24      obsname
      COMMON /OBS/      MAXDEX, NFGGE, LUN, DATANAME(5), HH(13,13,20),
     $                  VCOROE(18,18,4), OBSERR(200,4,19), WW(13,13,20),
     $                  OBSNAME(200), QOBS(200,5), OFFLEV(200)
 
C  TALLY MATRIX FOR RMS STATISTICS
      REAL              RMSA, RMSR, SGRMSA, SGRMSR
      COMMON /OBSKNT/   NTOT(200),    NACC(200),    NREJ(200),
     $                  NSIGA(200),   NSIGR(200),   RMSA(200),
     $                  IRMSA(200),   RMSR(200),   IRMSR(200),
     $                  SGRMSA(200),  ISGRMSA(200), SGRMSR(200),
     $                  ISGRMSR(200), NDUM(200,3)
 
      COMMON /PMH/      PMAND(18)
 
C  INITIALIZE VARIABLES FOR THE STATISTICS
      DO 50 I = 1, MAXDEX
         IRMSA(I)    = 0
         IRMSR(I)    = 0
         ISGRMSA(I)  = 0
         ISGRMSR(I)  = 0
         NACC(I)     = 0
         NREJ(I)     = 0
         NSIGA(I)    = 0
         NSIGR(I)    = 0
         NTOT(I)     = 0
         RMSA (I)    = 0.0
         RMSR (I)    = 0.0
         SGRMSA(I)   = 0.0
         SGRMSR(I)   = 0.0
 50   CONTINUE
 
C  LOOP OVER THE OBSERVATIONS TO ACCUMULATE STATISTICS
      DO 100 I = 1, NOBS
 
         KK       = RKX(I)
         NTOT(KK) = NTOT(KK) + 1
         LGOOD    = ( BBUD(I).EQ.1 )
 
C  FOR SIGNIFICANT LEVEL DATA.
         IF( SIGDAT.AND.(KK.LE.12).AND.(KK.GE.7) ) THEN
         ILEV = IPLEV( PX(I) )
         IF( ABS( PX(I)-PMAND(ILEV) ).GE.0.001 ) THEN
            IF( LGOOD ) THEN
               NSIGA(KK)   = NSIGA(KK) + 1
               ISGRMSA(KK) = ISGRMSA(KK) + 1
               SGRMSA(KK)  = SGRMSA(KK) + DEL1(I)**2
               IF( N.EQ.2 ) SGRMSA(KK) = SGRMSA(KK) + DEL2(I)**2
            ELSE
               NSIGR(KK) = NSIGR(KK) + 1
               ISGRMSR(KK) = ISGRMSR(KK) + 1
               SGRMSR(KK) = SGRMSR(KK) + DEL1(I)**2
               IF( N.EQ.2 ) SGRMSR(KK) = SGRMSR(KK) + DEL2(I)**2
            ENDIF
            GOTO 100
         ENDIF
         ENDIF
 
C  NOT SIGNIFICANT LEVEL DATA.
         IF( LGOOD ) THEN
            NACC(KK)    = NACC(KK) + 1
            IRMSA(KK)   = IRMSA(KK) + 1
            RMSA(KK)    = RMSA(KK) + DEL1(I)**2
            IF( N.EQ.2 ) RMSA(KK) = RMSA(KK) + DEL2(I)**2
         ELSE
            NREJ(KK)    = NREJ(KK) + 1
            IRMSR(KK)   = IRMSR(KK) + 1
            RMSR(KK)    = RMSR(KK) + DEL1(I)**2
            IF( N.EQ.2 ) RMSR(KK) = RMSR(KK) + DEL2(I)**2
         ENDIF
 
  100 CONTINUE
 
C  PRINT RMS STATISTICS
      WRITE( 6, 1010 )
      WRITE( 6, 1011 ) UNDRLINE
      WRITE( 6, 1000 )
      WRITE( 6, 1011 ) UNDRLINE
      DO 200 KK = 1, MAXDEX
      IF( NTOT(KK).GT.0 ) THEN
         IF( ISGRMSA(KK).GT.0 )
     $      SGRMSA(KK) = SQRT( SGRMSA(KK) / ISGRMSA(KK) )
         IF( ISGRMSR(KK).GT.0 )
     $      SGRMSR(KK) = SQRT( SGRMSR(KK) / ISGRMSR(KK) )
         IF( IRMSA(KK).GT.0 )
     $      RMSA(KK)   = SQRT( RMSA(KK) / IRMSA(KK) )
         IF( IRMSR(KK).GT.0 )
     $      RMSR(KK)   = SQRT( RMSR(KK) / IRMSR(KK) )
         WRITE( 6, 1001 ) OBSNAME(KK), NTOT(KK),
     $                    NSIGA(KK),   NSIGR(KK),
     $                    NACC(KK),    NREJ(KK),
     $                    SGRMSA(KK),  SGRMSR(KK),
     $                    RMSA(KK),    RMSR(KK)
      ENDIF
  200 CONTINUE
      WRITE( 6, 1011 ) UNDRLINE
 
      RETURN
1000  FORMAT(' SIGRMS: ',8H0   DATA ,7X,5HTOTAL ,9X,11HSIGNIFICANT,15X
     $     ,8H OTHER  ,14X,10HRMS ERRORS,16X,10HRMS ERRORS
     $     ,/' SIGRMS: ',47H    TYPE      REPORTS           LEVEL
     $     , 54H                              SIGN. LEVEL
     $     ,  7H  OTHER
     $     ,/' SIGRMS: ',47H                       ACCEPTED    REJECTED
     $     , 55H  ACCEPTED   REJECTED     ACCEPTED  REJECTED       ACCE
     $     , 15HPTED   REJECTED )
 1001 FORMAT(' SIGRMS: ',2X,A8,4X,I5,5X,I5,6X,I5,9X,I5,6X,I5,2X,
     $                            2X,E11.4,2X,E11.4,2X,E11.4,2X,E11.4 )
 1010 FORMAT('0SIGRMS:',30X,'* SIGNIFICANT LEVEL DATA STATISTICS *',/)
 1011 FORMAT(1X,33A4)
      END
