CDECK     TAU2INT
C***********************************************************************
C  SUBROUTINE TAU2INT
C  PURPOSE
C     CONVERTS  TAU = HRS SINCE 29OCT72 00Z. TO YYMMDD/HHMMSS
C  USAGE
C     CALL TAU2INT ( TAU, NYMD, NHMS )
C  DESCRIPTION OF PARAMETERS
C     TAU     - ELAPSED HOURS FROM 29OCT72 00Z TO BE CONVERTED
C     NYMD    - YYMMDD    INTEGER DATE OF TAU
C     NHMS    - HHMMSS    INTEGER TIME OF TAU
C  SUBPROGRAMS REQUIRED
C     HRDIFF  FUNCTION    COMPUTES TIME DIFFERENCES FROM YYMMDD/HHMNMSS
C  RECORD OF MODIFICATIONS
C     17SEP84 JIM.PFAENDTNER  NEW PROGRAM
C     18SEP84 JIM.PFAENDTNER  COMMENT ADDED, BUG FIXED
C     21SEP84 JIM.PFAENDTNER  BUG FIXED - SUBROUTINE NAME, ARG ORDER
C     24SEP84 JIM.PFAENDTNER  BUG FIXED
C     27SEP84 JIM.PFAENDTNER  BUG FIXED
C  REMARKS
C     . ONLY CORRECT IF TAU IS POSITIVE.
C***********************************************************************
C
      SUBROUTINE TAU2INT ( TAU, NYMD, NHMS )
C
C***********************************************************************
C     COMMON /TAUBASE/ NYMDTAU, NHMSTAU
      DATA             NYMDTAU, NHMSTAU / 721029,      0 /
C
C***********************************************************************
C
      NYMD     = 730101
      T        = HRDIFF ( NYMD, 0, NYMDTAU, NHMSTAU )
  100 IF ( T .LT. TAU ) THEN
         NYMD     = NYMD + 10000
         T        = HRDIFF ( NYMD, 0, NYMDTAU, NHMSTAU )
         GOTO     100
      ELSE
         NYMD     = NYMD - 9900
         T        = HRDIFF ( NYMD, 0, NYMDTAU, NHMSTAU )
         IM       = 2
      ENDIF
C
  110 IF ( T .LT. TAU ) THEN
         IF ( IM .LT. 12 ) THEN
            IM       = IM + 1
            NYMD     = NYMD + 100
            T        = HRDIFF ( NYMD, 0, NYMDTAU, NHMSTAU )
            GOTO     110
         ENDIF
      ELSE
         NYMD     = NYMD - 100
         T        = HRDIFF ( NYMD, 0, NYMDTAU, NHMSTAU )
      ENDIF
C
      DAYS     = ( TAU - T ) / 24.0
      NDIFF    = DAYS
      NYMD     = NYMD + NDIFF
C
      T        = ( DAYS - NDIFF ) * 24.0
      IH       = T
C
      T        = ( T - IH ) * 60.0
      IM       = T
C
      T        = ( T - IM ) * 60.0
      IS       = T + 0.499999999999
C
      IF ( IS .GE. 60 ) THEN
         IS       = 0
         IM       = IM + 1
      ENDIF
      IF ( IM .GE. 60 ) THEN
         IM       = 0
         IH       = IH + 1
      ENDIF
      IF ( IH .EQ. 24 ) THEN
         IH       = 23
         IM       = 59
         IS       = 59
      ENDIF
C
      NHMS     = IS + 100 * ( IM + 100 * IH )
C
      RETURN
      END
