c ztot: height (z) to virtual temperaure (t).  takes a 3d array of
c       heights and computes mean layer virtual temperatures
c       corresponding to the thicknesses between each pressure surface.
 
      SUBROUTINE ztot ( z, tv, PMAND, PMIDM, im, jnp, mlev )
 
C PHYSICAL CONSTANTS
C -------------------
 
      COMMON /PHYSIC/ BETA,  CP, GRAV,OMEGA2,RADE,RGAS,
     .                ROCP,CPOG,GAMMA, ROCP1,GOCP
      REAL BETA,CP,GRAV,OMEGA2,RADE,RGAS,ROCP,CPOG,GAMMA,
     .               ROCP1,GOCP
 
      REAL z(im,jnp,mlev), tv(im,jnp,mlev-1)
      REAL PMAND(MLEV), PMIDM(MLEV-1),
     .     PK, DEL, FACTOR
 
      DO  LEV=1,MLEV-1
 
         PK=PMIDM(LEV)**ROCP
         DEL=PMAND(LEV+1)**rocp-PMAND(LEV)**rocp
         FACTOR=GOCP*PK/DEL
 
         DO J = 1,JNP
            DO I = 1,IM
               tv(I,J,LEV)=(z(I,J,LEV)-z(I,J,LEV+1))*FACTOR
            end do
         end do
 
      end do
 
      RETURN
      END
