C......................................................................         
C                                                                     .         
C  Program:    AVGUVINC                                               .         
C  Language:   FORTRAN V (ANSI-77 STANDARD)                           .         
C  Computer:   CRAY YMP 4/832                                         .         
C                                                                     .         
C  Programmer: J. Pfaendtner                                          .         
C  Date:       Spring, 1990                                           .         
C......................................................................         
                                                                                
      SUBROUTINE AVGUVINC ( IM, CLAM, SLAM, UNP, VNP, USP, VSP )                
                                                                                
C  AVERAGES A VECTOR FIELD AT THE NORTH AND SOUTH POLES                         
                                                                                
                                                                                
      DIMENSION         CLAM(IM)                                                
      INTEGER           I                                                       
      INTEGER           IM                                                      
      DIMENSION         SLAM(IM)                                                
C     REAL              UBAR                                                    
      DIMENSION         UNP(IM)                                                 
      DIMENSION         USP(IM)                                                 
C     REAL              VBAR                                                    
      DIMENSION         VNP(IM)                                                 
      DIMENSION         VSP(IM)                                                 
                                                                                
C  NORTH POLE                                                                   
      UBAR = 0.0                                                                
      VBAR = 0.0                                                                
      DO 100 I = 1, IM                                                          
         UBAR = UBAR + ( UNP(I)*CLAM(I) - VNP(I)*SLAM(I) )                      
         VBAR = VBAR + ( VNP(I)*CLAM(I) + UNP(I)*SLAM(I) )                      
  100 CONTINUE                                                                  
      UBAR = UBAR / IM                                                          
      VBAR = VBAR / IM                                                          
      DO 110 I = 1, IM                                                          
         UNP(I) = UBAR*CLAM(I) + VBAR*SLAM(I)                                   
         VNP(I) = VBAR*CLAM(I) - UBAR*SLAM(I)                                   
  110 CONTINUE                                                                  
                                                                                
C     SOUTH POLE                                                                
      UBAR = 0.0                                                                
      VBAR = 0.0                                                                
      DO 200 I = 1, IM                                                          
         UBAR = UBAR + ( USP(I)*CLAM(I) + VSP(I)*SLAM(I) )                      
         VBAR = VBAR + ( VSP(I)*CLAM(I) - USP(I)*SLAM(I) )                      
  200 CONTINUE                                                                  
      UBAR = UBAR / IM                                                          
      VBAR = VBAR / IM                                                          
      DO 210 I = 1, IM                                                          
         USP(I) = UBAR*CLAM(I) - VBAR*SLAM(I)                                   
         VSP(I) = VBAR*CLAM(I) + UBAR*SLAM(I)                                   
  210 CONTINUE                                                                  
                                                                                
      RETURN                                                                    
      END                                                                       
