 
      SUBROUTINE BDPATCH(BLAT,BLON,GLAT,GLON,IGINDX,LGOOD,
     &                                               INDX,NG )
C......................................................................
C                                                                     .
C  Program:    BDPATCH                                                .
C  Language:   FORTRAN V (ANSI-77 STANDARD)                           .
C  Computer:   Cray YMP 4/832                                         .
C                                                                     .
C  Programmer: Y. BRIN    ("DECYBERIZATION" BY M.SEABLOM)             .
C  Date:       MARCH, 1990                                            .
C                                                                     .
C  PROGRAM BDPATCH SCANS FOR GOOD QUALITY OBSERVATIONS NEIGHBOURING A .
C  QUESTIONABLE ONE.                                                  .
C                                                                     .
C......................................................................
 
 
C**********************************************************************
C*                                                                    *
C*  N A S A   O P T I M U M   I N T E R P O L A T I O N   -   O 9 X   *
C*               Global Modeling and Simulation Branch                *
C*                   GODDARD SPACE FLIGHT CENTER                      *
C*                                                                    *
C**********************************************************************
 
 
 
C INPUT/OUTPUT ARGUMENTS.
 
      real           BLAT,BLON,GLAT(LGOOD),GLON(LGOOD),IGINDX(LGOOD),
     &               INDX(1), BUDDIST, BUDLAT,
     &               SIGE,DLAT,DLON,PI,PI180,PTOP,PINT,GI,OMG2RE,
     &               RADEI,RADEI2,GRADEI,GRADEI2,G2,POLEFAC,RTD,
     &               POLELAT
 
      INTEGER BWITHIN(20000)
      character*60 message
 
C MAXIMUM BATCH SIZE, MAXIMUM NUMBER OF NEIGHBORING POINTS.
 
      COMMON/BUDDY/ MAXLEV,MAXLIST,MAXBATCH, MAXINDX, BUDDIST, BUDLAT
 
C CONSTANTS. USE PI/180
       COMMON /CONST/ SIGE(20), DLAT, DLON, PI, PI180, PTOP,
     &                PINT, GI, OMG2RE, RADEI, RADEI2, GRADEI,
     &                GRADEI2, G2, POLEFAC, RTD, POLELAT
 
 
C LOCAL VARIABLES.
 
      real   MINLAT, MAXLAT, MINLON, MAXLON, BUDLON, COSLAT
      DATA BWITHIN / 20000 * 0 /
 
      message(1:60 ) = ' '
      NG = 0
 
C DEFINE BOUNDS OF THE BOX SURROUNDING THE GREAT CIRCLE AROUND BAD OB.
 
 
 
C ZONAL BOUNDS.
 
      MINLAT = BLAT - BUDLAT
      MAXLAT = BLAT + BUDLAT
 
C LONGITUDE BOUNDS (ESTIMATE FROM 'GBATCH' SUBROUTINE).
 
      COSLAT = max  ( cos (PI180*(BLAT + SIGN(BUDLAT,BLAT))),1.e-3)
      BUDLON = min ( BUDLAT/COSLAT,180.0)
 
      MINLON = BLON - BUDLON
      MAXLON = BLON + BUDLON
 
 
C DEFINE GOOD OBS WITHIN ZONAL BOUNDS FIRST.
 
 
      DO 2 I = 1,LGOOD
 
        IF ( GLAT(I) .GE. MINLAT  .AND.  GLAT(I) .LE. MAXLAT )
     &     BWITHIN(I) = 1
 
 2    CONTINUE
 
C CHECK ON LONGITUDE BOUNDS CONSIDERING (-180.0 - + 180.0)
C DISCONTINUITY AT THE INTERNATIONAL DATE LINE.
C IF BUDLON = 180 ALL LONGITUDES USED.
 
      IF(BUDLON .LT. 180.0  ) THEN
 
        IF(MAXLON.LE.180.0  .AND. MINLON.GE.-180.0  ) THEN
 
          DO 3 I = 1,LGOOD
            IF ( BWITHIN(I) .EQ. 1  .AND.  GLON(I) .GE. MINLON
     &          .AND.  GLON(I) .LE. MAXLON ) THEN
 
                 BWITHIN(I) = 1
            ELSE
                 BWITHIN(I) = 0
 
            END IF
 3        CONTINUE
 
        ELSE
 
          IF(MAXLON.GT.180.0  ) THEN
 
            DO 4 I = 1,LGOOD
               IF ( BWITHIN(I) .EQ. 1  .AND.  GLON(I) .LE.
     &              (MAXLON -360.0) .OR.  GLON(I) .GE. MINLON ) THEN
 
                 BWITHIN(I) = 1
               ELSE
                 BWITHIN(I) = 0
 
               END IF
 4          CONTINUE
 
          ENDIF
 
          IF(MINLON.LT.-180.0) THEN
 
            DO 5 I = 1,LGOOD
              IF ( BWITHIN(I) .EQ. 1  .AND.  GLON(I) .GE.
     &             (MINLON + 360.)  .OR.  GLON(I) .LE. MAXLON ) THEN
 
                  BWITHIN(I) = 1
              ELSE
                  BWITHIN(I) = 0
 
              END IF
 5          CONTINUE
 
          ENDIF
        ENDIF
      ENDIF
 
C COMPRESS OUT ALL UNUSABLE (OUTSIDE THE BOX) REPORTS.
 
      DO 6 I = 1,LGOOD
        IF ( BWITHIN(I) .EQ. 1 ) NG = NG + 1
 6    CONTINUE
 
      NCOUNT = 0
      DO 7 I = 1,LGOOD
       IF ( BWITHIN(I) .EQ. 1 ) THEN
          NCOUNT = NCOUNT + 1
          IGINDX(NCOUNT) = I
       END IF
7     CONTINUE
 
      IF ( NG.GT.0 .AND. NG.LE.MAXINDX ) THEN
 
        DO 8 I = 1,NG
          INDX(I) = IGINDX(I)
 8      CONTINUE
 
      END IF
 
 
      IF(NG.GT.MAXINDX) THEN
         message = ' BDPATCH: Overflow of INDX (good reps). '
         PRINT*,' INDX FOR GOOD REPS IN BDPATCH=',NG
         call flash ( 5,message,1 )
      ENDIF
 
      RETURN
      END
