C......................................................................
C                                                                     .
C  Program:    BUDCHK                                                 .
C  Language:   FORTRAN V (ANSI-77 STANDARD)                           .
C  Computer:   Cray YMP 4/832                                         .
C                                                                     .
C  Programmer: Y. BRIN    ("DECYBERIZATION" BY M.SEABLOM)             .
C  Date:       FEBRUARY, 1990                                         .
C                                                                     .
C  PROGRAM BUDCHK PERFORMS BUDDY CHECKING ON THOSE DELTAS WHICH FAILED.
C  THE GROSS CHECK.                                                   .
C                                                                     .
C                                                                     .
C......................................................................
 
 
C**********************************************************************
C*                                                                    *
C*  N A S A   O P T I M U M   I N T E R P O L A T I O N   -   O 9 X   *
C*               Global Modeling and Simulation Branch                *
C*                   GODDARD SPACE FLIGHT CENTER                      *
C*                                                                    *
C**********************************************************************
 
 
 
      SUBROUTINE BUDCHK (KX,LAT,LON,DELT,NOBS)
 
      real   KX(NOBS),LAT(NOBS),LON(NOBS),DELT(NOBS), BUDDIST,
     &       BUDLAT, CUTVAL(20000), IBAD(20000), IGOOD(20000)
      INTEGER BGRS(20000),BACC(20000),BBUD(20000),BCHK(20000)
      character *60 message
 
C MAXIMUM BAD/GOOD LIST SIZE, BATCH SIZE,NUMBER OF NEIGHBORING POINTS.
      COMMON/BUDDY/ MAXLEV,MAXLIST,MAXBATCH, MAXINDX, BUDDIST, BUDLAT
 
C PRINT FLAG
      COMMON /PRINT/ MSGLEV
      COMMON /BUDBITS/ BGRS,BACC,BBUD,BCHK
 
C LOCAL VARIABLES. USE BLANK COMMON BLOCK.
 
      COMMON CUTVAL,IGOOD,IBAD
      message(1:60) = ' '
 
 
C INITIALIZE OUTPUT ARRAYS
 
      DO 6 I = 1,20000
        BBUD(I) = 0
        BCHK(I) = 0
 6    CONTINUE
 
      NGOOD = 0
      NBAD  = 0
      NACCEPT = 0
 
C CREATE LISTS OF GOOD / BAD REPORTS.
 
      DO 1 I = 1,NOBS
 
        IF ( BACC(I) .EQ. 1 ) THEN
          NGOOD = NGOOD + 1
          IF ( NGOOD .GT. MAXLIST ) then
             message = ' NGOOD exceeds MAXLIST in subroutine BUDCHK.'
             call flash ( 5,message,1 )
          end if
          IGOOD(NGOOD) = I
        ELSE
          NBAD = NBAD + 1
          IF (NBAD .GT. MAXLIST) then
             message = ' NBAD exceeds MAXLIST in subroutine BUDCHK.'
             call flash ( 5,message,1 )
          end if
          IBAD(NBAD) = I
        END IF
 
 1    CONTINUE
 
      IF ( NGOOD .LT. 1 ) then
         message = ' BUDCHK: All reports have failed quality control.'
         call flash ( 4,message,1 )
      end if
 
      IF ( NBAD .LT. 1 ) THEN
 
        DO 2 I = 1,NOBS
          IF( BACC(I) .EQ. 1  .OR.  BBUD(I) .EQ. 1 ) THEN
              BBUD(I) = 1
          ELSE
              BBUD(I) = 0
          END IF
 2      CONTINUE
 
        RETURN
      END IF
 
      IF ( MSGLEV .GT. 0 ) WRITE(6,'('' BUDCHK: NBAD, NGOOD:'',2I8)')
     &                     NBAD, NGOOD
 
C   CALL BDBATCH TO PERFORM THE BUDDY CHECK.
 
 
      CALL BDBATCH (KX,LAT,LON,DELT,NOBS,NBAD,NGOOD)
 
 
C   BBUD POINTS TO REPORTS THAT ARE NO LONGER BAD - PASSED BUDDY CHECK.
 
 
      IF (MSGLEV.GT.5) THEN
 
         DO 3 I = 1,NOBS
           IF ( BBUD(I) .EQ. 1 ) THEN
              NACCEPT = NACCEPT + 1
           END IF
 3       CONTINUE
 
         WRITE ( 6,'('' BDBATCH:'',I8,'' ACCEPTED.'')') NACCEPT
 
 
         DO 4 I = 1,NOBS
 
           IF ( BBUD(I) .EQ. 1 ) WRITE(6,'('' ACCEPTED BY BDBATCH '',I6,
     &         3F10.2,'' '',E14.7)') I, KX(I), LAT(I), LON(I), DELT(I)
 
 4       CONTINUE
 
      END IF
 
      DO 5 I = 1,NOBS
 
        IF( BACC(I) .EQ. 1  .OR.  BBUD(I) .EQ. 1 ) THEN
            BBUD(I) = 1
        ELSE
           BBUD(I) = 0
        END IF
 
 5    CONTINUE
 
      RETURN
      END
