!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
!                                                                                 
      SUBROUTINE CORTABLE(pmand,nlevoi)                                         
                                                                                
C  READS Z-Z HORIZONTAL FORECAST ERROR CORRELATIONS AND DERIVATIVES             
C  AND THE VERTICAL FORECAST ERROR CORRELATIONS FROM UNITS 61 AND 63            
                                                                                
                                                                                
      DIMENSION         COR(2000)                                               
      LOGICAL           FIRST 
      INTEGER           I                                                       
      INTEGER           J                                                       
      INTEGER           K                                                       
      real              pmand(nlevoi)
      CHARACTER*80      TITLE                                                   
      real              vcor(25,25)
      integer           vcor_type
                                                                                
      COMMON /CORTABS/  HCORFE(2000,3,20,2)                                     
                                                                                
      common /fevcortb/ ncorlevs, fe_vcor_table(25*25,2)
 
c Number of levels stored in the correlation table on disk
 
      data input_ncorlevs /18/
      data              first /.true./
      save              first
                                                                                
      IF( .NOT.FIRST ) RETURN                                                   
      FIRST = .FALSE.                                                           
 
 
c  The following files read by CORTABLE have been opened in INITIAL: 
 
c  Unit 61 contains table lookup for forecat error horizontal correlation.
c  Unit 63 contains table lookup for forecast error vertical correlation.
                                                                                
                                                                                
C  READ THE HORIZONTAL CORRELATIONS AND DERIVATIVES                             
c  ------------------------------------------------ 
 
      do k = 1, 3                                                           
        do kk = 1,2000
          read( 61,* ) cor(kk)
        end do
         do j = 1, 20                                                       
            do i = 1,2000                                                       
               hcorfe(i,k,j,1) = cor(I)                                         
               hcorfe(i,k,j,2) = cor(I)                                         
            end do                                                              
         end do                                                                 
      end do                                                                    
 
c  Read lookup tables for the height and mixing ratio forecast error 
c  vertical correlation.  All levels from the tables will be read in. 
c  ------------------------------------------------------------------
 
c  Number of levels stored in correlation table in OI will be one more 
c  than the number of mandatory levels used in the analysis in order to 
c  "pad" the table below 1000 mb.
 
      ncorlevs=nlevoi+1
 
c  Position in the input table at which to start extracting levels.
 
      level_start=input_ncorlevs-nlevoi+1
 
      do 500 vcor_type = 1,2
 
         READ(63,1800) TITLE                                                    
 1800    FORMAT( A80 )                                                         
 
         do J=1,input_ncorlevs
            read(63,1802) (vcor(I,J),I=1,input_ncorlevs)
 1802       format(25f6.2)                                                      
         end do 
 
!        print 1804, vcor_type
!1804    format(/,' Forecast error vertical correlation lookup table',
!    .          ' read from unit 63.  Table ',i1,':')
!        PRINT 1806, TITLE                                                    
!1806    FORMAT(/,' ',A80,/)
!        do J=1,input_ncorlevs
!           print 1808, (vcor(I,J),I=1,input_ncorlevs)
!1808       format(' ',25f6.2)
!        end do  
 
c  Extract subset of levels in lookup table that will actually be used 
c  by specified OI resolution.  Assume contiguous set of levels is to be
c  taken from the table with the last level always being 1000 mb - no 
c  skipping of levels in the table.   Pad the table by duplicating the last
c  level, and compress the table to the required size.      
c
         k=0
         do j=level_start,input_ncorlevs
            do i=level_start,input_ncorlevs
               k=k+1
               fe_vcor_table(k,vcor_type)=vcor(i,j)
            end do 
            k=k+1
            fe_vcor_table(k,vcor_type)=fe_vcor_table(k-1,vcor_type)
         end do 
      
         do i=1,ncorlevs
            k=k+1
            fe_vcor_table(k,vcor_type)=
     .                          fe_vcor_table(k-ncorlevs,vcor_type)
         end do 
 
         print 1001, vcor_type
 1001    format(/,' Forecast error vertical correlation lookup table',
     .          ' (as it will be used by oi).  Table ',i1,':')
         PRINT 1002, TITLE                                                    
 1002    FORMAT(/,' ',A80)
         print 1003, pmand
 1003    format(/,' ',8x,18f6.1)
         print 1004
 1004    format(' ')
         kbeg=1
         kend=ncorlevs
         do j=1,ncorlevs
            if (j.lt.ncorlevs) then 
               print 1005, pmand(j),
     .                     (fe_vcor_table(k,vcor_type),k=kbeg,kend)
 1005          format(' ',f6.1,2x,19f6.2)
            else 
               print 1006, (fe_vcor_table(k,vcor_type),k=kbeg,kend)
 1006          format(' ',8x,19f6.2)
            end if 
            kbeg=kbeg+ncorlevs
            kend=kend+ncorlevs
         end do 
 
  500 end do 
      
      RETURN                                                                    
      END                                                                       
