                                                                        
      SUBROUTINE FILLUP( Z, IM, JM )                                    
                                                                        
C  FILLS IN MISSING VALUES IN A SMOOTH ARRAY                            
                                                                        
                                                                        
      INTEGER           IM                                              
      INTEGER           JM                                              
                                                                        
      LOGICAL           AGAIN                                           
      LOGICAL           DATA                                            
      INTEGER           I                                               
      INTEGER           IN                                              
      INTEGER           J                                               
      INTEGER           JN                                              
      INTEGER           N                                               
      INTEGER           NDI(8)                                          
      INTEGER           NDJ(8)                                          
      INTEGER           NNGHBR                                          
      REAL              PTOTAL                                          
      DIMENSION         Z(IM,JM)                                        
                                                                        
      DATA              NDI /  0, -1, -1, -1,  0,  1,  1,  1 /          
      DATA              NDJ / -1, -1,  0,  1,  1,  1,  0, -1 /          
      DATA              SPVAL / 0.0 /                                   
                                                                        
C  SCAN THE ARRAY, LOOKING FOR SPECIAL VALUES                           
  100 AGAIN = .FALSE.                                                   
      DATA  = .FALSE.                                                   
      DO 400 J = 1, JM                                                  
      DO 400 I = 1, IM                                                  
                                                                        
         IF( Z(I,J).EQ.SPVAL ) THEN                                     
                                                                        
C  TRY TO FILL A SPECIAL VALUE                                          
            NNGHBR = 0                                                  
            PTOTAL = 0.0                                                
C  SCAN THE NEIGHBORS OF THE SPECIAL POINT                              
            DO 200 N = 1, 8                                             
               IN     = MOD( I+NDI(N)+IM-1, IM ) + 1                    
               JN     = MAX( MIN( J+NDJ(N), JM ), 1 )                 
               IF( Z(IN,JN).NE.SPVAL ) THEN                             
                  NNGHBR = NNGHBR + 1                                   
                  PTOTAL = PTOTAL + Z(IN,JN)                            
               ENDIF                                                    
  200       CONTINUE                                                    
            IF( NNGHBR.NE.0 ) THEN                                      
               Z(I,J) = PTOTAL / NNGHBR                                 
            ELSE                                                        
               AGAIN = .TRUE.                                           
            ENDIF                                                       
         ELSE                                                           
                                                                        
C  MARK THE FACT THAT THERE IS AT LEAST ONE USEABLE DATA VALUE          
            DATA = .TRUE.                                               
         ENDIF                                                          
                                                                        
  400 CONTINUE                                                          
                                                                        
C  TEST WHETHER TO MAKE ANOTHER PASS                                    
      IF( .NOT.DATA ) THEN                                              
         AGAIN = .FALSE.                                                
         WRITE( 6, 900 )                                                
      ENDIF                                                             
      IF( AGAIN ) GOTO 100                                              
                                                                        
      RETURN                                                            
                                                                        
  900 FORMAT('0FILLUP: ** ERROR ** -  ARRAY TO BE FILLED IS VOID')      
      END                                                               
