CDECK     HRDIFTST
C     PROGRAM HRDIFTST (INPUT,OUTPUT,UNIT61=OUTPUT)
C     DIMENSION     NDAYS(12)
C     DATA NDAYS    /31,28,31,30,31,30,31,31,30,31,30,31/
C     CALL ZEITBEG('HRDIFTST')
C     DIFMIN       = 1000.
C     DIFMAX       = -1000.
C     MINYMD       = 1000
C     MAXYMD       = -1000
C     MINHMS       = 1000
C     MAXHMS       = -1000
C     NYMD0        = 721231
C     NHMS0        = 234000
C     CALL INT2TAU ( 721029,      0, TAU00)
C     CALL INT2TAU ( NYMD0 , NHMS0 , TAU0 )
C     CALL TAU2INT ( TAU0, NNYMD, NNHMS )
C     WRITE(61,900) TAU00, TAU0
C 900 FORMAT('      TAU00, TAU0  = ',2F20.10)
C     WRITE(61,901) TAU0, NNYMD, NNHMS
C 901 FORMAT('      TAU0 , NNYMD, NNHMS  = ',F20.10,2I10)
C     DO 200 IYR   = 73,77
C        DO 190 IMO   = 1,12
C        MAXDAY       = NDAYS(IMO)
C        IF ((IMO.EQ.2).AND.(MOD(IYR,4).EQ.0)) MAXDAY = 29
C           DO 180 IDA   = 1,MAXDAY
C              DO 170 JHR   = 1,24
C                 IHR          = JHR - 1
C                 DO 160 JMI   = 60,60
C                    IMI          = JMI - 20
C                    NYMD         = 10000 * IYR + 100 * IMO + IDA
C                    NHMS         = 10000 * IHR + 100 * IMI
C                    CALL ZEITBEG('INT2TAU ')
C                    CALL INT2TAU ( NYMD, NHMS, TAU )
C                    CALL ZEITEND
C                    DIFF         = (TAU-TAU0)
C                    DIFMIN       = AMIN1 (DIFMIN,DIFF)
C                    DIFMAX       = AMAX1 (DIFMAX,DIFF)
C                    CALL ZEITBEG('TAU2INT ')
C                    CALL TAU2INT ( TAU, NYMDX, NHMSX )
C                    CALL ZEITEND
C                    NYMDD        = (NYMDX-NYMD0)
C                    MINYMD       = MIN0 (MINYMD,NYMDD)
C                    MAXYMD       = MAX0 (MAXYMD,NYMDD)
C                    NHMSD        = (NHMSX-NHMS0)
C                    MINHMS       = MIN0 (MINHMS,NHMSD)
C                    MAXHMS       = MAX0 (MAXHMS,NHMSD)
C                    TAU0         = TAU
C                    NYMD0        = NYMD
C                    NHMS0        = NHMS
C 160             CONTINUE
C 170          CONTINUE
C 180       CONTINUE
C 190    CONTINUE
C 200 CONTINUE
C     WRITE(61,910) DIFMIN,  DIFMAX,  MINYMD,  MAXYMD,  MINHMS, MAXHMS
C 910 FORMAT('      DIFMIN   DIFMAX   MINYMD   MAXYMD   MINHMS  MAXHMS'/
C    $        3X,2F9.6,4I9)
C     CALL ZEITEND
C     CALL ZEITPRI(61)
C     STOP
C     END
CDECK     HRDIFF
C***********************************************************************
C  FUNCTION HRDIFF
C  PURPOSE
C     COMPUTES TIME DIFFERENCE IN HOURS BETWEEN TWO YYMMDD/HHMMSS TIMES
C  USAGE
C     DIFF = HRDIFF ( NYMD1, NHMS1, NYMD2, NHMS2 )
C  DESCRIPTION OF PARAMETERS
C     NYMD1   - YYMMDD    INTEGER DATE OF FIRST TIME
C     NHMS1   - HHMMSS    INTEGER TIME OF FIRST TIME
C     NYMD2   - YYMMDD    INTEGER DATE OF SECOND TIME
C     NHMS2   - HHMMSS    INTEGER TIME OF SECOND TIME
C  SUBPROGRAMS REQUIRED
C     YMDUPK  SUBROUTINE  UNPACKS YYMMDD/HHMMSS DATES AND TIMES
C  RECORD OF MODIFICATIONS
C     17SEP84 JIM.PFAENDTNER  NEW PROGRAM
C     18SEP84 JIM.PFAENDTNER  FIXED BUG
C     24SEP84 JIM.PFAENDTNER  FIXED BUG, CHANGED TO USE YMDUPK
C  REMARKS
C     . HRDIFF IS THE DIFFERENCE (PLUS OR MINUS) OF
C                    NYMD1/NHMS - NYMD2/NHMS2
C     . ONLY CORRECT IF BOTH TIMES ARE AFTER 1JAN72 00Z
C***********************************************************************
C
      FUNCTION HRDIFF ( NYMD1, NHMS1, NYMD2, NHMS2 )
C
C***********************************************************************
      DIMENSION     NDAYS(12)
      DATA NDAYS /  0   , 31   , 59   , 90   ,120   ,151   ,
     $            181   ,212   ,243   ,273   ,304   ,334    /
      DATA Q60   / 1.6666666666666E-02 /
C***********************************************************************
C
      CALL     YMDUPK ( NYMD1, NYR1, NMO1, NDA1 )
      HR1M72   = ( NYR1-72 ) * 365  +  ( NYR1-69 ) / 4  +  NDAYS (NMO1)
     $           +  NDA1 - 1
      IF ( ( NMO1 .GT. 2 ) .AND. ( MOD ( NYR1,4 ) .EQ. 0 ) ) THEN
         HR1M72   = HR1M72 + 1.0
      ENDIF
C
      CALL     YMDUPK ( NHMS1, NHR1, NMI1, NSE1 )
      HR1M72   = HR1M72 * 24.0  +  NHR1  +  ( NMI1 + NSE1 * Q60 ) * Q60
C
      CALL     YMDUPK ( NYMD2, NYR2, NMO2, NDA2 )
      HR2M72   = ( NYR2-72 ) * 365  +  ( NYR2-69 ) / 4  +  NDAYS (NMO2)
     $           +  NDA2 - 1
      IF ( ( NMO2 .GT. 2 ) .AND. ( MOD ( NYR2,4 ) .EQ. 0 ) ) THEN
         HR2M72   = HR2M72 + 1.0
      ENDIF
C
      CALL     YMDUPK ( NHMS2, NHR2, NMI2, NSE2 )
      HR2M72   = HR2M72 * 24.0  +  NHR2  +  ( NMI2 + NSE2 * Q60 ) * Q60
C
      HRDIFF   = HR1M72 - HR2M72
      RETURN
      END
