!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
!
       subroutine oihiswrt(iunit,nymd,nhms,nymd0,nhms0,im,jnp,nlev,
     .                     log8r,xlabel,job,pres,
     .                     phis,psla,psfc,tvsfc,usla,vsla,
     .                     upauwnd,upavwnd,upatemp,upahght,
     .                     uparmix,uparhmd,
     .                     prsdiag,udiag,vdiag,hgtdiag,rmxdiag)

c
       parameter  ( nsfld   = 6,nufld = 6,ndfld = 5)
c
       dimension      pres(nlev), psfc(im,jnp)
       dimension      phis(im,jnp),psla(im,jnp),tvsfc(im,jnp)
       dimension      usla(im,jnp),vsla(im,jnp)
c
       dimension      upauwnd(im,jnp,nlev),upavwnd(im,jnp,nlev)
       dimension      upatemp(im,jnp,nlev),upahght(im,jnp,nlev)
       dimension      uparmix(im,jnp,nlev),uparhmd(im,jnp,nlev)
c
       dimension      hgtdiag(im,jnp,nlev), tem(im,jnp)
       dimension      prsdiag(im,jnp),udiag(im,jnp,nlev)
       dimension      vdiag(im,jnp,nlev),rmxdiag(im,jnp,nlev)
c
!gvl
       character*8 job
!gvl   character*8    xnames(nsfld), xnameu(nufld), xnamed(ndfld)
       character*8    names(nsfld)
       character*8    nameu(nufld)
       character*8    named(ndfld)
       character * 80 xlabel
c
c
c           surface field
c
       DATA NAMES( 1) /'PHIS    '/
       DATA NAMES( 2) /'TVSFC   '/
       DATA NAMES( 3) /'PSFC    '/
       DATA NAMES( 4) /'SLP     '/
       DATA NAMES( 5) /'SLU     '/
       DATA NAMES( 6) /'SLV     '/
c
c        upper air

       DATA NAMEU( 1) /'UWND    '/
       DATA NAMEU( 2) /'VWND    '/
       DATA NAMEU( 3) /'HGHT    '/
       DATA NAMEU( 4) /'TMPU    '/
       DATA NAMEU( 5) /'MIXR    '/
       DATA NAMEU( 6) /'RH      '/
c
c           diagnostics
c
       DATA NAMED( 1) /'PRSE    '/
       DATA NAMED( 2) /'UWNDE   '/
       DATA NAMED( 3) /'VWNDE   '/
       DATA NAMED( 4) /'HGHTE   '/
       DATA NAMED( 5) /'MIXRE   '/
c
c********************************************************************
c            description  of input arguments
c
c       input :
c
c              iunit : unit number             job  : experiment numbeR
c              nymd  : experiment date         nhms : experiment time
c              im    : logitude index          jnp  : latitude index
c              nlev  : number of levels        log8r: analysis flag
c              xlabel: experiment description  pres : pressure levels
c
c        surface fields:
c
c             phis  : gravity * heights      psla : sealevel pressure
c             tvsfc : surface vertual temp.  usla : sealevel uwind
c             vsla  : selevel vwind          psfc : surface pressure
c
c        upperair fields :
c
c            upauwnd : upperair uwind         upavwnd: upperair vwind
c            upahght : upperair heights       uparmix: upperair vwind
c            upatemp : upperair temperatures  uparh  : relative humidity
c
c
c        surface diagnostics
c
c            prsdiag: pressure errors  tmpdiag: temperature errors
c
c        surface diagnostics
c
c            prsdiag  :  surface pressure errors
c            udiag    :  u-wind errors   vdiag   : v-wind errors
c            hgtdiag  : height errors    rmxdiag : mixing ratio errors
c
c *********************************************************************
c
c
c                     call a routine to write a header record
c
            call oihished(iunit,xlabel,job,log8r,pres,names,nymd,nhms,
     .                    nymd0,nhms0,nameu,named,
     .                    nsfld,nufld,ndfld,im,jnp,nlev)
c
c                 writeout surface fields
c
             call oihisout(iunit,phis,im,jnp,0.0,names(1))
             call oihisout(iunit,tvsfc,im,jnp,0.0,names(2))
             call oihisout(iunit,psfc,im,jnp,0.0,names(3))
             call oihisout(iunit,psla,im,jnp,0.0,names(4))
             call oihisout(iunit,usla,im,jnp,0.0,names(5))
             call oihisout(iunit,vsla,im,jnp,0.0,names(6))
c
c                  write out upper air fields
c

        do  50 k = nlev,1,-1
          call uptrans(iunit,upauwnd,im,jnp,nlev,k,tem,pres(k),nameu(1))
          call uptrans(iunit,upavwnd,im,jnp,nlev,k,tem,pres(k),nameu(2))
          call uptrans(iunit,upahght,im,jnp,nlev,k,tem,pres(k),nameu(3))
          call uptrans(iunit,upatemp,im,jnp,nlev,k,tem,pres(k),nameu(4))
          call uptrans(iunit,uparmix,im,jnp,nlev,k,tem,pres(k),nameu(5))
          call uptrans(iunit,uparhmd,im,jnp,nlev,k,tem,pres(k),nameu(6))
   50   continue


c
c             write out surface pressure diagnostics
c
             call oihisout(iunit,prsdiag,im,jnp,0.0,named(1))
c
c               write out upper air u,v,z and mixing ratio
c                          diagnostics
c
             call dgtrans(iunit,udiag,im,jnp,nlev,tem,pres,named(2))
             call dgtrans(iunit,vdiag,im,jnp,nlev,tem,pres,named(3))
             call dgtrans(iunit,hgtdiag,im,jnp,nlev,tem,pres,named(4))
             call dgtrans(iunit,rmxdiag,im,jnp,nlev,tem,pres,named(5))
c
             return
             end
