C  -------------------------------------------------------------------- 
C  -------------------------------------------------------------------- 
C                                                                       
         FUNCTION PAIRZ ( AZ )                                          
                                                                        
C  FIND     PRESSURE FROM THE STANDARD HEIGHTS                          
C   RETURNS PAIRZ = 99999.9    IF UNABLE TO DO SO                       
C     LOOK UP  U.S. STANDARD HEIGHT TABLE.                              
         REAL ZU                                                        
         REAL PL ( 12 ) , RHT (12)                                      
         DATA PL  / 50.,70.,100.,150.,200.,250.,300.,400. ,             
     &                500. , 700. , 850. , 1000./                       
         DATA RHT  /20576.1,18441.6, 16179.7, 13608.4,11784.1,          
     &   10362.9, 9164., 7185.4, 5574.4, 3012.2, 1457.3, 110.9/         
C   ----------------------------------------------------------------    
           ZU=0.                                                        
           PA = 99999.                                                  
            DO 10  LAD=1,12                                             
                 ZD=RHT (LAD)                                           
                 IF  (ZD .LE.AZ )  GO TO 20                             
                 ZU = ZD                                                
 10         CONTINUE                                                    
C     **********************                                            
C     AICRAFT IS BELOW  1000 MB                                         
            GO TO 90                                                    
C     ************************                                          
 20      CONTINUE                                                       
C   CHECK FOR AIRCRAFT ABOVE 50 MB                                      
         IF (LAD.EQ. 1 ) GO TO 90                                       
C     ************************                                          
                                                                        
C    FIND    PRESSURE                                                   
              LAU = LAD - 1                                             
              APD = ALOG (PL (LAD))                                     
              APU = ALOG (PL(LAU))                                      
              APA = ((ZU -AZ)* APD + (AZ - ZD )*APU)/(ZU - ZD)          
              PA = EXP (APA)                                            
C                                                                       
 90         CONTINUE                                                    
            PAIRZ = PA                                                  
          RETURN                                                        
       END                                                              
