 
      SUBROUTINE PRTRMS( KX, DEL, BGRS, BACC, BQ, BBUD, BCHK, NOBS )
 
C  PRINTS RMS STATISTICS FOR THE QUALITY CONTROL
 
 
      INTEGER           BACC(NOBS)
      INTEGER           BBUD(NOBS)
      INTEGER           BCHK(NOBS)
      INTEGER           BGRS(NOBS)
      INTEGER           BQ(NOBS)
      DIMENSION         DEL(NOBS)
      INTEGER           I
      INTEGER           KK
      real              KX(NOBS)
      LOGICAL           LACC
      LOGICAL           LCHEK
      LOGICAL           LGOOD
      LOGICAL           LQUAL
      INTEGER           NTNACC
      INTEGER           NTNBTH
      INTEGER           NTNCHK
      INTEGER           NTNCUT
      INTEGER           NTNOCH
      INTEGER           NTNQUL
      INTEGER           NTNREJ
      INTEGER           NTNTOT
      CHARACTER*4       UNDRLINE(33)
      data              undrline /'----','----',31*'----' /
      CHARACTER*8       DATANAME
      character *24     obsname
      LOGICAL           QOBS, OFFLEV
      REAL              RMSA, RMSR
 
C  OBSERVATIONS INFORMATION
      COMMON /OBS/      MAXDEX, NFGGE, LUN, DATANAME(5), HH(13,13,20),
     $                  VCOROE(18,18,4), OBSERR(200,4,19), WW(13,13,20),
     $                  OBSNAME(200), QOBS(200,5), OFFLEV(200)
 
C  TALLY MATRIX FOR RMS STATISTICS
      COMMON /OBSKNT/   NTOT(200),    NACC(200),    NREJ(200),
     $                  NCUT(200),    NQUAL(200),   NBOTH(200),
     $                  NCHK(200),    NOCHK(200),   RMSA(200),
     $                  IRMSA(200),   RMSR(200),    IRMSR(200),
     $                  NDUM(200,4)
 
C  INITIALIZE VARIABLES FOR THE STATISTICS
      DO 50 I = 1, MAXDEX
         IRMSA(I)    = 0
         IRMSR(I)    = 0
         NACC(I)     = 0
         NBOTH(I)    = 0
         NCHK(I)     = 0
         NCUT(I)     = 0
         NOCHK(I)    = 0
         NQUAL(I)    = 0
         NREJ(I)     = 0
         NTOT(I)     = 0
         RMSA(I)     = 0.0
         RMSR(I)     = 0.0
 50   CONTINUE
      NTNACC = 0
      NTNBTH = 0
      NTNCHK = 0
      NTNCUT = 0
      NTNOCH = 0
      NTNQUL = 0
      NTNREJ = 0
      NTNTOT = 0
 
C  LOOP OVER OBSERVATIONS TO ACCUMULATE STATISTICS.
      DO 100 I = 1, NOBS
         KK       = KX(I)
         NTOT(KK) = NTOT(KK) + 1
 
C  FINAL RESULTS OF GROSS AND BUDDY CHECKS.
         LGOOD = (BBUD(I).EQ.1)
         IF( LGOOD ) THEN
           NACC(KK)  = NACC(KK) + 1
           IRMSA(KK) = IRMSA(KK) + 1
           RMSA(KK)  = RMSA(KK) + DEL(I)**2
         ELSE
           NREJ(KK)  = NREJ(KK) + 1
           IRMSR(KK) = IRMSR(KK) + 1
           RMSR(KK)  = RMSR(KK) + DEL(I)**2
         ENDIF
 
C  REASON FOR REJECTION
         LGOOD = (BGRS(I).EQ.1)
         LQUAL = (BQ(I).EQ.1)
         IF( .NOT.LGOOD ) THEN
           IF( LQUAL ) NCUT(KK) = NCUT(KK) + 1
           IF( .NOT.LQUAL ) NBOTH(KK) = NBOTH(KK) + 1
         ELSE
           IF( .NOT.LQUAL ) NQUAL(KK) = NQUAL(KK) + 1
         ENDIF
 
C  REASON FOR REACCEPTANCE
C  FOR REPORTS THAT FAILED THE GROSS CHECK OR WERE OF SUSPICIOUS QUALITY
C  BUT ARE BEING USED, RECORD HOW THEY GOT ACCEPTED.
         LACC  = (BACC(I).EQ.1)
         LGOOD = (BBUD(I).EQ.1)
         IF( .NOT.LACC.AND.LGOOD ) THEN
            LCHEK = (BCHK(I).EQ.1)
            IF(.NOT.LCHEK) THEN
C  PASSED BUDDY CHECK
               NCHK(KK) = NCHK(KK) + 1
            ELSE
C  (SUSP. QUAL).AND.(PASSED GROSS).AND.(FAILED BUDDY)
               NOCHK(KK) = NOCHK(KK) + 1
            ENDIF
         ENDIF
 
  100 CONTINUE
 
C  PRINT RMS STATISTICS
      WRITE( 6, 1010 )
      WRITE( 6, 1011 ) UNDRLINE
      WRITE(6,1000)
      WRITE( 6, 1011 ) UNDRLINE
 
      DO 200 KK = 1, MAXDEX
      IF( NTOT(KK).GT.0 ) THEN
 
         IF( IRMSA(KK).GT.0 )
     $      RMSA(KK) = SQRT( RMSA(KK) / IRMSA(KK) )
         IF( IRMSR(KK).GT.0 )
     $      RMSR(KK) = SQRT( RMSR(KK) / IRMSR(KK) )
         WRITE( 6, 1002 ) OBSNAME(KK), NTOT(KK),
     $                    NACC(KK),    NREJ(KK),
     $                    NCUT(KK),    NQUAL(KK),   NBOTH(KK),
     $                    NCHK(KK),    NOCHK(KK),
     $                    RMSA(KK),    RMSR(KK)
 
         NTNTOT =  NTNTOT + NTOT(KK)
         NTNACC =  NTNACC + NACC(KK)
         NTNREJ =  NTNREJ + NREJ(KK)
         NTNCUT =  NTNCUT + NCUT(KK)
         NTNQUL =  NTNQUL + NQUAL(KK)
         NTNBTH =  NTNBTH + NBOTH(KK)
         NTNCHK =  NTNCHK + NCHK(KK)
         NTNOCH =  NTNOCH + NOCHK(KK)
 
      ENDIF
  200 CONTINUE
 
C  PRINT TOTALS.
      WRITE( 6, 1011 ) UNDRLINE
      WRITE( 6, 1003 ) NTNTOT,
     $                 NTNACC,  NTNREJ,
     $                 NTNCUT,  NTNQUL,  NTNBTH,
     $                 NTNCHK,  NTNOCH
 
C  TOTAL GROSS CHECK REJECTED AND BUDDY CHECK ACCEPTED REPORTS.
      NTGRS = NTNCUT + NTNQUL + NTNBTH
      NTBUD = NTNCHK + NTNOCH
      WRITE( 6, 1005 )
      WRITE( 6, 1004 ) NTGRS, NTBUD
 
      RETURN
 1000 FORMAT(T11,'Data',T22,'Total',T33,'Reports',T46,
     $                 'Reports',T63,'Did not pass',T89,'Reaccepted',
     $                                                     T119,'RMS',
     $      /,T11,'type',T21,'reports',T33,'accepted',T46,
     $                 'rejected',T63,'gross check',T84,'with buddy ',
     $                         'w/o buddy',T111,'Accepted   Rejected',
     $      /,T58,'Cutoff  Quality   Both',T88,'check',T98,
     $                                                     'check' )
 1002 FORMAT(1X,A24,5X,I6,5X,I6,5X,I6,5X,I5,4X,I5,4X,I5,
     $                                  6X,I5,6X,I5,6X,E11.4,3X,E11.4 )
 1003 FORMAT(1X,' Total  ',5X,I6,5X,I6,5X,I6,5X,I5,4X,I5,
     $                                              4X,I5,6X,I5,6X,I5 )
 1004 FORMAT(57X,I5,21X,I5,/)
 1005 FORMAT(52X,20('-'),10X,12('-') )
 1010 FORMAT(30X,' * Detailed Gross and',
     $                                      ' Buddy Check Results *',/)
 1011 FORMAT(1X,33A4)
      END
