
      subroutine INCRr (a,b)

      real a,b

      a = a + b

      end  subroutine INCRr

      subroutine INCRi (a,b)

      integer a,b

      a = a + b

      end  subroutine INCRi

      subroutine qcreport ( data, nobs, type, mlev, nymd, nhms )

      
      integer max_data
      parameter ( max_data = 150000 )

      real        data(*), testlevel
      integer     nobs, index(max_data), statistics(200,10), testval,
     $            type, level_type, index2_count, index2(max_data)
      character*6 analysis_time, date_temp, time_temp
      character*8 analysis_date
      logical     found, mandatory

      common /dataptrs/ ikx,ilat,ilon,iprs,ityp,idel,ifcer



!  Observations  information    common /obs/
     
      integer           mxqobs
      parameter       ( mxqobs = 200 )

      logical           qobs, offlev
      character*8       dataname, obsname

      real hh,vcoroe,obserr,ww
      common /obs/      obserr(mxqobs,4,19),
     $                  hh(13,13,20),ww(13,13,20),
     $                  vcoroe(18,18,4), 
     $                  qobs(mxqobs,5), obsname(mxqobs), offlev(mxqobs),
     $                  dataname(5), 
     $                  maxdex, nfgge, lun 


      common / pmh / pmand(18)


      real fe_accept    (200)
      real fe_fail      (200)
      real delta_accept (200)
      real delta_fail   (200)
      integer number_accept(200)
      integer number_fail  (200)



 1000 format(//,5x,"Data",8x,"Total",6x,"Number",4x," Suspect Observat",
     $       "ions",2x,"Gross Check  Reaccepted ",4x,"Mean Fcst Error",
     $       10x,"RMS - Delta",/,5x,"Type",7x,"Reports",4x,"Accepted",
     $       5x,"Total",6x,"Accepted",4x,"Failures",2x,"Buddy Check",
     $       5x,"Pass",8x,"Fail",8x,"Pass",8x,"Fail",/)

      write(6,*) "<<<<<<< Quality Control, Version 2.1 >>>>>>>>>>>>"

      write (date_temp,'(i6)') nymd
      analysis_date = date_temp(3:4) // '/' // date_temp(5:6) // '/'
     $                // date_temp(1:2)
      write (time_temp,'(bz,i6)') nhms
      analysis_time = time_temp(1:2) // ':' // time_temp(3:4) // 'Z'
      if ( nhms .eq. 0 )  analysis_time = ' 0:00Z'
      iuwnd = idel + nobs
      ivwnd = iuwnd + nobs
      ife   = ivwnd + nobs

!c     do i = 1,nobs
!c       data(iprs+i-1) = nint(data(iprs+i-1)*10.)/10.
!c     end do

!c First loop: group observations by mandatory level using INDEX as point
!c Second loop: find off level observations nearby.

      do levels = 1,mlev

         mandatory = .true.

         do level_type = 1,2

            statistics( 1:200, 1:10 ) = 0

            if ( mandatory ) then

              write(6,*)

               if ( type .eq. 1 ) then
                  write(6,*) "Geopotential height statistics for"
               else
                  write(6,*) "Wind speed statistics for"
               end if

               write (6,*) pmand( levels ), 
     $              "mb Tolerance Variable, Analysis date and time:", 
     $              analysis_date, analysis_time

            end if

            if ( mandatory ) then

                                ! call rwheneq ( nobs, data(iprs), 1,
                                ! &    pmand(levels), index, nval )

               index1_count = 0

               do ix = 1,nobs

                  if ( abs(data(iprs+ix-1)-pmand(levels)) < 1.e-3 ) then

                     call INCRi(index1_count,1)
                     index(index1_count) = ix

                  end if

               end do

               nval = index1_count

            else

               index2(1:nobs) = 0
               index2_count = 0
               do ix = 1,nobs

                  testlevel = log(data(iprs+ix-1))-log(pmand(levels))
                  if ( abs(testlevel) <= .1 ) then
                     found = .false.
                     do jx = 1,nobs
                        if ( index(jx) .eq. ix ) found = .true.
                     end do
                     if ( .not. found ) then
                        call INCRi(index2_count,1)
                        index2(index2_count) = ix
                     end if
                  end if

               end do

               nval = index2_count
               index(1:nval) = index2(1:nval)

               if ( nval .gt. 0 ) then
                  write(6,'(///)')
                  if ( type .eq. 1 ) then
                     write(6,*) "",
     $                    " Geopotential height statistics for nearby"
                  else 
                     write(6,*) "",
     $                    " Wind speed statistics for nearby"
                  endif 

                  write (6,*) pmand( levels )
                  write (6,*) "Analysis Time/Date:", 
     $                 analysis_date, analysis_time
                  write (6,*) "(off-level or significant level data)"

                  write(6,1000)

               end if
            end if

            !c Tally the total number of observations for each data type.

            do  i = 1,nval

               j = int (data(ikx+index(i)-1))
               i_itype = int(data(ityp+index(i)-1))

               call INCRi(statistics(j,1),1)

                                ! Total the number of accepted reports.

               if (i_itype .eq. type .or. i_itype .eq. 3) then
                  call INCRi(statistics(j,2),1)
               end if

            end do

!c Number of suspect observations. If type = 1, height observations
!c are being tallied, otherwise tally wind observations.



            if ( type .eq. 1 ) then ! Suspicious height observations.
               do  i = 1,nval

                  j = int (data(ikx+index(i)-1))
                  i_itype = int(data(ityp+index(i)-1))

                  testval = int( data( ityp+index(i)-1 ) * 10. )

                  SELECT CASE (testval)
                    CASE (13)
                           call INCRi (statistics(j,4), 1)
                           call INCRi (statistics(j,3), 1)
                    CASE (3)
                              call INCRi (statistics(j,3), 1)
                    CASE (12)
                              call INCRi (statistics(j,6), 1)
                              call INCRi (statistics(j,5), 1)
                    CASE (1)
                              call INCRi (statistics(j,5), 1)
                  END SELECT
               end do

            else                ! Suspicious wind observations.

               do  i = 1,nval

                  j = int (data(ikx+index(i)-1))
                  i_itype = int(data(ityp+index(i)-1))

                  testval = int( data( ityp+index(i)-1) * 100. ) -
     $                 int( data( ityp+index(i)-1 ) * 10.)* 10

                  SELECT CASE (testval)
                    CASE (3)
                            call INCRi(statistics(j,3),1)

                            if (i_itype.eq.2 .or. i_itype.eq.3) then
                               call INCRi(statistics(j,4),1)
                            end if

                    CASE (2)
                             call INCRi(statistics(j,5),1)
                             call INCRi(statistics(j,6),1)
                    CASE (1)
                            call INCRi(statistics(j,5),1)
                  END SELECT

               end do

            end if

! Average forecast errors and deltas for observations which passed and
! which failed the quality control.

            fe_accept = 0.
            fe_fail   = 0.
            delta_accept = 0.
            delta_fail   = 0.
            number_accept = 0
            number_fail   = 0

            if ( type .eq. 1 ) then

               do  i = 1,nval

                  j = int (data(ikx+index(i)-1))
                  i_itype = int(data(ityp+index(i)-1))


                  if ( i_itype .eq. 1 .or. i_itype .eq. 3 ) then

                     call INCRi(number_accept(j),1)
                     call INCRr(fe_accept(j), data( ife+index(i)-1 )  )
                     call INCRr(delta_accept(j), 
     $                    (data( idel+index(i)-1))**2 )

                  else if (int(data(ityp+index(i)-1)*10.).ne.4) then

                     call INCRi(number_fail(j),1)
                     call INCRr(fe_fail(j), data( ife+index(i)-1 ))
                     call INCRr(delta_fail(j), 
     $                    (data( idel+index(i)-1))**2)

                  end if

               end do

            else

               do  i = 1,nval

                  j = int (data(ikx+index(i)-1))
                  i_itype = int(data(ityp+index(i)-1))

                  if ( i_itype .eq. 2 .or. i_itype .eq. 3 ) then

                     call INCRi(number_accept(j),1)
                     call INCRr(fe_accept(j) , data( ife+index(i)-1 ))
                     call INCRr(delta_accept(j), 
     $                    (sqrt(data(iuwnd+index(i)-1)**2  
     $                    + data( ivwnd+index(i)-1 ) **2 ))**2)

                  else
                     testval = int( data( ityp+index(i)-1) * 100. ) -
     $                    int( data( ityp+index(i)-1 ) * 10.)* 10.
                     if ( testval .ne. 4 ) then

                        call INCRi(number_fail(j),1)
                        call INCRr(fe_fail(j), data( ife+index(i)-1 ))
                        call INCRr(delta_fail(j), 
     $                       (sqrt( data(iuwnd+index(i)-1) **2 
     $                       + data( ivwnd+index(i)-1 ) ** 2 ))**2)

                     end if
                  end if

               end do
            end if


            do  j=1,200
               
               if ( statistics(j,1) .ne. 0 ) then

                  if ( number_fail(j) .ne. 0 ) then
                     fe_fail(j) = fe_fail(j) / float( number_fail(j) )
                     delta_fail(j) = sqrt(delta_fail(j) 
     $                    / float( number_fail(j) ))
                  end if
                  if ( number_accept(j) .ne. 0 ) then
                     fe_accept(j) = fe_accept(j) 
     $                    / float( number_accept(j) )
                     delta_accept(j) = sqrt(delta_accept(j) 
     $                    / float( number_accept(j) ))
                  end if
                  
                  write(6,'(1x,a8,6i12,4e12.4)')   
     $                 obsname(j), ( statistics(j,ii),ii=1,6), 
     $                 fe_accept(j), fe_fail(j), 
     $                 delta_accept(j), delta_fail(j)
               
               end if
            end do


            mandatory = .false.
         end do
      end do

      return
      end subroutine qcreport


