!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
!                                                                         
C   --------------------------------------------------------------------
          SUBROUTINE RELHUMID (TEMP, DEWD,RHUM)                         
C   --------------------------------------------------------------------
C                                                                       
C   AND RETURN RELATIVE HUMIDITY AS A FUNCTION OF TEMPERATURE           
C   AND DEWPOINT DEPRESSION                                             
C   INPUT  -  TEMPERATURE IN DEG.  K ( 150 K, 320 K )                   
C             DEWPOINT DEPRESSION IN DEG. C ( <60.0 C )                 
C   OUTPUT  -   RELATIVE HUMIDITY (IN PERCENT)                          
                                                                        
       REAL    RHCON,RHMIN                                      
C      REAL    MIS, TEMCONS,FILL,DEWDMAX
                                                                        
        DATA   RHCON /5.42864014E3/, DEWDMAX /60.0/                     
        DATA   RHMIN /0.01/                                             
            TD = TEMP-  DEWD                                            
             DELTA = RHCON /TEMP - RHCON / TD                           
             RHUM = 100 * EXP (DELTA)                                   
          IF (RHUM.GT.RHMIN)  RETURN                                    
C       USE MINIMUM ALLOWABLE REL HUM (0.01 PERCENT )                   
             RHUM = RHMIN                                               
              RETURN                                                    
        END                                                             
