      SUBROUTINE VTERPV( ALAT, ALON, PRS, VAL, LEN, Q )

!gvl
!     output: VAL(:)
!     input : LEN, Q (:,:,:), ALAT(:), ALON(:),PRS(:)
C  3-DIMENSIONAL BILINEAR INTERPOLATION OF A FIELD, Q, TO A SET OF
C  LAT/LON/PRESSURE LOCATIONS
C  ALAT(I) IS ASSUMED TO BE BETWEEN  -90.0 AND  +90.0
C  ALON(I) IS ASSUMED TO BE BETWEEN -180.0 AND +180.0
C  VERTICAL INTERPOLATION IS LINEAR IN PRESSURE


      DIMENSION         ALAT(LEN)
      DIMENSION         ALON(LEN)
      REAL              AMLEV
      real              fill
      REAL              HL(len)
      INTEGER           II
      INTEGER           I0
      INTEGER           I1
      INTEGER           IPRS
      INTEGER           J0
      INTEGER           J1
      INTEGER           LEN
      DIMENSION         PRS(LEN)
      DIMENSION         Q(IM,JNP,MLEV)
      REAL              QDEGDX
      REAL              QDEGDY
      DIMENSION         VAL(LEN)
      REAL              VALDN(len)
      REAL              VALUP(len)
      REAL              WTJ1
      REAL              XI
      REAL              YJ

C  IM AND JNP ARE NEEDED FROM COMMON BLOCK /CONTRL/
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT,  MAXREP

C  VERTICAL INDICES
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1

      data fill /1.e10/

      AMLEV  = MLEV
      QDEGDX = IM / 360.0
      QDEGDY = (JNP-1) / 180.0

C  SET VERTICAL SUBSCRIPTS AND INTERPOLATION FACTORS
      DO 100 II = 1, LEN
         HL(II) = PINDX2(PRS(II))
100   end do

      do 200 ii = 1,len
         HL(ii) = AMIN1( AMAX1( HL(ii),1.0 ), AMLEV )
         LA   = HL(ii) + 0.0001
         LB   = MIN( LA+1, MLEV )

C  SET HORIZONTAL SUBSCRIPTS AND INTERPOLATION FACTORS
         YJ    = ( ALAT(II) +  90.0 ) * QDEGDY + 1.0
         J0    = MIN( MAX0( IFIX(YJ), 1 ), JNP-1 )
         J1    = J0 + 1
         WTJ1  = YJ - J0
         XI    = ( ALON(II) + 180.0 ) * QDEGDX + 1.0
         IF( XI.GE.(IM+1) ) XI = XI - IM
         IF( XI.LT.1 ) XI = XI + IM
         I0    = MIN( MAX( IFIX( XI ), 1 ), IM )
         I1    = I0 + 1
         IF( I0.EQ.IM ) I1 = 1
         WTI1  = XI - I0

c Screen for fill values on upper level - replace fill values according
c to predetermined criteria.

C
C For brevity, the four corner points will be identified as follows:
C
C         X X   8               X X   4
C         X X                   X X
C         C  (D3)               D  (D4)
C
C
C
C
C         X X   1               X X   2
C         X X                   X X
C         A   (D1)              B   (D2)
C
C
C
C Assign corner values
C
      A = Q(I0,J0,LA)
      B = Q(I1,J0,LA)
      C = Q(I0,J1,LA)
      D = Q(I1,J1,LA)

C Identify pattern of filled points by using a 4 bit binary representati
C e.g., 2 (decimal) = 0010 (binary) = corner B only is filled.

      IFL  = 0
      IQA  = 0
      IQB  = 0
      IQC  = 0
      IQD  = 0
      IFCOUNT = 0

      IF( A .EQ. FILL) THEN
              IFL = 1
              IQA = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( B .EQ. FILL) THEN
              IFL = IFL + 2
              IQB = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( D .EQ. FILL) THEN
              IFL = IFL + 4
              IQD = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( C .EQ. FILL) THEN
              IFL = IFL + 8
              IQC = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF

C
C Filled values are repalced with values obtained from the other corners
C so that the horizontal interpolation can be done.  Note that there are
C 16 special cases of filled patterns.
C
      D1 = FILL
      D2 = FILL
      D3 = FILL
      D4 = FILL
C
      IF( IFL .EQ. 0 ) THEN
        D1 = A
        D2 = B
        D3 = C
        D4 = D
      ELSE IF( IFL.EQ.1 .OR. IFL.EQ.4) THEN
        IFCOUNT = 2
        FV = ( (1-IQB)*B+(1-IQC)*C )/FLOAT(IFCOUNT)
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ELSE IF( IFL.EQ.2 .OR. IFL.EQ.8) THEN
        IFCOUNT = 2
        FV = ( (1-IQA)*A+(1-IQD)*D )/FLOAT(IFCOUNT)
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ELSE IF ( IFL .NE. 15) THEN
        DFACT = FLOAT(4-IFCOUNT)
        FV = ( (1-IQA)*A+(1-IQB)*B+(1-IQC)*C+(1-IQD)*D )/DFACT
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ENDIF

C  UPPER LEVEL INTERPOLATION

      if (d1.eq.fill) then
         valup(ii) = fill
      else
         A = D1
         B = D2
         C = D3
         D = D4
         VALUP(ii) = WTJ1  * ( WTI1*D+(1.0-WTI1)*C )
     $        + (1.0-WTJ1) * ( WTI1*B+(1.0-WTI1)*A )
      end if

  200 end do

      do 300 ii = 1,len
!        HL(ii) = AMIN1( AMAX1( HL(ii),1.0 ), AMLEV )
         LA   = HL(ii) + 0.0001
         LB   = MIN( LA+1, MLEV )

C  SET HORIZONTAL SUBSCRIPTS AND INTERPOLATION FACTORS
         YJ    = ( ALAT(II) +  90.0 ) * QDEGDY + 1.0
         J0    = MIN( MAX0( IFIX(YJ), 1 ), JNP-1 )
         J1    = J0 + 1
         WTJ1  = YJ - J0
         XI    = ( ALON(II) + 180.0 ) * QDEGDX + 1.0
         IF( XI.GE.(IM+1) ) XI = XI - IM
         IF( XI.LT.1 ) XI = XI + IM
         I0    = MIN( MAX( IFIX( XI ), 1 ), IM )
         I1    = I0 + 1
         IF( I0.EQ.IM ) I1 = 1
         WTI1  = XI - I0

C Similarly, screen for fill values on lower level
C
C Assign corner values
C
      A = Q(I0,J0,LB)
      B = Q(I1,J0,LB)
      C = Q(I0,J1,LB)
      D = Q(I1,J1,LB)

C Identify pattern of filled points by using a 4 bit binary representati
C e.g., 2 (decimal) = 0010 (binary) = corner B only is filled.

      IFL  = 0
      IQA  = 0
      IQB  = 0
      IQC  = 0
      IQD  = 0
      IFCOUNT = 0

      IF( A .EQ. FILL) THEN
              IFL = 1
              IQA = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( B .EQ. FILL) THEN
              IFL = IFL + 2
              IQB = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( D .EQ. FILL) THEN
              IFL = IFL + 4
              IQD = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF
      IF( C .EQ. FILL) THEN
              IFL = IFL + 8
              IQC = 1
              IFCOUNT = IFCOUNT + 1
      ENDIF

C
C Filled values are repalced with values obtained from the other corners
C so that the horizontal interpolation can be done.  Note that there are
C 16 special cases of filled patterns.
C
      D1 = FILL
      D2 = FILL
      D3 = FILL
      D4 = FILL
c
      IF( IFL .EQ. 0 ) THEN
              D1 = A
              D2 = B
              D3 = C
              D4 = D
      ELSE IF( IFL.EQ.1 .OR. IFL.EQ.4) THEN
        IFCOUNT = 2
        FV = ( (1-IQB)*B+(1-IQC)*C )/FLOAT(IFCOUNT)
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ELSE IF( IFL.EQ.2 .OR. IFL.EQ.8) THEN
        IFCOUNT = 2
        FV = ( (1-IQA)*A+(1-IQD)*D )/FLOAT(IFCOUNT)
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ELSE IF( IFL .NE. 15 ) THEN
        DFACT = FLOAT(4-IFCOUNT)
        FV = ( (1-IQA)*A+(1-IQB)*B+(1-IQC)*C+(1-IQD)*D )/DFACT
        D1 = FV + (1-IQA)*(A-FV)
        D2 = FV + (1-IQB)*(B-FV)
        D3 = FV + (1-IQC)*(C-FV)
        D4 = FV + (1-IQD)*(D-FV)
      ENDIF

C  LOWER LEVEL INTERPOLATION

      if (d1.eq.fill) then
         valdn(ii) = fill
      else
         A = D1
         B = D2
         C = D3
         D = D4
         VALDN(ii) = WTJ1  * ( WTI1*D+(1.0-WTI1)*C )
     $        + (1.0-WTJ1) * ( WTI1*B+(1.0-WTI1)*A )
      end if

 300  end do

      do 400 ii=1,len

C  VERTICAL INTERPOLATION

      if (valup(ii).ne.fill.and.valdn(ii).ne.fill) then
         VAL(II) = VALUP(ii) + ( VALDN(ii)-VALUP(ii) )
     &             * ( hl(ii) - int( hl(ii) ) )
      else if (valup(ii).eq.fill.and.valdn(ii).ne.fill) then
         val(ii) = valdn(ii)
      else if (valup(ii).ne.fill.and.valdn(ii).eq.fill) then
         val(ii) = valup(ii)
      else
         val(ii) = fill
      end if

  400 end do

      RETURN
      END
