      SUBROUTINE DATTAU( NYMD, NHMS, TAU )                              
                                                                        
C  CONVERT A DATE/TIME TO A TAU                                         
                                                                        
C  NOTE: THIS PROGRAM IS SET UP TO CONVERT DATES TO TAUS WITHIN THE     
C        THE YEARS 1972-1999. A STOP WILL BE ISSUED FOR DATES NOT       
C        WITHIN THIS RANGE.                                             
!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
!                                                                         
      INTEGER           DATE(4)                                         
      INTEGER           I                                               
      INTEGER           ILPNDX                                          
      INTEGER           IYEAR                                           
      INTEGER           IYRNDX                                          
      INTEGER           LEAPYR(7) 

      integer           montau(12)
      INTEGER           NHMS                                            
      INTEGER           NYMD                                            
      REAL              TAU                                             
      integer           taubis
      integer           tauend(5)

      data              leapyr / 75, 79, 83, 87, 91, 95, 99 /
C                     - THE LAST YEAR IN EACH OF THE FOUR YEAR PERIODS  

      data              MONTAU / 744, 672, 744, 720, 744, 720,      
     $                               744, 744, 720, 744, 720, 744 /     
C                     - NUMBER OF TAUS IN EACH MONTH OF THE YEAR        

      data              NTAU4Y / 35064 /                                
C                     - NUMBER OF HOURS IN ANY GIVEN FOUR YEAR PERIOD   
      data              TAUBIS / 7248 /                                 
C                     - TAU BIAS (THE 0 TAU IS NOT ON A YEAR BOUNDARY)  

      data              TAUEND / 0, 8784, 17544, 26304, 35064 /      
C                     - TAUS AT THE END OF THE 1ST TO 4TH YEARS         
                                                                        
C  UNPACK DATE PARAMETERS FROM MODEL FORM FOR PROCESSING                
      DATE(3) = NYMD / 10000                                            
      DATE(1) = ( NYMD - DATE(3) * 10000 ) / 100                        
      DATE(2) = NYMD - DATE(3) * 10000 - DATE(1) * 100                  
      DATE(4) = NHMS / 10000                                            
                                                                        
C  CHECK IF YEAR IS WITHIN THE RANGE OF YEARS FOR WHICH THERE ARE TAUS  
      IYEAR=DATE(3)                                                     
      IF( (IYEAR.LT.LEAPYR(1)) .OR. (IYEAR.GT.LEAPYR(7)) ) THEN         
         WRITE(6,900) DATE                                              
         print*, ' FATAL: DATTAU>> Date out of range.'
         STOP 'fatal.'
      ENDIF                                                             
                                                                        
C  DETERMINE WHICH LEAP YEAR GROUP IYEAR IS IN                          
      ILPNDX = 0                                                        
  100 ILPNDX = ILPNDX + 1                                               
      IF( (ILPNDX.LT.7) .AND. (IYEAR.GT.LEAPYR(ILPNDX)) ) GOTO 100      
                                                                        
C  DETERMINE WHICH YEAR IN THE LEAP YEAR GROUP IYEAR IS (1-4)           
      IYRNDX = 4 - LEAPYR(ILPNDX) + IYEAR                               
                                                                        
C  CALCULATE THE TAU AT THE END OF THE YEAR BEFORE IYEAR                
      TAU = ( ( ILPNDX * NTAU4Y ) - NTAU4Y ) + TAUEND(IYRNDX)           
                                                                        
C  SET THE NUMBER OF HOURS IN FEBRUARY                                  
      MONTAU(2) = 672                                                   
      IF( IYRNDX.EQ.1 ) MONTAU(2) = 696                                 
                                                                        
C  INCREMENT NUMBER OF TAUS UP TO THE GIVEN MONTH                       
      IF ( DATE(1).GT.1 ) THEN                                          
         DO 110 I = 1, DATE(1)-1                                        
            TAU = TAU + MONTAU(I)                                       
  110    CONTINUE                                                       
      ENDIF                                                             
                                                                        
C  INCREMENT TAU BY THE DAYS AND HOURS INTO THE MONTH                   
      TAU = TAU + DATE(2)*24.0 - 24.0 + DATE(4)                         
                                                                        
C  GET FINAL TAU BY SUBTRACTING THE TAU BIAS AND ADDING A WIGGLE        
      TAU = TAU - TAUBIS + 0.000001                                     
      TAU = IFIX( TAU + 0.1 )                                           
                                                                        
      RETURN                                                            
                                                                        
 900  FORMAT(' DATTAU: DATE OUT OF RANGE '/                             
     $       ' DATTAU: INPUT WAS: MONTH=',I2,'  DAY=',I2,'  YEAR=',I3,  
     $                                                   '  HOUR=',I2 ) 
      END                                                               
