      SUBROUTINE GETMIX( ILEV,   XKX,    XLAT,   XLON,   XPR,                   
     $                   XMIX,   XRH,    BQ,     NOBS,   NLOBS,
     $                   pmand,  mlev,   mmix,   sigdat )
                                                                                
C  THIS SUBROUTINE CHOOSES OBS OF RH/MIX AT A CERTAIN LEVEL, ILEV,              
C  AND STORES THEM INTO COMMON /LEVEL/ TO BE CHECKED BY ROUTINE CHKMIX          
                                                                                
                                                                                
      INTEGER           BQ(NOBS)                                                
      INTEGER           I                                                       
      INTEGER           II                                                      
      INTEGER           ILEV                                                    
      INTEGER           NLOBS                                                   
      INTEGER           NOBS                                                    
      real              pmand(mlev)
      DIMENSION         XKX(NOBS)                                               
      DIMENSION         XLAT(NOBS)                                              
      DIMENSION         XLON(NOBS)                                              
      DIMENSION         XMIX(NOBS)                                              
      DIMENSION         XPR(NOBS)                                               
      DIMENSION         XRH(NOBS)                                               
                                                                                
C  MAXIMUM BAD/GOOD LIST SIZE, BATCH SIZE, NUMBER OF NEIGHBORING POINTS         
      COMMON /BUDDY/    MAXLEV,  MAXLIST, MAXBATCH, MAXINDX,                    
     $                  BUDDIST, BUDLAT                                         
                                                                                
      LOGICAL           SIGDAT
                                                                                
C  DATA AT A PRESSURE LEVEL .                                                   
      COMMON /LEVEL/    INDX(20000), KX(20000), LAT(20000), LON(20000),         
     $                  PR(20000),   RH(20000), MIX(20000), DIFF(20000),        
     $                  QDATA(20000)                                            
      real              INDX, KX, LAT, LON, MIX                                 
      INTEGER           QDATA                                                   
                                                                                
      character*60   message
      message(1:60) = ' '
 
      lev1 = mlev - mmix + 1 
                                                                                
C  LOOP OVER REPORTS                                                            
      NLOBS = 0                                                                 
      DO 500 I = 1, NOBS                                                        
                                                                                
C  CHECK PRESSURE LEVEL (SIGNIFICANT LEVEL DATA BEING USED)                     
         IF( SIGDAT ) THEN                                                      
            IF( ILEV.NE.IPLEV(XPR(I)) ) GOTO 500                                
C  RULE OUT DATA ABOVE HIGHEST HUMIDITY ANALYSIS LEVEL                          
            IF( ILEV.EQ.lev1 .AND. XPR(I).LT.PMAND(lev1) )             
     $                                                        GOTO 500          
C  CHECK PRESSURE LEVEL (SIGNIFICANT LEVEL DATA NOT BEING USED)                 
         ELSE                                                                   
           IF( ABS( XPR(I)-PMAND(ILEV) ) .GT. 0.001 ) GOTO 500               
         ENDIF                                                                  
                                                                                
C  DATA IS AT AN ACCEPTABLE PRESSURE LEVEL                                      
         NLOBS = NLOBS + 1                                                      
         IF( NLOBS.GT.MAXLEV ) then                                             
           message = ' GETMIX: MAXLEV exceeded. '
           call flash (5,message,1)                                             
         end if                                                                 
         INDX(NLOBS)  = I                                                       
         QDATA(NLOBS) = BQ(I)                                                   
  500 CONTINUE                                                                  
                                                                                
C GATHER DATA USING INDX-ARRAY.                                                 
      IF( NLOBS.NE.0 ) THEN                                                     
         DO 600 II = 1, NLOBS                                                   
            I = INDX(II) + 0.5                                                  
            KX(II)   = XKX(I)                                                   
            LAT(II)  = XLAT(I)                                                  
            LON(II)  = XLON(I)                                                  
            PR(II)   = XPR(I)                                                   
            RH(II)   = XRH(I)                                                   
            MIX(II)  = XMIX(I)                                                  
  600    CONTINUE                                                               
      ENDIF                                                                     
                                                                                
      RETURN                                                                    
      END                                                                       
