                                                                        
                                                                        
C   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&   
       SUBROUTINE    GETPIECE (PRES1,PRES2,TEMP,KEY1)                   
C                                                                       
C  PURPOSE: GIVEN A 15 LAYERS , THIS SUBROUTINE  EXTRACT CONSISTENT     
C           "PIECE"  FROM REPORT                                        
C                                                                       
C      DATE :   12/03/91                                                
C                                                                       
C      INPUT:                                                           
C                                                                       
C         PRES1(15)   - LOW PRESSURE OF LAYER                           
C         PRES2(15)   - HIGH PRESSURE OF LAYER                          
C         TEMP(15)    - MEAN TEMPERATURE OF LAYER                       
C                                                                       
C         LMIN     - LIMIT OF MIN LENGTH OF "PIECE"                     
C                  (DEFAULT IS 3)                                       
C  OUTPUT:                                                              
C          COMMON /PIECE/  NXX,PP1(15),PP2(15),TDATA(15)                
C                 NXX  -  NUMBER OF LAYERS IN "PIECE"                   
C                 PP1     LOW PRESSURE      |                           
C                 PP2     HIGH PRESSURE     |  IN "PIECE"               
C                 TDATA   MEAN TEMPERATURE  |                           
C            KEY1  =:                                                   
C                 'GOOD' -                                              
C                 'NO-HIGH' -LOW PRESSURE IS TOO HIGH(<10MB             
C                 'NO-SMALL'-LENGTH IS < LMIN                           
C                 'NO-PRES' -LOW PRESSURE IS > 1100MB                   
C    CHECK  ---- "SUSPICIUS" TEMPERATURE (MUST BE 150K<TEMP<320K FOR    
C                 LAYER'S PRESSURE(LOW&HIGH) NOT MISSING)               
                                                                        
C  PROGRAMMER:  YELENA KONDRATYEVA                                      
C                                                                       
C                                                                       
C***********************************************************************
          CHARACTER * 20 KEY1                                           
          INTEGER      LMIN                                             
          REAL PM(16)                                                   
C  --EDGE PRESSURES USED FOR LAYERS                                     
C      COMMON /INPRO/ NX, PBAR(15), TBAR(15)                            
      COMMON /PIECE/  NXX,PP1(15),                                      
     *    PP2(15),TDATA(15)                                             
C        REAL PP1(15),PP2(15),TDATA(15)                                 
         REAL PRES1(15),PRES2(15),TEMP(15)                              
         DATA    PM    /1000., 850., 700., 500., 400., 300., 200.,      
     *    100., 70., 50., 30., 10., 5., 2., 1.,0.4/                     
C        INTEGER  NXX                                                   
C          DATA NXX /14/                                                
          DATA LMIN /3/                                                 
C          DATA    PP11   /1000., 850., 700., 500., 400., 300., 200.,   
C    *    100., 70., 50., 30., 10., 5., 2., 1./                         
C           DATA    PP11   /-900., 850., 700., 500., 400., 300.,-900.,  
C     *    100.,-900., 50., 30.,  10., 5.,-900., 1./                    
C           DATA    PP11   / 850., 700., 500., 400., 300., 200.,        
C           DATA    PP22   / 850., 700., 500., 400., 300., 200.,        
C     *    100., 70., 50., 30., 10., 5., 2., 1.,0.4/                    
C          DATA    PP22   /  700., 500., 400., 300., 200.,              
C    *    100., 70., 50., 30., 10., 5., 2., 1.,0.4/                     
C         DATA   TEMP  / 264., 258., 248., 235., 222., 207.,            
C    *    198.,194., 195.,196.,209.,232., 262.,281., 273/               
C          DATA   TEMP  / 264., 258., 248., 235., 222., 207.,           
C     *    198.,194., 195.,196.,209.,232., 262.,281., 273./             
                                                                        
                   KEY1='GOOD'                                          
           NXX=0                                                        
           N1=0                                                         
           N2=0                                                         
          M =0                                                          
          M1=0                                                          
          NBEGIN=1                                                      
C    POISK 1-GO UROVNYA                                                 
C    FIND FIRST LAYER                                                   
 4010    CONTINUE                                                       
        DO  4011  K=NBEGIN,15                                           
            IF (PRES1(K).NE.-900.0)  GO TO   4020                       
 4011     CONTINUE                                                      
           GO TO 5000                                                   
 4020     CONTINUE                                                      
              N1=K                                                      
C        PRINT *,'4020,POSK 1 UROVNA,N1=K  =>',N1,K                     
C    CHECK FIRST LAYER                                                  
          IF (PRES1(N1).GE.1100.0)  THEN                                
                KEY1='NO-PRES'                                          
              GO TO   5040                                              
          ENDIF                                                         
          IF (PRES2(N1).NE.PM(N1+1).OR.                                 
     .        TEMP(N1).LT.150.0  .OR.                                   
     .        TEMP(N1).GT.320.0 )   THEN                                
                NBEGIN =N1+1                                            
              GO TO   4010                                              
          ENDIF                                                         
C    IF  TOO HIGH                                                       
            IF (N1.GE.12) GO TO 5000                                    
C    FIND THE LAST LAYER                                                
                                                                        
 4030    CONTINUE                                                       
        DO  4031  K=N1+1,15                                             
          IF (PRES1(K).NE.PM(K).OR.                                     
     .        PRES2(K).NE.PM(K+1).OR.                                   
C    .        TEMP(K).EQ.-900.0)   GO TO 4040                           
     .        TEMP(K).LT.150.0  .OR.                                    
     .        TEMP(K).GT.320.0 )   GO TO 4040                           
 4031     CONTINUE                                                      
 4040     CONTINUE                                                      
              N2=K-1                                                    
C        PRINT *,'4040,POSK POSLED UROVNA,N2=K  =>',N2,K                
 4050     CONTINUE                                                      
C    CHECK LENGTH (MUST BE > OR = LMIN )                                
C    "BAD" LENGTH -IF CAN --> TRY TO FIND NEXT PIECE                    
        IF ((N2-N1+1).LT.LMIN) THEN                                     
C         PRINT *,'BAD DLINA, KEY =   ',KEY1                            
C         PRINT *,'BAD DLINA, N1,N2   ',N1,N2                           
             M1 = M1 + 1                                                
             IF ((N2+2).GT.12) GO TO 5000                               
             IF ((14-N2).LT.LMIN) GO TO 5000                            
                NBEGIN =N2+2                                            
                GO TO 4010                                              
          ENDIF                                                         
C     "GOOD" LENGTH :LOAD IF "BETTER" PREVIOUS,THEN                     
C     - IF CAN --> TRY TO FIND  NEXT PIECE                              
        IF ((N2-N1+1).GE.LMIN) THEN                                     
C          PRINT *,'GOD DLINA, KEY =   ',KEY1                           
C          PRINT *,'GOD DLINA, N1,N2   ',N1,N2                          
        IF (M.EQ.0) GO TO 4060                                          
        IF (M.NE.0.AND.(N2-N1+1).GT.NXX) GO TO 4060                     
             M=M+1                                                      
                GO TO 4070                                              
C      LOAD DATA                                                        
 4060     CONTINUE                                                      
             M=M+1                                                      
             NXX=N2-N1+1                                                
        DO      K=N1,N2                                                 
         PP1(K+1-N1)=   PRES1(K)                                        
         PP2(K+1- N1)=     PRES2(K)                                     
         TDATA(K+1-N1)=     TEMP(K)                                     
         ENDDO                                                          
 4070     CONTINUE                                                      
             IF ((N2+2).GT.12) GO TO 5000                               
             IF ((14-N2).LT.LMIN) GO TO 5000                            
                NBEGIN =N2+2                                            
                GO TO 4010                                              
          ENDIF                                                         
                                                                        
C   CHECK AND RETURN                                                    
 5000     CONTINUE                                                      
              IF ( M.EQ.0)   THEN                                       
                   KEY1='N0-HIGH'                                       
                 IF ( M1.GT.0)   THEN                                   
                        KEY1='NO-SMALL'                                 
                 ENDIF                                                  
                    NXX=0                                               
C          PRINT *,'5000, KEY =   ',KEY1                                
C          PRINT *,'M=0,5000, N1,N2= ',N1,N2                            
C          PRINT *,'M=0,5000. PP2 =   ',PP2                             
C                 STOP                                                  
                  RETURN                                                
              ENDIF                                                     
C    CHECK  --- "SUSPICIUS" (GAP)                                       
              IF ( M.GT.1.OR. M1.GE.1)   THEN                           
                KEY1='SUSP-GAP'                                         
                 GO TO 5040                                             
C                 RETURN                                                
              ENDIF                                                     
C    CHECK  ---- "SUSPICIUS" TEMPERATURE (MUST BE 150K<TEMP<320K FOR    
C                 LAYER'S PRESSURE(LOW&HIGH) NOT MISSING)               
         DO  5010  K=1,15                                               
          IF (PRES1(K).NE.-900.0.AND.                                   
     .       PRES2(K).NE.-900.0.AND.                                    
     .       TEMP(K).NE.-900.0.AND.                                     
     .       (TEMP(K).LT.150.0  .OR.                                    
     .        TEMP(K).GT.320.0 ))  THEN                                 
                KEY1='SUSP-TEMP'                                        
                 GO TO 5040                                             
           ENDIF                                                        
 5010     CONTINUE                                                      
 5040     CONTINUE                                                      
C          PRINT *,' NXX  =  , =  ,N1,N2=  ',NXX,N1,N2                  
C          PRINT *,' KEY =   ',KEY1                                     
C          PRINT *,' PP1 =   ',PP1                                      
C          PRINT *,' PP2 =   ',PP2                                      
C        STOP                                                           
         RETURN                                                         
         END                                                            
