# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
long yyleng; extern char yytext[];
long yymorfg;
extern char *yysptr, yysbuf[];
long yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	long *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
  
                L O O P M A R K   L E G E N D
                -----------------------------
  
                PRIMARY LOOP TYPE             LOOP MODIFIERS
                -----------------             --------------
                S - scalar loop               b - bottom loaded
                V - vector loop               c - computed safe vector length
                W - unwound loop              i - unconditionally vectorized with an IVDEP
                D - deleted loop              k - kernel scheduled
                                              r - unrolled
                                              s - short vector loop
                                              v - short safe vector length
  
  
      1      1.                         c**********************************************************************
      2      2.                         c                                                                     *
      3      3.                         c    Program Name: QCREPORT                                           *
      4      4.                         c    Programmer  : Michael Seablom, NASA/GSFC Code 910.3              *
      5      5.                         c                  Greenbelt, MD 20771  (301)286-7360 (FTS)888-7360   *
      6      6.                         c                                                                     *
      7      7.                         c    Date        : April 23, 1991                                     *
      8      8.                         c    Computer    : Cray YMP                                           *
      9      9.                         c    Language    : Cray Fortran (CFT77 Version 4.0)                   *
     10     10.                         c                                                                     *
     11     11.                         c  Program QCREPORT prints out upper air quality control statistics.  *
     12     12.                         c                                                                     *
     13     13.                         c  Modifications:                                                     *
     14     14.                         c                                                                     *
     15     15.                         c  Dec 1992 (Seablom) Corrected logic to allow report of 0.4mb level  *
     16     16.                         c  Dec 1992 (Seablom) Modified code to print out off-level cases.     *
     17     17.                         !
     18     18.                         !  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
     19     19.                         !                                                                     *
     20     20.                         c**********************************************************************
     21     21.                          
     22     22.                          
     23     23.                               subroutine qcreport ( data, nobs, type, mlev, nymd, nhms )
     24     24.                          
     25     25.                         C...Translated by FPP 6.0 (3.06G6) 12/04/95  19:40:19   -dc -e78
     26     26.                               real        data(1500000), testlevel
     27     27.                               integer     nobs, index(max_data), statistics(200,10), testval,
     28     28.                              &            type, level_type, index2_count, index2(max_data)
     29     29.                               character*6 analysis_time, time_temp
     30     30.                               character*8 dataname, date_temp
     31     31.                               character*10 analysis_date
     32     32.                               character*24 obsname
     33     33.                               logical     qobs, offlev, onestage, found, mandatory
     34     34.                          
     35     35.                               common /scan/ maxobs, rscan, onestage, max_data
     36     36.                               common /dataptrs/ ikx,ilat,ilon,iprs,ityp,idel,ifcer,itime
     37     37.                          
     38     38.                               common /obs/ maxdex, nfgge, lun, dataname(5), hh(13,13,20),
     39     39.                              &             vcoroe(18,18,4), obserr(200,4,19), ww(13,13,20),
     40     40.                              &             obsname(200), qobs(200,5), offlev(200)
     41     41.                          
     42     42.                               common / pmh / pmand(18)
     43     43.                          
     44     44.                               INTEGER J1X, J2X
     45     45.                               data statistics / 2000*0 /
     46     46.                          
     47     47.                          
     48     48.                          
     49     49.                          1000 format(//,5x,"Observation Type",t28,"Eligible Reports",t48,
     50     50.                              &       "RMS-Delta",t60,"Mean Fcst Error",/)
     51     51.                          
     52     52.                         !
  
     53     53.                         !  Disable parallelization of this subroutine.
     54     54.                         !
     55     55.                         CFPP$ NOCONCUR
     56     56.                         !gvl comma missing
     57     57.                               write(6,'("1",//,1x,80("-"),//,19x,"Quality Control, Version",    
     58     58.                              &      " 2.1    April, 1991",//, 80("-"),//)')
     59     59.                          
     60     60.                               if ( nymd .gt. 500000 ) write (date_temp,'("19",i6)') nymd
     61     61.                               if ( nymd .le. 500000 ) write (date_temp,'("20",i6)') nymd
     62     62.                               analysis_date = date_temp(5:6) // '-' // date_temp(7:8) // '-' 
     63     63.                              &                // date_temp(1:4)
     64     64.                               write (time_temp,'(bz,i6)') nhms
     65     65.                               analysis_time = time_temp(1:2) // ':' // time_temp(3:4) // 'Z' 
     66     66.                               if ( nhms .eq. 0 )  analysis_time = ' 0:00Z' 
     67     67.                               iuwnd = idel + nobs
     68     68.                               ivwnd = iuwnd + nobs
     69     69.                               ife   = ivwnd + nobs
     70     70.                          
     71     71.                          
     72     72.                         ! First loop: group observations by mandatory level using INDEX as point
     73     73.                         ! Second loop: find off level observations nearby.
     74     74.                          
     75     75. S----------------------<      do 1 levels = 1,mlev
     76     76. S                        
     77     77. S                               mandatory = .true.
     78     78. S                        
     79     79. S S--------------------<        do 2 level_type = 1,2
     80     80. S S                      
     81     81. S S                             if ( mandatory ) then
     82     82. S S                             write(6,'(///)')
     83     83. S S                             if ( type .eq. 1 ) write(6,'(/," Geopotential height statis",   
     84     84. S S                          &    "tics for ",f7.1,"mb. Tolerance variable.",/," Analysis",     
     85     85. S S                          &    " date: ",a10,3x,"Analysis time: ",bz,a6)')
     86     86. S S                          &    pmand( levels ), analysis_date, analysis_time
     87     87. S S                      
     88     88. S S                      
     89     89. S S                             if ( type .ne. 1 ) write(6,'(/," Wind speed statis",            
     90     90. S S                          &    "tics for ",f7.1,"mb. Tolerance variable.",/," Analysis",     
     91     91. S S                          &    " date: ",a10,3x,"Analysis time: ",bz,a6)')
     92     92. S S                          &    pmand( levels ), analysis_date, analysis_time
     93     93. S S                      
     94     94. S S                             write(6,1000)
     95     95. S S                             end if
     96     96. S S                      
     97     97. S S                      
     98     98. S S                     CDIR@ IVDEP
     99     99. S S V------------------<      do  j2x = 1,2000
    100    100. S S V                            STATISTICS(J2X,1) = 0
    101    101. S S V------------------>      END DO
    102    102. S S                      
    103    103. S S                             if ( mandatory ) then
    104    104. S S                      
    105    105. S S                              index1_count = 0
  
    106    106. S S                      
    107    107. S S V------------------<      do  ix = 1,nobs
    108    108. S S V                              if ( abs(data(iprs+ix-1)-pmand(levels)) .lt. 1.e-3 ) then
    109    109. S S V                    
    110    110. S S V                                 index1_count = index1_count + 1
    111    111. S S V                                 index(index1_count) = ix
    112    112. S S V                    
    113    113. S S V                              end if
    114    114. S S V                    
    115    115. S S V------------------>         end do
    116    116. S S                      
    117    117. S S                              nval = index1_count
    118    118. S S                      
    119    119. S S                             else
    120    120. S S                      
    121    121. S S                     CDIR@ IVDEP
    122    122. S S V------------------<      do  j1x = 1,nobs
    123    123. S S V                            INDEX2(J1X) = 0
    124    124. S S V------------------>      END DO
    125    125. S S                              index2_count = 0
    126    126. S S S------------------<      do  ix = 1,nobs
    127    127. S S S                               testlevel = log(data(iprs+ix-1))-log(pmand(levels))
    128    128. S S S                               if ( abs(testlevel) .le. .1 ) then
    129    129. S S S                                  found = .false.
    130    130. S S S                   CDIR@ IVDEP
    131    131. S S S V----------------<      do  jx = 1,nobs
    132    132. S S S V                                   if ( index(jx) .eq. ix ) found = .true.
    133    133. S S S V---------------->               end do
    134    134. S S S                                  if ( .not. found ) then
    135    135. S S S                                     index2_count = index2_count + 1
    136    136. S S S                                     index2(index2_count) = ix
    137    137. S S S                                  end if
    138    138. S S S                               end if
    139    139. S S S                    
    140    140. S S S------------------>         end do
    141    141. S S                      
    142    142. S S                              nval = index2_count
    143    143. S S                     CDIR@ IVDEP
    144    144. S S Vr-----------------<      do  j1x = 1,nval
    145    145. S S Vr                           INDEX(J1X) = INDEX2(J1X)
    146    146. S S Vr----------------->      END DO
    147    147. S S                      
    148    148. S S                              if ( nval .gt. 0 ) then
    149    149. S S                             write(6,'(///)')
    150    150. S S                             if ( type .eq. 1 ) write(6,'(/," Geopotential height statis",   
    151    151. S S                          &    "tics for nearby ",f7.1,"mb. Tolerance variable.",/,          
    152    152. S S                          &    " Analysis date: ",a10,3x,"Analysis time: ",bz,a6,            
    153    153. S S                          &    "  ( off-level or significant level data )"                   
    154    154. S S                          &    )')
    155    155. S S                          &    pmand( levels ), analysis_date, analysis_time
    156    156. S S                      
    157    157. S S                      
    158    158. S S                             if ( type .ne. 1 ) write(6,'(/," Wind speed statis",            
  
    159    159. S S                          &    "tics for nearby ",f7.1,"mb. Tolerance variable.",/,          
    160    160. S S                          &    " date: ",a10,3x,"Analysis time: ",bz,a6,                     
    161    161. S S                          &    "  ( off-level or significant level data )"                   
    162    162. S S                          &    )')
    163    163. S S                          &    pmand( levels ), analysis_date, analysis_time
    164    164. S S                      
    165    165. S S                             write(6,1000)
    166    166. S S                      
    167    167. S S                             end if
    168    168. S S                             end if
    169    169. S S                      
    170    170. S S                     c Tally the total number of observations for each data type.
    171    171. S S                      
    172    172. S S S------------------<        do 3 j = 1,200
    173    173. S S S                   CDIR@ IVDEP
    174    174. S S S V----------------<      do  i = 1,nval
    175    175. S S S V                          IF (DATA(IKX+INDEX(I)-1) .EQ. FLOAT(J)) STATISTICS(J,1) = 
    176    176. S S S V                      1      STATISTICS(J,1) + 1
    177    177. S S S V                  
    178    178. S S S V                          IF ((INT@(DATA(ITYP+INDEX(I)-1)).EQ.TYPE .OR. INT@(DATA(ITYP+
    179    179. S S S V                      1      INDEX(I)-1)).EQ.3) .AND. DATA(IKX+INDEX(I)-1).EQ.FLOAT(J)) 
    180    180. S S S V                      2      STATISTICS(J,2) = STATISTICS(J,2) + 1
    181    181. S S S V---------------->      END DO
    182    182. S S S                    
    183    183. S S S                    
    184    184. S S S                   c Number of suspect observations. If type = 1, height observations
    185    185. S S S                   c are being tallied, otherwise tally wind observations.
    186    186. S S S                    
    187    187. S S S                           if ( type .eq. 1 ) then
    188    188. S S S                    
    189    189. S S S                   c Suspicious height observations.
    190    190. S S S                    
    191    191. S S S                   CDIR@ IVDEP
    192    192. S S S V----------------<      do  i = 1,nval
    193    193. S S S V                            if ( data(ikx+index(i)-1) .eq. float(j) ) then
    194    194. S S S V                             testval = int( data( ityp+index(i)-1 ) * 10. )
    195    195. S S S V                  
    196    196. S S S V                             if ( testval .eq. 13 .or. testval .eq. 3 )
    197    197. S S S V                      &        statistics(j,3) = statistics(j,3) + 1
    198    198. S S S V                  
    199    199. S S S V                             if ( testval .eq. 13 )
    200    200. S S S V                      &        statistics(j,4) = statistics(j,4) + 1
    201    201. S S S V                  
    202    202. S S S V                 c Gross check failures.
    203    203. S S S V                  
    204    204. S S S V                             if ( testval .eq. 12 .or. testval .eq. 1 )
    205    205. S S S V                      &        statistics(j,5) = statistics(j,5) + 1
    206    206. S S S V                  
    207    207. S S S V                 c Number reaccepted by buddy check.
    208    208. S S S V                  
    209    209. S S S V                             if ( testval .eq. 12 ) statistics(j,6) = statistics(j,6) + 1
    210    210. S S S V                            end if
    211    211. S S S V---------------->          end do
  
    212    212. S S S                    
    213    213. S S S                          else
    214    214. S S S                    
    215    215. S S S                   c Suspicious wind observations.
    216    216. S S S                    
    217    217. S S S                   CDIR@ IVDEP
    218    218. S S S V----------------<      do  i = 1,nval
    219    219. S S S V                            if ( data(ikx+index(i)-1) .eq. float(j) ) then
    220    220. S S S V                             testval = int( data( ityp+index(i)-1) * 100. ) -
    221    221. S S S V                      &                int( data( ityp+index(i)-1 ) * 10.)* 10
    222    222. S S S V                  
    223    223. S S S V                             if ( testval .eq. 3 ) then
    224    224. S S S V                               statistics(j,3) = statistics(j,3) + 1
    225    225. S S S V                  
    226    226. S S S V                               if ( int(data(ityp+index(i)-1)) .eq. 2 .or.
    227    227. S S S V                      &           int(data(ityp+index(i)-1)) .eq. 3 )
    228    228. S S S V                      &           statistics(j,4) = statistics(j,4) + 1
    229    229. S S S V                  
    230    230. S S S V                             end if
    231    231. S S S V                  
    232    232. S S S V                 c Gross check failures.
    233    233. S S S V                  
    234    234. S S S V                             if ( testval .eq. 2 .or. testval .eq. 1 )
    235    235. S S S V                      &        statistics(j,5) = statistics(j,5) + 1
    236    236. S S S V                  
    237    237. S S S V                 c Number reaccepted by buddy check.
    238    238. S S S V                  
    239    239. S S S V                             if ( testval .eq. 2 )
    240    240. S S S V                      &         statistics(j,6)= statistics(j,6) + 1
    241    241. S S S V                            end if
    242    242. S S S V---------------->          end do
    243    243. S S S                    
    244    244. S S S                          end if
    245    245. S S S                    
    246    246. S S S                    
    247    247. S S S                   c Average forecast errors and deltas for observations which passed and
    248    248. S S S                   c which failed the quality control.
    249    249. S S S                    
    250    250. S S S                          fe_accept = 0.
    251    251. S S S                          fe_fail   = 0.
    252    252. S S S                          delta_accept = 0.
    253    253. S S S                          delta_fail   = 0.
    254    254. S S S                          number_accept = 0
    255    255. S S S                          number_fail   = 0
    256    256. S S S                    
    257    257. S S S                          if ( type .eq. 1 ) then
    258    258. S S S                    
    259    259. S S S                   CDIR@ IVDEP
    260    260. S S S V----------------<      do  i = 1,nval
    261    261. S S S V                           if ( data(ikx+index(i)-1) .eq. float(j) ) then
    262    262. S S S V                            itype = int( data( ityp+index(i)-1 ) )
    263    263. S S S V                  
    264    264. S S S V                            if ( itype .eq. 1 .or. itype .eq. 3 ) then
  
    265    265. S S S V                  
    266    266. S S S V                               number_accept = number_accept + 1
    267    267. S S S V                               fe_accept = fe_accept + data( ife+index(i)-1 )
    268    268. S S S V                               delta_accept = delta_accept + (data( idel+index(i)-1))**2
    269    269. S S S V                  
    270    270. S S S V                            else if ( int( data(ityp+index(i)-1)*10.) .ne. 4 ) then
    271    271. S S S V                  
    272    272. S S S V                               number_fail = number_fail + 1
    273    273. S S S V                               fe_fail = fe_fail + data( ife+index(i)-1 )
    274    274. S S S V                               delta_fail = delta_fail + (data( idel+index(i)-1))**2
    275    275. S S S V                  
    276    276. S S S V                            end if
    277    277. S S S V                           end if
    278    278. S S S V---------------->         end do
    279    279. S S S                    
    280    280. S S S                          else
    281    281. S S S                    
    282    282. S S S                   CDIR@ IVDEP
    283    283. S S S V----------------<      do  i = 1,nval
    284    284. S S S V                           if ( data(ikx+index(i)-1) .eq. float(j) ) then
    285    285. S S S V                            itype = int( data( ityp+index(i)-1 ) )
    286    286. S S S V                  
    287    287. S S S V                            if ( itype .eq. 2 .or. itype .eq. 3 ) then
    288    288. S S S V                  
    289    289. S S S V                               number_accept = number_accept + 1
    290    290. S S S V                               fe_accept = fe_accept + data( ife+index(i)-1 )
    291    291. S S S V                               delta_accept = delta_accept +
    292    292. S S S V                      &         (sqrt(data(iuwnd+index(i)-1)**2  +
    293    293. S S S V                      &               data( ivwnd+index(i)-1 ) **2 ))**2
    294    294. S S S V                  
    295    295. S S S V                            else
    296    296. S S S V                             testval = int( data( ityp+index(i)-1) * 100. ) -
    297    297. S S S V                      &                int( data( ityp+index(i)-1 ) * 10.)* 10.
    298    298. S S S V                             if ( testval .ne. 4 ) then
    299    299. S S S V                  
    300    300. S S S V                               number_fail = number_fail + 1
    301    301. S S S V                               fe_fail = fe_fail + data( ife+index(i)-1 )
    302    302. S S S V                               delta_fail = delta_fail +
    303    303. S S S V                      &                      (sqrt( data(iuwnd+index(i)-1) **2 +
    304    304. S S S V                      &                       data( ivwnd+index(i)-1 ) ** 2 ))**2
    305    305. S S S V                  
    306    306. S S S V                             end if
    307    307. S S S V                            end if
    308    308. S S S V                           end if
    309    309. S S S V---------------->         end do
    310    310. S S S                    
    311    311. S S S                            end if
    312    312. S S S                    
    313    313. S S S                            if ( number_fail .ne. 0 ) then
    314    314. S S S                              fe_fail = fe_fail / float( number_fail )
    315    315. S S S                              delta_fail = sqrt(delta_fail / float( number_fail ))
    316    316. S S S                            end if
    317    317. S S S                            if ( number_accept .ne. 0 ) then
  
    318    318. S S S                              fe_accept = fe_accept / float( number_accept )
    319    319. S S S                              delta_accept = sqrt(delta_accept / float( number_accept ))
    320    320. S S S                            end if
    321    321. S S S                            if ( statistics(j,1) .ne. 0 ) write(6,'(1x,a24,4x,i5,"[",i4,   
    322    322. S S S                        &      "%]",t48,e9.3,t61,e9.3)')
    323    323. S S S                        &      obsname(j), statistics(j,1),nint(float(statistics(j,2))/
    324    324. S S S                        &      float(statistics(j,1))*100), delta_accept, fe_accept
    325    325. S S S                    
    326    326. S S S------------------> 3      end do
    327    327. S S                      
    328    328. S S                            mandatory = .false.
    329    329. S S--------------------> 2     end do
    330    330. S----------------------> 1    end do
    331    331.                         !
    332    332.                         CFPP $ CONCUR
    333    333.                               return
    334    334.                               end
  
                V E C T O R I Z A T I O N   I N F O R M A T I O N
                -------------------------------------------------
 cft77-8035 cf77: VECTOR QCREPORT, Line = 75, File = /tmp/jtmp.091484a/qcreport.j, Line = 75
   Loop starting at line 75 was not vectorized.  It contains an inner loop.
 cft77-8035 cf77: VECTOR QCREPORT, Line = 79, File = /tmp/jtmp.091484a/qcreport.j, Line = 79
   Loop starting at line 79 was not vectorized.  It contains an inner loop.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 99, File = /tmp/jtmp.091484a/qcreport.j, Line = 99
   Loop starting at line 99 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 107, File = /tmp/jtmp.091484a/qcreport.j, Line = 107
   Loop starting at line 107 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 122, File = /tmp/jtmp.091484a/qcreport.j, Line = 122
   Loop starting at line 122 was vectorized.
 cft77-8035 cf77: VECTOR QCREPORT, Line = 126, File = /tmp/jtmp.091484a/qcreport.j, Line = 126
   Loop starting at line 126 was not vectorized.  It contains an inner loop.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 131, File = /tmp/jtmp.091484a/qcreport.j, Line = 131
   Loop starting at line 131 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 144, File = /tmp/jtmp.091484a/qcreport.j, Line = 144
   Loop starting at line 144 was vectorized.
 cft77-8035 cf77: VECTOR QCREPORT, Line = 172, File = /tmp/jtmp.091484a/qcreport.j, Line = 172
   Loop starting at line 172 was not vectorized.  It contains an inner loop.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 174, File = /tmp/jtmp.091484a/qcreport.j, Line = 174
   Loop starting at line 174 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 192, File = /tmp/jtmp.091484a/qcreport.j, Line = 192
   Loop starting at line 192 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 218, File = /tmp/jtmp.091484a/qcreport.j, Line = 218
   Loop starting at line 218 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 260, File = /tmp/jtmp.091484a/qcreport.j, Line = 260
   Loop starting at line 260 was vectorized.
 cft77-8004 cf77: VECTOR QCREPORT, Line = 283, File = /tmp/jtmp.091484a/qcreport.j, Line = 283
   Loop starting at line 283 was vectorized.
  
                O P T I M I Z A T I O N   I N F O R M A T I O N
                -----------------------------------------------
 cft77-8135 cf77: SCALAR QCREPORT, Line = 144, File = /tmp/jtmp.091484a/qcreport.j, Line = 144
   Loop starting at line 144 was unrolled 2 times.
  
                  
                E X T E R N A L   N A M E   T A B L E
                -------------------------------------
                $STKOFEN         : ENTRY, IMPORTED
                $WFA$            : ENTRY, IMPORTED
                $WFF             : ENTRY, IMPORTED
                $WFI             : ENTRY, IMPORTED
                $WFV$%           : ENTRY, IMPORTED
                %SQRT%           : ENTRY, IMPORTED
                ALLOC%           : ENTRY, IMPORTED
                ALOG%            : ENTRY, IMPORTED
                DEALLC%          : ENTRY, IMPORTED
                QCREPORT         : ENTRY, EXPORTED AT 00000004d RELATIVE
                SQRT%            : ENTRY, IMPORTED
  
                C R O S S   R E F E R E N C E   L I S T I N G
                ---------------------------------------------
 Name                            Address     Type    Usage     Storage                         Source Program References
 ----                            ----------  ----    -----     -------                         -------------------------
 ABS                                                 Intrinsic                                       128U       108U                 
 ANALYSIS_DATE                         1505  Char    Var       Stack                                 163U       155U        92U      
                                                                                                      86U        62M        31D      
 ANALYSIS_TIME                         1510  Char    Var       Stack                                 163U       155U        92U      
                                                                                                      86U        66M        65M      
                                                                                                      29D                            
 DATA                                        Real    Array     Dum_arg                               304U       303U       301U      
                                                                                                     297U       296U       293U      
                                                                                                     292U       290U       285A      
                                                                                                     284U       274U       273U      
                                                                                                     270U       268U       267U      
                                                                                                     262A       261U       227A      
                                                                                                     226A       221U       220U      
                                                                                                     219U       194U       193U      
                                                                                                     179U       178A/2     175U      
                                                                                                     127A       108U        26D      
                                                                                                      23D                            
 DATANAME                                 3 *Char    Array     OBS                                    38D        30D                 
 DATAPTRS                                            Comm_blk                                         36D                            
 DATE_TEMP                             1504  Char    Var       Stack                                  63U        62U/2      61M      
                                                                                                      60M        30D                 
 DELTA_ACCEPT                             0  Real    Var       Stack                                 324U       319M       319U      
                                                                                                     291M       291U       268M      
                                                                                                     268U       252M                 
 DELTA_FAIL                               0  Real    Var       Stack                                 315M       315U       302M      
                                                                                                     302U       274M       274U      
                                                                                                     253M                            
 FE_ACCEPT                                0  Real    Var       Stack                                 324U       318M       318U      
                                                                                                     290M       290U       267M      
                                                                                                     267U       250M                 
 FE_FAIL                                  0  Real    Var       Stack                                 314M       314U       301M      
                                                                                                     301U       273M       273U      
                                                                                                     251M                            
 FLOAT                                       Real    Intrinsic                                       324U       323U       319U      
