 
      SUBROUTINE TERPV3( L,      NS,     XLAT,   YLON,   DATA,
     $                   QDATA,  PFAC,   LQU,    DIF                 )
 
C  COMPUTES OBSERVATION MINUS BACKGROUND DIFFERENCES IN THREE DIMENSIONS
C  THE DIFFERENCES ARE COMPUTED AT THE LEVELS ABOVE AND BELOW THE
C  REPORT.  REPORTS ARE ASSUMED WITHIN ONE LEVEL OF L. THESE STRADDLING
C  DIFFERENCES ARE THEN INTERPOLATED USING THE PRESSURE FACTOR PREPARED
C  BY ROUTINE PREFAC. LQU(II) = (L-1) IF OBSERVATION IS ABOVE LEVEL L.
 
C  NOTE: WHEN TERPV3 IS CALLED FOR HIGHEST LEVEL, QDATA(I,J,1) IS THE
C  FIRST GUESS DATA AT THAT LEVEL. OTHERWISE, IT IS DATA FOR THE LEVEL
C  ABOVE THE ONE BEING ANALYZED.
 
 
      DIMENSION         DATA(NS)
      DIMENSION         DIF(NS)
      INTEGER           II
      INTEGER           L
      DIMENSION         LQU(NS)
C     HALF PRECISION    LQU
      INTEGER           NS
      DIMENSION         PFAC(NS)
      DIMENSION         QDATA(IM,JNP,mlev)
      DIMENSION         WORK(20000)
C     HALF PRECISION    WORK
      DIMENSION         XLAT(NS)
      DIMENSION         YLON(NS)
 
C  ANALYSIS CONTROL PARAMETERS (IM AND JNP ARE NEEDED BY THIS ROUTINE)
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT,  MAXREP
 
C  VERTICAL INDICES (MLEV IS NEEDED BY THIS ROUTINE)
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1
 
      if (l.eq.1) then 
         labove = 1
      else 
         labove = l - 1 
      end if 
      lcentral = l
      if (l.eq.mlev) then 
         lbelow  = mlev
      else 
         lbelow = l + 1 
      end if 
 
C  HORIZONTAL INTERPOLATION OF BACKGROUND FROM LEVEL BELOW
      CALL TERPV( XLAT, YLON, DIF, NS, QDATA(1,1,lbelow) )
 
C  HORIZONTAL INTERPOLATION OF BACKGROUND FROM LEVEL ABOVE
      CALL TERPV( XLAT, YLON, WORK, NS, QDATA(1,1,labove) )
      DO 100 II = 1, NS
         IF( LQU(II).LT.L ) DIF(II) =  WORK(II)
  100 CONTINUE
 
C  HORIZONTAL INTERPOLATION OF BACKGROUND AT CENTRAL LEVEL
      CALL TERPV( XLAT, YLON, WORK, NS, QDATA(1,1,lcentral) )
 
C  VERTICAL INTERPOLATION OF BACKGROUND AND FORMATION OF DIFFERENCE
      DO 200 II = 1, NS
         DIF(II) = DATA(II) - ( PFAC(II) * WORK(II) +
     $                                  ( 1.0 - PFAC(II) ) *  DIF(II) )
  200 CONTINUE
 
      RETURN
      END
