C ********************************************************************  
                                                                        
      SUBROUTINE THICKN ( PA,ZSURF ,KEY2)                               
C ********************************************************************  
C  COMPUTATION OF THICKNESSES OF THE MANDATORY LEVELS LAYERS            
C  PA = BOTTOM-MOST PRESSURE                                            
C  INPUT:- (P, T)-PROFILE IN /INPRO/                                    
C  ZSURF  : =0. FOR OCEAN ( =HEAD(11))                                  
C  OUTPUT:-  PREFER   -  REFERENCE PRESSURE                             
C            PREZ  : =   PRESSURE FOR REZULT DATA                       
C            ZREZ  : =   HEIGHTS FOR REZULT DATA                        
C            NA       =   NUMBER OF REZULT                              
C            KEY2\    =   'REJECT-HEIGHT'                               
C                     =   'REJECT-TMID'                                 
C       REAL PREZ (21),ZREZ(21),ZSURF                                   
C        REAL P_DATA (21),Z_DATA(21),ZSURF                              
        INTEGER   NA                                                    
          CHARACTER * 20 KEY2                                           
        REAL PM(21)                                                     
        DATA PM    /1000., 850., 700., 500., 400., 300., 250., 200.,    
     *    150., 100., 70., 50., 30., 20., 10., 7., 5., 3., 2., 1., 0.4/ 
      COMMON /INPRO/ NX, PBAR(15), TBAR(15)                             
      COMMON /ZTHICKN/ NA,PREFER, PREZ(21), ZREZ(21)                    
         REAL Z(21)                                                     
C  --HEIGHTS AND TEMPERATURES AT MANDATORY LEVELS (OUTPUT)              
         REAL PMID(20), DELFAC(20), HGTFAC(20), PREF, KAPPA             
          DATA     PREF/1000./                                          
          DATA Z1000/111./, R/287.055/, G/9.80655/, BETA/0.0065/,       
     *    C/0.0555/, KAPPA/.28563/                                      
        DATA  FILL /1.E15/                                              
C  --KAPPA = R/CP                                                       
C       DATA    KT/0/                                                   
C  * * *                                                                
C  COLLIN'S MID-PRESSURE FORMULA                                        
        PP(PL, PB) =                                                    
     *    ((PL**KAPPA - PB**KAPPA)/ALOG(PL/PB)/KAPPA)**(1/KAPPA)        
C  HEIGHT ESTIMATION FUNCTION                                           
        FF(XA) = XA/(1 + .00325*XA)                                     
C  --.00325 = BETA/2                                                    
C  INTEGER CONVERSION                                                   
C       IC(P) = 10*P + 0.5                                              
                                                                        
C  * * *                                                                
C  SUBROUTINE SETUP0                                                    
C  PRELIMINARY CALCULATIONS FOR LASER THICKNESSES                       
C  USES DSRN 89 FOR SCRIPPS TOPOGRAPHY                                  
C  ENTRY SETUP2                                                         
C  PRELIMINARY CALCULATIONS OF CONSTANT QUANTITIES                      
C  TO BE DONE ONCE ONLY                                                 
         IF (JUMP .EQ. 1) GO TO 11                                      
         DO 10 L = 1, 20                                                
C  MID-PRESSURES (COLLIN'S) IN THE MANDATORY LAYERS--                   
         PMID(L) = PP (PM(L), PM(L+1))                                  
C  TEMPERATURE FACTORS FOR THE MANDATORY LAYER THICKNESSES--            
        DELFAC(L) = R/G*ALOG(PM(L)/PM(L+1))                             
C  FACTOR FOR NOMINAL HEIGHT PROFILE--                                  
         HGTFAC(L) = FF(R/G*ALOG(PM(1)/PM(L)))                          
 10      CONTINUE                                                       
C        PRINT *,'PMID(19AND 20)=    ', PMID(19),PMID(20)               
            JUMP = 1                                                    
 11      CONTINUE                                                       
            KEY2 = 'GOOD'                                               
C  * * *                                                                
C  LOCATE (PA)                                                          
C  POSITIONS PA (BOTTOM PRESSURE) IN ARRAY PM (MANDATORY PRESSURES)     
          DO 12 LL = 1, 15                                              
          IF (PA .GT. PM(LL)) GO TO 13                                  
 12       CONTINUE                                                      
C  * * *                                                                
 13       CONTINUE                                                      
          IF (LL .EQ. 1) LL = 2                                         
              L0 = LL - 1                                               
C         PRINT *,'L0,LL====', L0,LL                                    
C  PRESSURE AT LOWEST EDGE IS BETWEEN PM(L0) AND PM(LL)                 
C        AND MAY BE PM(L0)                                              
                                                                        
                                                                        
C  * * *                                                                
C   FOR LAND OR INCOMPLETE OCEAN RETRIEVALS--   GO TO 4                 
      IF (ZSURF .NE. 0. .OR. PA .LT. 700.) GO TO 4                      
C                                                                       
C  THICKNESS OF PARTIAL LAYER ABOVE THE BOTTOM                          
C                                                                       
C  DATA EDGE PA IS BETW PM(L0) AND PM(LL) AND MAY BE PM(L0)             
        PMID00 = PP (PA, PM(LL))                                        
C        PRINT *,'PMID00 =;  ',PMID00                                   
C  INTERPOLATE FOR MID-TEMPERATURE OF THE MANDATORY LAYER USING THE     
C        COLLIN'S MID-PRESSURE OF THE LAYER--                           
        TMID = TINTER (PMID00)                                          
C        PRINT *,'TMID   =;  ',TMID                                     
C          IF (TMID .EQ. FILL)                                          
C    *    PRINT *, L0, LL, PM(L0), PA, PM(LL), PMID00                   
C1   FORMAT (' 1ST MAND. LAYER--', 2I3, 3F10.2, ' MID-PR', F10.2)       
        IF (TMID .EQ. FILL) THEN                                        
                 KEY2='REJECT-TMID'                                     
             RETURN                                                     
        ENDIF                                                           
C  THICKNESS OF PARTIAL LAYER JUST ABOVE BOTTOM--                       
         DELTAZ = R/G*TMID*ALOG(PA/PM(LL))                              
C        PRINT *,'DELTAZ   =;  ',DELTAZ                                 
C  APPROX TEMPERATURE AT BOTTOM (QQ, USED BELOW)                        
         TA = TBAR(1) + C*(PA - PMID00)                                 
C        PRINT *,'TA   =;  ',TA                                         
C  * * *                                                                
C  THICKNESS OF PARTIAL LAYER BELOW THE BOTTOM                          
C  SURFACE TEMPERATURE (FROM DATA)                                      
C     TSURF = COORDS(13)                                                
C  CORRECTED SURFACE TEMP--                                             
          TSURF = TA                                                    
C  --ORIGINALLY TSURF = (TSURF + TA)/2                                  
         DZ1000 = ZSURF - Z1000                                         
C        PRINT *,'DZ1000   =;  ',DZ1000                                 
C  TEMP AT 1000 MB USING CONSTANT LAPSE RATE FROM SURFACE--             
          T1000 = TSURF + BETA*DZ1000                                   
C        PRINT *,'T1000   =;  ',T1000                                   
C  SURFACE PRESSURE--                                                   
C  MEAN TEMP BETW SURF AND 1000 MB (INTERMEDIATE QUANTITY)              
        TMEAN = (TSURF + T1000)/2                                       
C        PRINT *,'TMEAN   =;  ',TMEAN                                   
        PSURF = PM(1)*EXP(-G/R*DZ1000/TMEAN)                            
C        PRINT *,'PSURF   =;  ',PSURF                                   
        IF (ABS(PSURF - PA) .GT. 100) THEN                              
                 KEY2='REJECT-HEIGHTS'                                  
          RETURN                                                        
         ENDIF                                                          
C  * * *                                                                
C                                                                       
C  COMPLETE MANDATORY LAYERS EXIST BELOW BOTTOM                         
C  COMPUTED HEIGHTS USING FORMULA, NOT DEPENDENT ON DATA                
          DO 2 I = 1, L0                                                
C  HEIGHT ABOVE 1000 MB--                                               
          Z(I) = T1000*HGTFAC(I)                                        
 2     CONTINUE                                                         
C  * * *                                                                
C  PARTIAL LAYER JUST BELOW BOTTOM                                      
C  COMPUTED HEIGHT AT BOTTOM OF LAYER                                   
C  HEIGHT OF BOTTOM ABOVE SURFACE--                                     
         DZSURF = TSURF*FF(R/G*ALOG(PSURF/PA))                          
C  --PRESUMABLY = ZA - ZSURF,                                           
C  HEIGHT OF BOTTOM ABOVE 1000 MB--                                     
        ZZ = DZ1000 + DZSURF                                            
C  PRESUMABLY = ZA - Z1000                                              
         IF (PA .EQ. PM(1)) ZZ = 0                                      
C  ADD THICKNESS OF PARTIAL LAYER TO GET HEIGHT OF FIRST                
C        MANDATORY LEVEL ABOVE BOTTOM                                   
         Z(LL) = ZZ + DELTAZ                                            
C  * * *                                                                
C  STANDARD COMPUTATIONS FOR REMAINING LAYERS                           
        DO 3 L = LL, 20                                                 
         TMID = TINTER (PMID(L))                                        
C  IF MID-PRESSURE IS OUTSIDE OF DATA RANGE--                           
         IF (TMID .EQ. FILL) GO TO 8                                    
         DZ = DELFAC(L)*TMID                                            
         Z(L+1) = Z(L) + DZ                                             
 3      CONTINUE                                                        
          L = 21                                                        
           GO TO 8                                                      
C  * * *                                                                
C  * * *                                                                
C6     CONTINUE                                                         
C  HEIGHTS UNRELIABLE                                                   
C  WIPE OUT COMPUTATIONS                                                
C     NA(1) = 0                                                         
C     KT = KT + 1                                                       
C        PRINT 7,PSURF, PA, PM(LL), PMID00,                             
C     *                TBAR(1), TA, T1000                               
C  7     FORMAT (' HEIGHTS REJECTED   (', F6.2, F8.2, ')  PSURF--', F7.2
C     *    '  PA--', F7.2, '  PM--', F7.2/ '  PMID--', F7.2,            
C     *    '  TSURF--', F6.2, '  TBAR--', F6.2, '  TA--', F6.2,         
C     *    '  T1000--', F6.2/)                                          
C          RETURN                                                       
C  * * *                                                                
 8     CONTINUE                                                         
C  HEIGHTS COMPUTED UP TO Z(L)                                          
C  LOAD /L2BDAT/ ARRAYS                                                 
        DO 9 I = 2, L                                                   
           J = I - 1                                                    
C       P1(J, 1) = PREF                                                 
C      P2(J, 1) = PM(I)                                                 
           PREFER = PREF                                                
          PREZ(J) = PM(I)                                               
          ZREZ(J) = Z(I)                                                
C      Q(J, 1) = FILL                                                   
 9     CONTINUE                                                         
        NA = J                                                          
C        PRINT *,'  PREFER =   ',PREFER                                 
C        PRINT *,' PRESSURE DATA =      ',PREZ                          
C        PRINT *,' Z-THICKNESS =  ',ZREZ                                
                                                                        
         RETURN                                                         
                                                                        
C  LAND RETRIEVAL OR INCOMPLETE OCEAN RETRIEVAL                         
C  COMPUTATIONS FOR REMAINING COMPLETE LAYERS                           
 4       CONTINUE                                                       
         L1 = LL                                                        
         IF (PA .EQ. PM(L0)) L1 = L0                                    
         HT = 0                                                         
        J = 0                                                           
        DO 5 L = L1, 20                                                 
         J = J + 1                                                      
          TMID = TINTER (PMID(L))                                       
C  IF MID-PRESSURE IS OUTSIDE OF DATA RANGE--                           
        IF (TMID .EQ. FILL) RETURN                                      
         DZ = DELFAC(L)*TMID                                            
         HT = HT + DZ                                                   
         PREFER = PM(L1)                                                
        PREZ(J) = PM(L+1)                                               
         ZREZ(J)= HT                                                    
C      Q(J, 1) = FILL                                                   
          NA = J                                                        
C        PRINT *,'J-LEVEL,  PREFER =   ',J,PREFER                       
C        PRINT *,' PRESSURE DATA =      ',PREZ(J)                       
C        PRINT *,' Z-THICKNESS =  ',ZREZ(J)                             
 5       CONTINUE                                                       
C        PRINT *,'  PREFER =   ',PREFER                                 
C        PRINT *,' PRESSURE DATA =      ',P_DATA                        
C        PRINT *,' Z-THICKNESS =  ',Z_DATA                              
                                                                        
          RETURN                                                        
C  * * *                                                                
C                                                                       
C                                                                       
C  * * *                                                                
C       ENTRY KTHGTS                                                    
C       IF (KT .GT. 0) PRINT 14, KT                                     
C14     FORMAT (I5, ' RETRIEVALS WITHOUT HEIGHTS')                      
C        KT = 0                                                         
C         RETURN                                                        
         END                                                            
