C                                                                       
C********************************************************************** 
                                                                        
          FUNCTION TINTER (P)                                           
C  INTERPOLATION FOR P IN TBAR VS. PBAR ARRAY                           
C     FILL  (=1.E15 )    RETURNED IF P IS OUTSIDE OF RANGE              
C  TINTER -INTERPOLATION TEMPERATURE FOR P USING TBAR,PBAR ARRAY        
         COMMON /INPRO/ NX, PBAR(15), TBAR(15)                          
        DATA  EPS/.05/                                                  
        DATA  FILL /1.E15/                                              
        DO 1 L = 1, NX                                                  
        IF (P .GE. PBAR(L)) GO TO 2                                     
 1       CONTINUE                                                       
C  P ABOVE LAST AVAILABLE PBAR                                          
C  NO MORE TEMPERATURES WILL BE COMPUTED--                              
         TINTER = FILL                                                  
         IF (PBAR(NX) - P .GT. EPS) RETURN                              
         L = NX                                                         
 2       CONTINUE                                                       
         IF (L .GT. 1) GO TO 3                                          
C  P IS AT LOWERMOST DATA                                               
        TINTER = TBAR(1)                                                
        RETURN                                                          
 3     CONTINUE                                                         
C  P IS BETWEEN PBAR(L-1) AND PBAR(L)                                   
C  LINEAR IN LOG P INTERPOLATION                                        
        A1 = ALOG (PBAR(L-1)/P)                                         
        A2 = ALOG (P/PBAR(L))                                           
        TINTER = (A1*TBAR(L) + A2*TBAR(L-1))/(A1 + A2)                  
        RETURN                                                          
        END                                                             
