                                                                        
C  *******************************************************              
             REAL FUNCTION  TOVSKX (LAND_OCEAN,LAT,MRX,MRY)             
C                                                                       
C  *******************************************************              
C  TOVSKX RETURN  KX (AS REAL) FOR SATELLITE ( TOVS ) DATA              
C     AS A FUNCTION OF STATION_ID AND LONGITUDE (FOR VISCONSIN)         
C     ----------------------------------------------------------------- 
C    | KX   |LAND/ |  NORTH/   |METHOD RETREIVAL  | A - CLEAR COLUMN    
C    |      |OCEAN |  SOUTH    | MRX    MRY       | B - PARTLY COLUMN   
C    |      |      |HEMISPHERE |                  | C - CLAUDY(MICROWAVE
C    |------------------------------------------------------------------
C    | 33.0 |   L  |   NH      |  1     1         |    A                
C    | 34.0 |   L  |   SH      |  1     1         |    A                
C    | 35.0 |   L  |   NH      |  2     1         |    B                
C    | 36.0 |   L  |   SH      |  2     1         |    B                
C    | 37.0 |   L  |   NH      |        2         |    C                
C    | 38.0 |   L  |   SH      |        2         |    C                
C    | 39.0 |   O  |   NH      |  1     1         |    A                
C    | 40.0 |   O  |   SH      |  1     1         |    A                
C    | 41.0 |   O  |   NH      |  2     1         |    B                
C    | 42.0 |   O  |   SH      |  2     1         |    B                
C    | 43.0 |   O  |   NH      |        2         |    C                
C    | 44.0 |   O  |   SH      |        2         |    C                
C     -------------------------------------------------                 
C                                                                       
C     TOVSKX RETURNS  KX=0.   FOR THE REST                              
C       ( LAND_OCEAN = 0.0   FOR OCEAN )                                
C  *******************************************************              
       REAL   LAND_OCEAN,LAT,MRX,MRY                                    
          TOVSKX  = 0.0                                                 
          IF (LAND_OCEAN .NE.0.0)       THEN                            
         IF (LAT.GE.0.0 .AND. MRX.EQ.1.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 33.0                      
         IF (LAT.LT.0.0 .AND. MRX.EQ.1.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 34.0                      
         IF (LAT.GE.0.0 .AND. MRX.EQ.2.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 35.0                      
         IF (LAT.LT.0.0 .AND. MRX.EQ.2.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 36.0                      
         IF (LAT.GE.0.0 .AND. MRY.EQ.2.0 )                              
     .                               TOVSKX = 37.0                      
         IF (LAT.LT.0.0 .AND. MRY.EQ.2.0 )                              
     .                               TOVSKX = 38.0                      
           ENDIF                                                        
          IF (LAND_OCEAN .EQ.0.0)       THEN                            
         IF (LAT.GE.0.0 .AND. MRX.EQ.1.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 39.0                      
         IF (LAT.LT.0.0 .AND. MRX.EQ.1.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 40.0                      
         IF (LAT.GE.0.0 .AND. MRX.EQ.2.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 41.0                      
         IF (LAT.LT.0.0 .AND. MRX.EQ.2.0 .AND. MRY.EQ.1.0)              
     .                               TOVSKX = 42.0                      
         IF (LAT.GE.0.0 .AND. MRY.EQ.2.0 )                              
     .                               TOVSKX = 43.0                      
         IF (LAT.LT.0.0 .AND. MRY.EQ.2.0)                               
     .                               TOVSKX = 44.0                      
           ENDIF                                                        
            RETURN                                                      
         END                                                            
