 
      SUBROUTINE TROPSE( TMOD, ZMOD )
!
!  Optimum Interpolation Analysis Version 1.1
!
C  COMPUTES TROPOPAUSE PRESSURE USING NMC ALGORITHM
C  RESULT, PTROP, IS RETURNED IN BLANK COMMON
 
 
      REAL              APBAR(8)
C  APBAR = MEAN LOG(PRESSURE) FOR 8 LAYERS.
      REAL              APTROP
      REAL              GTROP(3)
      INTEGER           I
      INTEGER           II
      INTEGER           II1
      INTEGER           IJ
      INTEGER           IMJNP
      INTEGER           J
      INTEGER           L
      INTEGER           NOTROP
      COMMON            PTROP(144*91), GAM(144*91*8)
C  GAM = (-DT/DZ) FOR 8 LAYERS BETWEEN 500 MB AND 50 MB. ( DEG K / KM )
      DIMENSION         TMOD(IM*JNP,MLEV)
      DIMENSION         ZMOD(IM*JNP,MLEV)
 
C  ANALYSIS CONTROL PARAMETERS
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT
 
      common /pmh/      pmand(18)
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,
     $                  SIGDAT,  MAXREP
 
C  VERTICAL INDICES
      COMMON /MLAY/     MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1
 
C  MANDATORY PRESSURE LEVELS
      COMMON /PRMAND18/ PMAND18(18), ALOGP18(18), PKAP18(18),
     $                  PKAP118(18), PM18(18)
 
      DATA              GTROP / 2.0, 2.5, 3.0 /
 
C  STATEMENT FUNCTIONS
      I(IJ) = MOD( IJ-1, IM ) + 1
      J(IJ) = (IJ-1) / IM + 1
 
C  INITIALIZE
      IMJNP  = IM * JNP
      NOTROP = 0
 
C  COMPUTE GAM = (-DT/DZ) FOR 8 LAYERS BETWEEN 500 MB AND 50 MB AND
C  MEAN LOG(PRESURE) FOR THE SAME LAYERS ( BOTTOM - TOP )
      II = 0
      DO 120 L = 1, 8
         apbar(l) = ( log(pmand(mlev-l-2)) + log(pmand(mlev-l-3)))* 0.5
         DO 110 IJ = 1, IMJNP
            GAM(II+IJ) = 1000.0 *
     $                   ( TMOD(IJ,MLEV-L-2) - TMOD(IJ,MLEV-L-3) ) /
     $                   ( ZMOD(IJ,MLEV-L-3) - ZMOD(IJ,MLEV-L-2) )
  110    CONTINUE
         II = II + IMJNP
  120 CONTINUE
 
C  ESTIMATE TROPOPAUSE AT EACH GRID POINT.
      DO 200 IJ = 1, IMJNP
 
C  TRY TO DEFINE THE TROPOPAUSE 3 TIMES WITH 3 DIFFERENT THRESHOLD
C  VALUES  GTROP(K).
         DO 190 K = 1, 3
            II = IJ
            DO 180 L = 1, 8
 
               IF( GAM(II).LT.GTROP(K) ) THEN
 
                  IF( L.GT.1 ) THEN
                     II1 = II - IMJNP
C  INTERPOLATE LOG(P) LINEARLY BETWEEN THE 2 MID LOG(P) LEVELS AT WHICH
C  WE KNOW THE GAMMA VALUES TO FIND THE GTROP LOCATION.
 
                     APTROP = ( APBAR(L-1) * ( GTROP(K) - GAM(II) ) +
     $                          APBAR(L)   * ( GAM(II1) - GTROP(K) ) ) /
     $                                       ( GAM(II1) - GAM(II)  )
                  ELSE
                     APTROP = APBAR(1)
                  ENDIF
                  PTROP(IJ) = EXP( APTROP )
                  GOTO 200
               ENDIF
               II = II + IMJNP
  180       CONTINUE
  190    CONTINUE
 
C  NO TROPOPAUSE FOUND. FILL PTROP WITH A 0.0
          NOTROP    = NOTROP + 1
          PTROP(IJ) = 0.0
          WRITE( 6, 900 ) I(IJ), J(IJ)
 
  200 CONTINUE
 
       WRITE( 6, 910 ) NOTROP
 
       RETURN
 
  900 FORMAT(' TROPSE: TROPOPAUSE NOT FOUND FOR I, J = ',2I4 )
  910 FORMAT('0TROPSE: TROPOPAUSE SEARCH FAILED FOR ',I5,' GRIDPOINTS' )
       END
