                                                                                
      SUBROUTINE BDBATCH(KX,LAT,LON,DELT,NOBS,NBAD,NGOOD)                       
C......................................................................         
C                                                                     .         
C  Program:    BDBATCH                                                .         
C  Language:   FORTRAN V (ANSI-77 STANDARD)                           .         
C  Computer:   Cray YMP 4/832                                         .         
C                                                                     .         
C  Programmer: Y. BRIN    ("DECYBERIZATION" BY M.SEABLOM)             .         
C  Date:       FEBRUARY, 1990                                         .         
C                                                                     .         
C  PROGRAM BDBATCH PERFORMS A 'BUDDY' CHECK ON QUESTIONABLE REPORTS.  .         
C                                                                     .         
C......................................................................         
                                                                                
                                                                                
C**********************************************************************         
C*                                                                    *         
C*  N A S A   O P T I M U M   I N T E R P O L A T I O N   -   O 9 X   *         
C*               Global Modeling and Simulation Branch                *         
C*                   GODDARD SPACE FLIGHT CENTER                      *         
C*                                                                    *         
C**********************************************************************         
                                                                                
                                                                                
                                                                                
      real           KX(NOBS),LAT(NOBS),LON(NOBS),DELT(NOBS),                   
     &               GLAT(20000), GLON(20000), IWORK(20000),                    
     &               XLAT(20000),XLON(20000),YLAT(20000),                       
     &                           YLON(20000),GDIST(20000)                       
      INTEGER BGRS(20000),BACC(20000),BBUD(20000),BCHK(20000),                  
     &        BDIST(20000)                                                      
                                                                                
                                                                                
      COMMON /PRINT/ MSGLEV                                                     
                                                                                
      COMMON /BUDBITS/ BGRS,BACC,BBUD,BCHK                                      
                                                                                
C MAXIMUM BATCH SIZE, MAXIMUM NUMBER OF NEIGHBORING POINTS.                     
                                                                                
      COMMON /BUDDY/ MAXLEV,MAXLIST,MAXBATCH, MAXINDX, BUDDIST, BUDLAT          
      real    BUDDIST, BUDLAT                                                   
                                                                                
C BLANK COMMON  HOLDS ALL DATA NECESSARY FOR GOOD/BAD BATCH PROCESSING          
                                                                                
                                                                                
      COMMON    CUTVAL,IGOOD,IBAD,GLAT,GLON,IWORK,                              
     .           XLAT,XLON,YLAT,YLON,GDIST,IBINDX,IGINDX,INDX,GDELT             
                                                                                
                                                                                
C CUTOFF VALUES, 'GOOD' , 'BAD' INDICES                                         
                                                                                
      real    CUTVAL(20000),IGOOD(20000),IBAD(20000)                            
                                                                                
C OTHER LOCAL VARIABLES.                                                        
                                                                                
      real  AVG                                                                 
      real  IBINDX(20000),IGINDX(20000)                                         
      real  INDX(10000),GDELT(10000)                                            
                                                                                
                                                                                
      LOGICAL NEXT                                                              
                                                                                
      MAXINDX = 10000                                                           
                                                                                
C CREATE ARRAYS OF GOOD LATS AND LONS.                                          
                                                                                
                                                                                
      CALL A77HGATH(LAT,IGOOD,GLAT,NGOOD)                                       
      CALL A77HGATH(LON,IGOOD,GLON,NGOOD)                                       
                                                                                
C INITIALIZE.                                                                   
                                                                                
                                                                                
      LBATCH = 0                                                                
      IBATCH = 0                                                                
      NEXT = .TRUE.                                                             
      I = 1                                                                     
                                                                                
C START LOOP BY BAD REPORTS CREATING BATCHES OF BAD/GOOD PAIRS.                 
                                                                                
                                                                                
 10   CONTINUE                                                                  
                                                                                
      IF(I .GT. NBAD) RETURN                                                    
      II = IBAD(I)                                                              
                                                                                
                                                                                
C GET A PATCH OF GOOD OBSERVATIONS AROUND A BAD ONE.                            
                                                                                
                                                                                
      IF(NEXT)  THEN                                                            
                                                                                
                                                                                
        CALL BDPATCH (LAT(II),LON(II),GLAT,GLON,                                
     .                                 IWORK,NGOOD,INDX,NGOB)                   
        IF (MSGLEV.GT.5) THEN                                                   
                                                                                
          WRITE (6,'('' BDBATCH: GOT PATCH FOR REP #'',I8,2F10.2,/,             
     &           '' GOT GOOD REPS IN THE PATCH '',I8 )') II, LAT(II),           
     &           LON(II), NGOB                                                  
                                                                                
        ENDIF                                                                   
                                                                                
      ENDIF                                                                     
                                                                                
C IF NUMBER OF OBS IN THE PATCH FITS INTO THE MAX SIZE OF BATCH                 
C ADD IT TO THE BATCH.                                                          
                                                                                
                                                                                
                                                                                
      IF((IBATCH + NGOB) .LE. MAXBATCH) THEN                                    
        NEXT = .TRUE.                                                           
        IF(NGOB.NE.0) THEN                                                      
          DO 15 K = 1,NGOB                                                      
            IBATCH = IBATCH + 1                                                 
            IBINDX(IBATCH) = II                                                 
            IGINDX(IBATCH) = IGOOD(int(INDX(K)) )                               
 15       CONTINUE                                                              
        ENDIF                                                                   
        IF(IBATCH.EQ.MAXBATCH .OR. I.EQ.NBAD)  LBATCH = IBATCH                  
                                                                                
      ELSE                                                                      
        NEXT = .FALSE.                                                          
        LBATCH = IBATCH                                                         
      ENDIF                                                                     
                                                                                
C BATCH IS FULL OR LIST OF BAD OBS IS EXHAUSTED.                                
                                                                                
                                                                                
      IF(LBATCH.NE.0) THEN                                                      
c       IF(MSGLEV.GT.5) WRITE(6,'('' BATCH CREATED LEN='',I8)') LBATCH          
                                                                                
                                                                                
C GATHER LATS/LONS IN THE BATCH INTO SEPARATE ARRAYS .                          
                                                                                
                                                                                
        CALL A77HGATH(LAT,IBINDX,XLAT,LBATCH)                                   
        CALL A77HGATH(LON,IBINDX,XLON,LBATCH)                                   
        CALL A77HGATH(LAT,IGINDX,YLAT,LBATCH)                                   
        CALL A77HGATH(LON,IGINDX,YLON,LBATCH)                                   
                                                                                
C COMPUTE GREAT CIRCLE DISTANCES BETWEEN BAD/GOOD PAIRS.                        
                                                                                
                                                                                
        CALL GCD(XLAT,XLON,YLAT,YLON,GDIST,LBATCH)                              
                                                                                
C                                                                               
C TURN ON BITS CORRESPONDING TO DISTANCES WITHIN THE LIMIT.                     
                                                                                
        NEWBATCH = 0                                                            
                                                                                
        DO 1 icmprs = 1,LBATCH                                                  
          IF ( GDIST(icmprs) .LE. BUDDIST ) THEN                                
             BDIST(icmprs) = 1                                                  
             NEWBATCH = NEWBATCH + 1                                            
          else                                                                  
             bdist(icmprs) = 0                                                  
          END IF                                                                
 1      CONTINUE                                                                
                                                                                
                                                                                
        IF(MSGLEV.GT.5) THEN                                                    
                                                                                
          DO 90 L = 1,LBATCH                                                    
            KB =  IBINDX(L)                                                     
            KG =  IGINDX(L)                                                     
            PRINT 84,KB,LAT(KB),LON(KB),KG,LAT(KG),LON(KG),GDIST(L),            
     .      BUDDIST                                                             
 84         FORMAT(' ',I8,2F10.2,I8,4F10.2)                                     
 90       CONTINUE                                                              
                                                                                
        ENDIF                                                                   
                                                                                
C COMPRESS OUT UNUSABLE PAIRS.                                                  
                                                                                
        NCOUNT = 0                                                              
        DO 2 icmprs = 1,LBATCH                                                  
          IF ( BDIST(icmprs) .EQ. 1 ) THEN                                      
             NCOUNT = NCOUNT + 1                                                
             IBINDX(NCOUNT) = IBINDX(icmprs)                                    
          END IF                                                                
 2      CONTINUE                                                                
                                                                                
        NCOUNT = 0                                                              
        DO 3 icmprs = 1,LBATCH                                                  
          IF ( BDIST(icmprs) .EQ. 1 ) THEN                                      
             NCOUNT = NCOUNT + 1                                                
             IGINDX(NCOUNT) = IGINDX(icmprs)                                    
          END IF                                                                
 3      CONTINUE                                                                
                                                                                
                                                                                
        IF(MSGLEV.GT.5) WRITE (6,'(/, '' BDBATCH: COMPRESSED OUT '',            
     &     ''FARTHER REPS. NEWBATCH:'',I6)') NEWBATCH                           
                                                                                
                                                                                
                                                                                
C LOOP OVER BAD DELTAS.COMPARE THEM AGAINST GOOD BUDDYS.                        
                                                                                
                                                                                
        KGOOD = 0                                                               
        KOLD = IBINDX(1)                                                        
        DO 20 K = 1,NEWBATCH + 1                                                
          IF(K.LE.NEWBATCH) THEN                                                
            KK = IBINDX(K)                                                      
          ELSE                                                                  
            KK = 0                                                              
          ENDIF                                                                 
                                                                                
          IF(KK.NE.KOLD) THEN                                                   
                                                                                
C  2 BUDDYS OR MORE ARE NEEDED.                                                 
                                                                                
            IF(KGOOD.GE.2) THEN                                                 
              BCHK(KOLD) = 1                                                    
              AVG = 0.                                                          
              DO 4 II = 1,KGOOD                                                 
                AVG = AVG + GDELT(II)                                           
 4            CONTINUE                                                          
              AVG = AVG/KGOOD                                                   
              IF( ABS(DELT(KOLD) - AVG) .LE. CUTVAL(KOLD))                      
     .                                           BBUD(KOLD) = 1                 
                                                                                
              IF(MSGLEV.GT.5) PRINT 86,KOLD,KGOOD,DELT(KOLD),AVG                
86            FORMAT(' * FOR INDEX ',2I8,                                       
     .                          '  GOOD BUDDYS.BDELT AND AVG ',2E14.7)          
                                                                                
            ELSE                                                                
                                                                                
              IF(MSGLEV.GT.5)  PRINT 87,KOLD,KGOOD,DELT(KOLD)                   
87            FORMAT(' * FOR INDEX ',2I8,                                       
     .                            '  GOOD BUDDYS.BDELT,NO AVG ',E14.7)          
                                                                                
            ENDIF                                                               
            KGOOD = 0                                                           
          ENDIF                                                                 
                                                                                
          IF(K.LE.NEWBATCH) THEN                                                
            KGOOD = KGOOD + 1                                                   
            JJ = IGINDX(K)                                                      
            GDELT(KGOOD) = DELT(JJ)                                             
            KOLD = KK                                                           
          END IF                                                                
 20     CONTINUE                                                                
                                                                                
C ALL DONE WITH THE BATCH.                                                      
                                                                                
                                                                                
        LBATCH = 0                                                              
        IBATCH = 0                                                              
        IF(NEXT) I = I + 1                                                      
      ELSE                                                                      
        I = I + 1                                                               
      ENDIF                                                                     
                                                                                
      GO TO 10                                                                  
                                                                                
1000  RETURN                                                                    
      END                                                                       
