                                                                        CON00010
      SUBROUTINE CONSTT ( TS, P, LA, LB )                               CON00020
                                                                        CON00030
C*****SUBR: CONSTT    VERSION: VECTOR      PROGRAM: OI            ******CON00040
C                                                                       CON00050
C  ENGLISH NAME: CONSTANT TEMPERATURE                                   CON00060
C                                                                       CON00070
C  LANGUAGE:  FORTRAN IV (H) EXTENDED (ENHANCED)                        CON00080
C                                                                       CON00090
C  PURPOSE: TO STABILIZE LAYERS BY ASSIGNING THE MEAN TEMPERATURE       CON00100
C           OF ALL THE LAYERS TO EACH LAYER                             CON00110
C                                                                       CON00120
C  CALLING SEQUENCE:                                                    CON00130
C                                                                       CON00140
C  NOTES:                                                               CON00150
C                                                                       CON00160
C  LOCAL VARIABLES:                                                     CON00170
C                                                                       CON00180
C  ERROR HANDLING:                                                      CON00190
C                                                                       CON00200
C  CALLS:                                                               CON00210
C                                                                       CON00220
C  METHOD: MAKES ARRAY TS CONSTANT FROM INDEX LA TO INDEX LB.           CON00230
C          USED IN STABILIZING THE POTENTIAL TEMPERATURES.              CON00240
C                                                                       CON00250
C  PROGRAMMER:                                                          CON00260
C                                                                       CON00270
C  MODIFIED:                                                            CON00280
C                                                                       CON00290
C***********************************************************************CON00300
                                                                        CON00310
      REAL           TS(1), P(1), S, TSBAR                              CON00320
                                                                        CON00330
      S = 0.00                                                          CON00340
                                                                        CON00350
      DO 3 K = LA, LB                                                   CON00360
         S = S + TS(K)*(P(K) - P(K+1))                                  CON00370
    3 CONTINUE                                                          CON00380
                                                                        CON00390
      TSBAR = S/(P(LA) - P(LB+1))                                       CON00400
                                                                        CON00410
      DO 5 K = LA, LB                                                   CON00420
         TS(K) = TSBAR                                                  CON00430
    5 CONTINUE                                                          CON00440
                                                                        CON00450
      RETURN                                                            CON00460
      END                                                               CON00470
