      SUBROUTINE GCD ( LAT1, LON1, LAT2, LON2, DIST, NP )                       
                                                                                
C......................................................................         
C                                                                     .         
C  Program:    GCD                                                    .         
C  Language:   FORTRAN V (ANSI-77 STANDARD)                           .         
C  Computer:   Cray YMP 8/432                                         .         
C                                                                     .         
C  Programmer: M. SEABLOM ( AFTER J. WOOLLEN, JULY 1985 )             .         
C  Date:       JANUARY, 1990                                          .         
C                                                                     .         
C  SUBROUTINE COMPUTES CHORD LENGTH APPROXIMATION TO GREAT CIRCLE     .         
C  DISTANCE.                                                          .         
C                                                                     .         
C  INPUT:  LAT1,LON1 AND LAT2,LON2  ARE THE LOCATIONS OF PAIRS OF     .         
C                                   POINTS ON THE EARTH.              .         
C                                                                     .         
C          NP  IS THE NUMBER OF PAIRS OF POINTS.                      .         
C                                                                     .         
C  OUTPUT: DIST  IS AN ARRAY CONTAINING THE DISTANCES OF THE PAIRS.   .         
C                                                                     .         
C  METHODOLOGY.                                                       .         
C       THE NORMAL ANGLE BETWEEN THE TWO POINTS IS GIVEN BY           .         
C                                                                     .         
C S*S/2 = 1 - COS(LAT1-LAT2) + COS(LAT1)*COS(LAT2)*(1-COS(LON1-LON2)) .         
C......................................................................         
                                                                                
      real     LAT1(NP), LAT2(NP), LON1(NP), LON2(NP),                          
     &         DIST(NP)                                                         
                                                                                
      PI   = 3.141592653                                                        
      DRC  = PI / 180.                                                          
      RADE = 6.375E3                                                            
                                                                                
      DO 1 I = 1,NP                                                             
                                                                                
         CLAT1 =  COS( LAT1(I)*DRC )                                            
         CLAT2 =  COS( LAT2(I)*DRC )                                            
         CLOND =  COS( (LON1(I)-LON2(I) )*DRC )                                 
         CDIF1 =  COS( (LAT1(I) - LAT2(I))*DRC )                                
                                                                                
         TEMP    = 1. - CDIF1 + CLAT1*CLAT2*                                    
     &             ( 1. - CLOND )                                               
                                                                                
         DIST(I) =  SQRT( 2. *TEMP    )*RADE                                    
                                                                                
 1    CONTINUE                                                                  
                                                                                
      RETURN                                                                    
      END                                                                       
