      subroutine initial(imr,jnpr,nlayr,nlevoi,pmandoi,repack)
 
!.....................................................................
!                                                                    .
!  Program Name: INITIAL                     Date: 1984              .
!                                                                    .
!  Programmer: M. Nestler                                            .
!                                                                    .
!  Program INITIAL sets OI constants and reads in namelist           .
!  parameters.                                                       .
!                                                                    .
!  Record of modifications:                                          .
!                                                                    .
!   08/1991 (M.Seablom)  OI version 1.2 upgrades; removal of volume  .
!                        definitions, addition of minivolume diag-   .
!                        nostic control from namelist.               .
!                                                                    .
!   05/1992 (M.Seablom)  OI version 1.3 upgrades; altered default    .
!                        dsn for observation error.                  .
!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
! 
!.....................................................................
 
 
 
      integer           mxqobs
      parameter       ( mxqobs = 200 )
 
      logical           qobs, offlev, repack
      character*8       dataname
      character *24     obsname
c     real              adjust
      real              cuth(18)
      data cuth       /  50., 50., 50., 50., 50., 50., 50., 50., 50.,
     $                   50., 50., 50., 50., 50., 50., 50., 50., 50.  /
c                     - Relative humidity gross check cutoff (percent)
      character *40     hcfile
      integer           i
      integer           iclose
      integer           icopy
      integer           ihour
      integer           iminute
      integer           iregn
      integer           isecond
      integer           itype
      integer           j
      character*20      jcs
      integer           kx
      real              lat_dump
      real              lon_dump
      integer           lev
      integer           lev_dump
      integer           levat
      integer           ll
      integer           maxins
      integer           mxmsgs
      data              mxmsgs / 20 /
      integer           nomsgs
      integer           numreg
      integer           nunit
      character *40     oefile
      dimension         pmandoi  (nlevoi)
      dimension         pmidmoi  (nlevoi-1)
      real              preal
c     subroutine        preslev
      real              pressure
      character*80      retmsg(20)
      real              rocpf
      real              rocpf1
      real              scan
      character*40      vcorfe_file
      character*40      vcoroe_file
 
 
! Initialize various common blocks (previously BLOCK DATA OI):
 
 
c  Observations  information    common /obs/
      common /obs/      maxdex, nfgge, lun, dataname(5), hh(13,13,20),
     $                  vcoroe(18,18,4), obserr(mxqobs,4,19),
     $                  ww(13,13,20),
     $                  obsname(mxqobs), qobs(mxqobs,5), offlev(mxqobs)

c  Mandatory pressure levels    common /prmand18/ and /prmand12/
c  PRMAND18  - 18 mandatory pressure levels used in full tropospheric -
c              stratospheric analysis
c  PRMAND12  - 12 mandatory pressure levels used in standard analysis
      common /prmand12/ pmand12(12),alogp12(12),pkap12(12),pkap112(12),
     $                  pm12(12)
      common /prmand18/ pmand18(18),alogp18(18),pkap18(18),pkap118(18),
     $                  pm18(18)
c  pmand12,pmand18 - mandatory pressure levels  (top to bottom)
c  alogp12,alogp18 - log of mandatory pressure levels  (top to bot)
c  pkap12,pkap18   - mandatory pressure raised to rgas/cp power
c  pkap112,pkap118 - mandatory pressure raised to rgas/cp + 1 power
c  pm12,pm18       - mandatory pressure levels  (bottom to top)
      COMMON /PRMID12/  PMID12(11)
 
      COMMON /PRMID18/  PMID18(17)
 
      COMMON /STREDGE/  PSTRAT(11), PMSTRAT(11)
 
C  SIX HOUR MODEL ERROR GROWTHS STARTING AT THE TOP
c  Error growth rates       common  /errgro/
      common /errgro/   pergro, tergro, rmxegro(18), hergro(18)

#ifdef CRAY
      DATA PERGRO  / 1.7e0 /
      DATA TERGRO  / 2.4e0 /
      DATA RMXEGRO / 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0,
     $               0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0,
     $               0.05e0, 0.15e0, 0.20e0, 0.65e0, 0.90e0, 1.20e0 /

      DATA HERGRO  / 23.9e0, 23.9e0, 23.9e0, 23.9e0, 23.9e0, 23.9e0,
     $               23.9e0, 20.8e0, 15.6e0, 14.2e0, 13.3e0, 12.3e0,
     $               11.6e0, 10.4e0,  9.2e0,  6.9e0,  5.5e0,  3.7e0  /
 
      DATA OFFLEV /
     1 .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     2 .TRUE.,      .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     3 .FALSE.,     .FALSE.,     .TRUE.,      .TRUE.,      .TRUE.,
     4 .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     5 .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     6 .TRUE.,      .TRUE.,      .TRUE.,      .FALSE.,     .FALSE.,
     7 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     8 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     9 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     T .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     1 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     2 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     3 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     4 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     5 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     6 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     7 .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     8 .FALSE.,     .FALSE.,     .true.,      .true.,      .false.,
     9 .true., 108*.false. /
 
 
C  MANDATORY PRESSURES STARTING AT THE TOP
      DATA PMAND12
     $    /   50.e0,   70.e0,  100.e0,  150.e0,  200.e0,  250.e0,
     $       300.e0,  400.e0,  500.e0,  700.e0,  850.e0, 1000.e0  /
      DATA PMAND18
     $    /   0.4e0,    1.e0,    2.e0,    5.e0,   10.e0,   30.e0,
     $        50.e0,   70.e0,  100.e0,  150.e0,  200.e0,  250.e0,
     $       300.e0,  400.e0,  500.e0,  700.e0,  850.e0, 1000.e0  /
 
C MANDATORY PRESSURES STARTING AT BOTTOM
      DATA PM12
     $    / 1000.e0,  850.e0,  700.e0,  500.e0,  400.e0,  300.e0,
     $       250.e0,  200.e0,  150.e0,  100.e0,   70.e0,   50.e0  /
      DATA PM18
     $    / 1000.e0,  850.e0,  700.e0,  500.e0,  400.e0,  300.e0,
     $       250.e0,  200.e0,  150.e0,  100.e0,   70.e0,   50.e0,
     $        30.e0,   10.e0,    5.e0,    2.e0,    1.e0,   0.4e0  /
 
C  MID LAYER PRESSURES
      DATA PMID12
     $    /  59.8e0,  84.7e0, 124.4e0, 174.6e0, 224.7e0, 274.7e0,
     $      349.1e0, 449.3e0, 598.0e0, 774.1e0, 924.3e0           /
      DATA PMID18
     $    /0.6325e0, 1.414e0, 3.162e0, 7.071e0, 17.32e0, 38.73e0,
     $      59.16e0, 83.67e0, 122.5e0, 174.6e0, 224.7e0, 274.7e0,
     $      349.1e0, 449.3e0, 598.0e0, 774.1e0, 924.3e0           /
 
C  EDGE PRESSURES IN STRATOSPHERE
      DATA PSTRAT
     $        / 0.30486097e0,     0.52482938e0,     0.90351310e0,
     $          1.55543104e0,     2.67773178e0,     4.60981380e0,
     $          7.93596409e0,    13.66205421e0,    23.51972907e0,
     $         40.49007909e0,    69.70516115e0                    /
 
C  MID LAYER PRESSURES IN STRATOSPHERE
      DATA PMSTRAT
     $        / 0.40000000e0,     0.68861471e0,     1.18547557e0,
     $          2.04083981e0,     3.51338084e0,     6.04841440e0,
     $         10.41256796e0,    17.92561891e0,    30.85961260e0,
     $         53.12595870e0,    91.45829289e0                    /
#endif 
 
c  Error limits   common  /clilim/
      common /clilim/   nlimit, plimit, tlimit, rmxlim(18), htlim(18)
 
c  NLIMIT  - limits are set to nlimit*(six-hour growth)
c  PLIMIT  - sea level pressure   (mb)
c  TLIMIT  - sea level temperature (k)
c  RMXLIM  - mixing ratio  (g/kg)
c  HTLIM   - heights  (m)

c  Initialize BUDDY common ( used for mixing ratio quality control ).

      common /buddy/ maxlev, maxlist, maxbatch, maxindx, buddist,
     &               budlat
 
c  Other physical constants   common /const/
      common /const/    sige, dlat,  dlon,   pi,     pi180,  ptop,
     $                  pint,   gi,     omg2re, radei,  radei2, gradei,
     $                  gradei2,g2,     polefac,rtd,    polelat
      real sige(20)
 
c  SIGE   - sigma values at model level interfaces
c  DLAT   - latitudinal resolution of analysis
c  DLON   - longitudinal resolution of analysis
c  PI     - 3.141...
c  PI180  - pi/180
c  PTOP   - pressure at top of 1st model layer   (10 mb)
c  PINT   - pressure of interface between troposphere and stratosphere
c           (120 mb)
c  GI     -  1./grav    ms-2
c  OMG2RE - omega2/rade
c  RADEI  - 1/rade
c  RADEI2 - 1/rade**2
c  GRADEI - grav/rade
c  GRADEI2- grav**2/rade**2
c  G2     - grav**2
c  POLEFAC- factor needed in polar sterographic projections
c  RTD    - radians to degrees conversion factor
c  POLELAT- latitude at which polar stereographic projection is
c            defined as 'true'. also defines beginning of 'polar'
c            regions
 
c  Analysis control parameters      common /contrl/
      common /contrl/   im,      jnp,     nb,      ndalt,   nhms,
     $                  nlay,    nlaym1,  nlayp1,  nymd,    strat,
     $                  idimen,  slp,     fdcos,   fexp,    flow,
     $                  sigdat,  maxrep
      logical           strat,   slp,     fdcos,   fexp,    flow,
     $                  sigdat
c  IM     - longitudinal dimension
c  JNP    - latitudinal dimension
c  NB     - index of current time step fields
c  NDALT  - time step between calls to analysis
c  NHMS   - current time  hhmmss
c  NLAY   - model vertical dimension
c  NLAYM1 - model vertical dimension minus 1
c  NLAYP1 - model vertical dimension plus 1
c  NYMD   - current date   yymmdd
c  STRAT  - logical flag for full stratosphere analysis
c  IDIMEN - dimension of analysis (2 or 3)
c  SLP    - flag to set puv analysis cross covariances to 0.0
c  FDCOS  - logical flag for damped cosine correlation model
c  FEXP   - logical flag for second order autoregressive correlation
c         - model
c  FLOW   - logical flag for flow dependent correlations
c  SIGDAT - logical flag for use of significant level data
 
c  Diagnostic prints  common /mvdumper/

      common/mvdumper/ num_dump, lat_dump(20),
     &                 lon_dump(20), lev_dump(20)

      common /dalctl/   seasat, usesas, dalflg
      logical           seasat, usesas, dalflg
 
c  PERGRO  - sea level pressure   (mb/6hrs)
c  TERGRO  - sea level temperature (k/6hrs)
c  RMXEGRO - mixing ratio  (g/kg/6hrs)
c  HERGRO  - heights   (m/6hrs)
 
      common /gridxx/   imx, jnpx, mlevx
 
c  Analysis vertical indices   common /mlay/
      common /mlay/     mlev, mlevm1, mmix, mmixm1, ls, lsm1
c  MLEV   - number of levels in huv analysis
c  MLEVM1 - mlev minus 1
c  MMIX   - number of levels in mixing ratio analysis
c  MMIXM1 - mmix minus 1
c  LS     - index of interface level in stratosphere analysis
c  LSM1   - ls minus 1
 
c  MAXDEX  -  number of instrument types used in analysis
c  NFGGE   -  number of logical units from which observations are read
c  LUN     -  first logical unit from which obs are read
c  DATANAME-  reference identification of data types
c  HH      -  vertical correlations of heights forecast error
c  VCOROE  -  vertical correlation of rawinsonde and satellite
c             observation error, respectively
c  OBSERR  -  instrument measurement error
c  WW      -  vertical correlation of mixing ratio forecast error
c  OBSNAME -  instrument name
c  QOBS    -  logical flag to determine which data to use in analysis
c  OFFLEV  -  logical flag to identify single level reports not on
c             mandatory levels   (e.g. aircraft)
 
      common /offdata/  kofflv(mxqobs)
 
c  Physical constants     common /physic/
      common /physic/   beta,   cp,     grav,   omega2, rade,   rgas,
     $                  rocp,   cpog,   gamma,  rocp1,  gocp
 
c  BETA   - standard lapse rate   (6.5 k/km)
c  CP     - specific heat at constant pressure   (1003.5)
c  GRAV   - acceleration from gravity  (9.80616 m/s2)
c  OMEGA2 - twice the angular velocity of the earth  (1.46e-4 s-2)
c  RADE   - radius of earth   (6371 km)
c  RGAS   - gas constant
c  ROCP   - rgas/cp
c  CPOG   - cp/g
c  GAMMA  - standard lapse rate  dt/dp   (.0052k/mb)
c  ROCP1  - rocp + 1
c  GOCP   - grav/cp
 
      common /pmh/      pmand(18)
 
c  Pressure level indices   common /prindex/
      common /prindex/  pindx(3201)
 
c  Print flag
      common /print/    msglev
 
 
c  Region indices   common /region/
      common /region/   hindreg(13104)
c  HINDREG - identifies correlation region in which grid point is
c            located
 
      common /satwind/  cwind
      logical           cwind
 
c  Search information    common /scan/
      common /scan/     maxobs, rscan, onestage, max_data
      real              rscan
      logical           onestage
c  MAXOBS  - maximum number of observations used to influence a
c            grid point
c  RSCAN   - maximum separation distance allowed between grid point
c            and observation before observation is not used for
c            the analysis of that grid point
c  MAX_DATA- maximum number of observations allowed
 
      common /sparam/ lsolve, ns, nr, nv, nh(13104), nq,
     &                kq(3), volcentre_x(13104),
     &                ngv, volcentre_y(13104), glatup(13104),
     &                glonup(13104)
 
      common /vcors/    vcorfe(13,13,20,2)
 
      namelist /alputz/ msglev, idimen, nfgge,  maxins, dataname,
     &                  strat,  slp,    sigdat, cwind, lat_dump,
     &                  lon_dump, lev_dump,
     &                  maxrep, scan,   numreg, lsolve, 
     &                  oefile, hcfile, seasat, usesas,
     &                  dalflg, max_data, num_dump,
     &                  vcorfe_file, vcoroe_file
 
#ifdef RS6000
      PERGRO= 1.7e0 
      TERGRO= 2.4e0 
      RMXEGRO =
     $     (/ 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0,
     $     0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0, 0.00e0,
     $     0.05e0, 0.15e0, 0.20e0, 0.65e0, 0.90e0, 1.20e0 /)

      HERGRO =(/ 23.9e0, 23.9e0, 23.9e0, 23.9e0, 23.9e0, 23.9e0,
     $     23.9e0, 20.8e0, 15.6e0, 14.2e0, 13.3e0, 12.3e0,
     $     11.6e0, 10.4e0,  9.2e0,  6.9e0,  5.5e0,  3.7e0  /)

! has wrong dimension in cray code

      OFFLEV = (/
     $ .TRUE.,   .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     $ .TRUE.,   .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .TRUE.,      .TRUE.,      .TRUE.,
     $ .TRUE.,   .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     $ .TRUE.,   .TRUE.,      .TRUE.,      .TRUE.,      .TRUE.,
     $ .TRUE.,   .TRUE.,      .TRUE.,      .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ .FALSE.,  .FALSE.,     .true.,      .true.,      .false.,
     $ .true.,   .false.,     .false.,     .false.,     .false.,
     $ .FALSE.,  .FALSE.,     .FALSE.,     .FALSE.,     .FALSE.,
     $ (.false.,i=1,100) /)


C  MANDATORY PRESSURES STARTING AT THE TOP
      PMAND12 =
     $    (/   50.e0,   70.e0,  100.e0,  150.e0,  200.e0,  250.e0,
     $       300.e0,  400.e0,  500.e0,  700.e0,  850.e0, 1000.e0  /)
      PMAND18 =
     $    (/   0.4e0,    1.e0,    2.e0,    5.e0,   10.e0,   30.e0,
     $        50.e0,   70.e0,  100.e0,  150.e0,  200.e0,  250.e0,
     $       300.e0,  400.e0,  500.e0,  700.e0,  850.e0, 1000.e0  /)
 
C MANDATORY PRESSURES STARTING AT BOTTOM
      PM12 =
     $    (/ 1000.e0,  850.e0,  700.e0,  500.e0,  400.e0,  300.e0,
     $       250.e0,  200.e0,  150.e0,  100.e0,   70.e0,   50.e0  /)
      PM18 =
     $    (/ 1000.e0,  850.e0,  700.e0,  500.e0,  400.e0,  300.e0,
     $       250.e0,  200.e0,  150.e0,  100.e0,   70.e0,   50.e0,
     $        30.e0,   10.e0,    5.e0,    2.e0,    1.e0,   0.4e0  /)
 
C  MID LAYER PRESSURES
      PMID12 =
     $    (/  59.8e0,  84.7e0, 124.4e0, 174.6e0, 224.7e0, 274.7e0,
     $      349.1e0, 449.3e0, 598.0e0, 774.1e0, 924.3e0           /)
      PMID18 =
     $    (/0.6325e0, 1.414e0, 3.162e0, 7.071e0, 17.32e0, 38.73e0,
     $      59.16e0, 83.67e0, 122.5e0, 174.6e0, 224.7e0, 274.7e0,
     $      349.1e0, 449.3e0, 598.0e0, 774.1e0, 924.3e0           /)
 
C  EDGE PRESSURES IN STRATOSPHERE
      PSTRAT =
     $        (/ 0.30486097e0,     0.52482938e0,     0.90351310e0,
     $          1.55543104e0,     2.67773178e0,     4.60981380e0,
     $          7.93596409e0,    13.66205421e0,    23.51972907e0,
     $         40.49007909e0,    69.70516115e0                    /)
 
C  MID LAYER PRESSURES IN STRATOSPHERE
      PMSTRAT =
     $        (/ 0.40000000e0,     0.68861471e0,     1.18547557e0,
     $          2.04083981e0,     3.51338084e0,     6.04841440e0,
     $         10.41256796e0,    17.92561891e0,    30.85961260e0,
     $         53.12595870e0,    91.45829289e0                    /)
#endif 
 
      write(6,'(" INITIAL: Setting up analysis....")')
      obsname(  1) = 'Surface Land Obs - 1    '
      obsname(  2) = 'Surface Land Obs - 2    '
      obsname(  3) = 'Surface Ship Obs - 1    '
      obsname(  4) = 'Surface Ship Obs - 2    '
      obsname(  5) = 'Environment Buoy        '
      obsname(  6) = 'Drifting Buoy           '
      obsname(  7) = 'Rawinsonde              '
      obsname(  8) = 'Pilot Balloon Wind      '
      obsname(  9) = 'Ship Released Rawinsonde'
      obsname( 10) = 'Dropwinsonde            '
      obsname( 11) = 'Radar-tracked Rawinsonde'
      obsname( 12) = 'Rocketsonde             '
      obsname( 13) = 'Balloon                 '
      obsname( 14) = 'Aircraft - Air/Sat Relay'
      obsname( 15) = 'Aircraft - Int. Data Sys'
      obsname( 16) = 'Aircraft Report         '
      obsname( 17) = 'Aircraft Coded Report   '
      obsname( 18) = 'Aircraft - ALPX         '
      obsname( 19) = 'Cld Trk Wind - Wisc E1  '
      obsname( 20) = 'Cld Trk Wind - Wisc E2  '
      obsname( 21) = 'Cld Trk Wind - Wisc W   '
      obsname( 22) = 'Cld Trk Wind - Wisc Ocea'
      obsname( 23) = 'Cld Trk Wind - Repr. Jap'
      obsname( 24) = 'Cld Trk Wind - NESS East'
      obsname( 25) = 'Cld Trk Wind - NESS West'
      obsname( 26) = 'Cld Trk Wind - Eurpoean '
      obsname( 27) = 'Cld Trk Wind - Japanese '
      obsname( 28) = 'SEASAT - Scatterometer  '
      obsname( 29) = 'WSAT 55                 '
      obsname( 30) = 'WSAT 57                 '
      obsname( 31) = 'Limb Infrared Mon -Strat'
      obsname( 32) = 'User-defined instrument '
      obsname( 33) = 'NESDIS NH Land AM type A'
      obsname( 34) = 'NESDIS SH Land AM type A'
      obsname( 35) = 'NESDIS NH Land AM type B'
      obsname( 36) = 'NESDIS SH Land AM type B'
      obsname( 37) = 'NESDIS NH Land AM type C'
      obsname( 38) = 'NESDIS SH Land AM type C'
      obsname( 39) = 'NESDIS NH Ocn  AM type A'
      obsname( 40) = 'NESDIS SH Ocn  AM type A'
      obsname( 41) = 'NESDIS NH Ocn  AM type B'
      obsname( 42) = 'NESDIS SH Ocn  AM type B'
      obsname( 43) = 'NESDIS NH Ocn  AM type C'
      obsname( 44) = 'NESDIS SH Ocn  AM type C'
      obsname( 45) = 'NESDIS NH Land PM type A'
      obsname( 46) = 'NESDIS SH Land PM type A'
      obsname( 47) = 'NESDIS NH Land PM type B'
      obsname( 48) = 'NESDIS SH Land PM type B'
      obsname( 49) = 'NESDIS NH Land PM type C'
      obsname( 50) = 'NESDIS SH Land PM type C'
      obsname( 51) = 'NESDIS NH Ocn  PM type A'
      obsname( 52) = 'NESDIS SH Ocn  PM type A'
      obsname( 53) = 'NESDIS NH Ocn  PM type B'
      obsname( 54) = 'NESDIS SH Ocn  PM type B'
      obsname( 55) = 'NESDIS NH Ocn  PM type C'
      obsname( 56) = 'NESDIS SH Ocn  PM type C'
      obsname( 57) = 'Special Sat NH  - Ocn  A'
      obsname( 58) = 'Special Sat SH  - Ocn  A'
      obsname( 59) = 'Special Sat NH  - Ocn  B'
      obsname( 60) = 'Special Sat SH  - Ocn  B'
      obsname( 61) = 'Special Sat NH  - Ocn  C'
      obsname( 62) = 'Special Sat SH  - Ocn  C'
      obsname( 63) = 'VAS NH Land - type A    '
      obsname( 64) = 'VAS SH Land - type A    '
      obsname( 65) = 'VAS NH Land - type B    '
      obsname( 66) = 'VAS SH Land - type B    '
      obsname( 67) = 'VAS NH Ocean- type A    '
      obsname( 68) = 'VAS SH Ocean- type A    '
      obsname( 69) = 'VAS NH Ocean- type B    '
      obsname( 70) = 'VAS SH Ocean- type B    '
      obsname( 71) = 'NASA-SDUO NH Land  A    '
      obsname( 72) = 'NASA-SDUO SH Land  A    '
      obsname( 73) = 'NASA-SDUO NH Land  B    '
      obsname( 74) = 'NASA-SDUO SH Land  B    '
      obsname( 75) = 'NASA-SDUO NH Land  C    '
      obsname( 76) = 'NASA-SDUO SH Land  C    '
      obsname( 77) = 'NASA-SDUO NH Land  D    '
      obsname( 78) = 'NASA-SDUO SH Land  D    '
      obsname( 79) = 'NASA-SDUO NH Ocean A    '
      obsname( 80) = 'NASA-SDUO SH Ocean A    '
      obsname( 81) = 'NASA-SDUO NH Ocean B    '
      obsname( 82) = 'NASA-SDUO SH Ocean B    '
      obsname( 83) = 'NASA-SDUO NH Ocean C    '
      obsname( 84) = 'NASA-SDUO SH Ocean C    '
      obsname( 85) = 'NASA-SDUO NH Ocean D    '
      obsname( 86) = 'NASA-SDUO SH Ocean D    '
      obsname( 87) = 'Pseudo-1000mb Heights   '
      obsname( 88) = 'ER-2 Aircraft / MMS Data'
      obsname( 89) = 'ACARS: arcft wind instr ' 
      obsname( 90) = 'User-defined inst 3     ' 
      obsname( 91) = 'UARS / MLS 1            '
      obsname( 92) = 'UARS / MLS 2            '
      obsname( 93) = 'UARS -     3            '
      obsname( 94) = 'UARS -     4            '
      obsname( 95) = 'User-defined inst 4     ' 
      obsname( 96) = 'SSM/I - 1               '
      obsname( 97) = 'SSM/I - 2               '
      obsname( 98) = 'AMSU      NH Land  A    '
      obsname( 99) = 'AMSU      SH Land  A    '
      obsname(100) = 'AMSU      NH Land  B    '
      obsname(101) = 'AMSU      SH Land  B    '
      obsname(102) = 'AMSU      NH Land  C    '
      obsname(103) = 'AMSU      SH Land  C    '
      obsname(104) = 'AMSU      NH Land  D    '
      obsname(105) = 'AMSU      SH Land  D    '
      obsname(106) = 'AMSU      NH Ocean A    '
      obsname(107) = 'AMSU      SH Ocean A    '
      obsname(108) = 'AMSU      NH Ocean B    '
      obsname(109) = 'AMSU      SH Ocean B    '
      obsname(110) = 'AMSU      NH Ocean C    '
      obsname(111) = 'AMSU      SH Ocean C    '
      obsname(112) = 'AMSU      NH Ocean D    '
      obsname(113) = 'AMSU      SH Ocean D    ' 
      lun         = 71
      onestage    = .false.
 
c  Set namelist default values.
 
      cwind       = .false.
      strat       = .false.
      slp         = .false.
      sigdat      = .false.
      idimen      = 3
      maxins      = 91
      maxrep      = 20
      numreg      = 1
      lsolve      = 12
      scan        = 1600.0
      msglev      = 1
      nfgge       = 1
      oefile      = '/u2/w3djl/oi1.3/params/obserr.std'
      hcfile      = '/u2/w3djl/oi1.1/params/hcorfe.dcos.a'
      dataname(1) = 'RGLOI20M'
      dataname(5) = 'sswind'
      seasat      = .false.
      usesas      = .false.
      dalflg      = .false.
      max_data    = 150000
      vcorfe_file = '/u2/w3djl/oi1.3/params/vcorfe.dat'
      vcoroe_file = '/u2/w3djl/oi1.3/params/vcoroe.dat'
      repack      = .false.
      num_dump    = 0
 
c  Read namelist values.
 
      read(65,alputz)
      write(6,alputz)
      do i = 1,nfgge
        if ( dataname(i)(1:3) .eq. 'rgl' .or. dataname(i)(1:3)
     &       .eq. 'RGL' ) repack = .true.
        if ( dataname(i)(1:3) .eq. 'rpk' .or. dataname(i)(1:3)
     &       .eq. 'RPK' ) repack = .true.
        if ( dataname(i)(1:3) .eq. 'reg' .or. dataname(i)(1:3)
     &       .eq. 'REG' ) repack = .true.
      end do
      maxobs = maxrep
      maxdex = maxins
      rscan  = scan
 
c  Assign values from model.
 
      im     = imr
      jnp    = jnpr
      nb     = 1
      ndalt  = 060000
      nlay   = nlayr
      nlaym1 = nlay-1
      nlayp1 = nlay+1
      beta   = 0.0065
      cp     = 1004.1600
      dlat   = 180.0 / (jnp-1.0)
      dlon   = 360.0 / im
      grav   = 9.8100
      pi     = 4. * atan(1.)
      pi2    = 2.0 * pi
      omega2 = 2.0 * pi2 / 86164.09
      pi180  = pi / 180.0
      ptop   = 10.
      rade   = 6375.0 e3 / 1000.0
      rgas   = 287.0
      rocp   = rgas / cp
      rocp1  = rocp + 1.0
      cpog   = cp / grav
      gocp   = grav / cp
      nr     = maxrep * 3
 
CCC - DJL This sige array is no longer used to hold model edge sigmas 
CCC   sige( 1:nlayp1 ) = 0.
 
      write(6,'(/," INITIAL: Grid is ",i3," x ",i3,/,
     &     t8,"DLAT:",f4.1,
     &     " DLON: ",f4.1," NDALT: ",i6)') 
     &     im, jnp, dlat, dlon, ndalt
 
c  Read which data types are to be used.
 
      do nunit = 1, nfgge
         do kx = 1, mxqobs
            qobs(kx,nunit) = .false.
         end do
      end do
 
      do kx = 1, mxqobs
         kofflv(kx) = 0
         if( offlev(kx) ) kofflv(kx) = 1
      end do
 
!   Read nfgge qobs arrays.
 
      do iobs = 1,nfgge
        read ( 66,910 ) ( qobs(kx,iobs), kx = 1,mxqobs )
 
        write( 6,'(//," OBSERVATIONS ELIGIBLE FOR THIS ANALYSIS",
     &   " FROM DATASET",i2,3x,a8,/)') iobs,dataname(iobs)
 
         do kx = 1, maxins
            if ( qobs ( kx,iobs ) ) then
 
              if ( kofflv(kx) .eq. 0 ) then
                write (6,'(5x,a24," (only mandatory levels)")')
     &              obsname(kx)
              else
                write (6,'(5x,a24," (all levels analyzed)")')
     &              obsname(kx)
              end if
            end if
 
         end do

         write( 6,'(//," OBSERVATIONS NOT ELIGIBLE ",/)')

         do kx = 1,maxins

           if (.not. qobs(kx,iobs) ) then
             write(6,'(10x,a24)') obsname(kx)
           end if

         end do
 
      end do
 
 
c  Set mandatory levels for the analysis.
 
      do ll = 1, nlevoi
         pmand(ll)   = pmandoi(ll)
         print*,' Analysis level ',ll,pmand(ll),' mb.'
      end do
 
      rocpf  = rocp
      rocpf1 = rocp1
 
      do ll = 1, 18
         preal       = pmand18(ll)
         alogp18(ll) = alog(preal)
         pkap18(ll)  = pmand18(ll)**rocpf
         pkap118(ll) = pmand18(ll)**rocpf1
      end do
 
      do ll = 1, 12
         preal       = pmand12(ll)
         alogp12(ll) = alog(preal)
         pkap12(ll)  = pmand12(ll)**rocpf
         pkap112(ll) = pmand12(ll)**rocpf1
      end do
 
c  Assign analysis vertical indices.
 
      mlev   = nlevoi
      mlevm1 = mlev - 1
      mmix   = 6
      mmixm1 = mmix - 1
      write(6,'(" INITIAL: Vertical indicies: LS=",i3," MLEV=",i3)')
     &      ls, mlev
 
c  Set the gridxx common.
 
      imx   = im
      jnpx  = jnp
      mlevx = mlev
 
c  Derive other constants.
 
      gamma   = 0.0552
      gi      = 1.0 / grav
      omg2re  = omega2 / rade
      radei   = 1.0 / rade
      radei2  = radei * radei
      gradei  = grav * ( radei * 0.001 )
      gradei2 = gradei * gradei
      g2      = grav * grav
      polelat = 70.0
      polefac = 1.0 + sin( 1.0 * polelat * pi180 )
      rtd     = 1.0 / pi180
 
c Initialize all constants in buddy common.
      maxlev   = 20000
      maxlist  = 20000
      maxbatch = 20000
      maxindx  = 1000
      budlat   = 5.0
      buddist  = budlat * pi180 / radei
 
c  Compute an index array for evenly spaced pressure levels.  The array
c  PINDX consists of a whole number which is the index of the mandatory
c  level above the pressure level and a fractional part which is the linear
c  in log(P) interpolation weight from the upper mandatory level.  The
c  index of the PINDX array is related to the pressure through a linear
c  mapping which is summarized in the following table:
c
c                      Pressure       PINDX
c       Pressure      Resolution      index        RFACT     RDISP
c       --------      ----------      -----        -----     -----
c
c      0.1 - 1            .001        1 - 901      1000.      -99.
c        1 - 10           .01       901 - 1801      100.      801.
c       10 - 50           .1       1801 - 2201       10.     1701.
c       50 - 1050        1.        2201 - 3201        1.     2151.
c
c  There are 900 pressures tabulated between each factor of 10 change in
c  pressure, except for the 10 - 50 mb range, where the range is reduced 
c  so that the 50 - 1050 mb range is identical to the original PINDX array.
c
      call preslev(pmand,nlevoi,pindx)
 
c  Set limits for prediction errors. These limits equal the six-hour
c  model growth rates times nlimit.
 
      nlimit = 8
 
c  1) sea level pressure and temperature:
      plimit = pergro * nlimit
      tlimit = tergro * nlimit
c  2) heights and mixing ratio:
 
      do ll = 1, 18
         rmxlim(ll) = rmxegro(ll) * nlimit
         htlim(ll)  = hergro(ll) * nlimit
      end do
 
c  Adjust 6-hour error growths based on frequency of analysis.
 
      if( ndalt.ne.60000 ) then
         ihour   = ndalt / 10000
         iminute = ( ndalt - 10000 * ihour ) / 100
         isecond = mod ( ndalt, 100 )
         adjust  = 6.0 / ( ihour + iminute/60.0 + isecond/3600.0 )
         pergro  = pergro / adjust
         tergro  = tergro / adjust
 
         do ll = 1, 18
            rmxegro(ll) = rmxegro(ll) / adjust
            hergro(ll) = hergro(ll) / adjust
         end do
 
      endif
 
 
c  Determine region indices and set flow dependent flag.
 
      if( (numreg.gt.0).and.(numreg.le.20) ) then
 
         do ll = 1, im*jnp
            hindreg(ll) = numreg
         end do
 
      else if ( numreg.le.0 ) then
 
         read(66,935) ( hindreg(ll),ll = 1, 46*72 )
         flow = .false.
         if ( numreg.lt.0 ) flow = .true.
 
      endif
 
      write(6,'(/," Flow dependent code: ",l10)') flow
 
 
c  Parameter files residing on Cray are opened here.
 
c  Open file containing table lookup for forecat error horizontal correlation
 
      open ( unit=61, file=hcfile )
 
c  Open observation error file from Cray.
 
      open ( unit=62, file=oefile )
 
c  Open file containing table lookup for forecast error vertical correlation
                                                                                
      open ( unit=63, file=vcorfe_file )
 
c  Open file containing table lookup for observation error vertical correlation
 
      open ( unit=92, file=vcoroe_file )
 
      write(6,'(/," Parameter files opened: ",/)') 
      write(6,'(" Horizontal forecast error correlation:  ",a40)') 
     .                                                       hcfile
      write(6,'(" Vertical forecast error correlation:    ",a40)') 
     .                                                  vcorfe_file
      write(6,'(" Observation error standard deviations:  ",a40)') 
     .                                                       oefile
      write(6,'(" Vertical observation error correlation: ",a40)') 
     .                                                  vcoroe_file
 
c  Read and set the observation errors.
 
      call setobse(obserr,mxqobs,nlevoi)
 
      write(6,'(" INITIAL: Analysis setup complete.")')
 
      return
 
 
  910 format( 7x, 50l1, 23x )
  935 format( 18(1x,i2) )
  965 format( 80x )
  970 format( 1x, 13f6.4)
  975 format( 1x, 7( f5.2, 1x ) )
 
      end
