!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
! 
      SUBROUTINE ITPINIT(IM,JNP,MLEV,NLAY,SIGE)                         ITP00010
                                                                        ITP00020
                                                                        ITP00030
      DIMENSION SIGE(NLAY+1)                                            ITP00040
                                                                        ITP00050
C ANALYSIS CONTROL PARAMETERS                                           ITP00060
C ---------------------------                                           ITP00070
                                                                        ITP00080
      LOGICAL STRAT,SLP,FDCOS,FEXP,SAVEAE,SIGDAT,end_of_file            ITP00090
       COMMON /CONTRL/ IM0, JNP0, NB, NDALT, NHMS, NLAY0,               ITP00100
     .                 NLAYM1, NLAYP1,                                  ITP00110
     .                 NYMD, STRAT, IDIMEN, SLP, FDCOS, FEXP, SAVEAE,   ITP00120
     .                 SIGDAT,MAXREP                                    ITP00130
                                                                        ITP00140
C PHYSICAL CONSTANTS                                                    ITP00150
C ------------------                                                    ITP00160
                                                                        ITP00170
       real          BETA,CP,GRAV,OMEGA2,RADE,RGAS,ROCP,CPOG,           ITP00180
     .                GAMMA,ROCP1,GOCP                                  ITP00190
       COMMON /PHYSIC/ BETA, CP, GRAV, OMEGA2, RADE, RGAS, ROCP,        ITP00200
     .                 CPOG, GAMMA, ROCP1, GOCP                         ITP00210
!gvl   REAL PRESSURE                                                    ITP00220
C                                                                       ITP00230
C INDEXES OF SIGMA LEVELS                                               ITP00240
C -----------------------                                               ITP00250
                                                                        ITP00260
      COMMON /SGINDEX/ IDXSIGMA(1000)                                   ITP00270
                                                                        ITP00280
C OTHER CONSTANTS                                                       ITP00290
C ---------------                                                       ITP00300
                                                                        ITP00310
      real           SIGE0,DLAT,DLON,PI,PI180,PTOP,PINT,GI,OMG2RE,      ITP00320
     .               RADEI,RADEI2,GRADEI,GRADEI2,G2,POLEFAC,RTD,        ITP00330
     .               POLELAT                                            ITP00340
       COMMON /CONST/ SIGE0(20), DLAT, DLON, PI, PI180, PTOP,           ITP00350
     .                PINT, GI, OMG2RE, RADEI, RADEI2, GRADEI,          ITP00360
     .                GRADEI2, G2, POLEFAC, RTD, POLELAT                ITP00370
                                                                        ITP00380
                                                                        ITP00390
C MID LAYER SIGMA VALUES                                                ITP00400
C ----------------------                                                ITP00410
                                                                        ITP00420
      real sigm, sigma                                                  ITP00430
!     real preslevm  
      COMMON /MIDSIGMA/ SIGM(100)                                       ITP00440
                                                                        ITP00450
C VERTICAL INDICES                                                      ITP00460
C ----------------                                                      ITP00470
                                                                        ITP00480
        COMMON /MLAY/ MLEV0, MLEVM1, MMIX, MMIXM1, LS, LSM1             ITP00490
        COMMON /MLAY2/ MLEVM2, MLEVP1                                   ITP00500
                                                                        ITP00510
C PRODUCTS OF GRID LIMITS                                               ITP00520
C -----------------------                                               ITP00530
                                                                        ITP00540
      COMMON /PRODLIM/ IJMLEV, IJMLEVM1, ILBELOW, IMJNP, IMLSM1,        ITP00550
     .                 IMMLEV, IMMLEVM1, IMMLEVP1, IMNLAY, IMNLAYP1     ITP00560
                                                                        ITP00570
C ASSIGN TYPES OF LOCAL VARIABLES                                       ITP00580
C -------------------------------                                       ITP00590
                                                                        ITP00600
                                                                        ITP00610
      PRINT 11                                                          ITP00620
 11   FORMAT(/,' *** IN ITPINIT ***')                                   ITP00630
                                                                        ITP00640
C SET ADDITIONAL VALUES IN COMMON WHICH ARE USED EXCLUSIVELY BY THE     ITP00650
C INTERPOLATION ROUTINES SIGTOP AND PTOSIG                              ITP00660
C -----------------------------------------------------------------     ITP00670
                                                                        ITP00680
C OTHER MLEV VARIATIONS                                                 ITP00690
C ---------------------                                                 ITP00700
                                                                        ITP00710
      MLEVM2=MLEV-2                                                     ITP00720
      MLEVP1=MLEV+1                                                     ITP00730
                                                                        ITP00740
C INITIALIZE PRODUCTS OF GRID LIMITS                                    ITP00750
C ----------------------------------                                    ITP00760
                                                                        ITP00770
      IJMLEV=IM*JNP*MLEV                                                ITP00780
      IJMLEVM1=IM*JNP*MLEVM1                                            ITP00790
      ILBELOW=IM*(NLAY-LSM1)                                            ITP00800
      IMJNP=IM*JNP                                                      ITP00810
      IMLSM1=IM*LSM1                                                    ITP00820
      IMMLEV=IM*MLEV                                                    ITP00830
      IMMLEVM1=IM*MLEVM1                                                ITP00840
      IMMLEVP1=IM*MLEVP1                                                ITP00850
      IMNLAY=IM*NLAY                                                    ITP00860
      IMNLAYP1=IM*NLAYP1                                                ITP00870
                                                                        ITP00880
C SET MID LAYER SIGMA VALUES AND USE SIGM(NLAYP1) TO REPRESENT SURFACE  ITP00890
C --------------------------------------------------------------------  ITP00900
                                                                        ITP00910
      DO 610 L=1,NLAY                                                   ITP00920
         SIGM(L)=(SIGE(L)+SIGE(L+1))*0.5                                ITP00930
  610 CONTINUE                                                          ITP00940
      SIGM(NLAY+1)=1.00                                                 ITP00950
                                                                        ITP00960
                                                                        ITP00970
C FOR SIGMA VALUES FROM .001 TO 1.000, DETERMINE THE INDEX OF THE MODEL ITP00980
C SIGMA LEVEL WHICH LIES AT OR ABOVE THE SIGMA VALUE                    ITP00990
C --------------------------------------------------------------------- ITP01000
                                                                        ITP01010
      do 630 isig = 1,1000                                              ITP01020
         sigma = float(isig)/1000.0                                     ITP01030
         iflag = 0                                                      ITP01040
           l = 0                                                        ITP01050
           end_of_file = .false.                                        ITP01060
           do while (.not. end_of_file)                                 ITP01070
             l = l + 1                                                  ITP01080
             if(sigm(l) .gt. sigma) then                                ITP01090
                 isigl = l                                              ITP01100
                 iflag = 1                                              ITP01110
                 end_of_file = .true.                                   ITP01120
             endif                                                      ITP01130
             if(l .eq. nlayp1) end_of_file = .true.                     ITP01140
           end do                                                       ITP01150
         if(iflag .le. 0) isigl = nlay + 2                              ITP01160
         idxsigma(isig) = isigl - 1                                     ITP01170
  630 continue                                                          ITP01180
      return                                                            ITP01190
      end                                                               ITP01200
