C ------------------------------------------------------------------    
         SUBROUTINE  MOISTAT( IDATE, INTIME, IWINDOW,TYP_DATA,          
     &                       KNT,NOBS)                                  
C ------------------------------------------------------------------    
                                                                        
C*********************************   GODDARD LABORATORY FOR ATMOSPHERES 
C                                                                       
C  PURPOSE: GIVEN A TIME WINDOW,TYPEOF DATASET AND KOUNTES SUBROUTINE   
C         PRINTS STATISTICAL REPORT                                     
C                                                                       
C      DATE :   01/14/92                                                
C                                                                       
C      INPUT:                                                           
C                                                                       
C         IDATE    - CENTRAL DATE OF WINDOW (YYMMHH)                    
C         INTIME    - CENTRAL TIME OF WINDOW (HHMMSS)                   
C         IWINDOW  - SIZE OF WINDOW  ( HHMMSS)                          
C          NOBS     - NUMBER OF OBSERVATIONS ACTUALLY FOUND ( <=MAX_DATA
C         TYP_DATA  - NAME OF DATA SET (RAWINSONDE,AIRCRAFT, ...)       
C          KNT(30)  - ARRAY OF KOUNTERS                                 
C                                                                       
C                                                                       
C     KNT(I)  COUNT THE NUMBER OF LEVELS OR REPORTS                     
C                                                                       
                                                                        
C  KNT(1)=KOUNTLL  - COUNT REPORTS WITH "BAD" LATTITUDE OR LONGITUDE    
C  KNT(2)= KOUNT1_0 - COUNT REPORTS WITH NO DATA FOR CATEGORY 1         
C  KNT(3)=KOUNT1_21- COUNT REPORTS WITH NUMBER 0F LEVELS >20 FOR CAT.1  
C  KNT(4)= KOUNTBLEV- COUNT LEVELS WITH "BAD"  TEMPERATURE              
C  KNT(5)= KNT_BLEVD- COUNT LEVELS WITH "BAD" DEWPOINT DEPRESSION       
C  KNT(6)= KNT_BLEVH- COUNT LEVELS WITH REL. HUMIDITY <=0.01            
C  KNT(20)=KOUNTREP - COUNT REPORTS                                     
                                                                        
                                                                        
C  PROGRAMMER:  YELENA KONDRATYEVA                                      
C                                                                       
C                                                                       
C***********************************************************************
                                                                        
C ------------                                                          
C     CHARACTER*60 MESSAGE                                              
      CHARACTER*60 MES (30)                                             
                                                                        
       CHARACTER*10  TYP_DATA                                           
       INTEGER         KNT (30)                                         
        MES(1)='   REPORTS DO NOT PASS LIMIT CHECK FOR LAT / LONG'      
        MES(2)='   REPORTS HAVE NO DATA(LEVELS) FOR CAT.1'              
        MES(3)='   REPORTS HAVE MORE THAH 20 LEVELS FOR CAT.1'          
        MES(4)='   LEVELS DO NOT PASS LIMIT CHECK FOR TEMPERATURE'      
        MES(5)='   LEVELS DO NOT PASS LIMIT CHECK FOR DEWP.DEPRESSION'  
        MES(6)='   LEVELS HAVE REL.HUMIDITY <=0.01 '                    
                                                                        
C      MESSAGE (1:60) = ' '                                             
C      -----------------------------------                              
C      !   PRINT  RESULTS                !                              
C      -----------------------------------                              
                                                                        
 7000   PRINT *, ' '                                                    
        PRINT *,'         ',TYP_DATA,' DATA SUMMARY FOR : '             
        PRINT *,'        ------------------------------'                
        PRINT *,'                            DATE   - ',IDATE           
        PRINT *,'                            TIME   - ',INTIME          
        PRINT *,'                       TIME WINDOW - ', IWINDOW        
        PRINT *,'    '                                                  
        PRINT *,' NUMBER OF ',TYP_DATA,' REPORTS = ',KNT(20)            
        PRINT *,'     '                                                 
                                                                        
            DO I=1,15                                                   
                  IF (KNT(I).GT.0)   THEN                               
        PRINT *,KNT( I), MES(I)                                         
                  ENDIF                                                 
             ENDDO                                                      
        PRINT *,'                '                                      
        PRINT *,' RETURNED NUMBER OF OBSERVATIONS (NOBS) =',NOBS        
                                                                        
                                                                        
        RETURN                                                          
        END                                                             
