       SUBROUTINE PTOSIGW(LAT,WDELMAN,WDELSLV,WSIGFGS,VPMAND,           
     .                    PSLA,PMIDSIG,OCEAN,PTOP,TPROFILE,psfc)        
C                                                                       
C MODIFIED: 901215 DJL - IF LOWER MANDATORY BRACKETING LEVEL IS BELOW   
C                        SURFACE, SET INCREMENT THERE TO 0.             
!
!  Gregor von Laszewski, 12/95 Changed to compile on RS6000 using xlf
! 
       LOGICAL STRAT,SLP,FDCOS,FEXP,SAVEAE,SIGDAT,OCEAN(IM,JNP)         
       LOGICAL DEBUG                                                    
C                                                                       
       REAL           BETA,CP,GRAV,OMEGA2,RADE,RGAS,ROCP,CPOG,GAMMA,    
     .                PTOP,BEFFGS,WDMABV,WDMBLW,             
     .                PTSIFB,VMPSL,WDELSIG,PTSIFA                       
!gvl   real GCOP, RCOP1
C                                                                       
       DIMENSION      PMIDSIG(IM,NLAY), VPMAND(MLEV)                    
C                                                                       
       DIMENSION      WDELMAN(IM,JNP,MLEV),WSIGFGS(IM,NLAY),            
     .                PSLA(IM,JNP),WDELSLV(IM,JNP)                      
       DIMENSION      TPROFILE(8,NLAY,NPROF)                            
       real           psfc(im)
C                                                                       
       real           fill
       integer        fillmsg_count 
C                                                                       
C ANALYSIS CONTROL VARIABLES                                            
C --------------------------                                            
                                                                        
       COMMON /CONTRL/ IM, JNP, NB, NDALT, NHMS, NLAY, NLAYM1, NLAYP1,  
     .                 NYMD, STRAT, IDIMEN, SLP, FDCOS, FEXP, SAVEAE,   
     .                 SIGDAT,MAXREP                                    
C                                                                       
       COMMON /PRNTPROF/NPROF,ILOC(10),JLOC(10)                         
                                                                        
C VERTICAL INDEX COMMON                                                 
C ----------------------                                                
                                                                        
       COMMON /MLAY/ MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1               
       COMMON /MLAY2/ MLEVM2, MLEVP1                                    
                                                                        
C PRODUCTS OF GRID LIMITS                                               
C -----------------------                                               
C                                                                       
       COMMON /PHYSIC/ BETA,  CP, GRAV,OMEGA2,RADE,RGAS,                
     .                 ROCP,CPOG,GAMMA, ROCP1,GOCP                      
 
      data DEBUG /.false./                                                 
      data fill /1.e10/
C                                                                       
C             PURPOSE:  INTERPOLATE WIND DELTAS FROM                    
C                       MANDATORY LEVELS TO MODEL LEVELS                
C                                                                       
       if (lat.eq.1) fillmsg_count = 0
                                                                        
C                       FIND MANDATORY UPPER LEVEL AND LOWER LEVEL      
C                       AT MODEL LEVEL                                  
C                                                                       
       DO 70 I = 1,IM                                                   
             DO 60 N = 1,NLAY                                           
                  NBLW = 0                                              
                  NABV = 0                                              
                  VMPSL = PMIDSIG(I,N)                                  
               DO 40 M = 1,MLEV                                         
                  IF(VMPSL .LE. VPMAND(M))THEN                          
                      NBLW = M                                          
                      GO TO 45                                          
                  ENDIF                                                 
   40          CONTINUE                                                 
               NBLW = MLEV + 1                                              
   45          CONTINUE                                                 
               NABV = NBLW - 1                                          
C                                                                       
             if(nblw .le. mlev) then
               IF(NABV .LE. 0) THEN                                     
C                                                                       
C                        USE DELTA AT 10MB FOR THE INTERPOLATION        
C                                                                       
                   PTSIFB = (PMIDSIG(I,N) ** ROCP-PTOP**ROCP)/          
     .                       (VPMAND(NBLW)  ** ROCP-PTOP**ROCP)         
                   PTSIFA = 1.000 - PTSIFB                              
                   WDMABV = 0.0                                         
                   WDMBLW = WDELMAN(I,LAT,NBLW)                         
C                                                                       
C                                                                       
C                        CHECK WHETHER THE GRID POINTS ARE OVER         
C                        OCEAN                                          
C                                                                       
                 ELSE IF(OCEAN(I,LAT) .AND. NBLW .EQ. MLEV) THEN        
C                                                                       
C                       COMPUTE INTERPOLATION FACTORS FOR THE           
C                       SEALEVEL                                        
C                                                                       
                   PTSIFB = (PMIDSIG(I,N) ** ROCP-VPMAND(NABV)**ROCP)/  
     .                      (PSLA(I,LAT) ** ROCP-VPMAND(NABV)**ROCP)    
                   PTSIFA = 1.000 - PTSIFB                              
                   WDMBLW = WDELSLV(I,LAT)                              
                   WDMABV = WDELMAN(I,LAT,NABV)                         
C                                                                       
                ELSE IF (VPMAND(NBLW).GT.PSFC(I)) THEN                  
C                                                                       
C                       COMPUTE INTERPOLATION FACTORS FOR A SIGMA LEVEL 
C                       WITH A BRACKETING LOWER MANDATORY LEVEL THAT IS 
C                       BELOW THE SURFACE.  SET INCREMENT THERE TO 0    
C                       BEFORE INTERPOLATING.                           
C                                                                       
C                                                                       
                  PTSIFB = (PMIDSIG(I,N) ** ROCP-VPMAND(NABV)**ROCP)/   
     .                     (VPMAND(NBLW)  ** ROCP-VPMAND(NABV)**ROCP)   
                  PTSIFA = 1.0 - PTSIFB   
                  WDMABV = WDELMAN(I,LAT,NABV)                          
                  WDMBLW = 0.                                           
C                                                                       
                ELSE                                                    
C                                                                       
C                       COMPUTE INTERPOLATION FACTORS FOR               
C                       NORMAL LEVELS                                   
C                                                                       
C                                                                       
                  PTSIFB = (PMIDSIG(I,N) ** ROCP-VPMAND(NABV)**ROCP)/   
     .                     (VPMAND(NBLW)  ** ROCP-VPMAND(NABV)**ROCP)   
                  PTSIFA = 1.000 - PTSIFB                               
                  WDMABV = WDELMAN(I,LAT,NABV)                          
                  WDMBLW = WDELMAN(I,LAT,NBLW)                          
 
               ENDIF                                                    
             elseif(.not. ocean(i,lat)) then
c
c             set parameters to compute if the
c             sigma level is below lowest  mandtory level
c             just assign increment at lowest mandatory 
c             level to sigma level
c   
                  ptsifa = 1.0
                  ptsifb = 0.0
                  wdmabv = wdelman(i,lat,mlev)
                  wdmblw = 0.0
C                                                                       
C                                                                       
C                        CHECK WHETHER THE GRID POINTS ARE OVER         
C                        OCEAN                                          
C                                                                       
              ELSE        
C                                                                       
C                       COMPUTE INTERPOLATION FACTORS FOR THE           
C                       SEALEVEL                                        
C                                                                       
                PTSIFB = (PMIDSIG(I,N) ** ROCP -  
     .                                    VPMAND(mlev-1)**ROCP)/  
     .                   (PSLA(I,LAT) ** ROCP -    
     .                                   VPMAND(mlev-1)**ROCP)    
                PTSIFA = 1.000 - PTSIFB                              
                WDMBLW = WDELSLV(I,LAT)                              
                WDMABV = WDELMAN(I,LAT,mlev-1)                         
c
             endif
 
C                                                                       
c                       Final trap for filled mandatory level increments 
c
               if (wdmabv.eq.fill.or.wdmblw.eq.fill) then
 
                  fillmsg_count = fillmsg_count + 1 
 
                  if (debug.and.fillmsg_count.le.10) then
 
                     print 9901
 9901                format(' *** Note: attempted to use filled',
     .                   ' analysis increment in PTOSIGW; increment',
     .                   ' set to 0.')
 
                  else if (debug.and.fillmsg_count.eq.11) then
 
                     print 9902
 9902                format(' *** Note: more than 10 attempts to use',
     .                      ' filled analysis increments in PTOSIGW')
 
                  end if 
 
                  if (wdmabv.eq.fill) then
                     wdmabv=0.
                     wdmblw=0.
                  else if (wdmblw.eq.fill) then
                     wdmblw=0. 
                  end if 
 
               end if 
c
C                                                                       
C                       INTERPOLATE MANDATORY DELTAS WIND LEVELS        
C                       TO SIGMA LEVELS                                 
 
               WDELSIG = PTSIFA * WDMABV + PTSIFB * WDMBLW              
c
c             sigma level is below lowest mid mandtory level
c             just assign increment at lowest mid mandatory 
c             level to sigma level
c   

c
               BEFFGS  = WSIGFGS(I,N)                                   
               WSIGFGS(I,N) = WSIGFGS(I,N) + WDELSIG                    
C                                                                       
C                 LOAD PROFILES IN TO AN ARRAY FOR DEBUGGING            
C                                                                       
                 IF(NPROF .GT. 0) THEN                                  
                  DO 50 NQ = 1,NPROF                                    
                   IF(I .EQ. ILOC(NQ) .AND. LAT .EQ. JLOC(NQ)) THEN     
                       TPROFILE(1,N,NQ) = VMPSL                         
                       TPROFILE(2,N,NQ) = VPMAND(NBLW)                  
                       TPROFILE(3,N,NQ) = VPMAND(NABV)                  
                       TPROFILE(4,N,NQ) = BEFFGS                        
                       TPROFILE(5,N,NQ) = WDMBLW                        
                       TPROFILE(6,N,NQ) = WDMABV                        
                       TPROFILE(7,N,NQ) = WDELSIG                       
                       TPROFILE(8,N,NQ) = WSIGFGS(I,N)                  
                   ENDIF                                                
   50             CONTINUE                                              
                 ENDIF                                                  
   60        CONTINUE                                                   
   70  CONTINUE                                                         
C                                                                       
C                               PRINT THE PROFILES                      
C                                                                       
       IF(DEBUG) THEN                                                   
           IF(NPROF .GT. 0) THEN                                        
C                                                                       
                   DO 90 NP = 1,NPROF                                   
                    IF(LAT .EQ. JLOC(NP)) THEN                          
                       WRITE(6,1000) ILOC(NP),JLOC(NP),LAT              
                       DO 80 N = 1,NLAY                                 
                            WRITE(6,1100) (TPROFILE(I,N,NP),I=1,8)      
   80                  CONTINUE                                         
                    ENDIF                                               
   90              CONTINUE                                             
           ENDIF                                                        
       ENDIF                                                            
C                                                                       
       RETURN                                                           
 1000  FORMAT(//10X,'LONGITUDE INDEX : ',I4,'LATITUDE INDEX : ',I4,     
     .        10X,'GIVEN LATITUDE INDEX : ',I4,//1X,                    
     .         1X,'SIG. PRESSURE  ',1X,                                 
     .        'MAND.PRES.BELOW',1X,'MAND.PRES.ABOVE',1X,                
     .        1X,'MODEL FG. WINDS',1X,                                  
     .        'WND DELTA BELOW',1X,'WND DELTA ABOVE',1X,                
     .        'WND SIG DELTAS ',1X,'UPDT MODEL WINDS'//)                
 1100  FORMAT(8(1X,F15.4))                                              
       END                                                              
