                                                                        
      SUBROUTINE STABLE ( LAT, SIGFGS, PEDGESIG )                       
                                                                        
      LOGICAL UNSTABLE                                                  
      LOGICAL STRAT,SLP,FDCOS,FEXP,SAVEAE,SIGDAT                        
                                                                        
C MODEL ARRAY DIMENSIONS                                                
C ----------------------                                                
                                                                        
      REAL           SIGFGS(IM,NLAY), PEDGESIG(IM,NLAYP1),              
     .               POTEMP(nlay), SIGPRS(nlayp1)                             
                                                                        
      COMMON /PRNTPROF/ NPROF,ILOC(10),JLOC(10)                         
      COMMON /CONTRL/ IM, JNP, NB, NDALT, NHMS, NLAY, NLAYM1, NLAYP1,   
     .                NYMD, STRAT, IDIMEN, SLP, FDCOS, FEXP, SAVEAE,    
     .                SIGDAT,MAXREP                                     
C                                                                       
                                                                        
      KT=0                                                              
                                                                        
C DO FOR EACH LONGITUDE                                                 
C ---------------------                                                 
                                                                        
      DO 200 LON=1,IM                                                   
                                                                        
C ASSIGN POTENTIAL TEMPERATURES AND SIGMA EDGE PRESSURES FOR PROFILE    
C ------------------------------------------------------------------    
                                                                        
         DO 40 LEVEL=1,NLAY                                             
            POTEMP(LEVEL)=SIGFGS(LON,LEVEL)                             
   40    CONTINUE                                                       
                                                                        
         DO 50 LEVEL=1,NLAYP1                                           
            SIGPRS(LEVEL)=PEDGESIG(LON,LEVEL)                           
   50    CONTINUE                                                       
                                                                        
C CHECK INDIVIDUAL PROFILE FOR STABILITY (STABLE IF POTENTIAL           
C TEMPERATURE INCREASES WITH HEIGHT)                                    
C -----------------------------------------------------------           
                                                                        
         UNSTABLE=.FALSE.                                               
                                                                        
   70    LEVEL=0                                                        
   80       LEVEL=LEVEL+1                                               
            IF (LEVEL.LT.NLAYM1.AND.POTEMP(LEVEL).GE.POTEMP(LEVEL+1))   
     .                                                       GO TO 80   
                                                                        
C IF PROFILE IS STABLE THEN STOP PROCESSING                             
C -----------------------------------------                             
                                                                        
            IF (LEVEL.EQ.NLAYM1.AND.POTEMP(LEVEL).GE.POTEMP(LEVEL+1))   
     .                                                      GO TO 100   
                                                                        
C ELSE REPLACE UNSTABLE PORTION WITH A CONSTANT                         
C ---------------------------------------------                         
                                                                        
            UNSTABLE=.TRUE.                                             
            LEVEL1=LEVEL+1                                              
                                                                        
   90       CONTINUE                                                    
            CALL CONSTT ( POTEMP, SIGPRS, LEVEL, LEVEL1 )               
                                                                        
C AFTER ADJUSTMENT, CHECK STABILITY OF LAYER BELOW AND THEN GO BACK     
C AND RECHECK PROFILE UNLESS LOWEST LAYER JUST DONE - THEN JUST RECHECK 
C --------------------------------------------------------------------- 
                                                                        
            IF (LEVEL1.EQ.NLAY) GO TO 70                                
                                                                        
C IF LAYER BELOW STILL STABLE, RECHECK ENTIRE PROFILE - THIS IS         
C NECESSARY SINCE ADJUSTMENT MAY MAKE LAYER ABOVE UNSTABLE              
C -------------------------------------------------------------         
                                                                        
            IF (POTEMP(LEVEL1+1).LE.POTEMP(LEVEL1)) GO TO 70            
                                                                        
C ELSE LAYER BELOW NOW UNSTABLE, COMBINE WITH ABOVE LAYER(S) AND        
C STABILIZE ALL OF THEM AT ONCE                                         
C --------------------------------------------------------------        
                                                                        
            LEVEL1=LEVEL1+1                                             
            GO TO 90                                                    
                                                                        
  100    CONTINUE                                                       
                                                                        
C IF PROFILE WAS FOUND TO BE UNSTABLE, INCREMENT COUNTER AND SAVE       
C ADJUSTED POTENTIAL TEMPERATURE PROFILE                                
C ---------------------------------------------------------------       
                                                                        
         IF (UNSTABLE) THEN                                             
                                                                        
            KT=KT+1                                                     
                                                                        
            IF (NPROF.GT.0) THEN                                        
               PRINT 2000, KT,LAT,LON                                   
 2000          FORMAT(' KT=',I5,2X,'UNSTABLE PROFILE ADJUSTED AT LAT',  
     .                I4,2X,'LON',I4)                                   
            END IF                                                      
                                                                        
            DO 140 LEVEL=1,NLAY                                         
               SIGFGS(LON,LEVEL)=POTEMP(LEVEL)                          
  140       CONTINUE                                                    
                                                                        
         END IF                                                         
                                                                        
  200 CONTINUE                                                          
                                                                        
      RETURN                                                            
      END                                                               
