C                                                                       
C   CHANGES 90/03/12                                                    
C               DECYBERIZED VERSION (FROM O89)                          
C                                                                       
      SUBROUTINE TDRYBULB ( TV, RMIX, TDRY, PMAND, PMIDM )              
                                                                        
C ANALYSIS CONTROL VARIABLES                                            
C --------------------------                                            
      LOGICAL           STRAT,   SLP,     FDCOS,   FEXP,    SAVEAE,     
     $                  SIGDAT                                          
      COMMON /CONTRL/   IM,      JNP,     NB,      NDALT,   NHMS,       
     $                  NLAY,    NLAYM1,  NLAYP1,  NYMD,    STRAT,      
     $                  IDIMEN,  SLP,     FDCOS,   FEXP,    SAVEAE,     
     $                  SIGDAT,  MAXREP                                 
                                                                        
C VERTICAL INDEX COMMON                                                 
C ----------------------                                                
                                                                        
      COMMON /MLAY/ MLEV, MLEVM1, MMIX, MMIXM1, LS, LSM1                
                                                                        
C PRODUCTS OF GRID LIMITS                                               
C -----------------------                                               
                                                                        
      COMMON /PRODLIM/ IJMLEV, IJMLEVM1, ILBELOW, IMJNP, IMLSM1,        
     .                 IMMLEV, IMMLEVM1, IMMLEVP1, IMNLAY, IMNLAYP1     
                                                                        
C SUBROUTINE ARGUMENTS AND LOCAL VARIABLES                              
C ----------------------------------------                              
                                                                        
             DIMENSION TV(IM,JNP,MLEV), RMIX(IM,JNP,MLEV),              
     .            TDRY(IM,JNP,MLEV), PMAND(MLEV), PMIDM(MLEVM1)         
      real fill
      data fill /1.e10/                                                        
                                                                        
                                                                        
C INTERPOLATE MID MANDATORY VIRTUAL TEMPERATURES TO MANDATORY LEVELS    
C ------------------------------------------------------------------    
                                                                        
      DO 200 MANDLEV=1,MLEV                                             
                                                                        
         IF (MANDLEV.EQ.1) THEN                                         
            MIDMLEVB=2                                                  
         ELSE IF (MANDLEV.EQ.MLEV) THEN                                 
            MIDMLEVB=MLEVM1                                             
         ELSE                                                           
            MIDMLEVB=MANDLEV                                            
         END IF                                                         
                                                                        
         MIDMLEVA=MIDMLEVB-1                                            
                                                                        
         FACTORA=LOG(PMIDM(MIDMLEVB)/PMAND(MANDLEV))/                  
     .           LOG(PMIDM(MIDMLEVB)/PMIDM(MIDMLEVA))                  
         FACTORB=1.0-FACTORA                                            
                                                                        
         DO 30 J = 1,JNP                                                
           DO 20 I = 1,IM                                               
               TDRY(I,J,MANDLEV)=FACTORA*TV(I,J,MIDMLEVA)+              
     .                               FACTORB*TV(I,J,MIDMLEVB)           
                                                                        
   20      CONTINUE                                                     
   30    CONTINUE                                                       
  200 CONTINUE                                                          
                                                                        
C CONVERT VIRTUAL TEMPS ON MANDATORY LEVELS TO DRY BULB TEMPS           
C -----------------------------------------------------------           
                                                                        
                                                                        
      DO 400 MANDLEV=1,MLEV                                             
                                                                        
         DO 50 J = 1,JNP                                                
           DO 40 I = 1,IM                                               
                                                                        
C OBTAIN SPECIFIC HUMIDITIES FROM MIXING RATIOS (KEEP BETWEEN 0 AND 1)  
C --------------------------------------------------------------------  
              if (RMIX(I,J,MANDLEV).ne.fill) then 
                                                                        
               SHMAND=RMIX(I,J,MANDLEV)/1000.0                          
               SHMAND=SHMAND/(1.0+SHMAND)                               
               IF(SHMAND .GT. 1.0) SHMAND=1.0                           
               IF(SHMAND .LT. 0.0) SHMAND=0.0                           
                                                                        
C CONVERT VIRTUAL TEMPERATURES TO DRY BULB TEMPERATURES                 
C -----------------------------------------------------                 
                                                                        
               TDRY(I,J,MANDLEV)=                                       
     .               TDRY(I,J,MANDLEV)/(1.0+0.610*SHMAND)               
                                                                        
              end if 
 
   40      CONTINUE                                                     
   50    CONTINUE                                                       
  400 CONTINUE                                                          
                                                                        
      RETURN                                                            
      END                                                               
