      SUBROUTINE OBSCORRS(pmand,nlevoi)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     DECYBERIZED VERSION 7/90 (S. BLOOM)
C
C
C  SUBROUTINE OBSCORRS PUTS TOGETHER TABLES FOR LOOKING UP HORIZONTAL
C


C  AND VERTICAL CORRELATIONS OF OBSERVATIONAL ERRORS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      real              pmand(nlevoi)
      real              vcor(25,25)
      integer           vcor_type

      common /oevcortb/ ncorlevs, oe_vcor_table(25*25,4)
      COMMON /OBSCORR/ VCORLIST(200),HCORLIST(200),VCOROE(13,13,4),
     .                 HCOROE(1200,5)
      DIMENSION D(1200)
      CHARACTER*80 TITLE
C____________________________________________________________________
C     |                                                             |
C     |       TABLE SHOWING HOR. AND VERT. CORRELATION TYPES        |
C-----|-------------------------------------------------------------|
#ifdef CRAY
      DATA HCORLIST
     ./31*0,1,4*2,2*3,4*2,2*3,4*2,2*3,4*2,2*3,4*2,2*3,8*5,16*4,114*0/
#endif
#if defined(RS6000) || defined(DEC_ALPHA)
      HCORLIST = 0
      HCORLIST(1:86) =
     &     (/ (0, i=1,31),
     &     1,
     &     (2, i=1,4),
     &     (3, i=1,2),
     &     (2,i=1,4),
     &     (3,i=1,2),
     &     (2,i=1,4),
     &     (3,i=1,2),
     &     (2,i=1,4),
     &     (3,i=1,2),
     &     (2,i=1,4),
     &     (3,i=1,2),
     &     (5,i=1,8),
     &     (4,i=1,16)/)
#endif
C-----|----|-|---------------|---------------|-------|---|----|-----|
C     |  N |V|T              |N              |S  E   | V | G  |  U  |
C     |  O |T|I              |O              |P  F   | A | L  |  N  |
C     |  N |P|R              |A              |E  F   | S | A  |  U  |
C     |  E |R|O              |A              |C  O   |   | S  |  S  |
C     |    | |S              |6              |L  R   |   |    |  E  |
C     |    | |               |               |   T   |   | R  |  D  |
C     |    | |A B  C  A B  C |A B  C  A B  C |A B  C |   | E  |     |
C     |    | |L L  L  W W  W |L L  L  W W  W |W W  W |   | T  |     |
C-----|----|-|---------------|---------------|-------|---|----|-----|
#ifdef CRAY
      DATA VCORLIST
     ./31*0,2,4*3,2*4,4*3,2*4,4*3,2*4,4*3,2*4,4*3,2*4,8*3,16*3,114*0/
#endif
#if defined(RS6000) || defined(DEC_ALPHA)
      vcorlist = 0
      VCORLIST(1:86) =
     &     (/ (0, i=1,31),
     &     2,
     &     (3,i=1,4),
     &     (4,i=1,2),
     &     (3,i=1,4),
     &     (4,i=1,2),
     &     (3,i=1,4),
     &     (4,i=1,2),
     &     (3,i=1,4),
     &     (4,i=1,2),
     &     (3,i=1,4),
     &     (4,i=1,2),
     &     (3,i=1,8),
     &     (3,i=1,16) /)
#endif

C--------------------------------------------------------------------


c Number of levels stored in the correlation table on disk
      data input_ncorlevs /18/
C----------------------------------------------------------------------


C  ENTRIES FOR HORIZONTAL CORRELATION OF OBS ERROR (10 KM SEPARATION)
C  ------------------------------------------------------------------

      DO 5 K=1,1200
          D(K) = 10. * (K-1)
 5    CONTINUE

C  VTPR HORIZONTAL CORRELATION FUNCTION
C  ------------------------------------

      DO 10 K=1,1200
          HCOROE(K,1) = EXP(-(D(K)/600.)**2)
 10   CONTINUE

C  TIROS-NOAA6 A&B HORIZONTAL CORRELATION FUNCTION
C  -----------------------------------------------

      DO 20 K=1,1200
          HCOROE(K,2) = EXP(-(D(K)/150.  )**2)
 20   CONTINUE

C  TIROS-NOAA6  C  HORIZONTAL CORRELATION FUNCTION
C  -----------------------------------------------

      DO 30 K=1,1200
          HCOROE(K,3) = EXP(-(D(K)/150.  )**2)
 30   CONTINUE

C  GLA * RETRIEVALS HORIZONTAL CORRELATION FUNCTION
C  ------------------------------------------------

      DO 40 K=1,1200
          HCOROE(K,4) = EXP(-(D(K)/150.  )**2) ! <-- Altered !!
 40   CONTINUE

C  VAS * RETRIEVALS HORIZONTAL CORRELATION FUNCTION
C  ------------------------------------------------

      DO 50 K=1,1200
          HCOROE(K,5) = EXP(-(D(K)/600.)**2)
 50   CONTINUE


c  The following file read by OBSCORRS has been opened in INITIAL:

c  Unit 92 contains table lookup for observation error vertical correlation.


c  Read lookup tables for the height observation error vertical
c  correlation.  All levels from the tables will be read in.
c  ------------------------------------------------------------

c  Number of levels stored in correlation table in OI will be one more
c  than the number of mandatory levels used in the analysis in order to
c  "pad" the table below 1000 mb.

      ncorlevs=nlevoi+1

c  Position in the input table at which to start extracting levels.

      level_start=input_ncorlevs-nlevoi+1

      do 500 vcor_type = 1,4

         READ(92,900) TITLE
  900    FORMAT( A80 )

         do J=1,input_ncorlevs
            read(92,1900) (vcor(I,J),I=1,input_ncorlevs)
 1900       format(25f6.2)
         end do

!        print 1901, vcor_type
!1901    format(/,' Observation error vertical correlation lookup',
!    .          ' table read from unit 92.  Table ',i1,':')
!        PRINT 901, TITLE
! 901    FORMAT(/,' ',A80,/)
!        do J=1,input_ncorlevs
!           print 1902, (vcor(I,J),I=1,input_ncorlevs)
!1902       format(' ',25f6.2)
!        end do

c  Extract subset of levels in lookup table that will actually be used
c  by specified OI resolution.  Assume contiguous set of levels is to be
c  taken from the table with the last level always being 1000 mb - no
c  skipping of levels in the table.   Pad the table by duplicating the last
c  level, and compress the table to the required size.
c
         k=0
         do j=level_start,input_ncorlevs
            do i=level_start,input_ncorlevs
               k=k+1
               oe_vcor_table(k,vcor_type)=vcor(i,j)
            end do
            k=k+1
            oe_vcor_table(k,vcor_type)=oe_vcor_table(k-1,vcor_type)
         end do

         do i=1,ncorlevs
            k=k+1
            oe_vcor_table(k,vcor_type)=
     .                          oe_vcor_table(k-ncorlevs,vcor_type)
         end do

         print 1001, vcor_type
 1001    format(/,' Observation error vertical correlation lookup',
     .          ' table (as it will be used by oi).  Table ',i1,':')
         PRINT 1002, TITLE
 1002    FORMAT(/,' ',A80)
         print 1003, pmand
 1003    format(/,' ',8x,18f6.1)
         print 1004
 1004    format(' ')
         kbeg=1
         kend=ncorlevs
         do j=1,ncorlevs
            if (j.lt.ncorlevs) then
               print 1005, pmand(j),
     .                     (oe_vcor_table(k,vcor_type),k=kbeg,kend)
 1005          format(' ',f6.1,2x,19f6.2)
            else
               print 1006, (oe_vcor_table(k,vcor_type),k=kbeg,kend)
 1006          format(' ',8x,19f6.2)
            end if
            kbeg=kbeg+ncorlevs
            kend=kend+ncorlevs
         end do

  500 end do

C  FILL IN CORRELATION TYPES FOR THE RAWINSONDES
C  ---------------------------------------------

      VCORLIST(7) =  1.
      VCORLIST(8) =  1.
      VCORLIST(9) =  1.

      HCORLIST(7) = -1.
      HCORLIST(8) = -1.
      HCORLIST(9) = -1.

      RETURN
      END
